!+
      SUBROUTINE NITRO
! ---------------------------------------------------------------------------
! PURPOSE - Load common block /FLUDPC/
!.....NITROGEN TABLES FOR FLUID SUBPROGRAM.                             

!      WRITTEN BY: THEODORE E. FESSLER, NASA TM X-3572, AUGUST 1977     
!      REWRITTEN BY: LT. MARK D. KLEM & MARGARET P. PROCTOR, JANUARY 198
!                                                                       
!      THE ORIGINAL PROGRAM WAS WRITTEN IN SFTRAN, BUT THIS PROGRAM IS  
!      REWRITTEN IN STANDARD FORTRAN 77 TO RUN PRIMARILY ON PERSONAL    
!      COMPUTERS AND CAN ALSO RUN ON MAINFRAMES. MUCH OF THE OLD CODE WA
!      COMMENTED OUT BUT LEFT INTACT FOR DOCUMENTATION AND REFERENCE    
!      PURPOSES.                                                        
!                                                                       
!********************************************************************** 

  INTERFACE
    SUBROUTINE Fluid(T,P,RHO,PROPS,NP,ENTRY,VAPOR,ERROR,igoto)
      REAL,INTENT(IN OUT):: t
      REAL,INTENT(IN OUT):: p
      REAL,INTENT(IN OUT):: rho
      REAL,INTENT(OUT),DIMENSION(:):: props
      INTEGER,INTENT(IN):: np
      INTEGER,INTENT(IN):: entry
      LOGICAL,INTENT(OUT):: vapor
      INTEGER,INTENT(OUT):: error
      INTEGER,INTENT(IN):: igoto
    END Subroutine Fluid
  END INTERFACE


!                -- UNITS --                                            
                                                                        
!       R = 0.29680 JOULES / GRAM - DEG. K      C(1)                    
!       TCRIT = 126.30 DEG. K                   C(2)                    
!       PCRIT = 3.417 MEGA-NEWTONS / METER**2   C(3)                    
!       DCRIT = 0.3105  GRAMS / CENTIMETER**3   C(4)                    
!       VISCOSITY = GRAMS / CENTIMETER - SEC.        PROP(7)            
!       CONDUCTIVITY = WATTS / CENTIMETER - DEG. K   PROP(8)            
                                                                        
!     DIMENSION G(21,4),TT(27),DD(30),GG(27,30,8),SAT(35,8),C(8),M(4)   
!********************************************************************** 
      DIMENSION G(29,4),TT(27),DD(30),GG(27,30,8),SAT(40,8),C(8),M(4) 
       INTEGER ERROR,ENTRY 
       DIMENSION PROPS(8) 
       LOGICAL VAPOR 
!********************************************************************** 
      DIMENSION X0001(100),X0101(100),X0201(100),X0301(100),X0401(100), &
     &          X0501(100),X0601(100),X0701(100),X0801(100),X0901(100), &
     &          X1001(100),X1101(100),X1201(100),X1301(100),X1401(100), &
     &          X1501(100),X1601(100),X1701(100),X1801(100),X1901(100), &
     &          X2001(100),X2101(100),X2201(100),X2301(100),X2401(100), &
     &          X2501(100),X2601(100),X2701(100),X2801(100),X2901(100), &
     &          X3001(100),X3101(100),X3201(100),X3301(100),X3401(100), &
     &          X3501(100),X3601(100),X3701(100),X3801(100),X3901(100), &
     &          X4001(100),X4101(100),X4201(100),X4301(100),X4401(100), &
     &          X4501(100),X4601(100),X4701(100),X4801(100),X4901(100), &
     &          X5001(100),X5101(100),X5201(100),X5301(100),X5401(100), &
     &          X5501(100),X5601(100),X5701(100),X5801(100),X5901(100), &
     &          X6001(100),X6101(100),X6201(100),X6301(100),X6401(100), &
     &          X6501(100),X6601(100),X6701(100),X6801(100),X6901(9)    
                                                                        
      DIMENSION Z(6909) 
!********************************************************************** 
       COMMON /FLUDPC/ G,TT,DD,GG,SAT,C,M,NG,N1,NTT,N3,NS 
!********************************************************************** 
      EQUIVALENCE (X0001,Z(0001)), (X0101,Z(0101)), (X0201,Z(0201)),    &
     &            (X0301,Z(0301)), (X0401,Z(0401)), (X0501,Z(0501)),    &
     &            (X0601,Z(0601)), (X0701,Z(0701)), (X0801,Z(0801)),    &
     &            (X0901,Z(0901)), (X1001,Z(1001)), (X1101,Z(1101)),    &
     &            (X1201,Z(1201)), (X1301,Z(1301)), (X1401,Z(1401)),    &
     &            (X1501,Z(1501)), (X1601,Z(1601)), (X1701,Z(1701)),    &
     &            (X1801,Z(1801)), (X1901,Z(1901)), (X2001,Z(2001)),    &
     &            (X2101,Z(2101)), (X2201,Z(2201)), (X2301,Z(2301)),    &
     &            (X2401,Z(2401)), (X2501,Z(2501)), (X2601,Z(2601)),    &
     &            (X2701,Z(2701)), (X2801,Z(2801)), (X2901,Z(2901)),    &
     &            (X3001,Z(3001)), (X3101,Z(3101)), (X3201,Z(3201)),    &
     &            (X3301,Z(3301)), (X3401,Z(3401)), (X3501,Z(3501))     
      EQUIVALENCE (X3601,Z(3601)), (X3701,Z(3701)), (X3801,Z(3801)),    &
     &            (X3901,Z(3901)), (X4001,Z(4001)), (X4101,Z(4101)),    &
     &            (X4201,Z(4201)), (X4301,Z(4301)), (X4401,Z(4401)),    &
     &            (X4501,Z(4501)), (X4601,Z(4601)), (X4701,Z(4701)),    &
     &            (X4801,Z(4801)), (X4901,Z(4901)), (X5001,Z(5001)),    &
     &            (X5101,Z(5101)), (X5201,Z(5201)), (X5301,Z(5301)),    &
     &            (X5401,Z(5401)), (X5501,Z(5501)), (X5601,Z(5601)),    &
     &            (X5701,Z(5701)), (X5801,Z(5801)), (X5901,Z(5901)),    &
     &            (X6001,Z(6001)), (X6101,Z(6101)), (X6201,Z(6201)),    &
     &            (X6301,Z(6301)), (X6401,Z(6401)), (X6501,Z(6501)),    &
     &            (X6601,Z(6601)), (X6701,Z(6701)), (X6801,Z(6801)),    &
     &            (X6901,Z(6901))                                       
                                                                        
!********************************************************************** 
!********************************************************************** 
      DATA X0001/ 5.1200E-1, 6.0000E-1, 7.0000E-1, 8.0000E-1, 9.0000E-1,&
     & 9.5000E-1, 1.0000E+0, 1.0500E+0, 1.1000E+0, 1.2000E+0, 1.4000E+0,&
     & 1.8000E+0, 2.0000E+0, 2.4000E+0, 2.8000E+0, 3.5000E+0, 4.0000E+0,&
     & 5.0000E+0, 6.0000E+0, 7.0000E+0, 7.9000E+0, 1.5311E+1, 1.5708E+1,&
     & 1.6094E+1, 1.6429E+1, 1.6724E+1, 1.6859E+1, 1.6987E+1, 1.7109E+1,&
     & 1.7225E+1, 1.7443E+1, 1.7828E+1, 1.8456E+1, 1.8719E+1, 1.9175E+1,&
     & 1.9561E+1, 2.0124E+1, 2.0464E+1, 2.1044E+1, 2.1534E+1, 2.1965E+1,&
     & 2.2315E+1, 5.1598E+0, 5.3558E+0, 5.5785E+0, 5.8011E+0, 6.0236E+0,&
     & 6.1348E+0, 6.2460E+0, 6.3572E+0, 6.4684E+0, 6.6907E+0, 7.1351E+0,&
     & 8.0235E+0, 8.4676E+0, 9.3566E+0, 1.0248E+1, 1.1818E+1, 1.2953E+1,&
     & 1.5276E+1, 1.7690E+1, 2.0211E+1, 2.2563E+1, 2.5057E+0, 2.5051E+0,&
     & 2.5041E+0, 2.5032E+0, 2.5023E+0, 2.5019E+0, 2.5015E+0, 2.5011E+0,&
     & 2.5008E+0, 2.5001E+0, 2.4990E+0, 2.4981E+0, 2.4986E+0, 2.5021E+0,&
     & 2.5096E+0, 2.5346E+0, 2.5624E+0, 2.6416E+0, 2.7442E+0, 2.8509E+0,&
     & 2.9262E+0, 5.1200E-1, 6.2000E-1, 6.9000E-1, 7.5700E-1, 8.1000E-1,&
     & 8.5400E-1, 9.0800E-1, 9.3000E-1, 9.5000E-1, 9.6500E-1, 9.7500E-1,&
     & 9.8100E-1, 9.8800E-1, 9.9300E-1, 9.9750E-1, 9.9800E-1/           
      DATA X0101/ 1.0300E+0, 1.0500E+0, 1.1000E+0, 1.3000E+0, 1.8000E+0,&
     & 2.8000E+0, 3.5000E+0, 5.0000E+0, 6.0000E+0, 7.0000E+0, 7.9000E+0,&
     & 5.5500E-4, 2.0000E-3, 1.3000E-2, 3.0000E-2, 7.0000E-2, 1.0900E-1,&
     & 1.7000E-1, 2.7000E-1, 3.2000E-1, 3.9000E-1, 4.5000E-1, 5.2000E-1,&
     & 5.6000E-1, 6.3000E-1, 6.9000E-1, 7.9000E-1, 8.0000E-1, 1.1900E+0,&
     & 1.3500E+0, 1.4790E+0, 1.6100E+0, 1.8800E+0, 2.0600E+0, 2.2000E+0,&
     & 2.3000E+0, 2.4900E+0, 2.6000E+0, 2.8000E+0, 2.9000E+0, 2.9500E+0,&
     & 1.2752E+0, 1.2760E+0, 1.2763E+0, 1.2765E+0, 1.2766E+0, 1.2767E+0,&
     & 1.2768E+0, 1.2769E+0, 1.2769E+0, 1.2769E+0, 1.2769E+0, 1.2769E+0,&
     & 1.2769E+0, 1.2769E+0, 1.2769E+0, 1.2769E+0, 1.2770E+0, 1.2770E+0,&
     & 1.2770E+0, 1.2772E+0, 1.2773E+0, 1.2774E+0, 1.2774E+0, 1.2774E+0,&
     & 1.2774E+0, 1.2774E+0, 1.2774E+0, 1.2695E+0, 1.2724E+0, 1.2736E+0,&
     & 1.2743E+0, 1.2748E+0, 1.2751E+0, 1.2755E+0, 1.2756E+0, 1.2757E+0,&
     & 1.2758E+0, 1.2758E+0, 1.2758E+0, 1.2759E+0, 1.2759E+0, 1.2759E+0,&
     & 1.2759E+0, 1.2760E+0, 1.2761E+0, 1.2762E+0, 1.2767E+0, 1.2771E+0,&
     & 1.2774E+0, 1.2775E+0, 1.2776E+0, 1.2776E+0, 1.2777E+0, 1.2777E+0,&
     & 1.2297E+0, 1.2455E+0, 1.2529E+0, 1.2580E+0, 1.2611E+0/           
      DATA X0201/ 1.2632E+0, 1.2653E+0, 1.2660E+0, 1.2666E+0, 1.2671E+0,&
     & 1.2673E+0, 1.2675E+0, 1.2677E+0, 1.2678E+0, 1.2679E+0, 1.2680E+0,&
     & 1.2687E+0, 1.2692E+0, 1.2701E+0, 1.2729E+0, 1.2760E+0, 1.2779E+0,&
     & 1.2784E+0, 1.2790E+0, 1.2792E+0, 1.2793E+0, 1.2794E+0, 1.1761E+0,&
     & 1.2064E+0, 1.2218E+0, 1.2334E+0, 1.2403E+0, 1.2451E+0, 1.2498E+0,&
     & 1.2515E+0, 1.2529E+0, 1.2539E+0, 1.2546E+0, 1.2549E+0, 1.2554E+0,&
     & 1.2556E+0, 1.2559E+0, 1.2559E+0, 1.2577E+0, 1.2587E+0, 1.2609E+0,&
     & 1.2672E+0, 1.2742E+0, 1.2786E+0, 1.2798E+0, 1.2811E+0, 1.2815E+0,&
     & 1.2819E+0, 1.2821E+0, 1.0648E+0, 1.1231E+0, 1.1539E+0, 1.1782E+0,&
     & 1.1939E+0, 1.2045E+0, 1.2152E+0, 1.2189E+0, 1.2221E+0, 1.2243E+0,&
     & 1.2258E+0, 1.2266E+0, 1.2276E+0, 1.2282E+0, 1.2288E+0, 1.2289E+0,&
     & 1.2328E+0, 1.2350E+0, 1.2401E+0, 1.2542E+0, 1.2702E+0, 1.2802E+0,&
     & 1.2829E+0, 1.2859E+0, 1.2870E+0, 1.2877E+0, 1.2883E+0, 9.7861E-1,&
     & 1.0546E+0, 1.0957E+0, 1.1292E+0, 1.1516E+0, 1.1675E+0, 1.1835E+0,&
     & 1.1892E+0, 1.1939E+0, 1.1973E+0, 1.1994E+0, 1.2007E+0, 1.2021E+0,&
     & 1.2031E+0, 1.2040E+0, 1.2041E+0, 1.2100E+0, 1.2133E+0, 1.2209E+0,&
     & 1.2422E+0, 1.2664E+0, 1.2817E+0, 1.2860E+0, 1.2905E+0/           
      DATA X0301/ 1.2922E+0, 1.2934E+0, 1.2942E+0, 8.6247E-1, 9.6146E-1,&
     & 1.0160E+0, 1.0613E+0, 1.0922E+0, 1.1146E+0, 1.1381E+0, 1.1464E+0,&
     & 1.1534E+0, 1.1583E+0, 1.1615E+0, 1.1633E+0, 1.1654E+0, 1.1669E+0,&
     & 1.1682E+0, 1.1683E+0, 1.1770E+0, 1.1820E+0, 1.1932E+0, 1.2248E+0,&
     & 1.2609E+0, 1.2840E+0, 1.2906E+0, 1.2977E+0, 1.3002E+0, 1.3021E+0,&
     & 1.3033E+0, 7.1204E-1, 8.3894E-1, 9.1002E-1, 9.6983E-1, 1.0113E+0,&
     & 1.0419E+0, 1.0746E+0, 1.0864E+0, 1.0963E+0, 1.1034E+0, 1.1079E+0,&
     & 1.1105E+0, 1.1135E+0, 1.1156E+0, 1.1175E+0, 1.1177E+0, 1.1301E+0,&
     & 1.1373E+0, 1.1534E+0, 1.1993E+0, 1.2529E+0, 1.2880E+0, 1.2982E+0,&
     & 1.3092E+0, 1.3133E+0, 1.3162E+0, 1.3182E+0, 6.5991E-1, 7.9442E-1,&
     & 8.7004E-1, 9.3401E-1, 9.7871E-1, 1.0120E+0, 1.0479E+0, 1.0610E+0,&
     & 1.0721E+0, 1.0800E+0, 1.0850E+0, 1.0880E+0, 1.0913E+0, 1.0937E+0,&
     & 1.0958E+0, 1.0960E+0, 1.1100E+0, 1.1180E+0, 1.1362E+0, 1.1881E+0,&
     & 1.2494E+0, 1.2901E+0, 1.3020E+0, 1.3151E+0, 1.3200E+0, 1.3234E+0,&
     & 1.3257E+0, 6.0059E-1, 7.4316E-1, 8.2422E-1, 8.9268E-1, 9.4073E-1,&
     & 9.7685E-1, 1.0162E+0, 1.0307E+0, 1.0431E+0, 1.0519E+0, 1.0575E+0,&
     & 1.0608E+0, 1.0646E+0, 1.0672E+0, 1.0695E+0, 1.0698E+0/           
      DATA X0401/ 1.0855E+0, 1.0946E+0, 1.1150E+0, 1.1741E+0, 1.2450E+0,&
     & 1.2932E+0, 1.3076E+0, 1.3235E+0, 1.3294E+0, 1.3336E+0, 1.3365E+0,&
     & 5.6592E-1, 7.1118E-1, 7.9370E-1, 8.6499E-1, 9.1553E-1, 9.5299E-1,&
     & 9.9422E-1, 1.0095E+0, 1.0226E+0, 1.0320E+0, 1.0380E+0, 1.0415E+0,&
     & 1.0455E+0, 1.0483E+0, 1.0508E+0, 1.0511E+0, 1.0679E+0, 1.0776E+0,&
     & 1.0996E+0, 1.1637E+0, 1.2418E+0, 1.2961E+0, 1.3125E+0, 1.3308E+0,&
     & 1.3377E+0, 1.3426E+0, 1.3460E+0, 5.4102E-1, 6.8774E-1, 7.7100E-1,&
     & 8.4229E-1, 8.9355E-1, 9.3210E-1, 9.7437E-1, 9.9014E-1, 1.0038E+0,&
     & 1.0135E+0, 1.0198E+0, 1.0235E+0, 1.0277E+0, 1.0306E+0, 1.0332E+0,&
     & 1.0335E+0, 1.0512E+0, 1.0614E+0, 1.0847E+0, 1.1533E+0, 1.2388E+0,&
     & 1.2999E+0, 1.3186E+0, 1.3398E+0, 1.3478E+0, 1.3535E+0, 1.3574E+0,&
     & 5.3467E-1, 6.7871E-1, 7.6074E-1, 8.3276E-1, 8.8428E-1, 9.2285E-1,&
     & 9.6555E-1, 9.8148E-1, 9.9529E-1, 1.0051E+0, 1.0115E+0, 1.0152E+0,&
     & 1.0195E+0, 1.0225E+0, 1.0251E+0, 1.0254E+0, 1.0434E+0, 1.0538E+0,&
     & 1.0776E+0, 1.1482E+0, 1.2374E+0, 1.3021E+0, 1.3222E+0, 1.3450E+0,&
     & 1.3537E+0, 1.3599E+0, 1.3641E+0, 5.2734E-1, 6.8066E-1, 7.5635E-1,&
     & 8.2446E-1, 8.7427E-1, 9.1260E-1, 9.5499E-1, 9.7040E-1/           
      DATA X0501/ 9.8413E-1, 9.9399E-1, 1.0004E+0, 1.0041E+0, 1.0084E+0,&
     & 1.0114E+0, 1.0141E+0, 1.0144E+0, 1.0326E+0, 1.0432E+0, 1.0675E+0,&
     & 1.1407E+0, 1.2355E+0, 1.3065E+0, 1.3289E+0, 1.3546E+0, 1.3644E+0,&
     & 1.3715E+0, 1.3763E+0, 5.6250E-1, 6.6797E-1, 7.4609E-1, 8.2031E-1,&
     & 8.7109E-1, 9.1016E-1, 9.4727E-1, 9.6411E-1, 9.7778E-1, 9.8755E-1,&
     & 9.9385E-1, 9.9757E-1, 1.0019E+0, 1.0049E+0, 1.0075E+0, 1.0078E+0,&
     & 1.0260E+0, 1.0366E+0, 1.0610E+0, 1.1356E+0, 1.2346E+0, 1.3105E+0,&
     & 1.3350E+0, 1.3632E+0, 1.3740E+0, 1.3818E+0, 1.3871E+0, 5.7007E-1,&
     & 7.0058E-1, 7.6895E-1, 8.3110E-1, 8.7189E-1, 9.0599E-1, 9.4468E-1,&
     & 9.6012E-1, 9.7260E-1, 9.8197E-1, 9.8805E-1, 9.9163E-1, 9.9575E-1,&
     & 9.9865E-1, 1.0012E+0, 1.0015E+0, 1.0192E+0, 1.0296E+0, 1.0538E+0,&
     & 1.1294E+0, 1.2341E+0, 1.3181E+0, 1.3458E+0, 1.3781E+0, 1.3907E+0,&
     & 1.3997E+0, 1.4059E+0, 5.8426E-1, 7.1095E-1, 7.7216E-1, 8.3215E-1,&
     & 8.7418E-1, 9.0732E-1, 9.4496E-1, 9.6014E-1, 9.7254E-1, 9.8180E-1,&
     & 9.8780E-1, 9.9134E-1, 9.9542E-1, 9.9830E-1, 1.0009E+0, 1.0012E+0,&
     & 1.0188E+0, 1.0292E+0, 1.0533E+0, 1.1290E+0, 1.2342E+0, 1.3189E+0,&
     & 1.3469E+0, 1.3797E+0, 1.3924E+0, 1.4016E+0, 1.4079E+0/           
      DATA X0601/ 6.8350E-1, 7.7264E-1, 8.1801E-1, 8.6092E-1, 8.9320E-1,&
     & 9.1933E-1, 9.4975E-1, 9.6239E-1, 9.7293E-1, 9.8083E-1, 9.8603E-1,&
     & 9.8909E-1, 9.9267E-1, 9.9519E-1, 9.9746E-1, 9.9771E-1, 1.0135E+0,&
     & 1.0231E+0, 1.0460E+0, 1.1234E+0, 1.2449E+0, 1.3558E+0, 1.3955E+0,&
     & 1.4438E+0, 1.4630E+0, 1.4770E+0, 1.4867E+0, 6.2500E-1, 7.4219E-1,&
     & 7.9297E-1, 8.4766E-1, 8.8281E-1, 9.1797E-1, 9.4189E-1, 9.5557E-1,&
     & 9.6704E-1, 9.7534E-1, 9.8068E-1, 9.8393E-1, 9.8773E-1, 9.9037E-1,&
     & 9.9275E-1, 9.9302E-1, 1.0096E+0, 1.0197E+0, 1.0437E+0, 1.1248E+0,&
     & 1.2528E+0, 1.3720E+0, 1.4154E+0, 1.4688E+0, 1.4903E+0, 1.5059E+0,&
     & 1.5168E+0, 6.2207E-1, 7.1655E-1, 7.7393E-1, 8.2715E-1, 8.6646E-1,&
     & 8.9746E-1, 9.3327E-1, 9.4719E-1, 9.5950E-1, 9.6854E-1, 9.7446E-1,&
     & 9.7797E-1, 9.8204E-1, 9.8492E-1, 9.8749E-1, 9.8778E-1, 1.0056E+0,&
     & 1.0164E+0, 1.0419E+0, 1.1269E+0, 1.2595E+0, 1.3835E+0, 1.4291E+0,&
     & 1.4857E+0, 1.5085E+0, 1.5252E+0, 1.5368E+0, 5.5640E-1, 6.7261E-1,&
     & 7.4194E-1, 8.0347E-1, 8.4863E-1, 8.8345E-1, 9.2354E-1, 9.3899E-1,&
     & 9.5258E-1, 9.6250E-1, 9.6897E-1, 9.7281E-1, 9.7723E-1, 9.8036E-1,&
     & 9.8315E-1, 9.8346E-1, 1.0027E+0, 1.0142E+0, 1.0413E+0/           
      DATA X0701/ 1.1299E+0, 1.2654E+0, 1.3919E+0, 1.4388E+0, 1.4974E+0,&
     & 1.5212E+0, 1.5385E+0, 1.5507E+0, 4.4424E-1, 6.0252E-1, 6.9359E-1,&
     & 7.7223E-1, 8.2841E-1, 8.7106E-1, 9.1842E-1, 9.3614E-1, 9.5147E-1,&
     & 9.6250E-1, 9.6964E-1, 9.7384E-1, 9.7868E-1, 9.8209E-1, 9.8512E-1,&
     & 9.8546E-1, 1.0061E+0, 1.0184E+0, 1.0467E+0, 1.1360E+0, 1.2667E+0,&
     & 1.3878E+0, 1.4334E+0, 1.4911E+0, 1.5147E+0, 1.5321E+0, 1.5442E+0,&
     & 4.2513E-1, 5.9900E-1, 6.9702E-1, 7.8003E-1, 8.3824E-1, 8.8155E-1,&
     & 9.2848E-1, 9.4563E-1, 9.6036E-1, 9.7090E-1, 9.7770E-1, 9.8170E-1,&
     & 9.8628E-1, 9.8951E-1, 9.9238E-1, 9.9269E-1, 1.0122E+0, 1.0236E+0,&
     & 1.0499E+0, 1.1313E+0, 1.2480E+0, 1.3560E+0, 1.3972E+0, 1.4500E+0,&
     & 1.4717E+0, 1.4878E+0, 1.4990E+0, 4.4072E-1, 6.1805E-1, 7.1598E-1,&
     & 7.9724E-1, 8.5287E-1, 8.9324E-1, 9.3558E-1, 9.5093E-1, 9.6405E-1,&
     & 9.7341E-1, 9.7943E-1, 9.8297E-1, 9.8702E-1, 9.8987E-1, 9.9240E-1,&
     & 9.9268E-1, 1.0098E+0, 1.0198E+0, 1.0428E+0, 1.1130E+0, 1.2125E+0,&
     & 1.3051E+0, 1.3409E+0, 1.3873E+0, 1.4066E+0, 1.4209E+0, 1.4309E+0,&
     & 4.5496E-1, 6.3469E-1, 7.3124E-1, 8.0896E-1, 8.6025E-1, 8.9599E-1,&
     & 9.3320E-1, 9.4661E-1, 9.5805E-1, 9.6619E-1, 9.7142E-1/           
      DATA X0801/ 9.7449E-1, 9.7800E-1, 9.8047E-1, 9.8266E-1, 9.8290E-1,&
     & 9.9771E-1, 1.0063E+0, 1.0261E+0, 1.0860E+0, 1.1703E+0, 1.2495E+0,&
     & 1.2806E+0, 1.3212E+0, 1.3382E+0, 1.3509E+0, 1.3598E+0, 5.2420E-1,&
     & 6.7056E-1, 7.4552E-1, 8.0262E-1, 8.3762E-1, 8.6161E-1, 8.8619E-1,&
     & 8.9495E-1, 9.0238E-1, 9.0764E-1, 9.1101E-1, 9.1299E-1, 9.1524E-1,&
     & 9.1682E-1, 9.1823E-1, 9.1838E-1, 9.2783E-1, 9.3331E-1, 9.4575E-1,&
     & 9.8290E-1, 1.0345E+0, 1.0846E+0, 1.1052E+0, 1.1328E+0, 1.1446E+0,&
     & 1.1535E+0, 1.1598E+0, 5.3451E-1, 6.5822E-1, 7.1697E-1, 7.5742E-1,&
     & 7.8178E-1, 7.9825E-1, 8.1490E-1, 8.2078E-1, 8.2574E-1, 8.2923E-1,&
     & 8.3147E-1, 8.3277E-1, 8.3426E-1, 8.3530E-1, 8.3623E-1, 8.3633E-1,&
     & 8.4253E-1, 8.4610E-1, 8.5417E-1, 8.7788E-1, 9.1046E-1, 9.4333E-1,&
     & 9.5745E-1, 9.7703E-1, 9.8559E-1, 9.9208E-1, 9.9671E-1, 4.4417E-1,&
     & 4.9667E-1, 5.1686E-1, 5.2979E-1, 5.3702E-1, 5.4159E-1, 5.4592E-1,&
     & 5.4736E-1, 5.4854E-1, 5.4935E-1, 5.4986E-1, 5.5015E-1, 5.5048E-1,&
     & 5.5071E-1, 5.5092E-1, 5.5094E-1, 5.5226E-1, 5.5300E-1, 5.5458E-1,&
     & 5.5864E-1, 5.6364E-1, 5.7065E-1, 5.7467E-1, 5.8107E-1, 5.8413E-1,&
     & 5.8654E-1, 5.8830E-1, 2.8313E-1, 3.0197E-1, 3.0858E-1/           
      DATA X0901/ 3.1232E-1, 3.1413E-1, 3.1509E-1, 3.1581E-1, 3.1599E-1,&
     & 3.1612E-1, 3.1619E-1, 3.1622E-1, 3.1624E-1, 3.1626E-1, 3.1627E-1,&
     & 3.1628E-1, 3.1628E-1, 3.1631E-1, 3.1631E-1, 3.1623E-1, 3.1550E-1,&
     & 3.1400E-1, 3.1410E-1, 3.1498E-1, 3.1690E-1, 3.1796E-1, 3.1883E-1,&
     & 3.1949E-1, 1.5882E-1, 1.6603E-1, 1.6830E-1, 1.6937E-1, 1.6974E-1,&
     & 1.6983E-1, 1.6977E-1, 1.6971E-1, 1.6963E-1, 1.6957E-1, 1.6953E-1,&
     & 1.6950E-1, 1.6947E-1, 1.6944E-1, 1.6942E-1, 1.6942E-1, 1.6925E-1,&
     & 1.6913E-1, 1.6884E-1, 1.6767E-1, 1.6575E-1, 1.6480E-1, 1.6490E-1,&
     & 1.6548E-1, 1.6587E-1, 1.6620E-1, 1.6647E-1, 1.0000E+0, 9.9999E-1,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 9.9974E-1, 9.9981E-1, 9.9987E-1, 9.9989E-1, 9.9990E-1,&
     & 9.9991E-1, 9.9993E-1, 9.9993E-1, 9.9994E-1, 9.9994E-1, 9.9994E-1,&
     & 9.9994E-1, 9.9994E-1, 9.9994E-1, 9.9995E-1, 9.9994E-1, 9.9995E-1,&
     & 9.9995E-1, 9.9996E-1, 9.9998E-1, 9.9998E-1, 9.9999E-1/           
      DATA X1001/ 9.9999E-1, 9.9999E-1, 9.9999E-1, 9.9999E-1, 9.9999E-1,&
     & 9.9747E-1, 9.9833E-1, 9.9871E-1, 9.9896E-1, 9.9911E-1, 9.9922E-1,&
     & 9.9933E-1, 9.9937E-1, 9.9940E-1, 9.9942E-1, 9.9944E-1, 9.9944E-1,&
     & 9.9945E-1, 9.9946E-1, 9.9947E-1, 9.9947E-1, 9.9950E-1, 9.9953E-1,&
     & 9.9958E-1, 9.9972E-1, 9.9984E-1, 9.9990E-1, 9.9991E-1, 9.9992E-1,&
     & 9.9992E-1, 9.9992E-1, 9.9992E-1, 9.9445E-1, 9.9603E-1, 9.9684E-1,&
     & 9.9745E-1, 9.9783E-1, 9.9809E-1, 9.9836E-1, 9.9845E-1, 9.9853E-1,&
     & 9.9858E-1, 9.9862E-1, 9.9864E-1, 9.9866E-1, 9.9868E-1, 9.9869E-1,&
     & 9.9869E-1, 9.9879E-1, 9.9884E-1, 9.9896E-1, 9.9930E-1, 9.9961E-1,&
     & 9.9976E-1, 9.9978E-1, 9.9980E-1, 9.9981E-1, 9.9981E-1, 9.9982E-1,&
     & 9.8718E-1, 9.9059E-1, 9.9240E-1, 9.9383E-1, 9.9475E-1, 9.9538E-1,&
     & 9.9602E-1, 9.9625E-1, 9.9643E-1, 9.9656E-1, 9.9665E-1, 9.9670E-1,&
     & 9.9675E-1, 9.9679E-1, 9.9683E-1, 9.9683E-1, 9.9706E-1, 9.9719E-1,&
     & 9.9748E-1, 9.9827E-1, 9.9904E-1, 9.9940E-1, 9.9947E-1, 9.9952E-1,&
     & 9.9953E-1, 9.9954E-1, 9.9955E-1, 9.8094E-1, 9.8571E-1, 9.8826E-1,&
     & 9.9035E-1, 9.9174E-1, 9.9273E-1, 9.9373E-1, 9.9409E-1, 9.9438E-1,&
     & 9.9459E-1, 9.9472E-1, 9.9479E-1, 9.9488E-1, 9.9494E-1/           
      DATA X1101/ 9.9500E-1, 9.9500E-1, 9.9536E-1, 9.9556E-1, 9.9602E-1,&
     & 9.9726E-1, 9.9848E-1, 9.9904E-1, 9.9915E-1, 9.9923E-1, 9.9925E-1,&
     & 9.9927E-1, 9.9928E-1, 9.7156E-1, 9.7835E-1, 9.8203E-1, 9.8507E-1,&
     & 9.8715E-1, 9.8864E-1, 9.9020E-1, 9.9075E-1, 9.9120E-1, 9.9152E-1,&
     & 9.9173E-1, 9.9185E-1, 9.9198E-1, 9.9208E-1, 9.9216E-1, 9.9217E-1,&
     & 9.9273E-1, 9.9304E-1, 9.9375E-1, 9.9568E-1, 9.9759E-1, 9.9848E-1,&
     & 9.9864E-1, 9.9877E-1, 9.9880E-1, 9.9883E-1, 9.9885E-1, 9.5798E-1,&
     & 9.6724E-1, 9.7249E-1, 9.7696E-1, 9.8002E-1, 9.8226E-1, 9.8462E-1,&
     & 9.8547E-1, 9.8618E-1, 9.8667E-1, 9.8699E-1, 9.8717E-1, 9.8738E-1,&
     & 9.8753E-1, 9.8766E-1, 9.8767E-1, 9.8854E-1, 9.8903E-1, 9.9013E-1,&
     & 9.9312E-1, 9.9611E-1, 9.9751E-1, 9.9777E-1, 9.9798E-1, 9.9804E-1,&
     & 9.9808E-1, 9.9811E-1, 9.5142E-1, 9.6239E-1, 9.6829E-1, 9.7331E-1,&
     & 9.7670E-1, 9.7927E-1, 9.8198E-1, 9.8295E-1, 9.8378E-1, 9.8435E-1,&
     & 9.8472E-1, 9.8494E-1, 9.8518E-1, 9.8535E-1, 9.8550E-1, 9.8552E-1,&
     & 9.8653E-1, 9.8710E-1, 9.8837E-1, 9.9187E-1, 9.9537E-1, 9.9702E-1,&
     & 9.9733E-1, 9.9757E-1, 9.9764E-1, 9.9769E-1, 9.9773E-1, 9.4385E-1,&
     & 9.5630E-1, 9.6313E-1, 9.6892E-1, 9.7247E-1, 9.7536E-1/           
      DATA X1201/ 9.7848E-1, 9.7960E-1, 9.8057E-1, 9.8125E-1, 9.8169E-1,&
     & 9.8194E-1, 9.8223E-1, 9.8243E-1, 9.8261E-1, 9.8263E-1, 9.8382E-1,&
     & 9.8450E-1, 9.8601E-1, 9.9014E-1, 9.9433E-1, 9.9631E-1, 9.9668E-1,&
     & 9.9697E-1, 9.9706E-1, 9.9712E-1, 9.9717E-1, 9.3970E-1, 9.5142E-1,&
     & 9.5850E-1, 9.6484E-1, 9.6948E-1, 9.7231E-1, 9.7566E-1, 9.7690E-1,&
     & 9.7798E-1, 9.7874E-1, 9.7923E-1, 9.7951E-1, 9.7983E-1, 9.8006E-1,&
     & 9.8026E-1, 9.8028E-1, 9.8161E-1, 9.8237E-1, 9.8406E-1, 9.8871E-1,&
     & 9.9344E-1, 9.9569E-1, 9.9611E-1, 9.9645E-1, 9.9655E-1, 9.9662E-1,&
     & 9.9667E-1, 9.3188E-1, 9.4556E-1, 9.5361E-1, 9.6021E-1, 9.6509E-1,&
     & 9.6890E-1, 9.7256E-1, 9.7395E-1, 9.7518E-1, 9.7600E-1, 9.7654E-1,&
     & 9.7685E-1, 9.7721E-1, 9.7746E-1, 9.7768E-1, 9.7770E-1, 9.7918E-1,&
     & 9.8002E-1, 9.8190E-1, 9.8708E-1, 9.9239E-1, 9.9494E-1, 9.9542E-1,&
     & 9.9581E-1, 9.9592E-1, 9.9601E-1, 9.9607E-1, 9.3213E-1, 9.4385E-1,&
     & 9.5093E-1, 9.5825E-1, 9.6362E-1, 9.6704E-1, 9.7095E-1, 9.7238E-1,&
     & 9.7365E-1, 9.7453E-1, 9.7510E-1, 9.7543E-1, 9.7580E-1, 9.7606E-1,&
     & 9.7629E-1, 9.7632E-1, 9.7787E-1, 9.7875E-1, 9.8072E-1, 9.8617E-1,&
     & 9.9179E-1, 9.9450E-1, 9.9501E-1, 9.9543E-1, 9.9556E-1/           
      DATA X1301/ 9.9565E-1, 9.9571E-1, 9.1797E-1, 9.4312E-1, 9.4629E-1,&
     & 9.5483E-1, 9.5972E-1, 9.6387E-1, 9.6855E-1, 9.6985E-1, 9.7119E-1,&
     & 9.7212E-1, 9.7273E-1, 9.7309E-1, 9.7349E-1, 9.7377E-1, 9.7402E-1,&
     & 9.7404E-1, 9.7570E-1, 9.7664E-1, 9.7876E-1, 9.8462E-1, 9.9073E-1,&
     & 9.9371E-1, 9.9428E-1, 9.9474E-1, 9.9488E-1, 9.9499E-1, 9.9506E-1,&
     & 7.5000E-1, 8.0469E-1, 8.6328E-1, 9.0234E-1, 9.3359E-1, 9.4922E-1,&
     & 9.5825E-1, 9.6387E-1, 9.6753E-1, 9.6948E-1, 9.7054E-1, 9.7105E-1,&
     & 9.7166E-1, 9.7197E-1, 9.7223E-1, 9.7225E-1, 9.7398E-1, 9.7497E-1,&
     & 9.7718E-1, 9.8334E-1, 9.8982E-1, 9.9301E-1, 9.9362E-1, 9.9412E-1,&
     & 9.9428E-1, 9.9440E-1, 9.9448E-1, 9.5047E-1, 9.6155E-1, 9.6225E-1,&
     & 9.5978E-1, 9.6124E-1, 9.6271E-1, 9.6479E-1, 9.6617E-1, 9.6704E-1,&
     & 9.6783E-1, 9.6836E-1, 9.6866E-1, 9.6904E-1, 9.6930E-1, 9.6955E-1,&
     & 9.6958E-1, 9.7138E-1, 9.7242E-1, 9.7474E-1, 9.8129E-1, 9.8829E-1,&
     & 9.9179E-1, 9.9247E-1, 9.9304E-1, 9.9322E-1, 9.9335E-1, 9.9345E-1,&
     & 9.5016E-1, 9.6346E-1, 9.5972E-1, 9.5944E-1, 9.6060E-1, 9.6230E-1,&
     & 9.6438E-1, 9.6607E-1, 9.6677E-1, 9.6756E-1, 9.6810E-1, 9.6841E-1,&
     & 9.6879E-1, 9.6905E-1, 9.6930E-1, 9.6933E-1, 9.7114E-1/           
      DATA X1401/ 9.7218E-1, 9.7451E-1, 9.8109E-1, 9.8813E-1, 9.9166E-1,&
     & 9.9235E-1, 9.9292E-1, 9.9311E-1, 9.9324E-1, 9.9334E-1, 1.8959E+0,&
     & 1.5421E+0, 1.3473E+0, 1.2013E+0, 1.1099E+0, 1.0508E+0, 9.9865E-1,&
     & 9.8404E-1, 9.7366E-1, 9.6802E-1, 9.6521E-1, 9.6388E-1, 9.6270E-1,&
     & 9.6207E-1, 9.6167E-1, 9.6164E-1, 9.6343E-1, 9.6444E-1, 9.6676E-1,&
     & 9.7367E-1, 9.8173E-1, 9.8610E-1, 9.8700E-1, 9.8780E-1, 9.8808E-1,&
     & 9.8830E-1, 9.8847E-1,-5.3750E+0,-2.9023E+0,-1.5938E+0,-5.9766E-1,&
     & 1.5625E-2, 4.1406E-1, 7.4536E-1, 8.3911E-1, 9.0039E-1, 9.3213E-1,&
     & 9.4647E-1, 9.5247E-1, 9.5703E-1, 9.5862E-1, 9.5890E-1, 9.5886E-1,&
     & 9.6055E-1, 9.6151E-1, 9.6374E-1, 9.7055E-1, 9.7880E-1, 9.8340E-1,&
     & 9.8437E-1, 9.8526E-1, 9.8558E-1, 9.8584E-1, 9.8603E-1, 9.8950E-1,&
     & 9.6558E-1, 9.5483E-1, 9.4995E-1, 9.4775E-1, 9.4751E-1, 9.4923E-1,&
     & 9.5053E-1, 9.5200E-1, 9.5330E-1, 9.5425E-1, 9.5485E-1, 9.5559E-1,&
     & 9.5614E-1, 9.5641E-1, 9.5637E-1, 9.5800E-1, 9.5893E-1, 9.6110E-1,&
     & 9.6786E-1, 9.7627E-1, 9.8104E-1, 9.8206E-1, 9.8301E-1, 9.8337E-1,&
     & 9.8366E-1, 9.8388E-1, 1.1157E+0, 1.0405E+0, 1.0039E+0, 9.7803E-1,&
     & 9.6346E-1, 9.5508E-1, 9.4998E-1, 9.4952E-1, 9.4988E-1/           
      DATA X1501/ 9.5067E-1, 9.5142E-1, 9.5197E-1, 9.5270E-1, 9.5325E-1,&
     & 9.5351E-1, 9.5347E-1, 9.5506E-1, 9.5598E-1, 9.5813E-1, 9.6493E-1,&
     & 9.7355E-1, 9.7847E-1, 9.7953E-1, 9.8055E-1, 9.8095E-1, 9.8127E-1,&
     & 9.8153E-1, 9.3332E-1, 9.3275E-1, 9.3343E-1, 9.3483E-1, 9.3635E-1,&
     & 9.3793E-1, 9.4023E-1, 9.4129E-1, 9.4231E-1, 9.4323E-1, 9.4401E-1,&
     & 9.4458E-1, 9.4533E-1, 9.4590E-1, 9.4617E-1, 9.4613E-1, 9.4779E-1,&
     & 9.4875E-1, 9.5103E-1, 9.5829E-1, 9.6753E-1, 9.7278E-1, 9.7392E-1,&
     & 9.7507E-1, 9.7555E-1, 9.7595E-1, 9.7627E-1, 9.0692E-1, 9.1547E-1,&
     & 9.2053E-1, 9.2504E-1, 9.2840E-1, 9.3104E-1, 9.3409E-1, 9.3528E-1,&
     & 9.3641E-1, 9.3742E-1, 9.3826E-1, 9.3886E-1, 9.3966E-1, 9.4025E-1,&
     & 9.4055E-1, 9.4051E-1, 9.4232E-1, 9.4338E-1, 9.4585E-1, 9.5370E-1,&
     & 9.6350E-1, 9.6894E-1, 9.7012E-1, 9.7133E-1, 9.7186E-1, 9.7232E-1,&
     & 9.7268E-1, 9.0344E-1, 9.1055E-1, 9.1508E-1, 9.1943E-1, 9.2286E-1,&
     & 9.2570E-1, 9.2918E-1, 9.3051E-1, 9.3178E-1, 9.3288E-1, 9.3378E-1,&
     & 9.3442E-1, 9.3526E-1, 9.3589E-1, 9.3621E-1, 9.3617E-1, 9.3816E-1,&
     & 9.3930E-1, 9.4199E-1, 9.5039E-1, 9.6067E-1, 9.6622E-1, 9.6741E-1,&
     & 9.6866E-1, 9.6922E-1, 9.6971E-1, 9.7011E-1, 9.0326E-1/           
      DATA X1601/ 9.0772E-1, 9.1134E-1, 9.1535E-1, 9.1889E-1, 9.2208E-1,&
     & 9.2592E-1, 9.2739E-1, 9.2876E-1, 9.2995E-1, 9.3090E-1, 9.3157E-1,&
     & 9.3245E-1, 9.3310E-1, 9.3345E-1, 9.3341E-1, 9.3553E-1, 9.3675E-1,&
     & 9.3961E-1, 9.4844E-1, 9.5906E-1, 9.6466E-1, 9.6583E-1, 9.6708E-1,&
     & 9.6766E-1, 9.6816E-1, 9.6858E-1, 8.8577E-1, 8.9604E-1, 9.0248E-1,&
     & 9.0849E-1, 9.1314E-1, 9.1710E-1, 9.2172E-1, 9.2346E-1, 9.2506E-1,&
     & 9.2641E-1, 9.2748E-1, 9.2821E-1, 9.2917E-1, 9.2988E-1, 9.3026E-1,&
     & 9.3023E-1, 9.3263E-1, 9.3400E-1, 9.3720E-1, 9.4688E-1, 9.5805E-1,&
     & 9.6357E-1, 9.6466E-1, 9.6581E-1, 9.6637E-1, 9.6687E-1, 9.6729E-1,&
     & 8.7110E-1, 8.9032E-1, 8.9994E-1, 9.0705E-1, 9.1238E-1, 9.1682E-1,&
     & 9.2192E-1, 9.2382E-1, 9.2556E-1, 9.2701E-1, 9.2814E-1, 9.2891E-1,&
     & 9.2992E-1, 9.3066E-1, 9.3107E-1, 9.3104E-1, 9.3360E-1, 9.3507E-1,&
     & 9.3846E-1, 9.4859E-1, 9.5998E-1, 9.6527E-1, 9.6622E-1, 9.6720E-1,&
     & 9.6769E-1, 9.6815E-1, 9.6853E-1, 8.6994E-1, 8.9754E-1, 9.0995E-1,&
     & 9.1908E-1, 9.2567E-1, 9.3095E-1, 9.3688E-1, 9.3906E-1, 9.4104E-1,&
     & 9.4266E-1, 9.4391E-1, 9.4476E-1, 9.4585E-1, 9.4666E-1, 9.4712E-1,&
     & 9.4708E-1, 9.4991E-1, 9.5152E-1, 9.5521E-1, 9.6592E-1/           
      DATA X1701/ 9.7703E-1, 9.8100E-1, 9.8128E-1, 9.8131E-1, 9.8137E-1,&
     & 9.8149E-1, 9.8162E-1, 8.9574E-1, 9.2581E-1, 9.3954E-1, 9.4955E-1,&
     & 9.5665E-1, 9.6227E-1, 9.6851E-1, 9.7079E-1, 9.7284E-1, 9.7452E-1,&
     & 9.7582E-1, 9.7670E-1, 9.7784E-1, 9.7868E-1, 9.7915E-1, 9.7911E-1,&
     & 9.8201E-1, 9.8365E-1, 9.8737E-1, 9.9791E-1, 1.0078E+0, 1.0096E+0,&
     & 1.0088E+0, 1.0072E+0, 1.0066E+0, 1.0061E+0, 1.0057E+0, 9.3779E-1,&
     & 9.6888E-1, 9.8307E-1, 9.9329E-1, 1.0005E+0, 1.0061E+0, 1.0124E+0,&
     & 1.0146E+0, 1.0166E+0, 1.0183E+0, 1.0196E+0, 1.0205E+0, 1.0217E+0,&
     & 1.0225E+0, 1.0230E+0, 1.0229E+0, 1.0258E+0, 1.0274E+0, 1.0310E+0,&
     & 1.0408E+0, 1.0487E+0, 1.0475E+0, 1.0453E+0, 1.0416E+0, 1.0399E+0,&
     & 1.0386E+0, 1.0376E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9930E-1,&
     & 9.9949E-1, 9.9958E-1, 9.9965E-1, 9.9970E-1, 9.9973E-1, 9.9977E-1,&
     & 9.9978E-1, 9.9979E-1, 9.9980E-1, 9.9980E-1, 9.9980E-1/           
      DATA X1801/ 9.9981E-1, 9.9981E-1, 9.9981E-1, 9.9981E-1, 9.9983E-1,&
     & 9.9983E-1, 9.9985E-1, 9.9990E-1, 9.9995E-1, 9.9997E-1, 9.9997E-1,&
     & 9.9997E-1, 9.9997E-1, 9.9996E-1, 9.9996E-1, 9.9398E-1, 9.9556E-1,&
     & 9.9638E-1, 9.9700E-1, 9.9740E-1, 9.9768E-1, 9.9798E-1, 9.9809E-1,&
     & 9.9818E-1, 9.9824E-1, 9.9828E-1, 9.9831E-1, 9.9834E-1, 9.9836E-1,&
     & 9.9837E-1, 9.9837E-1, 9.9849E-1, 9.9856E-1, 9.9871E-1, 9.9914E-1,&
     & 9.9959E-1, 9.9976E-1, 9.9976E-1, 9.9972E-1, 9.9970E-1, 9.9968E-1,&
     & 9.9967E-1, 9.8600E-1, 9.8953E-1, 9.9140E-1, 9.9288E-1, 9.9384E-1,&
     & 9.9451E-1, 9.9522E-1, 9.9547E-1, 9.9569E-1, 9.9584E-1, 9.9594E-1,&
     & 9.9600E-1, 9.9606E-1, 9.9611E-1, 9.9615E-1, 9.9615E-1, 9.9643E-1,&
     & 9.9659E-1, 9.9694E-1, 9.9796E-1, 9.9902E-1, 9.9942E-1, 9.9942E-1,&
     & 9.9934E-1, 9.9928E-1, 9.9924E-1, 9.9921E-1, 9.6773E-1, 9.7552E-1,&
     & 9.7974E-1, 9.8315E-1, 9.8543E-1, 9.8704E-1, 9.8871E-1, 9.8931E-1,&
     & 9.8982E-1, 9.9019E-1, 9.9042E-1, 9.9056E-1, 9.9071E-1, 9.9082E-1,&
     & 9.9092E-1, 9.9093E-1, 9.9158E-1, 9.9195E-1, 9.9280E-1, 9.9518E-1,&
     & 9.9767E-1, 9.9861E-1, 9.9861E-1, 9.9842E-1, 9.9829E-1, 9.9819E-1,&
     & 9.9812E-1, 9.5110E-1, 9.6240E-1, 9.6859E-1, 9.7372E-1/           
      DATA X1901/ 9.7721E-1, 9.7973E-1, 9.8236E-1, 9.8331E-1, 9.8411E-1,&
     & 9.8468E-1, 9.8504E-1, 9.8526E-1, 9.8550E-1, 9.8567E-1, 9.8582E-1,&
     & 9.8584E-1, 9.8686E-1, 9.8744E-1, 9.8876E-1, 9.9248E-1, 9.9635E-1,&
     & 9.9779E-1, 9.9780E-1, 9.9749E-1, 9.9729E-1, 9.9714E-1, 9.9703E-1,&
     & 9.2566E-1, 9.4225E-1, 9.5142E-1, 9.5910E-1, 9.6441E-1, 9.6830E-1,&
     & 9.7244E-1, 9.7393E-1, 9.7518E-1, 9.7608E-1, 9.7665E-1, 9.7698E-1,&
     & 9.7736E-1, 9.7763E-1, 9.7787E-1, 9.7789E-1, 9.7948E-1, 9.8040E-1,&
     & 9.8246E-1, 9.8825E-1, 9.9426E-1, 9.9647E-1, 9.9647E-1, 9.9598E-1,&
     & 9.9567E-1, 9.9543E-1, 9.9527E-1, 8.8496E-1, 9.0962E-1, 9.2358E-1,&
     & 9.3544E-1, 9.4365E-1, 9.4974E-1, 9.5627E-1, 9.5864E-1, 9.6065E-1,&
     & 9.6207E-1, 9.6298E-1, 9.6351E-1, 9.6411E-1, 9.6454E-1, 9.6492E-1,&
     & 9.6496E-1, 9.6748E-1, 9.6894E-1, 9.7220E-1, 9.8134E-1, 9.9073E-1,&
     & 9.9413E-1, 9.9410E-1, 9.9331E-1, 9.9283E-1, 9.9246E-1, 9.9220E-1,&
     & 8.6597E-1, 8.9479E-1, 9.1061E-1, 9.2418E-1, 9.3361E-1, 9.4068E-1,&
     & 9.4830E-1, 9.5109E-1, 9.5346E-1, 9.5514E-1, 9.5622E-1, 9.5685E-1,&
     & 9.5757E-1, 9.5807E-1, 9.5851E-1, 9.5856E-1, 9.6155E-1, 9.6326E-1,&
     & 9.6712E-1, 9.7788E-1, 9.8892E-1, 9.9287E-1, 9.9282E-1/           
      DATA X2001/ 9.9187E-1, 9.9131E-1, 9.9088E-1, 9.9058E-1, 8.3862E-1,&
     & 8.7280E-1, 8.9209E-1, 9.0869E-1, 9.1969E-1, 9.2815E-1, 9.3734E-1,&
     & 9.4069E-1, 9.4357E-1, 9.4560E-1, 9.4690E-1, 9.4766E-1, 9.4853E-1,&
     & 9.4914E-1, 9.4968E-1, 9.4974E-1, 9.5335E-1, 9.5543E-1, 9.6008E-1,&
     & 9.7306E-1, 9.8631E-1, 9.9098E-1, 9.9090E-1, 9.8974E-1, 9.8906E-1,&
     & 9.8854E-1, 9.8818E-1, 8.2031E-1, 8.5645E-1, 8.7744E-1, 8.9575E-1,&
     & 9.0875E-1, 9.1794E-1, 9.2821E-1, 9.3203E-1, 9.3528E-1, 9.3761E-1,&
     & 9.3910E-1, 9.3997E-1, 9.4096E-1, 9.4166E-1, 9.4227E-1, 9.4234E-1,&
     & 9.4647E-1, 9.4884E-1, 9.5415E-1, 9.6895E-1, 9.8400E-1, 9.8924E-1,&
     & 9.8912E-1, 9.8778E-1, 9.8700E-1, 9.8641E-1, 9.8602E-1, 7.9419E-1,&
     & 8.3667E-1, 8.6060E-1, 8.8086E-1, 8.9526E-1, 9.0622E-1, 9.1788E-1,&
     & 9.2220E-1, 9.2595E-1, 9.2857E-1, 9.3027E-1, 9.3126E-1, 9.3239E-1,&
     & 9.3318E-1, 9.3388E-1, 9.3395E-1, 9.3865E-1, 9.4134E-1, 9.4738E-1,&
     & 9.6418E-1, 9.8121E-1, 9.8706E-1, 9.8689E-1, 9.8533E-1, 9.8445E-1,&
     & 9.8378E-1, 9.8334E-1, 7.8394E-1, 8.2690E-1, 8.5083E-1, 8.7280E-1,&
     & 8.8818E-1, 8.9966E-1, 9.1219E-1, 9.1679E-1, 9.2075E-1, 9.2357E-1,&
     & 9.2537E-1, 9.2643E-1, 9.2763E-1, 9.2847E-1, 9.2922E-1/           
      DATA X2101/ 9.2930E-1, 9.3430E-1, 9.3717E-1, 9.4360E-1, 9.6147E-1,&
     & 9.7956E-1, 9.8573E-1, 9.8552E-1, 9.8385E-1, 9.8291E-1, 9.8220E-1,&
     & 9.8173E-1, 7.6172E-1, 8.1787E-1, 8.3716E-1, 8.6084E-1, 8.7720E-1,&
     & 8.8940E-1, 9.0326E-1, 9.0782E-1, 9.1211E-1, 9.1517E-1, 9.1713E-1,&
     & 9.1829E-1, 9.1961E-1, 9.2054E-1, 9.2136E-1, 9.2144E-1, 9.2693E-1,&
     & 9.3008E-1, 9.3714E-1, 9.5677E-1, 9.7659E-1, 9.8326E-1, 9.8298E-1,&
     & 9.8111E-1, 9.8007E-1, 9.7930E-1, 9.7879E-1, 6.8750E-1, 7.2266E-1,&
     & 7.7734E-1, 8.2422E-1, 8.5156E-1, 8.7500E-1, 8.9063E-1, 8.9844E-1,&
     & 9.0405E-1, 9.0796E-1, 9.1023E-1, 9.1154E-1, 9.1304E-1, 9.1405E-1,&
     & 9.1493E-1, 9.1502E-1, 9.2088E-1, 9.2424E-1, 9.3179E-1, 9.5277E-1,&
     & 9.7394E-1, 9.8097E-1, 9.8064E-1, 9.7859E-1, 9.7748E-1, 9.7666E-1,&
     & 9.7613E-1, 7.3543E-1, 7.9662E-1, 8.1664E-1, 8.4058E-1, 8.5683E-1,&
     & 8.6975E-1, 8.8395E-1, 8.8974E-1, 8.9441E-1, 8.9788E-1, 9.0009E-1,&
     & 9.0139E-1, 9.0291E-1, 9.0395E-1, 9.0489E-1, 9.0499E-1, 9.1136E-1,&
     & 9.1503E-1, 9.2324E-1, 9.4616E-1, 9.6927E-1, 9.7681E-1, 9.7636E-1,&
     & 9.7407E-1, 9.7284E-1, 9.7196E-1, 9.7139E-1, 7.3534E-1, 7.9245E-1,&
     & 8.1944E-1, 8.3925E-1, 8.5567E-1, 8.6871E-1, 8.8274E-1/           
      DATA X2201/ 8.8889E-1, 8.9339E-1, 8.9687E-1, 8.9910E-1, 9.0041E-1,&
     & 9.0192E-1, 9.0298E-1, 9.0393E-1, 9.0403E-1, 9.1045E-1, 9.1414E-1,&
     & 9.2242E-1, 9.4550E-1, 9.6878E-1, 9.7636E-1, 9.7591E-1, 9.7359E-1,&
     & 9.7236E-1, 9.7147E-1, 9.7089E-1, 3.8510E+0, 2.6936E+0, 2.0907E+0,&
     & 1.6248E+0, 1.3362E+0, 1.1493E+0, 9.8504E-1, 9.3888E-1, 9.0700E-1,&
     & 8.8964E-1, 8.8115E-1, 8.7721E-1, 8.7375E-1, 8.7201E-1, 8.7098E-1,&
     & 8.7089E-1, 8.7830E-1, 8.8248E-1, 8.9194E-1, 9.1887E-1, 9.4650E-1,&
     & 9.5512E-1, 9.5439E-1, 9.5156E-1, 9.5020E-1, 9.4928E-1, 9.4874E-1,&
     &-2.0375E+1,-1.2012E+1,-7.6758E+0,-4.3555E+0,-2.3047E+0,-9.8438E-1,&
     & 1.4233E-1, 4.5337E-1, 6.5918E-1, 7.6587E-1, 8.1439E-1, 8.3476E-1,&
     & 8.5033E-1, 8.5598E-1, 8.5719E-1, 8.5710E-1, 8.6460E-1, 8.6885E-1,&
     & 8.7850E-1, 9.0625E-1, 9.3503E-1, 9.4409E-1, 9.4342E-1, 9.4074E-1,&
     & 9.3948E-1, 9.3867E-1, 9.3823E-1, 8.5986E-1, 8.1299E-1, 7.9614E-1,&
     & 7.9053E-1, 7.9272E-1, 7.9886E-1, 8.1126E-1, 8.1808E-1, 8.2513E-1,&
     & 8.3095E-1, 8.3508E-1, 8.3765E-1, 8.4075E-1, 8.4302E-1, 8.4426E-1,&
     & 8.4417E-1, 8.5184E-1, 8.5619E-1, 8.6611E-1, 8.9476E-1, 9.2466E-1,&
     & 9.3429E-1, 9.3381E-1, 9.3140E-1, 9.3031E-1, 9.2965E-1/           
      DATA X2301/ 9.2933E-1, 1.2959E+0, 1.0664E+0, 9.5605E-1, 8.7939E-1,&
     & 8.3806E-1, 8.1654E-1, 8.0664E-1, 8.0776E-1, 8.1137E-1, 8.1570E-1,&
     & 8.1936E-1, 8.2185E-1, 8.2506E-1, 8.2742E-1, 8.2872E-1, 8.2863E-1,&
     & 8.3666E-1, 8.4123E-1, 8.5164E-1, 8.8172E-1, 9.1314E-1, 9.2366E-1,&
     & 9.2347E-1, 9.2153E-1, 9.2066E-1, 9.2019E-1, 9.2001E-1, 5.7751E-1,&
     & 6.3118E-1, 6.6370E-1, 6.9316E-1, 7.1522E-1, 7.3272E-1, 7.5318E-1,&
     & 7.6120E-1, 7.6832E-1, 7.7402E-1, 7.7830E-1, 7.8115E-1, 7.8479E-1,&
     & 7.8743E-1, 7.8897E-1, 7.8890E-1, 7.9850E-1, 8.0393E-1, 8.1623E-1,&
     & 8.5116E-1, 8.8714E-1, 9.0036E-1, 9.0115E-1, 9.0057E-1, 9.0034E-1,&
     & 9.0037E-1, 9.0055E-1, 3.9868E-1, 5.1366E-1, 5.7708E-1, 6.2966E-1,&
     & 6.6561E-1, 6.9168E-1, 7.1898E-1, 7.2861E-1, 7.3705E-1, 7.4362E-1,&
     & 7.4843E-1, 7.5158E-1, 7.5553E-1, 7.5840E-1, 7.6015E-1, 7.6011E-1,&
     & 7.7108E-1, 7.7728E-1, 7.9119E-1, 8.2998E-1, 8.6933E-1, 8.8467E-1,&
     & 8.8627E-1, 8.8679E-1, 8.8703E-1, 8.8743E-1, 8.8787E-1, 3.0308E-1,&
     & 4.4829E-1, 5.2709E-1, 5.9125E-1, 6.3419E-1, 6.6460E-1, 6.9542E-1,&
     & 7.0617E-1, 7.1549E-1, 7.2263E-1, 7.2775E-1, 7.3107E-1, 7.3520E-1,&
     & 7.3817E-1, 7.4006E-1, 7.4004E-1, 7.5191E-1, 7.5859E-1/           
      DATA X2401/ 7.7352E-1, 8.1469E-1, 8.5611E-1, 8.7293E-1, 8.7514E-1,&
     & 8.7651E-1, 8.7712E-1, 8.7778E-1, 8.7841E-1, 2.2260E-1, 4.0127E-1,&
     & 4.9553E-1, 5.6988E-1, 6.1768E-1, 6.4999E-1, 6.8242E-1, 6.9368E-1,&
     & 7.0338E-1, 7.1076E-1, 7.1599E-1, 7.1936E-1, 7.2352E-1, 7.2652E-1,&
     & 7.2845E-1, 7.2845E-1, 7.4069E-1, 7.4759E-1, 7.6294E-1, 8.0505E-1,&
     & 8.4734E-1, 8.6499E-1, 8.6759E-1, 8.6952E-1, 8.7036E-1, 8.7121E-1,&
     & 8.7196E-1, 1.0610E-1, 3.5066E-1, 4.7042E-1, 5.5650E-1, 6.0481E-1,&
     & 6.3728E-1, 6.6975E-1, 6.8102E-1, 6.9068E-1, 6.9795E-1, 7.0305E-1,&
     & 7.0629E-1, 7.1028E-1, 7.1314E-1, 7.1505E-1, 7.1507E-1, 7.2719E-1,&
     & 7.3402E-1, 7.4923E-1, 7.9088E-1, 8.3290E-1, 8.5130E-1, 8.5446E-1,&
     & 8.5725E-1, 8.5848E-1, 8.5960E-1, 8.6055E-1, 1.7036E-2, 3.4493E-1,&
     & 4.8413E-1, 5.6336E-1, 6.0857E-1, 6.3916E-1, 6.6992E-1, 6.8062E-1,&
     & 6.8981E-1, 6.9671E-1, 7.0153E-1, 7.0458E-1, 7.0833E-1, 7.1102E-1,&
     & 7.1283E-1, 7.1286E-1, 7.2443E-1, 7.3095E-1, 7.4550E-1, 7.8547E-1,&
     & 8.2613E-1, 8.4438E-1, 8.4772E-1, 8.5085E-1, 8.5224E-1, 8.5348E-1,&
     & 8.5451E-1, 1.0462E-1, 4.3642E-1, 5.3432E-1, 5.9497E-1, 6.3113E-1,&
     & 6.5616E-1, 6.8175E-1, 6.9075E-1, 6.9850E-1, 7.0433E-1/           
      DATA X2501/ 7.0840E-1, 7.1097E-1, 7.1412E-1, 7.1638E-1, 7.1793E-1,&
     & 7.1796E-1, 7.2785E-1, 7.3346E-1, 7.4601E-1, 7.8090E-1, 8.1706E-1,&
     & 8.3392E-1, 8.3727E-1, 8.4067E-1, 8.4222E-1, 8.4358E-1, 8.4469E-1,&
     & 2.4634E-1, 4.8547E-1, 5.6472E-1, 6.1587E-1, 6.4709E-1, 6.6899E-1,&
     & 6.9158E-1, 6.9959E-1, 7.0650E-1, 7.1170E-1, 7.1533E-1, 7.1763E-1,&
     & 7.2045E-1, 7.2248E-1, 7.2386E-1, 7.2389E-1, 7.3278E-1, 7.3783E-1,&
     & 7.4917E-1, 7.8089E-1, 8.1406E-1, 8.2974E-1, 8.3294E-1, 8.3631E-1,&
     & 8.3786E-1, 8.3924E-1, 8.4036E-1, 3.0569E-1, 5.0915E-1, 5.8013E-1,&
     & 6.2684E-1, 6.5567E-1, 6.7602E-1, 6.9712E-1, 7.0462E-1, 7.1110E-1,&
     & 7.1599E-1, 7.1940E-1, 7.2157E-1, 7.2422E-1, 7.2613E-1, 7.2743E-1,&
     & 7.2746E-1, 7.3584E-1, 7.4060E-1, 7.5131E-1, 7.8136E-1, 8.1293E-1,&
     & 8.2792E-1, 8.3101E-1, 8.3431E-1, 8.3585E-1, 8.3722E-1, 8.3833E-1,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0042E+0, 1.0035E+0/           
      DATA X2601/ 1.0029E+0, 1.0024E+0, 1.0021E+0, 1.0018E+0, 1.0016E+0,&
     & 1.0015E+0, 1.0014E+0, 1.0014E+0, 1.0013E+0, 1.0013E+0, 1.0013E+0,&
     & 1.0013E+0, 1.0013E+0, 1.0013E+0, 1.0012E+0, 1.0011E+0, 1.0010E+0,&
     & 1.0006E+0, 1.0003E+0, 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0388E+0, 1.0298E+0, 1.0248E+0, 1.0206E+0,&
     & 1.0178E+0, 1.0158E+0, 1.0137E+0, 1.0129E+0, 1.0123E+0, 1.0118E+0,&
     & 1.0115E+0, 1.0114E+0, 1.0112E+0, 1.0110E+0, 1.0109E+0, 1.0109E+0,&
     & 1.0101E+0, 1.0096E+0, 1.0085E+0, 1.0055E+0, 1.0022E+0, 1.0006E+0,&
     & 1.0003E+0, 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0929E+0,&
     & 1.0705E+0, 1.0583E+0, 1.0484E+0, 1.0419E+0, 1.0371E+0, 1.0322E+0,&
     & 1.0304E+0, 1.0289E+0, 1.0278E+0, 1.0271E+0, 1.0267E+0, 1.0262E+0,&
     & 1.0259E+0, 1.0256E+0, 1.0256E+0, 1.0236E+0, 1.0225E+0, 1.0200E+0,&
     & 1.0128E+0, 1.0051E+0, 1.0013E+0, 1.0006E+0, 1.0002E+0, 1.0001E+0,&
     & 1.0000E+0, 1.0000E+0, 1.2145E+0, 1.1632E+0, 1.1352E+0, 1.1124E+0,&
     & 1.0970E+0, 1.0860E+0, 1.0745E+0, 1.0704E+0, 1.0669E+0, 1.0644E+0,&
     & 1.0627E+0, 1.0618E+0, 1.0607E+0, 1.0600E+0, 1.0593E+0, 1.0592E+0,&
     & 1.0547E+0, 1.0521E+0, 1.0463E+0, 1.0298E+0, 1.0119E+0/           
      DATA X2701/ 1.0031E+0, 1.0015E+0, 1.0004E+0, 1.0002E+0, 1.0001E+0,&
     & 1.0000E+0, 1.3215E+0, 1.2472E+0, 1.2061E+0, 1.1721E+0, 1.1488E+0,&
     & 1.1320E+0, 1.1143E+0, 1.1079E+0, 1.1025E+0, 1.0987E+0, 1.0962E+0,&
     & 1.0948E+0, 1.0931E+0, 1.0920E+0, 1.0909E+0, 1.0908E+0, 1.0839E+0,&
     & 1.0800E+0, 1.0710E+0, 1.0458E+0, 1.0184E+0, 1.0048E+0, 1.0023E+0,&
     & 1.0006E+0, 1.0003E+0, 1.0001E+0, 1.0001E+0, 1.4748E+0, 1.3686E+0,&
     & 1.3093E+0, 1.2597E+0, 1.2253E+0, 1.2001E+0, 1.1733E+0, 1.1636E+0,&
     & 1.1554E+0, 1.1496E+0, 1.1459E+0, 1.1437E+0, 1.1412E+0, 1.1395E+0,&
     & 1.1379E+0, 1.1377E+0, 1.1273E+0, 1.1213E+0, 1.1078E+0, 1.0696E+0,&
     & 1.0280E+0, 1.0073E+0, 1.0035E+0, 1.0009E+0, 1.0004E+0, 1.0002E+0,&
     & 1.0001E+0, 1.6957E+0, 1.5443E+0, 1.4593E+0, 1.3878E+0, 1.3378E+0,&
     & 1.3008E+0, 1.2609E+0, 1.2464E+0, 1.2341E+0, 1.2254E+0, 1.2198E+0,&
     & 1.2166E+0, 1.2128E+0, 1.2102E+0, 1.2079E+0, 1.2076E+0, 1.1921E+0,&
     & 1.1831E+0, 1.1629E+0, 1.1056E+0, 1.0428E+0, 1.0112E+0, 1.0053E+0,&
     & 1.0014E+0, 1.0006E+0, 1.0003E+0, 1.0001E+0, 1.7842E+0, 1.6175E+0,&
     & 1.5232E+0, 1.4433E+0, 1.3871E+0, 1.3454E+0, 1.3001E+0, 1.2836E+0,&
     & 1.2694E+0, 1.2594E+0, 1.2530E+0, 1.2493E+0, 1.2450E+0/           
      DATA X2801/ 1.2420E+0, 1.2394E+0, 1.2391E+0, 1.2212E+0, 1.2109E+0,&
     & 1.1878E+0, 1.1220E+0, 1.0497E+0, 1.0130E+0, 1.0061E+0, 1.0016E+0,&
     & 1.0007E+0, 1.0003E+0, 1.0001E+0, 1.8926E+0, 1.7073E+0, 1.6016E+0,&
     & 1.5119E+0, 1.4483E+0, 1.4009E+0, 1.3492E+0, 1.3302E+0, 1.3139E+0,&
     & 1.3023E+0, 1.2949E+0, 1.2906E+0, 1.2856E+0, 1.2822E+0, 1.2791E+0,&
     & 1.2788E+0, 1.2581E+0, 1.2462E+0, 1.2194E+0, 1.1432E+0, 1.0587E+0,&
     & 1.0153E+0, 1.0072E+0, 1.0018E+0, 1.0008E+0, 1.0003E+0, 1.0001E+0,&
     & 1.9780E+0, 1.7734E+0, 1.6592E+0, 1.5620E+0, 1.4939E+0, 1.4423E+0,&
     & 1.3857E+0, 1.3648E+0, 1.3470E+0, 1.3344E+0, 1.3263E+0, 1.3215E+0,&
     & 1.3161E+0, 1.3123E+0, 1.3089E+0, 1.3085E+0, 1.2859E+0, 1.2729E+0,&
     & 1.2434E+0, 1.1595E+0, 1.0659E+0, 1.0172E+0, 1.0081E+0, 1.0020E+0,&
     & 1.0008E+0, 1.0003E+0, 1.0001E+0, 2.0466E+0, 1.8333E+0, 1.7124E+0,&
     & 1.6089E+0, 1.5361E+0, 1.4812E+0, 1.4210E+0, 1.3987E+0, 1.3796E+0,&
     & 1.3659E+0, 1.3571E+0, 1.3520E+0, 1.3462E+0, 1.3420E+0, 1.3384E+0,&
     & 1.3380E+0, 1.3135E+0, 1.2994E+0, 1.2676E+0, 1.1763E+0, 1.0734E+0,&
     & 1.0193E+0, 1.0090E+0, 1.0022E+0, 1.0009E+0, 1.0003E+0, 1.0001E+0,&
     & 2.0742E+0, 1.8601E+0, 1.7332E+0, 1.6289E+0, 1.5552E+0/           
      DATA X2901/ 1.4990E+0, 1.4376E+0, 1.4147E+0, 1.3950E+0, 1.3810E+0,&
     & 1.3720E+0, 1.3667E+0, 1.3606E+0, 1.3564E+0, 1.3526E+0, 1.3522E+0,&
     & 1.3270E+0, 1.3124E+0, 1.2794E+0, 1.1848E+0, 1.0774E+0, 1.0203E+0,&
     & 1.0095E+0, 1.0022E+0, 1.0009E+0, 1.0003E+0, 1.0000E+0, 2.1016E+0,&
     & 1.8945E+0, 1.7634E+0, 1.6567E+0, 1.5808E+0, 1.5239E+0, 1.4610E+0,&
     & 1.4370E+0, 1.4167E+0, 1.4022E+0, 1.3928E+0, 1.3874E+0, 1.3811E+0,&
     & 1.3767E+0, 1.3728E+0, 1.3724E+0, 1.3462E+0, 1.3310E+0, 1.2968E+0,&
     & 1.1978E+0, 1.0836E+0, 1.0220E+0, 1.0102E+0, 1.0024E+0, 1.0009E+0,&
     & 1.0002E+0, 9.9997E-1, 2.0000E+0, 1.8750E+0, 1.7383E+0, 1.6523E+0,&
     & 1.5859E+0, 1.5352E+0, 1.4727E+0, 1.4482E+0, 1.4290E+0, 1.4148E+0,&
     & 1.4054E+0, 1.3999E+0, 1.3937E+0, 1.3893E+0, 1.3853E+0, 1.3849E+0,&
     & 1.3584E+0, 1.3430E+0, 1.3082E+0, 1.2069E+0, 1.0883E+0, 1.0233E+0,&
     & 1.0108E+0, 1.0024E+0, 1.0008E+0, 1.0002E+0, 9.9991E-1, 2.1028E+0,&
     & 1.9095E+0, 1.7821E+0, 1.6765E+0, 1.6019E+0, 1.5457E+0, 1.4832E+0,&
     & 1.4607E+0, 1.4405E+0, 1.4260E+0, 1.4168E+0, 1.4113E+0, 1.4051E+0,&
     & 1.4007E+0, 1.3968E+0, 1.3964E+0, 1.3702E+0, 1.3550E+0, 1.3204E+0,&
     & 1.2181E+0, 1.0948E+0, 1.0251E+0, 1.0115E+0, 1.0024E+0/           
      DATA X3001/ 1.0007E+0, 1.0001E+0, 9.9979E-1, 2.1111E+0, 1.9129E+0,&
     & 1.7880E+0, 1.6760E+0, 1.6035E+0, 1.5469E+0, 1.4839E+0, 1.4615E+0,&
     & 1.4411E+0, 1.4265E+0, 1.4173E+0, 1.4118E+0, 1.4056E+0, 1.4012E+0,&
     & 1.3973E+0, 1.3969E+0, 1.3708E+0, 1.3557E+0, 1.3212E+0, 1.2190E+0,&
     & 1.0953E+0, 1.0253E+0, 1.0115E+0, 1.0024E+0, 1.0007E+0, 1.0000E+0,&
     & 9.9977E-1, 1.6821E+0, 1.6036E+0, 1.5482E+0, 1.4987E+0, 1.4631E+0,&
     & 1.4353E+0, 1.4027E+0, 1.3909E+0, 1.3794E+0, 1.3714E+0, 1.3660E+0,&
     & 1.3629E+0, 1.3592E+0, 1.3566E+0, 1.3543E+0, 1.3540E+0, 1.3380E+0,&
     & 1.3283E+0, 1.3049E+0, 1.2254E+0, 1.1066E+0, 1.0281E+0, 1.0120E+0,&
     & 1.0015E+0, 9.9971E-1, 9.9911E-1, 9.9894E-1, 1.3750E+0, 1.3750E+0,&
     & 1.3672E+0, 1.3672E+0, 1.3711E+0, 1.3672E+0, 1.3479E+0, 1.3403E+0,&
     & 1.3354E+0, 1.3315E+0, 1.3284E+0, 1.3266E+0, 1.3244E+0, 1.3228E+0,&
     & 1.3214E+0, 1.3212E+0, 1.3106E+0, 1.3038E+0, 1.2866E+0, 1.2203E+0,&
     & 1.1074E+0, 1.0278E+0, 1.0112E+0, 1.0006E+0, 9.9901E-1, 9.9852E-1,&
     & 9.9845E-1, 1.2617E+0, 1.2908E+0, 1.3030E+0, 1.3115E+0, 1.3147E+0,&
     & 1.3147E+0, 1.3115E+0, 1.3092E+0, 1.3066E+0, 1.3044E+0, 1.3028E+0,&
     & 1.3018E+0, 1.3005E+0, 1.2995E+0, 1.2987E+0, 1.2986E+0/           
      DATA X3101/ 1.2918E+0, 1.2871E+0, 1.2742E+0, 1.2168E+0, 1.1075E+0,&
     & 1.0270E+0, 1.0102E+0, 9.9979E-1, 9.9831E-1, 9.9796E-1, 9.9798E-1,&
     & 1.1030E+0, 1.1804E+0, 1.2205E+0, 1.2500E+0, 1.2676E+0, 1.2773E+0,&
     & 1.2841E+0, 1.2854E+0, 1.2857E+0, 1.2854E+0, 1.2850E+0, 1.2846E+0,&
     & 1.2841E+0, 1.2837E+0, 1.2833E+0, 1.2832E+0, 1.2794E+0, 1.2763E+0,&
     & 1.2665E+0, 1.2153E+0, 1.1074E+0, 1.0258E+0, 1.0089E+0, 9.9876E-1,&
     & 9.9750E-1, 9.9732E-1, 9.9745E-1, 8.7999E-1, 1.0433E+0, 1.1264E+0,&
     & 1.1896E+0, 1.2279E+0, 1.2520E+0, 1.2720E+0, 1.2770E+0, 1.2801E+0,&
     & 1.2816E+0, 1.2822E+0, 1.2824E+0, 1.2826E+0, 1.2826E+0, 1.2826E+0,&
     & 1.2825E+0, 1.2809E+0, 1.2789E+0, 1.2711E+0, 1.2211E+0, 1.1078E+0,&
     & 1.0222E+0, 1.0053E+0, 9.9615E-1, 9.9547E-1, 9.9574E-1, 9.9615E-1,&
     & 8.3438E-1, 1.0316E+0, 1.1308E+0, 1.2047E+0, 1.2486E+0, 1.2753E+0,&
     & 1.2959E+0, 1.3005E+0, 1.3030E+0, 1.3040E+0, 1.3043E+0, 1.3043E+0,&
     & 1.3042E+0, 1.3040E+0, 1.3038E+0, 1.3038E+0, 1.3009E+0, 1.2981E+0,&
     & 1.2883E+0, 1.2311E+0, 1.1082E+0, 1.0190E+0, 1.0023E+0, 9.9404E-1,&
     & 9.9387E-1, 9.9450E-1, 9.9515E-1, 8.3510E-1, 1.0544E+0, 1.1624E+0,&
     & 1.2408E+0, 1.2854E+0, 1.3108E+0, 1.3275E+0, 1.3304E+0/           
      DATA X3201/ 1.3315E+0, 1.3314E+0, 1.3310E+0, 1.3306E+0, 1.3300E+0,&
     & 1.3295E+0, 1.3290E+0, 1.3289E+0, 1.3240E+0, 1.3199E+0, 1.3071E+0,&
     & 1.2409E+0, 1.1083E+0, 1.0161E+0, 9.9953E-1, 9.9221E-1, 9.9249E-1,&
     & 9.9344E-1, 9.9430E-1, 7.1634E-1, 9.7372E-1, 1.1059E+0, 1.2068E+0,&
     & 1.2690E+0, 1.3087E+0, 1.3065E+0, 1.3127E+0, 1.3625E+0, 1.4689E+0,&
     & 1.5134E+0, 1.7208E+0, 1.8720E+0, 1.3972E+0, 1.3462E+0, 1.4240E+0,&
     & 1.3429E+0, 1.3377E+0, 1.3223E+0, 1.2485E+0, 1.1081E+0, 1.0137E+0,&
     & 9.9737E-1, 9.9079E-1, 9.9143E-1, 9.9263E-1, 9.9365E-1, 1.6185E+0,&
     & 1.3614E+0, 1.2907E+0, 1.2936E+0, 1.3449E+0, 1.3758E+0, 1.3636E+0,&
     & 1.3659E+0, 1.4124E+0, 1.5165E+0, 1.5595E+0, 1.7660E+0, 1.9161E+0,&
     & 1.4406E+0, 1.3890E+0, 1.4667E+0, 1.3814E+0, 1.3737E+0, 1.3525E+0,&
     & 1.2625E+0, 1.1067E+0, 1.0084E+0, 9.9279E-1, 9.8786E-1, 9.8925E-1,&
     & 9.9098E-1, 9.9233E-1, 1.7669E+0, 1.4469E+0, 1.3532E+0, 1.3473E+0,&
     & 1.3912E+0, 1.4162E+0, 1.3975E+0, 1.3974E+0, 1.4418E+0, 1.5444E+0,&
     & 1.5864E+0, 1.7924E+0, 1.9419E+0, 1.4659E+0, 1.4139E+0, 1.4916E+0,&
     & 1.4037E+0, 1.3943E+0, 1.3696E+0, 1.2699E+0, 1.1050E+0, 1.0050E+0,&
     & 9.8985E-1, 9.8601E-1, 9.8789E-1, 9.8995E-1, 9.9151E-1/           
      DATA X3301/ 1.6381E+0, 1.5700E+0, 1.4667E+0, 1.4436E+0, 1.4733E+0,&
     & 1.4874E+0, 1.4565E+0, 1.4520E+0, 1.4926E+0, 1.5924E+0, 1.6326E+0,&
     & 1.8376E+0, 1.9859E+0, 1.5091E+0, 1.4563E+0, 1.5339E+0, 1.4412E+0,&
     & 1.4290E+0, 1.3979E+0, 1.2806E+0, 1.1003E+0, 9.9778E-1, 9.8392E-1,&
     & 9.8238E-1, 9.8524E-1, 9.8796E-1, 9.8991E-1, 1.6629E+0, 1.6285E+0,&
     & 1.5205E+0, 1.4890E+0, 1.5118E+0, 1.5205E+0, 1.4837E+0, 1.4770E+0,&
     & 1.5156E+0, 1.6141E+0, 1.6535E+0, 1.8579E+0, 2.0057E+0, 1.5285E+0,&
     & 1.4753E+0, 1.5529E+0, 1.4579E+0, 1.4443E+0, 1.4101E+0, 1.2844E+0,&
     & 1.0969E+0, 9.9376E-1, 9.8068E-1, 9.8044E-1, 9.8382E-1, 9.8689E-1,&
     & 9.8907E-1, 1.6733E+0, 1.6564E+0, 1.5463E+0, 1.5107E+0, 1.5301E+0,&
     & 1.5362E+0, 1.4965E+0, 1.4887E+0, 1.5264E+0, 1.6242E+0, 1.6632E+0,&
     & 1.8674E+0, 2.0149E+0, 1.5375E+0, 1.4842E+0, 1.5617E+0, 1.4656E+0,&
     & 1.4513E+0, 1.4156E+0, 1.2858E+0, 1.0950E+0, 9.9164E-1, 9.7898E-1,&
     & 9.7943E-1, 9.8309E-1, 9.8635E-1, 9.8863E-1, 1.0021E+0, 1.0014E+0,&
     & 1.0011E+0, 1.0009E+0, 1.0007E+0, 1.0006E+0, 1.0005E+0, 1.0005E+0,&
     & 1.0005E+0, 1.0004E+0, 1.0004E+0, 1.0004E+0, 1.0004E+0, 1.0004E+0,&
     & 1.0004E+0, 1.0004E+0, 1.0004E+0, 1.0004E+0, 1.0003E+0/           
      DATA X3401/ 1.0002E+0, 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0078E+0, 1.0051E+0, 1.0039E+0,&
     & 1.0031E+0, 1.0026E+0, 1.0023E+0, 1.0019E+0, 1.0018E+0, 1.0017E+0,&
     & 1.0016E+0, 1.0016E+0, 1.0016E+0, 1.0015E+0, 1.0015E+0, 1.0015E+0,&
     & 1.0015E+0, 1.0014E+0, 1.0013E+0, 1.0011E+0, 1.0007E+0, 1.0003E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0527E+0, 1.0348E+0, 1.0264E+0, 1.0207E+0, 1.0173E+0, 1.0150E+0,&
     & 1.0127E+0, 1.0119E+0, 1.0112E+0, 1.0107E+0, 1.0104E+0, 1.0103E+0,&
     & 1.0101E+0, 1.0099E+0, 1.0098E+0, 1.0098E+0, 1.0090E+0, 1.0085E+0,&
     & 1.0075E+0, 1.0047E+0, 1.0019E+0, 1.0006E+0, 1.0004E+0, 1.0002E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.1268E+0, 1.0859E+0, 1.0655E+0,&
     & 1.0505E+0, 1.0417E+0, 1.0360E+0, 1.0303E+0, 1.0283E+0, 1.0266E+0,&
     & 1.0255E+0, 1.0248E+0, 1.0243E+0, 1.0238E+0, 1.0235E+0, 1.0232E+0,&
     & 1.0232E+0, 1.0212E+0, 1.0201E+0, 1.0176E+0, 1.0110E+0, 1.0044E+0,&
     & 1.0014E+0, 1.0008E+0, 1.0004E+0, 1.0003E+0, 1.0003E+0, 1.0002E+0,&
     & 1.3511E+0, 1.2380E+0, 1.1802E+0, 1.1364E+0, 1.1097E+0, 1.0928E+0,&
     & 1.0767E+0, 1.0713E+0, 1.0668E+0, 1.0637E+0, 1.0617E+0/           
      DATA X3501/ 1.0605E+0, 1.0593E+0, 1.0584E+0, 1.0576E+0, 1.0575E+0,&
     & 1.0522E+0, 1.0493E+0, 1.0429E+0, 1.0261E+0, 1.0102E+0, 1.0032E+0,&
     & 1.0019E+0, 1.0010E+0, 1.0008E+0, 1.0006E+0, 1.0005E+0, 1.6298E+0,&
     & 1.4312E+0, 1.3274E+0, 1.2466E+0, 1.1955E+0, 1.1616E+0, 1.1307E+0,&
     & 1.1205E+0, 1.1122E+0, 1.1066E+0, 1.1030E+0, 1.1009E+0, 1.0986E+0,&
     & 1.0970E+0, 1.0956E+0, 1.0954E+0, 1.0861E+0, 1.0809E+0, 1.0698E+0,&
     & 1.0415E+0, 1.0158E+0, 1.0048E+0, 1.0029E+0, 1.0015E+0, 1.0012E+0,&
     & 1.0010E+0, 1.0009E+0, 2.3331E+0, 1.9041E+0, 1.6784E+0, 1.5010E+0,&
     & 1.3874E+0, 1.3111E+0, 1.2397E+0, 1.2177E+0, 1.2002E+0, 1.1884E+0,&
     & 1.1811E+0, 1.1770E+0, 1.1723E+0, 1.1691E+0, 1.1662E+0, 1.1659E+0,&
     & 1.1477E+0, 1.1378E+0, 1.1168E+0, 1.0666E+0, 1.0242E+0, 1.0072E+0,&
     & 1.0044E+0, 1.0024E+0, 1.0019E+0, 1.0016E+0, 1.0015E+0, 5.2261E+0,&
     & 3.7648E+0, 2.9996E+0, 2.4020E+0, 2.0222E+0, 1.7694E+0, 1.5366E+0,&
     & 1.4663E+0, 1.4146E+0, 1.3817E+0, 1.3620E+0, 1.3510E+0, 1.3388E+0,&
     & 1.3305E+0, 1.3233E+0, 1.3225E+0, 1.2780E+0, 1.2548E+0, 1.2085E+0,&
     & 1.1094E+0, 1.0370E+0, 1.0108E+0, 1.0066E+0, 1.0038E+0, 1.0031E+0,&
     & 1.0027E+0, 1.0025E+0, 8.0173E+0, 5.5610E+0, 4.2726E+0/           
      DATA X3601/ 3.2628E+0, 2.6189E+0, 2.1885E+0, 1.7891E+0, 1.6671E+0,&
     & 1.5767E+0, 1.5217E+0, 1.4898E+0, 1.4721E+0, 1.4528E+0, 1.4398E+0,&
     & 1.4287E+0, 1.4275E+0, 1.3601E+0, 1.3264E+0, 1.2610E+0, 1.1305E+0,&
     & 1.0427E+0, 1.0124E+0, 1.0077E+0, 1.0046E+0, 1.0038E+0, 1.0033E+0,&
     & 1.0031E+0, 1.6787E+1, 1.1078E+1, 8.0918E+0, 5.7605E+0, 4.2803E+0,&
     & 3.2964E+0, 2.3923E+0, 2.1199E+0, 1.9204E+0, 1.8009E+0, 1.7356E+0,&
     & 1.7007E+0, 1.6636E+0, 1.6391E+0, 1.6183E+0, 1.6161E+0, 1.4974E+0,&
     & 1.4415E+0, 1.3397E+0, 1.1582E+0, 1.0498E+0, 1.0146E+0, 1.0092E+0,&
     & 1.0056E+0, 1.0047E+0, 1.0042E+0, 1.0039E+0, 3.3871E+1, 2.1720E+1,&
     & 1.5381E+1, 1.0446E+1, 7.3267E+0, 5.2620E+0, 3.3802E+0, 2.8197E+0,&
     & 2.4137E+0, 2.1739E+0, 2.0448E+0, 1.9792E+0, 1.9115E+0, 1.8682E+0,&
     & 1.8323E+0, 1.8284E+0, 1.6356E+0, 1.5514E+0, 1.4077E+0, 1.1784E+0,&
     & 1.0547E+0, 1.0163E+0, 1.0105E+0, 1.0066E+0, 1.0056E+0, 1.0050E+0,&
     & 1.0047E+0, 8.9488E+1, 5.5977E+1, 3.8561E+1, 2.5061E+1, 1.6583E+1,&
     & 1.1019E+1, 6.0212E+0, 4.5626E+0, 3.5273E+0, 2.9322E+0, 2.6219E+0,&
     & 2.4690E+0, 2.3219E+0, 2.2329E+0, 2.1620E+0, 2.1546E+0, 1.8136E+0,&
     & 1.6823E+0, 1.4783E+0, 1.1954E+0, 1.0591E+0, 1.0182E+0/           
      DATA X3701/ 1.0121E+0, 1.0079E+0, 1.0068E+0, 1.0061E+0, 1.0057E+0,&
     & 1.4680E+2, 9.1379E+1, 6.2581E+1, 4.0260E+1, 2.6240E+1, 1.7038E+1,&
     & 8.7705E+0, 6.3573E+0, 4.6435E+0, 3.6582E+0, 3.1441E+0, 2.8906E+0,&
     & 2.6467E+0, 2.5069E+0, 2.3992E+0, 2.3882E+0, 1.9154E+0, 1.7501E+0,&
     & 1.5090E+0, 1.2011E+0, 1.0610E+0, 1.0193E+0, 1.0130E+0, 1.0086E+0,&
     & 1.0075E+0, 1.0068E+0, 1.0064E+0, 4.2990E+2, 2.6491E+2, 1.7935E+2,&
     & 1.1324E+2, 7.1864E+1, 4.4839E+1, 2.0766E+1, 1.3829E+1, 8.9658E+0,&
     & 6.2202E+0, 4.8192E+0, 4.1435E+0, 3.5114E+0, 3.1630E+0, 2.9228E+0,&
     & 2.8994E+0, 2.0649E+0, 1.8333E+0, 1.5349E+0, 1.2035E+0, 1.0631E+0,&
     & 1.0213E+0, 1.0148E+0, 1.0102E+0, 1.0090E+0, 1.0082E+0, 1.0077E+0,&
     & 1.1663E+3, 7.1488E+2, 4.8119E+2, 3.0088E+2, 1.8832E+2, 1.1511E+2,&
     & 5.0246E+1, 3.1734E+1, 1.8878E+1, 1.1721E+1, 8.1316E+0, 6.4321E+0,&
     & 4.8793E+0, 4.0540E+0, 3.5135E+0, 3.4653E+0, 2.1222E+0, 1.8428E+0,&
     & 1.5213E+0, 1.1981E+0, 1.0642E+0, 1.0230E+0, 1.0165E+0, 1.0118E+0,&
     & 1.0104E+0, 1.0095E+0, 1.0090E+0, 2.8342E+3, 1.7538E+3, 1.1914E+3,&
     & 7.5464E+2, 4.7952E+2, 2.9833E+2, 1.3451E+2, 8.6271E+1, 5.1707E+1,&
     & 3.1594E+1, 2.0951E+1, 1.5627E+1, 1.0422E+1, 7.3689E+0/           
      DATA X3801/ 5.0937E+0, 4.8686E+0, 1.9657E+0, 1.6946E+0, 1.4287E+0,&
     & 1.1782E+0, 1.0649E+0, 1.0265E+0, 1.0200E+0, 1.0149E+0, 1.0134E+0,&
     & 1.0123E+0, 1.0116E+0, 3.5666E+3, 2.2054E+3, 1.4970E+3, 9.4708E+2,&
     & 6.0085E+2, 3.7298E+2, 1.6718E+2, 1.0668E+2, 6.3399E+1, 3.8266E+1,&
     & 2.4999E+1, 1.8379E+1, 1.1926E+1, 8.1544E+0, 5.3563E+0, 5.0803E+0,&
     & 1.9317E+0, 1.6701E+0, 1.4162E+0, 1.1758E+0, 1.0650E+0, 1.0269E+0,&
     & 1.0204E+0, 1.0153E+0, 1.0137E+0, 1.0126E+0, 1.0119E+0, 5.3664E+3,&
     & 3.3134E+3, 2.2457E+3, 1.4175E+3, 8.9656E+2, 5.5414E+2, 2.4559E+2,&
     & 1.5517E+2, 9.0696E+1, 5.3420E+1, 3.3845E+1, 2.4125E+1, 1.4707E+1,&
     & 9.2455E+0, 5.2325E+0, 4.8394E+0, 1.6263E+0, 1.4424E+0, 1.2815E+0,&
     & 1.1484E+0, 1.0818E+0, 1.0519E+0, 1.0451E+0, 1.0382E+0, 1.0353E+0,&
     & 1.0330E+0, 1.0315E+0, 8.5194E+2, 5.2231E+2, 3.5175E+2, 2.2009E+2,&
     & 1.3792E+2, 8.4438E+1, 3.7043E+1, 2.3516E+1, 1.4109E+1, 8.8677E+0,&
     & 6.2368E+0, 4.9889E+0, 3.8476E+0, 3.2393E+0, 2.8395E+0, 2.8037E+0,&
     & 1.8071E+0, 1.6049E+0, 1.3820E+0, 1.1802E+0, 1.0999E+0, 1.0689E+0,&
     & 1.0616E+0, 1.0535E+0, 1.0498E+0, 1.0468E+0, 1.0449E+0, 1.8958E+2,&
     & 1.1699E+2, 7.9387E+1, 5.0351E+1, 3.2204E+1, 2.0372E+1/           
      DATA X3901/ 9.8622E+0, 6.8473E+0, 4.7431E+0, 3.5628E+0, 2.9654E+0,&
     & 2.6797E+0, 2.4154E+0, 2.2721E+0, 2.1657E+0, 2.1550E+0, 1.7280E+0,&
     & 1.5934E+0, 1.4113E+0, 1.2053E+0, 1.1173E+0, 1.0853E+0, 1.0777E+0,&
     & 1.0685E+0, 1.0641E+0, 1.0606E+0, 1.0582E+0, 5.2402E+1, 3.2832E+1,&
     & 2.2688E+1, 1.4856E+1, 9.9578E+0, 6.7620E+0, 3.9192E+0, 3.1023E+0,&
     & 2.5311E+0, 2.2098E+0, 2.0466E+0, 1.9682E+0, 1.8906E+0, 1.8424E+0,&
     & 1.8034E+0, 1.7993E+0, 1.6038E+0, 1.5253E+0, 1.4003E+0, 1.2233E+0,&
     & 1.1356E+0, 1.1041E+0, 1.0964E+0, 1.0862E+0, 1.0811E+0, 1.0769E+0,&
     & 1.0740E+0, 8.1978E+0, 5.5900E+0, 4.2416E+0, 3.2032E+0, 2.5562E+0,&
     & 2.1363E+0, 1.7662E+0, 1.6612E+0, 1.5889E+0, 1.5448E+0, 1.5192E+0,&
     & 1.5051E+0, 1.4897E+0, 1.4793E+0, 1.4703E+0, 1.4693E+0, 1.4156E+0,&
     & 1.3886E+0, 1.3368E+0, 1.2356E+0, 1.1709E+0, 1.1475E+0, 1.1409E+0,&
     & 1.1301E+0, 1.1236E+0, 1.1180E+0, 1.1142E+0, 3.8317E+0, 2.8834E+0,&
     & 2.3927E+0, 2.0145E+0, 1.7786E+0, 1.6253E+0, 1.4898E+0, 1.4512E+0,&
     & 1.4218E+0, 1.4025E+0, 1.3908E+0, 1.3842E+0, 1.3768E+0, 1.3718E+0,&
     & 1.3674E+0, 1.3669E+0, 1.3393E+0, 1.3248E+0, 1.2953E+0, 1.2321E+0,&
     & 1.1908E+0, 1.1784E+0, 1.1741E+0, 1.1641E+0, 1.1571E+0/           
      DATA X4001/ 1.1507E+0, 1.1463E+0, 2.7664E+0, 2.1916E+0, 1.8983E+0,&
     & 1.6760E+0, 1.5406E+0, 1.4553E+0, 1.3844E+0, 1.3626E+0, 1.3454E+0,&
     & 1.3340E+0, 1.3269E+0, 1.3229E+0, 1.3184E+0, 1.3153E+0, 1.3126E+0,&
     & 1.3123E+0, 1.2951E+0, 1.2859E+0, 1.2670E+0, 1.2263E+0, 1.2042E+0,&
     & 1.2030E+0, 1.2013E+0, 1.1929E+0, 1.1857E+0, 1.1789E+0, 1.1742E+0,&
     & 2.5148E+0, 1.9964E+0, 1.7403E+0, 1.5542E+0, 1.4477E+0, 1.3867E+0,&
     & 1.3401E+0, 1.3237E+0, 1.3034E+0, 1.2797E+0, 1.2689E+0, 1.2420E+0,&
     & 1.2242E+0, 1.2764E+0, 1.2818E+0, 1.2705E+0, 1.2688E+0, 1.2622E+0,&
     & 1.2488E+0, 1.2214E+0, 1.2127E+0, 1.2205E+0, 1.2212E+0, 1.2145E+0,&
     & 1.2074E+0, 1.2004E+0, 1.1955E+0, 1.7154E+0, 1.5432E+0, 1.4490E+0,&
     & 1.3717E+0, 1.3194E+0, 1.2879E+0, 1.2649E+0, 1.2563E+0, 1.2435E+0,&
     & 1.2266E+0, 1.2192E+0, 1.1977E+0, 1.1838E+0, 1.2281E+0, 1.2334E+0,&
     & 1.2239E+0, 1.2270E+0, 1.2240E+0, 1.2183E+0, 1.2110E+0, 1.2266E+0,&
     & 1.2535E+0, 1.2598E+0, 1.2576E+0, 1.2511E+0, 1.2441E+0, 1.2391E+0,&
     & 1.4885E+0, 1.4063E+0, 1.3536E+0, 1.3037E+0, 1.2677E+0, 1.2459E+0,&
     & 1.2312E+0, 1.2255E+0, 1.2157E+0, 1.2018E+0, 1.1958E+0, 1.1769E+0,&
     & 1.1649E+0, 1.2051E+0, 1.2101E+0, 1.2016E+0, 1.2064E+0/           
      DATA X4101/ 1.2049E+0, 1.2025E+0, 1.2046E+0, 1.2334E+0, 1.2722E+0,&
     & 1.2822E+0, 1.2835E+0, 1.2778E+0, 1.2710E+0, 1.2661E+0, 1.2867E+0,&
     & 1.2550E+0, 1.2353E+0, 1.2132E+0, 1.1957E+0, 1.1856E+0, 1.1808E+0,&
     & 1.1788E+0, 1.1732E+0, 1.1635E+0, 1.1597E+0, 1.1448E+0, 1.1355E+0,&
     & 1.1688E+0, 1.1734E+0, 1.1664E+0, 1.1733E+0, 1.1739E+0, 1.1760E+0,&
     & 1.1922E+0, 1.2430E+0, 1.3046E+0, 1.3227E+0, 1.3320E+0, 1.3283E+0,&
     & 1.3224E+0, 1.3180E+0, 1.2192E+0, 1.2021E+0, 1.1912E+0, 1.1777E+0,&
     & 1.1664E+0, 1.1602E+0, 1.1590E+0, 1.1583E+0, 1.1544E+0, 1.1464E+0,&
     & 1.1434E+0, 1.1303E+0, 1.1222E+0, 1.1524E+0, 1.1566E+0, 1.1504E+0,&
     & 1.1580E+0, 1.1593E+0, 1.1633E+0, 1.1853E+0, 1.2463E+0, 1.3198E+0,&
     & 1.3424E+0, 1.3566E+0, 1.3544E+0, 1.3491E+0, 1.3453E+0, 1.1904E+0,&
     & 1.1790E+0, 1.1715E+0, 1.1615E+0, 1.1527E+0, 1.1483E+0, 1.1485E+0,&
     & 1.1485E+0, 1.1452E+0, 1.1381E+0, 1.1354E+0, 1.1232E+0, 1.1157E+0,&
     & 1.1443E+0, 1.1484E+0, 1.1425E+0, 1.1504E+0, 1.1520E+0, 1.1568E+0,&
     & 1.1815E+0, 1.2475E+0, 1.3270E+0, 1.3520E+0, 1.3690E+0, 1.3675E+0,&
     & 1.3627E+0, 1.3591E+0, 9.9855E-1, 9.9914E-1, 9.9937E-1, 9.9953E-1,&
     & 9.9962E-1, 9.9968E-1, 9.9974E-1, 9.9976E-1, 9.9978E-1/           
      DATA X4201/ 9.9979E-1, 9.9980E-1, 9.9981E-1, 9.9981E-1, 9.9982E-1,&
     & 9.9982E-1, 9.9982E-1, 9.9984E-1, 9.9985E-1, 9.9988E-1, 9.9995E-1,&
     & 1.0000E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 9.9475E-1, 9.9689E-1, 9.9772E-1, 9.9828E-1, 9.9862E-1,&
     & 9.9884E-1, 9.9907E-1, 9.9914E-1, 9.9921E-1, 9.9925E-1, 9.9928E-1,&
     & 9.9930E-1, 9.9932E-1, 9.9933E-1, 9.9935E-1, 9.9935E-1, 9.9942E-1,&
     & 9.9947E-1, 9.9957E-1, 9.9984E-1, 1.0001E+0, 1.0002E+0, 1.0003E+0,&
     & 1.0003E+0, 1.0003E+0, 1.0003E+0, 1.0003E+0, 9.6689E-1, 9.7913E-1,&
     & 9.8483E-1, 9.8864E-1, 9.9088E-1, 9.9238E-1, 9.9386E-1, 9.9438E-1,&
     & 9.9481E-1, 9.9511E-1, 9.9530E-1, 9.9541E-1, 9.9554E-1, 9.9563E-1,&
     & 9.9571E-1, 9.9572E-1, 9.9623E-1, 9.9653E-1, 9.9718E-1, 9.9893E-1,&
     & 1.0007E+0, 1.0016E+0, 1.0017E+0, 1.0019E+0, 1.0020E+0, 1.0020E+0,&
     & 1.0020E+0, 9.2542E-1, 9.5090E-1, 9.6361E-1, 9.7297E-1, 9.7843E-1,&
     & 9.8203E-1, 9.8559E-1, 9.8682E-1, 9.8784E-1, 9.8856E-1, 9.8901E-1,&
     & 9.8928E-1, 9.8958E-1, 9.8979E-1, 9.8997E-1, 9.8999E-1, 9.9122E-1,&
     & 9.9192E-1, 9.9345E-1, 9.9755E-1, 1.0016E+0, 1.0036E+0, 1.0040E+0,&
     & 1.0044E+0, 1.0045E+0, 1.0046E+0, 1.0046E+0, 8.1880E-1/           
      DATA X4301/ 8.7786E-1, 9.0833E-1, 9.3175E-1, 9.4630E-1, 9.5570E-1,&
     & 9.6484E-1, 9.6796E-1, 9.7055E-1, 9.7236E-1, 9.7350E-1, 9.7416E-1,&
     & 9.7491E-1, 9.7543E-1, 9.7589E-1, 9.7595E-1, 9.7900E-1, 9.8072E-1,&
     & 9.8449E-1, 9.9440E-1, 1.0039E+0, 1.0084E+0, 1.0093E+0, 1.0101E+0,&
     & 1.0103E+0, 1.0105E+0, 1.0106E+0, 7.0978E-1, 8.0016E-1, 8.4794E-1,&
     & 8.8576E-1, 9.1019E-1, 9.2678E-1, 9.4257E-1, 9.4790E-1, 9.5229E-1,&
     & 9.5533E-1, 9.5725E-1, 9.5836E-1, 9.5962E-1, 9.6049E-1, 9.6126E-1,&
     & 9.6135E-1, 9.6642E-1, 9.6927E-1, 9.7546E-1, 9.9146E-1, 1.0064E+0,&
     & 1.0131E+0, 1.0144E+0, 1.0155E+0, 1.0159E+0, 1.0161E+0, 1.0163E+0,&
     & 4.9219E-1, 6.4822E-1, 7.3164E-1, 7.9852E-1, 8.4242E-1, 8.7281E-1,&
     & 9.0262E-1, 9.1240E-1, 9.2035E-1, 9.2581E-1, 9.2922E-1, 9.3119E-1,&
     & 9.3341E-1, 9.3496E-1, 9.3632E-1, 9.3647E-1, 9.4532E-1, 9.5024E-1,&
     & 9.6080E-1, 9.8721E-1, 1.0106E+0, 1.0206E+0, 1.0224E+0, 1.0240E+0,&
     & 1.0245E+0, 1.0248E+0, 1.0250E+0,-9.9823E-2, 2.4916E-1, 4.3587E-1,&
     & 5.8542E-1, 6.8348E-1, 7.5127E-1, 8.1763E-1, 8.3934E-1, 8.5641E-1,&
     & 8.6781E-1, 8.7484E-1, 8.7885E-1, 8.8335E-1, 8.8645E-1, 8.8916E-1,&
     & 8.8946E-1, 9.0681E-1, 9.1620E-1, 9.3584E-1, 9.8180E-1/           
      DATA X4401/ 1.0188E+0, 1.0331E+0, 1.0357E+0, 1.0378E+0, 1.0384E+0,&
     & 1.0388E+0, 1.0391E+0,-5.2344E-1,-3.5721E-2, 2.2546E-1, 4.3500E-1,&
     & 5.7266E-1, 6.6818E-1, 7.6205E-1, 7.9291E-1, 8.1728E-1, 8.3323E-1,&
     & 8.4293E-1, 8.4843E-1, 8.5457E-1, 8.5877E-1, 8.6244E-1, 8.6284E-1,&
     & 8.8597E-1, 8.9828E-1, 9.2353E-1, 9.8025E-1, 1.0235E+0, 1.0396E+0,&
     & 1.0424E+0, 1.0447E+0, 1.0454E+0, 1.0459E+0, 1.0462E+0,-1.5220E+0,&
     &-6.8726E-1,-2.4243E-1, 1.1279E-1, 3.4486E-1, 5.0490E-1, 6.6073E-1,&
     & 7.1137E-1, 7.5098E-1, 7.7665E-1, 7.9185E-1, 8.0033E-1, 8.0968E-1,&
     & 8.1602E-1, 8.2151E-1, 8.2211E-1, 8.5586E-1, 8.7323E-1, 9.0772E-1,&
     & 9.8005E-1, 1.0308E+0, 1.0488E+0, 1.0520E+0, 1.0545E+0, 1.0553E+0,&
     & 1.0559E+0, 1.0562E+0,-2.9885E+0,-1.6301E+0,-9.0845E-1,-3.3398E-1,&
     & 3.8849E-2, 2.9364E-1, 5.3922E-1, 6.1797E-1, 6.7885E-1, 7.1783E-1,&
     & 7.4062E-1, 7.5307E-1, 7.6658E-1, 7.7563E-1, 7.8339E-1, 7.8423E-1,&
     & 8.3037E-1, 8.5321E-1, 8.9690E-1, 9.8225E-1, 1.0379E+0, 1.0570E+0,&
     & 1.0603E+0, 1.0631E+0, 1.0640E+0, 1.0646E+0, 1.0650E+0,-6.4565E+0,&
     &-3.8147E+0,-2.4209E+0,-1.3215E+0,-6.1417E-1,-1.3596E-1, 3.1526E-1,&
     & 4.5642E-1, 5.6332E-1, 6.3005E-1, 6.6816E-1, 6.8857E-1/           
      DATA X4501/ 7.1005E-1, 7.2408E-1, 7.3587E-1, 7.3714E-1, 8.0349E-1,&
     & 8.3425E-1, 8.8981E-1, 9.8824E-1, 1.0470E+0, 1.0666E+0, 1.0701E+0,&
     & 1.0732E+0, 1.0742E+0, 1.0749E+0, 1.0754E+0,-9.5042E+0,-5.7334E+0,&
     &-3.7478E+0,-2.1838E+0,-1.1804E+0,-5.0525E-1, 1.2894E-1, 3.2574E-1,&
     & 4.7379E-1, 5.6547E-1, 6.1739E-1, 6.4501E-1, 6.7388E-1, 6.9230E-1,&
     & 7.0754E-1, 7.0916E-1, 7.9102E-1, 8.2706E-1, 8.8955E-1, 9.9348E-1,&
     & 1.0526E+0, 1.0722E+0, 1.0758E+0, 1.0790E+0, 1.0801E+0, 1.0809E+0,&
     & 1.0814E+0,-2.1271E+1,-1.3034E+1,-8.7263E+0,-5.3552E+0,-3.2124E+0,&
     &-1.7847E+0,-4.6814E-1,-6.9611E-2, 2.2369E-1, 4.0046E-1, 4.9770E-1,&
     & 5.4816E-1, 5.9953E-1, 6.3129E-1, 6.5635E-1, 6.5896E-1, 7.7820E-1,&
     & 8.2444E-1, 8.9782E-1, 1.0058E+0, 1.0628E+0, 1.0820E+0, 1.0857E+0,&
     & 1.0892E+0, 1.0904E+0, 1.0913E+0, 1.0920E+0,-4.6145E+1,-2.8359E+1,&
     &-1.9090E+1,-1.1879E+1,-7.3281E+0,-4.3203E+0,-1.5942E+0,-7.8320E-1,&
     &-1.9824E-1, 1.4529E-1, 3.2925E-1, 4.2223E-1, 5.1425E-1, 5.6910E-1,&
     & 6.1075E-1, 6.1492E-1, 7.8137E-1, 8.3614E-1, 9.1512E-1, 1.0192E+0,&
     & 1.0718E+0, 1.0903E+0, 1.0941E+0, 1.0979E+0, 1.0993E+0, 1.1003E+0,&
     & 1.1010E+0,-1.1511E+2,-7.1386E+1,-4.8557E+1,-3.0753E+1/           
      DATA X4601/-1.9475E+1,-1.1996E+1,-5.1526E+0,-3.1024E+0,-1.6094E+0,&
     &-7.2131E-1,-2.3956E-1, 7.1173E-3, 2.5475E-1, 4.0514E-1, 5.2163E-1,&
     & 5.3347E-1, 8.3228E-1, 8.9252E-1, 9.6402E-1, 1.0445E+0, 1.0866E+0,&
     & 1.1037E+0, 1.1077E+0, 1.1120E+0, 1.1137E+0, 1.1149E+0, 1.1157E+0,&
     &-1.3776E+2,-8.5385E+1,-5.8049E+1,-3.6749E+1,-2.3270E+1,-1.4342E+1,&
     &-6.1915E+0,-3.7568E+0,-1.9891E+0,-9.4151E-1,-3.7567E-1,-8.7081E-2,&
     & 2.0140E-1, 3.7563E-1, 5.0979E-1, 5.2337E-1, 8.4120E-1, 9.0070E-1,&
     & 9.6990E-1, 1.0471E+0, 1.0881E+0, 1.1050E+0, 1.1090E+0, 1.1134E+0,&
     & 1.1151E+0, 1.1163E+0, 1.1172E+0,-2.2105E+2,-1.3681E+2,-9.2905E+1,&
     &-5.8743E+1,-3.7170E+1,-2.2919E+1,-9.9644E+0,-6.1197E+0,-3.3448E+0,&
     &-1.7136E+0,-8.4032E-1,-3.9871E-1, 3.8552E-2, 2.9944E-1, 4.9759E-1,&
     & 5.1747E-1, 8.9800E-1, 9.5628E-1, 1.0198E+0, 1.0858E+0, 1.1211E+0,&
     & 1.1397E+0, 1.1457E+0, 1.1530E+0, 1.1560E+0, 1.1582E+0, 1.1598E+0,&
     &-4.7172E+1,-2.9004E+1,-1.9523E+1,-1.2141E+1,-7.4844E+0,-4.4023E+0,&
     &-1.6104E+0,-7.7881E-1,-1.7871E-1, 1.7424E-1, 3.6324E-1, 4.5888E-1,&
     & 5.5366E-1, 6.1024E-1, 6.5327E-1, 6.5758E-1, 8.3008E-1, 8.8659E-1,&
     & 9.6705E-1, 1.0684E+0, 1.1176E+0, 1.1402E+0, 1.1472E+0/           
      DATA X4701/ 1.1559E+0, 1.1595E+0, 1.1621E+0, 1.1640E+0,-1.4879E+1,&
     &-9.0327E+0,-5.9678E+0,-3.5676E+0,-2.0393E+0,-1.0193E+0,-7.5729E-2,&
     & 2.1135E-1, 4.2346E-1, 5.5194E-1, 6.2303E-1, 6.6010E-1, 6.9805E-1,&
     & 7.2166E-1, 7.4088E-1, 7.4290E-1, 8.4122E-1, 8.8211E-1, 9.4967E-1,&
     & 1.0523E+0, 1.1074E+0, 1.1323E+0, 1.1401E+0, 1.1497E+0, 1.1537E+0,&
     & 1.1566E+0, 1.1587E+0,-5.5210E+0,-3.1809E+0,-1.9490E+0,-9.7852E-1,&
     &-3.5689E-1, 6.1447E-2, 4.5410E-1, 5.7588E-1, 6.6739E-1, 7.2403E-1,&
     & 7.5607E-1, 7.7310E-1, 7.9122E-1, 8.0316E-1, 8.1325E-1, 8.1434E-1,&
     & 8.7204E-1, 8.9919E-1, 9.4864E-1, 1.0362E+0, 1.0899E+0, 1.1157E+0,&
     & 1.1239E+0, 1.1342E+0, 1.1384E+0, 1.1416E+0, 1.1437E+0,-5.7404E-1,&
     &-3.4195E-2, 2.5041E-1, 4.7470E-1, 6.1871E-1, 7.1586E-1, 8.0730E-1,&
     & 8.3577E-1, 8.5725E-1, 8.7117E-1, 8.7957E-1, 8.8431E-1, 8.8958E-1,&
     & 8.9318E-1, 8.9631E-1, 8.9665E-1, 9.1621E-1, 9.2648E-1, 9.4722E-1,&
     & 9.9224E-1, 1.0278E+0, 1.0492E+0, 1.0568E+0, 1.0668E+0, 1.0710E+0,&
     & 1.0741E+0, 1.0763E+0, 3.1447E-1, 5.2898E-1, 6.4159E-1, 7.2995E-1,&
     & 7.8638E-1, 8.2420E-1, 8.5941E-1, 8.7022E-1, 8.7874E-1, 8.8443E-1,&
     & 8.8794E-1, 8.8994E-1, 8.9219E-1, 8.9373E-1, 8.9509E-1/           
      DATA X4801/ 8.9524E-1, 9.0387E-1, 9.0853E-1, 9.1823E-1, 9.4079E-1,&
     & 9.6103E-1, 9.7603E-1, 9.8214E-1, 9.9054E-1, 9.9419E-1, 9.9694E-1,&
     & 9.9890E-1, 5.8183E-1, 6.8970E-1, 7.4521E-1, 7.8778E-1, 8.1412E-1,&
     & 8.3107E-1, 8.4577E-1, 8.5039E-1, 8.5407E-1, 8.5655E-1, 8.5808E-1,&
     & 8.5896E-1, 8.5994E-1, 8.6062E-1, 8.6122E-1, 8.6128E-1, 8.6509E-1,&
     & 8.6715E-1, 8.7146E-1, 8.8153E-1, 8.9109E-1, 9.0021E-1, 9.0462E-1,&
     & 9.1110E-1, 9.1404E-1, 9.1629E-1, 9.1790E-1, 6.5941E-1, 7.2681E-1,&
     & 7.6002E-1, 7.8409E-1, 7.9777E-1, 8.0554E-1, 8.1219E-1, 8.1425E-1,&
     & 8.1586E-1, 8.1694E-1, 8.1760E-1, 8.1797E-1, 8.1839E-1, 8.1868E-1,&
     & 8.1893E-1, 8.1895E-1, 8.2053E-1, 8.2137E-1, 8.2306E-1, 8.2659E-1,&
     & 8.2967E-1, 8.3452E-1, 8.3754E-1, 8.4239E-1, 8.4468E-1, 8.4648E-1,&
     & 8.4778E-1, 6.8296E-1, 6.9325E-1, 6.9714E-1, 6.9882E-1, 6.9873E-1,&
     & 6.9812E-1, 6.9701E-1, 6.9649E-1, 6.9599E-1, 6.9561E-1, 6.9535E-1,&
     & 6.9520E-1, 6.9502E-1, 6.9489E-1, 6.9477E-1, 6.9476E-1, 6.9392E-1,&
     & 6.9341E-1, 6.9214E-1, 6.8778E-1, 6.8178E-1, 6.7930E-1, 6.7963E-1,&
     & 6.8114E-1, 6.8208E-1, 6.8289E-1, 6.8351E-1, 6.1933E-1, 6.1494E-1,&
     & 6.1139E-1, 6.0748E-1, 6.0434E-1, 6.0179E-1, 5.9882E-1/           
      DATA X4901/ 5.9767E-1, 5.9665E-1, 5.9590E-1, 5.9541E-1, 5.9512E-1,&
     & 5.9479E-1, 5.9455E-1, 5.9434E-1, 5.9432E-1, 5.9286E-1, 5.9199E-1,&
     & 5.8994E-1, 5.8332E-1, 5.7425E-1, 5.6863E-1, 5.6765E-1, 5.6739E-1,&
     & 5.6760E-1, 5.6785E-1, 5.6808E-1, 3.9015E-1, 3.7626E-1, 3.6926E-1,&
     & 3.6355E-1, 3.5959E-1, 3.5664E-1, 3.5336E-1, 3.5212E-1, 3.5105E-1,&
     & 3.5027E-1, 3.4976E-1, 3.4947E-1, 3.4912E-1, 3.4888E-1, 3.4866E-1,&
     & 3.4864E-1, 3.4715E-1, 3.4627E-1, 3.4421E-1, 3.3762E-1, 3.2818E-1,&
     & 3.2084E-1, 3.1872E-1, 3.1665E-1, 3.1600E-1, 3.1560E-1, 3.1535E-1,&
     & 2.1709E-1, 2.0753E-1, 2.0282E-1, 1.9903E-1, 1.9644E-1, 1.9451E-1,&
     & 1.9237E-1, 1.9157E-1, 1.9087E-1, 1.9037E-1, 1.9004E-1, 1.8985E-1,&
     & 1.8962E-1, 1.8947E-1, 1.8933E-1, 1.8931E-1, 1.8835E-1, 1.8777E-1,&
     & 1.8644E-1, 1.8214E-1, 1.7586E-1, 1.7067E-1, 1.6905E-1, 1.6734E-1,&
     & 1.6675E-1, 1.6636E-1, 1.6610E-1, 1.1453E-1, 1.0906E-1, 1.0638E-1,&
     & 1.0424E-1, 1.0277E-1, 1.0168E-1, 1.0047E-1, 1.0002E-1, 9.9626E-2,&
     & 9.9341E-2, 9.9155E-2, 9.9046E-2, 9.8920E-2, 9.8831E-2, 9.8751E-2,&
     & 9.8743E-2, 9.8199E-2, 9.7876E-2, 9.7119E-2, 9.4687E-2, 9.1093E-2,&
     & 8.8062E-2, 8.7089E-2, 8.6032E-2, 8.5658E-2, 8.5406E-2/           
      DATA X5001/ 8.5240E-2, 4.6498E-5, 5.5965E-5, 6.2098E-5, 6.7928E-5,&
     & 7.2497E-5, 7.6254E-5, 8.0813E-5, 8.2653E-5, 8.4315E-5, 8.5557E-5,&
     & 8.6381E-5, 8.6875E-5, 8.7449E-5, 8.7859E-5, 8.8227E-5, 8.8268E-5,&
     & 9.0873E-5, 9.2487E-5, 9.6479E-5, 1.1180E-4, 1.4582E-4, 2.0299E-4,&
     & 2.3667E-4, 3.0176E-4, 3.4081E-4, 3.7730E-4, 4.0839E-4, 4.6534E-5,&
     & 5.6001E-5, 6.2133E-5, 6.7964E-5, 7.2533E-5, 7.6290E-5, 8.0849E-5,&
     & 8.2688E-5, 8.4351E-5, 8.5592E-5, 8.6417E-5, 8.6910E-5, 8.7485E-5,&
     & 8.7895E-5, 8.8263E-5, 8.8304E-5, 9.0908E-5, 9.2523E-5, 9.6515E-5,&
     & 1.1183E-4, 1.4585E-4, 2.0302E-4, 2.3671E-4, 3.0180E-4, 3.4084E-4,&
     & 3.7734E-4, 4.0843E-4, 4.6739E-5, 5.6282E-5, 6.2415E-5, 6.8245E-5,&
     & 7.2814E-5, 7.6571E-5, 8.1130E-5, 8.2970E-5, 8.4633E-5, 8.5874E-5,&
     & 8.6698E-5, 8.7192E-5, 8.7766E-5, 8.8176E-5, 8.8544E-5, 8.8585E-5,&
     & 9.1190E-5, 9.2804E-5, 9.6796E-5, 1.1211E-4, 1.4613E-4, 2.0330E-4,&
     & 2.3699E-4, 3.0208E-4, 3.4112E-4, 3.7762E-4, 4.0871E-4, 4.7099E-5,&
     & 5.6727E-5, 6.2883E-5, 6.8713E-5, 7.3282E-5, 7.7039E-5, 8.1598E-5,&
     & 8.3438E-5, 8.5101E-5, 8.6342E-5, 8.7166E-5, 8.7660E-5, 8.8235E-5,&
     & 8.8644E-5, 8.9013E-5, 8.9054E-5, 9.1658E-5, 9.3272E-5/           
      DATA X5101/ 9.7265E-5, 1.1258E-4, 1.4660E-4, 2.0377E-4, 2.3746E-4,&
     & 3.0255E-4, 3.4159E-4, 3.7809E-4, 4.0918E-4, 4.8234E-5, 5.7943E-5,&
     & 6.4131E-5, 6.9975E-5, 7.4544E-5, 7.8301E-5, 8.2860E-5, 8.4700E-5,&
     & 8.6362E-5, 8.7604E-5, 8.8428E-5, 8.8922E-5, 8.9496E-5, 8.9906E-5,&
     & 9.0274E-5, 9.0315E-5, 9.2920E-5, 9.4534E-5, 9.8526E-5, 1.1384E-4,&
     & 1.4786E-4, 2.0503E-4, 2.3872E-4, 3.0381E-4, 3.4285E-4, 3.7935E-4,&
     & 4.1044E-4, 4.9552E-5, 5.9336E-5, 6.5554E-5, 7.1418E-5, 7.5993E-5,&
     & 7.9750E-5, 8.4309E-5, 8.6149E-5, 8.7812E-5, 8.9053E-5, 8.9877E-5,&
     & 9.0371E-5, 9.0946E-5, 9.1356E-5, 9.1724E-5, 9.1765E-5, 9.4369E-5,&
     & 9.5984E-5, 9.9976E-5, 1.1529E-4, 1.4931E-4, 2.0648E-4, 2.4017E-4,&
     & 3.0526E-4, 3.4430E-4, 3.8080E-4, 4.1189E-4, 5.2143E-5, 6.1991E-5,&
     & 6.8235E-5, 7.4117E-5, 7.8701E-5, 8.2462E-5, 8.7021E-5, 8.8861E-5,&
     & 9.0524E-5, 9.1765E-5, 9.2589E-5, 9.3083E-5, 9.3658E-5, 9.4067E-5,&
     & 9.4436E-5, 9.4476E-5, 9.7081E-5, 9.8695E-5, 1.0269E-4, 1.1800E-4,&
     & 1.5203E-4, 2.0919E-4, 2.4288E-4, 3.0797E-4, 3.4701E-4, 3.8351E-4,&
     & 4.1460E-4, 5.7742E-5, 6.7607E-5, 7.3873E-5, 7.9778E-5, 8.4367E-5,&
     & 8.8134E-5, 9.2696E-5, 9.4535E-5, 9.6198E-5, 9.7439E-5/           
      DATA X5201/ 9.8264E-5, 9.8757E-5, 9.9332E-5, 9.9742E-5, 1.0011E-4,&
     & 1.0015E-4, 1.0276E-4, 1.0437E-4, 1.0836E-4, 1.2368E-4, 1.5770E-4,&
     & 2.1487E-4, 2.4855E-4, 3.1365E-4, 3.5269E-4, 3.8918E-4, 4.2028E-4,&
     & 6.1106E-5, 7.1008E-5, 7.7292E-5, 8.3204E-5, 8.7804E-5, 9.1572E-5,&
     & 9.6136E-5, 9.7975E-5, 9.9638E-5, 1.0088E-4, 1.0170E-4, 1.0220E-4,&
     & 1.0277E-4, 1.0318E-4, 1.0355E-4, 1.0359E-4, 1.0620E-4, 1.0781E-4,&
     & 1.1180E-4, 1.2712E-4, 1.6114E-4, 2.1831E-4, 2.5199E-4, 3.1709E-4,&
     & 3.5613E-4, 3.9262E-4, 4.2372E-4, 6.6519E-5, 7.6547E-5, 8.2809E-5,&
     & 8.8744E-5, 9.3330E-5, 9.7100E-5, 1.0166E-4, 1.0350E-4, 1.0517E-4,&
     & 1.0641E-4, 1.0723E-4, 1.0773E-4, 1.0830E-4, 1.0871E-4, 1.0908E-4,&
     & 1.0912E-4, 1.1172E-4, 1.1334E-4, 1.1733E-4, 1.3265E-4, 1.6667E-4,&
     & 2.2384E-4, 2.5752E-4, 3.2261E-4, 3.6166E-4, 3.9815E-4, 4.2924E-4,&
     & 7.1943E-5, 8.1897E-5, 8.8215E-5, 9.4190E-5, 9.8761E-5, 1.0252E-4,&
     & 1.0709E-4, 1.0893E-4, 1.1059E-4, 1.1183E-4, 1.1266E-4, 1.1315E-4,&
     & 1.1372E-4, 1.1413E-4, 1.1450E-4, 1.1454E-4, 1.1715E-4, 1.1876E-4,&
     & 1.2275E-4, 1.3807E-4, 1.7209E-4, 2.2926E-4, 2.6295E-4, 3.2804E-4,&
     & 3.6708E-4, 4.0358E-4, 4.3467E-4, 7.9036E-5, 8.8990E-5/           
      DATA X5301/ 9.5308E-5, 1.0127E-4, 1.0592E-4, 1.0967E-4, 1.1424E-4,&
     & 1.1608E-4, 1.1775E-4, 1.1899E-4, 1.1981E-4, 1.2030E-4, 1.2088E-4,&
     & 1.2129E-4, 1.2166E-4, 1.2170E-4, 1.2430E-4, 1.2592E-4, 1.2991E-4,&
     & 1.4523E-4, 1.7925E-4, 2.3642E-4, 2.7010E-4, 3.3519E-4, 3.7424E-4,&
     & 4.1073E-4, 4.4182E-4, 8.3864E-5, 9.3639E-5, 9.9778E-5, 1.0574E-4,&
     & 1.1045E-4, 1.1415E-4, 1.1874E-4, 1.2058E-4, 1.2224E-4, 1.2348E-4,&
     & 1.2431E-4, 1.2480E-4, 1.2538E-4, 1.2579E-4, 1.2615E-4, 1.2619E-4,&
     & 1.2880E-4, 1.3041E-4, 1.3441E-4, 1.4972E-4, 1.8374E-4, 2.4091E-4,&
     & 2.7460E-4, 3.3969E-4, 3.7873E-4, 4.1523E-4, 4.4632E-4, 9.2208E-5,&
     & 1.0252E-4, 1.0824E-4, 1.1432E-4, 1.1891E-4, 1.2276E-4, 1.2735E-4,&
     & 1.2916E-4, 1.3083E-4, 1.3207E-4, 1.3289E-4, 1.3339E-4, 1.3396E-4,&
     & 1.3437E-4, 1.3474E-4, 1.3478E-4, 1.3739E-4, 1.3900E-4, 1.4299E-4,&
     & 1.5831E-4, 1.9233E-4, 2.4950E-4, 2.8319E-4, 3.4828E-4, 3.8732E-4,&
     & 4.2382E-4, 4.5491E-4, 9.9182E-5, 1.1063E-4, 1.1635E-4, 1.2302E-4,&
     & 1.2779E-4, 1.3161E-4, 1.3536E-4, 1.3727E-4, 1.3894E-4, 1.4015E-4,&
     & 1.4099E-4, 1.4148E-4, 1.4206E-4, 1.4247E-4, 1.4283E-4, 1.4287E-4,&
     & 1.4548E-4, 1.4709E-4, 1.5109E-4, 1.6640E-4, 2.0042E-4/           
      DATA X5401/ 2.5759E-4, 2.9128E-4, 3.5637E-4, 3.9541E-4, 4.3191E-4,&
     & 4.6300E-4, 1.1487E-4, 1.2623E-4, 1.3157E-4, 1.3749E-4, 1.4201E-4,&
     & 1.4580E-4, 1.5029E-4, 1.5224E-4, 1.5388E-4, 1.5512E-4, 1.5595E-4,&
     & 1.5644E-4, 1.5702E-4, 1.5743E-4, 1.5780E-4, 1.5784E-4, 1.6044E-4,&
     & 1.6206E-4, 1.6605E-4, 1.8136E-4, 2.1539E-4, 2.7256E-4, 3.0624E-4,&
     & 3.7133E-4, 4.1037E-4, 4.4687E-4, 4.7796E-4, 1.1552E-4, 1.2682E-4,&
     & 1.3386E-4, 1.3905E-4, 1.4360E-4, 1.4741E-4, 1.5193E-4, 1.5386E-4,&
     & 1.5547E-4, 1.5672E-4, 1.5755E-4, 1.5804E-4, 1.5862E-4, 1.5902E-4,&
     & 1.5939E-4, 1.5943E-4, 1.6204E-4, 1.6365E-4, 1.6764E-4, 1.8296E-4,&
     & 2.1698E-4, 2.7415E-4, 3.0784E-4, 3.7293E-4, 4.1197E-4, 4.4847E-4,&
     & 4.7956E-4, 1.9086E-4, 2.0282E-4, 2.0854E-4, 2.1422E-4, 2.1876E-4,&
     & 2.2253E-4, 2.2703E-4, 2.2901E-4, 2.3061E-4, 2.3186E-4, 2.3269E-4,&
     & 2.3318E-4, 2.3376E-4, 2.3416E-4, 2.3453E-4, 2.3457E-4, 2.3718E-4,&
     & 2.3879E-4, 2.4278E-4, 2.5810E-4, 2.9212E-4, 3.4929E-4, 3.8298E-4,&
     & 4.4807E-4, 4.8711E-4, 5.2361E-4, 5.5470E-4, 2.4414E-4, 2.4700E-4,&
     & 2.4796E-4, 2.5368E-4, 2.5845E-4, 2.6226E-4, 2.6476E-4, 2.6673E-4,&
     & 2.6834E-4, 2.6953E-4, 2.7033E-4, 2.7081E-4, 2.7139E-4/           
      DATA X5501/ 2.7179E-4, 2.7216E-4, 2.7220E-4, 2.7480E-4, 2.7642E-4,&
     & 2.8041E-4, 2.9572E-4, 3.2975E-4, 3.8691E-4, 4.2060E-4, 4.8569E-4,&
     & 5.2473E-4, 5.6123E-4, 5.9232E-4, 2.6417E-4, 2.7359E-4, 2.7931E-4,&
     & 2.8539E-4, 2.8998E-4, 2.9373E-4, 2.9834E-4, 3.0018E-4, 3.0185E-4,&
     & 3.0309E-4, 3.0391E-4, 3.0441E-4, 3.0498E-4, 3.0539E-4, 3.0576E-4,&
     & 3.0580E-4, 3.0841E-4, 3.1002E-4, 3.1401E-4, 3.2933E-4, 3.6335E-4,&
     & 4.2052E-4, 4.5420E-4, 5.1930E-4, 5.5834E-4, 5.9483E-4, 6.2593E-4,&
     & 3.0869E-4, 3.1793E-4, 3.2449E-4, 3.3075E-4, 3.3557E-4, 3.3943E-4,&
     & 3.4406E-4, 3.4595E-4, 3.4765E-4, 3.4892E-4, 3.4977E-4, 3.5027E-4,&
     & 3.5086E-4, 3.5128E-4, 3.5165E-4, 3.5170E-4, 3.5436E-4, 3.5601E-4,&
     & 3.6009E-4, 3.7575E-4, 4.1054E-4, 4.6900E-4, 5.0344E-4, 5.6999E-4,&
     & 6.0991E-4, 6.4723E-4, 6.7902E-4, 4.3553E-4, 4.4620E-4, 4.5294E-4,&
     & 4.5935E-4, 4.6432E-4, 4.6840E-4, 4.7334E-4, 4.7533E-4, 4.7713E-4,&
     & 4.7847E-4, 4.7937E-4, 4.7990E-4, 4.8052E-4, 4.8097E-4, 4.8136E-4,&
     & 4.8141E-4, 4.8423E-4, 4.8597E-4, 4.9030E-4, 5.0687E-4, 5.4369E-4,&
     & 6.0556E-4, 6.4202E-4, 7.1246E-4, 7.5472E-4, 7.9422E-4, 8.2787E-4,&
     & 5.6443E-4, 5.7551E-4, 5.8253E-4, 5.8915E-4, 5.9432E-4/           
      DATA X5601/ 5.9855E-4, 6.0368E-4, 6.0576E-4, 6.0763E-4, 6.0903E-4,&
     & 6.0995E-4, 6.1051E-4, 6.1116E-4, 6.1162E-4, 6.1203E-4, 6.1208E-4,&
     & 6.1501E-4, 6.1683E-4, 6.2133E-4, 6.3857E-4, 6.7689E-4, 7.4127E-4,&
     & 7.7920E-4, 8.5250E-4, 8.9647E-4, 9.3757E-4, 9.7258E-4, 7.1011E-4,&
     & 7.2152E-4, 7.2874E-4, 7.3556E-4, 7.4088E-4, 7.4525E-4, 7.5055E-4,&
     & 7.5269E-4, 7.5462E-4, 7.5606E-4, 7.5702E-4, 7.5759E-4, 7.5826E-4,&
     & 7.5874E-4, 7.5917E-4, 7.5922E-4, 7.6224E-4, 7.6412E-4, 7.6876E-4,&
     & 7.8657E-4, 8.2613E-4, 8.9261E-4, 9.3178E-4, 1.0075E-3, 1.0529E-3,&
     & 1.0953E-3, 1.1315E-3, 8.5313E-4, 8.6469E-4, 8.7206E-4, 8.7902E-4,&
     & 8.8446E-4, 8.8893E-4, 8.9436E-4, 8.9655E-4, 8.9853E-4, 9.0001E-4,&
     & 9.0099E-4, 9.0158E-4, 9.0226E-4, 9.0275E-4, 9.0319E-4, 9.0323E-4,&
     & 9.0633E-4, 9.0826E-4, 9.1301E-4, 9.3124E-4, 9.7175E-4, 1.0398E-3,&
     & 1.0799E-3, 1.1574E-3, 1.2039E-3, 1.2473E-3, 1.2843E-3, 1.2749E-3,&
     & 1.2869E-3, 1.2946E-3, 1.3018E-3, 1.3075E-3, 1.3122E-3, 1.3179E-3,&
     & 1.3202E-3, 1.3223E-3, 1.3238E-3, 1.3248E-3, 1.3255E-3, 1.3262E-3,&
     & 1.3267E-3, 1.3271E-3, 1.3272E-3, 1.3304E-3, 1.3325E-3, 1.3374E-3,&
     & 1.3565E-3, 1.3990E-3, 1.4702E-3, 1.5122E-3, 1.5934E-3/           
      DATA X5701/ 1.6421E-3, 1.6876E-3, 1.7264E-3, 1.6669E-3, 1.6792E-3,&
     & 1.6870E-3, 1.6945E-3, 1.7004E-3, 1.7052E-3, 1.7110E-3, 1.7134E-3,&
     & 1.7155E-3, 1.7171E-3, 1.7182E-3, 1.7188E-3, 1.7195E-3, 1.7201E-3,&
     & 1.7205E-3, 1.7206E-3, 1.7239E-3, 1.7260E-3, 1.7311E-3, 1.7507E-3,&
     & 1.7944E-3, 1.8677E-3, 1.9108E-3, 1.9943E-3, 2.0443E-3, 2.0911E-3,&
     & 2.1310E-3, 2.9133E-3, 2.9261E-3, 2.9344E-3, 2.9423E-3, 2.9484E-3,&
     & 2.9535E-3, 2.9597E-3, 2.9621E-3, 2.9644E-3, 2.9661E-3, 2.9672E-3,&
     & 2.9679E-3, 2.9686E-3, 2.9692E-3, 2.9697E-3, 2.9697E-3, 2.9733E-3,&
     & 2.9754E-3, 2.9808E-3, 3.0015E-3, 3.0475E-3, 3.1248E-3, 3.1703E-3,&
     & 3.2582E-3, 3.3110E-3, 3.3603E-3, 3.4023E-3, 3.8770E-3, 3.8898E-3,&
     & 3.8981E-3, 3.9060E-3, 3.9122E-3, 3.9172E-3, 3.9234E-3, 3.9259E-3,&
     & 3.9281E-3, 3.9298E-3, 3.9309E-3, 3.9316E-3, 3.9324E-3, 3.9329E-3,&
     & 3.9334E-3, 3.9335E-3, 3.9370E-3, 3.9392E-3, 3.9446E-3, 3.9653E-3,&
     & 4.0113E-3, 4.0885E-3, 4.1340E-3, 4.2220E-3, 4.2747E-3, 4.3241E-3,&
     & 4.3661E-3, 4.5079E-3, 4.5207E-3, 4.5290E-3, 4.5369E-3, 4.5431E-3,&
     & 4.5481E-3, 4.5543E-3, 4.5568E-3, 4.5590E-3, 4.5607E-3, 4.5618E-3,&
     & 4.5625E-3, 4.5633E-3, 4.5638E-3, 4.5643E-3, 4.5644E-3/           
      DATA X5801/ 4.5679E-3, 4.5701E-3, 4.5755E-3, 4.5962E-3, 4.6421E-3,&
     & 4.7194E-3, 4.7649E-3, 4.8529E-3, 4.9056E-3, 4.9550E-3, 4.9970E-3,&
     & 5.9339E-5, 7.1856E-5, 7.9969E-5, 8.7734E-5, 9.3877E-5, 9.8976E-5,&
     & 1.0523E-4, 1.0778E-4, 1.1010E-4, 1.1184E-4, 1.1300E-4, 1.1369E-4,&
     & 1.1451E-4, 1.1509E-4, 1.1561E-4, 1.1567E-4, 1.1814E-4, 1.2004E-4,&
     & 1.2489E-4, 1.4530E-4, 1.9969E-4, 2.9632E-4, 3.4866E-4, 4.5220E-4,&
     & 5.1648E-4, 5.7790E-4, 6.3117E-4, 5.9340E-5, 7.1857E-5, 7.9969E-5,&
     & 8.7735E-5, 9.3877E-5, 9.8977E-5, 1.0524E-4, 1.0778E-4, 1.1010E-4,&
     & 1.1184E-4, 1.1300E-4, 1.1370E-4, 1.1451E-4, 1.1509E-4, 1.1561E-4,&
     & 1.1567E-4, 1.1814E-4, 1.2004E-4, 1.2489E-4, 1.4530E-4, 1.9969E-4,&
     & 2.9632E-4, 3.4866E-4, 4.5220E-4, 5.1648E-4, 5.7790E-4, 6.3117E-4,&
     & 5.9345E-5, 7.1861E-5, 7.9974E-5, 8.7739E-5, 9.3882E-5, 9.8981E-5,&
     & 1.0524E-4, 1.0779E-4, 1.1011E-4, 1.1185E-4, 1.1300E-4, 1.1370E-4,&
     & 1.1451E-4, 1.1509E-4, 1.1561E-4, 1.1567E-4, 1.1814E-4, 1.2005E-4,&
     & 1.2489E-4, 1.4530E-4, 1.9969E-4, 2.9632E-4, 3.4867E-4, 4.5220E-4,&
     & 5.1648E-4, 5.7791E-4, 6.3118E-4, 5.9351E-5, 7.1868E-5, 7.9981E-5,&
     & 8.7746E-5, 9.3889E-5, 9.8988E-5, 1.0525E-4, 1.0780E-4/           
      DATA X5901/ 1.1011E-4, 1.1185E-4, 1.1301E-4, 1.1371E-4, 1.1452E-4,&
     & 1.1510E-4, 1.1562E-4, 1.1568E-4, 1.1815E-4, 1.2005E-4, 1.2490E-4,&
     & 1.4531E-4, 1.9970E-4, 2.9633E-4, 3.4867E-4, 4.5221E-4, 5.1649E-4,&
     & 5.7792E-4, 6.3119E-4, 6.8045E-5, 8.0562E-5, 8.8675E-5, 9.6441E-5,&
     & 1.0258E-4, 1.0768E-4, 1.1394E-4, 1.1649E-4, 1.1881E-4, 1.2055E-4,&
     & 1.2171E-4, 1.2240E-4, 1.2321E-4, 1.2379E-4, 1.2431E-4, 1.2437E-4,&
     & 1.2685E-4, 1.2875E-4, 1.3359E-4, 1.5400E-4, 2.0840E-4, 3.0502E-4,&
     & 3.5737E-4, 4.6090E-4, 5.2518E-4, 5.8661E-4, 6.3988E-4, 7.3266E-5,&
     & 8.5784E-5, 9.3894E-5, 1.0166E-4, 1.0780E-4, 1.1290E-4, 1.1916E-4,&
     & 1.2171E-4, 1.2403E-4, 1.2577E-4, 1.2692E-4, 1.2762E-4, 1.2843E-4,&
     & 1.2901E-4, 1.2953E-4, 1.2959E-4, 1.3206E-4, 1.3397E-4, 1.3881E-4,&
     & 1.5922E-4, 2.1361E-4, 3.1024E-4, 3.6259E-4, 4.6612E-4, 5.3040E-4,&
     & 5.9183E-4, 6.4510E-4, 8.2355E-5, 9.4887E-5, 1.0300E-4, 1.1076E-4,&
     & 1.1690E-4, 1.2200E-4, 1.2826E-4, 1.3081E-4, 1.3313E-4, 1.3487E-4,&
     & 1.3603E-4, 1.3672E-4, 1.3753E-4, 1.3811E-4, 1.3864E-4, 1.3869E-4,&
     & 1.4117E-4, 1.4307E-4, 1.4792E-4, 1.6833E-4, 2.2272E-4, 3.1935E-4,&
     & 3.7169E-4, 4.7523E-4, 5.3951E-4, 6.0093E-4, 6.5420E-4/           
      DATA X6001/ 9.9562E-5, 1.1204E-4, 1.2015E-4, 1.2792E-4, 1.3406E-4,&
     & 1.3916E-4, 1.4542E-4, 1.4797E-4, 1.5028E-4, 1.5202E-4, 1.5318E-4,&
     & 1.5388E-4, 1.5469E-4, 1.5527E-4, 1.5579E-4, 1.5585E-4, 1.5832E-4,&
     & 1.6022E-4, 1.6507E-4, 1.8548E-4, 2.3987E-4, 3.3650E-4, 3.8884E-4,&
     & 4.9238E-4, 5.5666E-4, 6.1809E-4, 6.7136E-4, 1.0910E-4, 1.2159E-4,&
     & 1.2971E-4, 1.3748E-4, 1.4362E-4, 1.4872E-4, 1.5498E-4, 1.5753E-4,&
     & 1.5985E-4, 1.6159E-4, 1.6275E-4, 1.6344E-4, 1.6425E-4, 1.6483E-4,&
     & 1.6536E-4, 1.6541E-4, 1.6789E-4, 1.6979E-4, 1.7464E-4, 1.9505E-4,&
     & 2.4944E-4, 3.4607E-4, 3.9841E-4, 5.0195E-4, 5.6623E-4, 6.2765E-4,&
     & 6.8092E-4, 1.2344E-4, 1.3614E-4, 1.4423E-4, 1.5199E-4, 1.5811E-4,&
     & 1.6320E-4, 1.6946E-4, 1.7201E-4, 1.7433E-4, 1.7607E-4, 1.7723E-4,&
     & 1.7792E-4, 1.7873E-4, 1.7931E-4, 1.7983E-4, 1.7989E-4, 1.8237E-4,&
     & 1.8427E-4, 1.8911E-4, 2.0952E-4, 2.6391E-4, 3.6054E-4, 4.1289E-4,&
     & 5.1642E-4, 5.8070E-4, 6.4213E-4, 6.9540E-4, 1.3691E-4, 1.4937E-4,&
     & 1.5742E-4, 1.6540E-4, 1.7159E-4, 1.7662E-4, 1.8287E-4, 1.8543E-4,&
     & 1.8774E-4, 1.8948E-4, 1.9064E-4, 1.9134E-4, 1.9215E-4, 1.9273E-4,&
     & 1.9325E-4, 1.9331E-4, 1.9578E-4, 1.9768E-4, 2.0253E-4/           
      DATA X6101/ 2.2294E-4, 2.7733E-4, 3.7396E-4, 4.2630E-4, 5.2984E-4,&
     & 5.9412E-4, 6.5555E-4, 7.0882E-4, 1.5378E-4, 1.6624E-4, 1.7440E-4,&
     & 1.8215E-4, 1.8835E-4, 1.9346E-4, 1.9971E-4, 2.0225E-4, 2.0458E-4,&
     & 2.0631E-4, 2.0747E-4, 2.0817E-4, 2.0898E-4, 2.0956E-4, 2.1008E-4,&
     & 2.1014E-4, 2.1261E-4, 2.1452E-4, 2.1936E-4, 2.3977E-4, 2.9416E-4,&
     & 3.9079E-4, 4.4314E-4, 5.4667E-4, 6.1095E-4, 6.7238E-4, 7.2565E-4,&
     & 1.6481E-4, 1.7667E-4, 1.8448E-4, 1.9234E-4, 1.9854E-4, 2.0363E-4,&
     & 2.0989E-4, 2.1245E-4, 2.1477E-4, 2.1651E-4, 2.1767E-4, 2.1836E-4,&
     & 2.1917E-4, 2.1975E-4, 2.2027E-4, 2.2033E-4, 2.2281E-4, 2.2471E-4,&
     & 2.2956E-4, 2.4997E-4, 3.0436E-4, 4.0098E-4, 4.5333E-4, 5.5686E-4,&
     & 6.2114E-4, 6.8257E-4, 7.3584E-4, 1.8120E-4, 1.9586E-4, 2.0295E-4,&
     & 2.1100E-4, 2.1726E-4, 2.2244E-4, 2.2884E-4, 2.3129E-4, 2.3362E-4,&
     & 2.3536E-4, 2.3652E-4, 2.3722E-4, 2.3803E-4, 2.3861E-4, 2.3913E-4,&
     & 2.3919E-4, 2.4166E-4, 2.4357E-4, 2.4841E-4, 2.6882E-4, 3.2321E-4,&
     & 4.1984E-4, 4.7219E-4, 5.7572E-4, 6.4000E-4, 7.0143E-4, 7.5470E-4,&
     & 2.1362E-4, 2.2602E-4, 2.2221E-4, 2.2984E-4, 2.3651E-4, 2.4128E-4,&
     & 2.4587E-4, 2.4855E-4, 2.5088E-4, 2.5260E-4, 2.5374E-4/           
      DATA X6201/ 2.5443E-4, 2.5525E-4, 2.5582E-4, 2.5634E-4, 2.5640E-4,&
     & 2.5887E-4, 2.6077E-4, 2.6562E-4, 2.8603E-4, 3.4042E-4, 4.3705E-4,&
     & 4.8939E-4, 5.9293E-4, 6.5721E-4, 7.1864E-4, 7.7191E-4,-5.2035E-5,&
     & 7.6085E-5, 1.4002E-4, 1.9085E-4, 2.2353E-4, 2.4598E-4, 2.6714E-4,&
     & 2.7401E-4, 2.7895E-4, 2.8216E-4, 2.8399E-4, 2.8496E-4, 2.8600E-4,&
     & 2.8666E-4, 2.8721E-4, 2.8727E-4, 2.8974E-4, 2.9164E-4, 2.9649E-4,&
     & 3.1690E-4, 3.7129E-4, 4.6792E-4, 5.2026E-4, 6.2380E-4, 6.8808E-4,&
     & 7.4950E-4, 8.0277E-4,-4.7565E-5, 7.9036E-5, 1.4322E-4, 1.9401E-4,&
     & 2.2677E-4, 2.4919E-4, 2.7042E-4, 2.7722E-4, 2.8217E-4, 2.8540E-4,&
     & 2.8723E-4, 2.8820E-4, 2.8924E-4, 2.8990E-4, 2.9045E-4, 2.9050E-4,&
     & 2.9298E-4, 2.9488E-4, 2.9973E-4, 3.2014E-4, 3.7453E-4, 4.7116E-4,&
     & 5.2350E-4, 6.2704E-4, 6.9132E-4, 7.5274E-4, 8.0601E-4, 1.0020E-4,&
     & 2.2824E-4, 2.9181E-4, 3.4227E-4, 3.7544E-4, 3.9832E-4, 4.1951E-4,&
     & 4.2635E-4, 4.3135E-4, 4.3452E-4, 4.3635E-4, 4.3732E-4, 4.3836E-4,&
     & 4.3902E-4, 4.3957E-4, 4.3963E-4, 4.4210E-4, 4.4400E-4, 4.4885E-4,&
     & 4.6926E-4, 5.2365E-4, 6.2028E-4, 6.7262E-4, 7.7616E-4, 8.4044E-4,&
     & 9.0186E-4, 9.5513E-4, 4.5776E-4, 4.7302E-4, 5.0354E-4/           
      DATA X6301/ 4.8733E-4, 4.9400E-4, 5.0068E-4, 5.0449E-4, 5.0658E-4,&
     & 5.0890E-4, 5.1063E-4, 5.1183E-4, 5.1246E-4, 5.1329E-4, 5.1386E-4,&
     & 5.1438E-4, 5.1444E-4, 5.1691E-4, 5.1881E-4, 5.2366E-4, 5.4407E-4,&
     & 5.9846E-4, 6.9509E-4, 7.4743E-4, 8.5097E-4, 9.1525E-4, 9.7667E-4,&
     & 1.0299E-3, 5.2547E-4, 5.3883E-4, 5.4497E-4, 5.5295E-4, 5.5921E-4,&
     & 5.6422E-4, 5.7056E-4, 5.7308E-4, 5.7540E-4, 5.7714E-4, 5.7830E-4,&
     & 5.7899E-4, 5.7981E-4, 5.8039E-4, 5.8091E-4, 5.8096E-4, 5.8344E-4,&
     & 5.8534E-4, 5.9019E-4, 6.1060E-4, 6.6499E-4, 7.6162E-4, 8.1396E-4,&
     & 9.1750E-4, 9.8178E-4, 1.0432E-3, 1.0965E-3, 5.9795E-4, 6.1035E-4,&
     & 6.1822E-4, 6.2639E-4, 6.3264E-4, 6.3777E-4, 6.4402E-4, 6.4657E-4,&
     & 6.4890E-4, 6.5064E-4, 6.5180E-4, 6.5249E-4, 6.5330E-4, 6.5388E-4,&
     & 6.5440E-4, 6.5446E-4, 6.5694E-4, 6.5884E-4, 6.6369E-4, 6.8410E-4,&
     & 7.3849E-4, 8.3511E-4, 8.8746E-4, 9.9099E-4, 1.0553E-3, 1.1167E-3,&
     & 1.1700E-3, 7.6979E-4, 7.8213E-4, 7.9021E-4, 7.9801E-4, 8.0414E-4,&
     & 8.0924E-4, 8.1551E-4, 8.1805E-4, 8.2037E-4, 8.2211E-4, 8.2327E-4,&
     & 8.2397E-4, 8.2478E-4, 8.2536E-4, 8.2588E-4, 8.2594E-4, 8.2841E-4,&
     & 8.3031E-4, 8.3516E-4, 8.5557E-4, 9.0996E-4, 1.0066E-3/           
      DATA X6401/ 1.0589E-3, 1.1625E-3, 1.2267E-3, 1.2882E-3, 1.3414E-3,&
     & 8.9985E-4, 9.1237E-4, 9.2046E-4, 9.2823E-4, 9.3438E-4, 9.3947E-4,&
     & 9.4573E-4, 9.4828E-4, 9.5060E-4, 9.5234E-4, 9.5350E-4, 9.5419E-4,&
     & 9.5500E-4, 9.5558E-4, 9.5611E-4, 9.5616E-4, 9.5864E-4, 9.6054E-4,&
     & 9.6539E-4, 9.8580E-4, 1.0402E-3, 1.1368E-3, 1.1892E-3, 1.2927E-3,&
     & 1.3570E-3, 1.4184E-3, 1.4717E-3, 1.0105E-3, 1.0230E-3, 1.0311E-3,&
     & 1.0389E-3, 1.0450E-3, 1.0501E-3, 1.0564E-3, 1.0589E-3, 1.0613E-3,&
     & 1.0630E-3, 1.0641E-3, 1.0648E-3, 1.0657E-3, 1.0662E-3, 1.0668E-3,&
     & 1.0668E-3, 1.0693E-3, 1.0712E-3, 1.0760E-3, 1.0964E-3, 1.1508E-3,&
     & 1.2475E-3, 1.2998E-3, 1.4033E-3, 1.4676E-3, 1.5291E-3, 1.5823E-3,&
     & 1.0947E-3, 1.1073E-3, 1.1154E-3, 1.1232E-3, 1.1293E-3, 1.1344E-3,&
     & 1.1407E-3, 1.1432E-3, 1.1455E-3, 1.1473E-3, 1.1484E-3, 1.1491E-3,&
     & 1.1499E-3, 1.1505E-3, 1.1510E-3, 1.1511E-3, 1.1536E-3, 1.1555E-3,&
     & 1.1603E-3, 1.1807E-3, 1.2351E-3, 1.3317E-3, 1.3841E-3, 1.4876E-3,&
     & 1.5519E-3, 1.6133E-3, 1.6666E-3, 1.2675E-3, 1.2800E-3, 1.2881E-3,&
     & 1.2959E-3, 1.3020E-3, 1.3071E-3, 1.3134E-3, 1.3159E-3, 1.3182E-3,&
     & 1.3200E-3, 1.3211E-3, 1.3218E-3, 1.3226E-3, 1.3232E-3/           
      DATA X6501/ 1.3237E-3, 1.3238E-3, 1.3263E-3, 1.3282E-3, 1.3330E-3,&
     & 1.3534E-3, 1.4078E-3, 1.5044E-3, 1.5568E-3, 1.6603E-3, 1.7246E-3,&
     & 1.7860E-3, 1.8393E-3, 1.3753E-3, 1.3878E-3, 1.3959E-3, 1.4037E-3,&
     & 1.4098E-3, 1.4149E-3, 1.4212E-3, 1.4237E-3, 1.4260E-3, 1.4278E-3,&
     & 1.4289E-3, 1.4296E-3, 1.4304E-3, 1.4310E-3, 1.4315E-3, 1.4316E-3,&
     & 1.4341E-3, 1.4360E-3, 1.4408E-3, 1.4612E-3, 1.5156E-3, 1.6123E-3,&
     & 1.6646E-3, 1.7681E-3, 1.8324E-3, 1.8938E-3, 1.9471E-3, 1.5868E-3,&
     & 1.5993E-3, 1.6074E-3, 1.6152E-3, 1.6213E-3, 1.6264E-3, 1.6327E-3,&
     & 1.6352E-3, 1.6376E-3, 1.6393E-3, 1.6405E-3, 1.6411E-3, 1.6420E-3,&
     & 1.6425E-3, 1.6431E-3, 1.6431E-3, 1.6456E-3, 1.6475E-3, 1.6523E-3,&
     & 1.6728E-3, 1.7271E-3, 1.8238E-3, 1.8761E-3, 1.9797E-3, 2.0439E-3,&
     & 2.1054E-3, 2.1586E-3, 1.7004E-3, 1.7129E-3, 1.7210E-3, 1.7287E-3,&
     & 1.7349E-3, 1.7400E-3, 1.7462E-3, 1.7488E-3, 1.7511E-3, 1.7529E-3,&
     & 1.7540E-3, 1.7547E-3, 1.7555E-3, 1.7561E-3, 1.7566E-3, 1.7567E-3,&
     & 1.7592E-3, 1.7611E-3, 1.7659E-3, 1.7863E-3, 1.8407E-3, 1.9373E-3,&
     & 1.9897E-3, 2.0932E-3, 2.1575E-3, 2.2189E-3, 2.2722E-3, 1.7592E-3,&
     & 1.7717E-3, 1.7798E-3, 1.7875E-3, 1.7937E-3, 1.7988E-3/           
      DATA X6601/ 1.8050E-3, 1.8076E-3, 1.8099E-3, 1.8117E-3, 1.8128E-3,&
     & 1.8135E-3, 1.8143E-3, 1.8149E-3, 1.8154E-3, 1.8155E-3, 1.8180E-3,&
     & 1.8199E-3, 1.8247E-3, 1.8451E-3, 1.8995E-3, 1.9961E-3, 2.0485E-3,&
     & 2.1520E-3, 2.2163E-3, 2.2777E-3, 2.3310E-3, 5.1200E-1, 5.2000E-1,&
     & 5.3000E-1, 5.4000E-1, 5.5000E-1, 5.6000E-1, 5.7000E-1, 5.8000E-1,&
     & 5.9000E-1, 6.0000E-1, 6.2000E-1, 6.4000E-1, 6.6000E-1, 6.8000E-1,&
     & 7.0000E-1, 7.2000E-1, 7.4000E-1, 7.6000E-1, 7.8000E-1, 8.0000E-1,&
     & 8.2000E-1, 8.4000E-1, 8.6000E-1, 8.8000E-1, 9.0000E-1, 9.2000E-1,&
     & 9.4000E-1, 9.5000E-1, 9.6000E-1, 9.7000E-1, 9.8000E-1, 9.8500E-1,&
     & 9.9000E-1, 9.9500E-1, 1.0000E+0, 4.8031E-3, 5.7127E-3, 7.0384E-3,&
     & 8.5979E-3, 1.0419E-2, 1.2530E-2, 1.4962E-2, 1.7747E-2, 2.0917E-2,&
     & 2.4506E-2, 3.3084E-2, 4.3772E-2, 5.6879E-2, 7.2725E-2, 9.1643E-2,&
     & 1.1397E-1, 1.4007E-1, 1.7029E-1, 2.0498E-1, 2.4452E-1, 2.8927E-1,&
     & 3.3960E-1, 3.9590E-1, 4.5856E-1, 5.2804E-1, 6.0482E-1, 6.8951E-1,&
     & 7.3504E-1, 7.8285E-1, 8.3305E-1, 8.8580E-1, 9.1318E-1, 9.4126E-1,&
     & 9.7006E-1, 1.0000E+0, 2.7638E+0, 2.7506E+0, 2.7339E+0, 2.7170E+0,&
     & 2.6999E+0, 2.6826E+0, 2.6651E+0, 2.6474E+0, 2.6295E+0/           
      DATA X6701/ 2.6115E+0, 2.5747E+0, 2.5372E+0, 2.4988E+0, 2.4595E+0,&
     & 2.4190E+0, 2.3774E+0, 2.3344E+0, 2.2898E+0, 2.2435E+0, 2.1950E+0,&
     & 2.1441E+0, 2.0901E+0, 2.0325E+0, 1.9703E+0, 1.9020E+0, 1.8253E+0,&
     & 1.7364E+0, 1.6851E+0, 1.6271E+0, 1.5591E+0, 1.4746E+0, 1.4217E+0,&
     & 1.3555E+0, 1.2616E+0, 1.0000E+0, 2.7887E-3, 3.2715E-3, 3.9641E-3,&
     & 4.7653E-3, 5.6861E-3, 6.7377E-3, 7.9320E-3, 9.2810E-3, 1.0797E-2,&
     & 1.2494E-2, 1.6483E-2, 2.1364E-2, 2.7260E-2, 3.4310E-2, 4.2663E-2,&
     & 5.2491E-2, 6.3985E-2, 7.7369E-2, 9.2902E-2, 1.1090E-1, 1.3173E-1,&
     & 1.5591E-1, 1.8406E-1, 2.1708E-1, 2.5629E-1, 3.0379E-1, 3.6329E-1,&
     & 3.9965E-1, 4.4251E-1, 4.9494E-1, 5.6323E-1, 6.0765E-1, 6.6458E-1,&
     & 7.4649E-1, 1.0000E+0, 1.1141E+1, 1.1246E+1, 1.1377E+1, 1.1506E+1,&
     & 1.1634E+1, 1.1759E+1, 1.1882E+1, 1.2003E+1, 1.2122E+1, 1.2238E+1,&
     & 1.2465E+1, 1.2682E+1, 1.2892E+1, 1.3095E+1, 1.3291E+1, 1.3483E+1,&
     & 1.3672E+1, 1.3858E+1, 1.4044E+1, 1.4229E+1, 1.4416E+1, 1.4604E+1,&
     & 1.4795E+1, 1.4990E+1, 1.5190E+1, 1.5399E+1, 1.5623E+1, 1.5745E+1,&
     & 1.5878E+1, 1.6027E+1, 1.6204E+1, 1.6310E+1, 1.6438E+1, 1.6609E+1,&
     & 1.7031E+1, 2.2282E+1, 2.2159E+1, 2.2012E+1, 2.1872E+1/           
      DATA X6801/ 2.1738E+1, 2.1610E+1, 2.1488E+1, 2.1370E+1, 2.1258E+1,&
     & 2.1149E+1, 2.0944E+1, 2.0753E+1, 2.0573E+1, 2.0404E+1, 2.0243E+1,&
     & 2.0089E+1, 1.9941E+1, 1.9797E+1, 1.9657E+1, 1.9518E+1, 1.9381E+1,&
     & 1.9244E+1, 1.9104E+1, 1.8960E+1, 1.8809E+1, 1.8646E+1, 1.8463E+1,&
     & 1.8360E+1, 1.8244E+1, 1.8110E+1, 1.7946E+1, 1.7844E+1, 1.7718E+1,&
     & 1.7546E+1, 1.7031E+1, 9.2157E-2, 1.4675E-1, 2.1553E-1, 2.8477E-1,&
     & 3.5435E-1, 4.2413E-1, 4.9402E-1, 5.6393E-1, 6.3378E-1, 7.0352E-1,&
     & 8.4254E-1, 9.8085E-1, 1.1186E+0, 1.2562E+0, 1.3941E+0, 1.5332E+0,&
     & 1.6741E+0, 1.8178E+0, 1.9652E+0, 2.1170E+0, 2.2742E+0, 2.4374E+0,&
     & 2.6076E+0, 2.7860E+0, 2.9746E+0, 3.1769E+0, 3.3998E+0, 3.5231E+0,&
     & 3.6584E+0, 3.8116E+0, 3.9941E+0, 4.1039E+0, 4.2360E+0, 4.4127E+0,&
     & 4.8413E+0, 5.7962E+0, 5.8213E+0, 5.8520E+0, 5.8823E+0, 5.9119E+0,&
     & 5.9409E+0, 5.9693E+0, 5.9969E+0, 6.0238E+0, 6.0499E+0, 6.0996E+0,&
     & 6.1458E+0, 6.1882E+0, 6.2264E+0, 6.2602E+0, 6.2892E+0, 6.3130E+0,&
     & 6.3311E+0, 6.3431E+0, 6.3482E+0, 6.3457E+0, 6.3346E+0, 6.3134E+0,&
     & 6.2802E+0, 6.2321E+0, 6.1644E+0, 6.0691E+0, 6.0066E+0, 5.9297E+0,&
     & 5.8321E+0, 5.7012E+0, 5.6148E+0, 5.5037E+0, 5.3450E+0/           
      DATA X6901/ 4.8413E+0, 2.9680E-1, 1.2630E+2, 3.4170E+0, 3.1050E-1,&
     & 1.0000E-3, 2.0000E-3, 1.0000E-3, 1.0000E-3/                      
                                                                        
!----------------------------------------------------------------------------

       NG = 21 
       N1 = 27 
       NTT = 30 
       N3 = 8 
       NS = 35 
       DO 20 I=1,4 
         DO 10 J=1,21 
           G(J,I) = Z(J+(I-1)*21) 
   10    CONTINUE 
   20  CONTINUE 

       DO 30 I=1,27
         TT(I) = Z(I+84) 
   30 END DO 

       DO 40 I=1,30
         DD(I) = Z(I+111) 
   40  CONTINUE 

       KK=141
       DO 70 I=1,8 
         DO 60 J=1,30 
           DO 50 K=1,27 
             KK=KK+1 
             GG(K,J,I) = Z(KK) 
   50      CONTINUE 
   60    CONTINUE 
   70  CONTINUE 

       DO 90 I=1,8
         DO 80 J=1,35 
           SAT(J,I) = Z(J+(I-1)*35+6621) 
   80    CONTINUE 
   90  CONTINUE 

      DO 100 I=1,8
        C(I) = Z(I+6901) 
  100 CONTINUE 


      IGOTO = 4
      CALL FLUID(TEMP,PRES,DENS,PROPS,NP,ENTRY,VAPOR,ERROR,IGOTO) 

      RETURN
      END Subroutine NITRO
