      PROGRAM MAIN
C
C This is PC Version of classic NASA hypersonic arbitrary body program.
C It was translated to PC by Igor Polyakov, Ukraine.
C
C *********************************************************************
C ******                                                         ******
C * SUPERSONIC-HYPERSONIC ARBITRARY-BODY AERODYNAMIC COMPUTER PROGRAM *
C ******                                                         ******
C *********************************************************************
C
C    This is the Mark-4 Mod 0 Version of the supersonic-hypersonic
c    arbitrary-body force analysis program, the basic program
c    was developed at the Douglas Aircraft Company, Aircraft
c    Division under sponsorship of the Air Force Flight Dynamics Lab.
C
C ******* THIS PROGRAM WAS WRITTEN BY A.E.GENTRY AND D.N.SMYTH ********
C *********************************************************************
C
C
C
C ****** EXECUTIVE MAIN PROGRAM ******
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     _             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      DIMENSION IPG(20)
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     _        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER PAGE,ERROR
      INTEGER CASE
      Character *4 TITLE(15)
C
      ERROR = 0
      PAGE = 1
      TAPEIN = 5
      TAPEOT = 6
      TAPEA = 3
      TAPEB = 2
      TAPEC = 11
      TAPED = 14
      TAPEE = 12
      TAPEF = 13
      TAPEG = 7
      OPEN( TAPEIN, FILE = 'TAPEIN' )
      OPEN( TAPEOT, FILE = 'TAPEOT' )
      OPEN( 1, FILE = 'TmpInput' )
      OPEN( TAPEA, FILE = 'TAPEA', FORM = 'UNFORMATTED' )
      OPEN( TAPEB, FILE = 'TAPEB', FORM = 'UNFORMATTED' )
      OPEN( TAPEC, FILE = 'TAPEC', FORM = 'UNFORMATTED' )
      OPEN( TAPED, FILE = 'TAPED', FORM = 'UNFORMATTED' )
      OPEN( TAPEE, FILE = 'TAPEE', FORM = 'UNFORMATTED' )
      OPEN( TAPEF, FILE = 'TAPEF', FORM = 'UNFORMATTED' )
      OPEN( TAPEG, FILE = 'TAPEG', FORM = 'UNFORMATTED' )
      OPEN(  4, ACCESS='DIRECT', FILE = 'Unit4' , RECL=100 )
      OPEN(  9, ACCESS='DIRECT', FILE = 'Unit9' , RECL=164 )
      OPEN( 10, ACCESS='DIRECT', FILE = 'Unit10', RECL=100 )
*      open( 15, FILE = 'output' )
      REWIND  TAPEA
      REWIND  TAPEB
      REWIND  TAPEC
      REWIND  TAPEE
      REWIND  TAPEF
      REWIND  8
C *********************************************************************
C ***** READ EXECUTIVE FLAG CARD
      READ( TAPEIN, '( // 2I7 )' )  IEROR, INMONT
      IF( INMONT .EQ. 1 )  CALL MONITR
C
C ***** READ SYSTEM CONTROL CARD TO SELECT PROGRAM TO BE USED AND ORDER
C ***** OF USE. A MAXIMUM OF 20 OPTIONS MAY BE USED. THIS VERSION OF
C ***** THE PROGRAM WILL ALLOW ONLY OPTIONS 1, 2, 3, 4.
C**********************************************************************
C
      READ( TAPEIN, '( // 20I1, 39X, A4 )' )  IPG, CASE
      WRITE( TAPEOT, "(  //,
     _       '** SUPERSONIC-HYPERSONIC ARBITRARY-BODY',
     _       ' AERODYNAMIC COMPUTER PROGRAM SYSTEM **', ///,
     _        ' ', 10X,
     _       'PROGRAM OPTIONS ARE IN THE FOLLOWING ORDER :',/ )" )
      IF ( IPG(1) .EQ. 0 )  GOTO 220
C
C
      Do  I=1,20
         IF ( IPG(I) .EQ. 0 )  GOTO 90
         IF ( IPG(I) .GT. 4 )  GOTO 240
         IF ( IPG(I) .EQ. 1 )  WRITE( TAPEOT,
     _      "( 15X, I2, '. GEOMETRY PROGRAM  (OPTION 1)' )" ) I
         IF ( IPG(I) .EQ. 2 )  WRITE( TAPEOT,
     _      "( 15X, I2, '. AERODYNAMIC PROGRAM  (OPTION 2)' )" ) I
         IF ( IPG(I) .EQ. 3 )  WRITE( TAPEOT,
     _      "( 15X, I2, '. GRAPHICS PROGRAM  (OPTION 3)' )" ) I
         IF ( IPG(I) .EQ. 4 )  WRITE( TAPEOT,
     _      "( 15X, I2, '. AUXILIARY PROGRAMS (OPTION 4)' )" )  I
      EndDo
   90 I = 0
C
  100 IF ( I .LT. 20 ) THEN
         I = I+1
      ELSE
         GOTO 260
      ENDIF
      IF ( IPG(I) .EQ. 0 )  GOTO 260
C
      IPROG = IPG(I)
      GOTO( 110, 120 ), IPROG
C#    GOTO( 110, 120, 130, 140) , IPROG
  110 CALL  GEOM
      GOTO  150
C
  120 CALL AERO
      GOTO  150
C
C#130 CALL  GRAPH
      GOTO  150
C
C#140 CALL AUXILI
      GOTO  150
C
  150 IF ( ERROR .EQ. 2 ) GOTO 200
      IF ( ERROR .NE. 0 ) GOTO 190
      WRITE( TAPEOT, "( //,
     _       '*** MAIN PROGRAM NOW HAS CONTROL OF SYSTEM ***' )" )
      GOTO 100
C
C
  190 WRITE( TAPEOT,
     _       "( '***AN ERROR HAS OCCURRED IN PHASE' , I3,
     _       ' AND WAS DETECTED AFTER RETURN TO THE MAIN EXECUTIVE RO',
     _       'UTINE.  ERROR =' ,I2 )" )  I, ERROR
      GOTO  280
C
  200 WRITE( TAPEOT,
     _       "( //, '*** FATAL ERROR *** PROGRAM STOPPED' )" )
      GOTO  280
C
  220 WRITE( TAPEOT,
     _       "( //, '*** FIRST PHASE OPTION IS ZERO ***',
     _       '**** FATAL ERROR ****' )" )
      GOTO  260
C
  240 WRITE( TAPEOT,
     _       "( //, '*** PROGRAM OPTION IS GREATER THEN 4 *',
     _       '** FATAL ERROR ***' )" )
      GOTO  280
C
  260 WRITE( TAPEOT,
     _       "( //,
     _       '*** NORMAL PROGRAM TERMINATION ***' )" )
  280 STOP
      END
      SUBROUTINE ACONE(ANGLE,CP,ALF,PHI,ALFP,EMP,IT,IPRCK)
C   CIRCULAR CONE AT ANGLE OF ATTACK.
C   BASED ON ARC CP #792 AND EXTENDED BY D.N. SMYTH.
C
      DIMENSION FS(8),BS(8),ANGLE(3)
      DIMENSION AA(6),A(18)
C
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /FSBS/FS,BS
C
      DATA A/-0.07657,  1.4775,   0.064669,
     1        0.42339,  0.13241,  0.035871,
     2       -0.002083,-0.075797,-0.01923,
     3        0.29898, -0.10011,  0.29589,
     4       -0.99727, -0.41751,  0.068791,
     5       -0.039442, 0.10422,  0.063801/
      DATA RC/.17453292E-1/
C
      G=GAM
      EM=FS(6)
      GM1=G-1.0
      DCR=ANGLE(1)*RC
      GP1=G+1.0
      PMIN=0.3
      CPCONE=0.0
      CPSTAG=0.0
      CPX=0.0
      DPSK=0.0
      COSA=dcos(DBLE(ALF))
      SINA=dsin(DBLE(ALF))
      COSP=dcos(DBLE(PHI))
      SINP=dsin(DBLE(PHI))
      EM2=EM**2
      CPMIN=(PMIN-1.0)/(0.5*G*EM2)
C
      IF (DCR .LT. 0.0) GOTO 35
      IF (DCR .LT. 1.E-4) GOTO 5
      IF (DCR .LT. 0.0872665) GOTO 4
      IF (IT .EQ. 1) GOTO 4
C
C   JONE'S METHOD (AIAA JL., FEB., 1972, PP234-236).
      EM2I=1.0/EM2
      COS2P=dcos(DBLE(2.0*PHI))
      T=dsin(DBLE(2.9*DCR))*dtan(DBLE(DCR))
      AC=ALF/DCR
      EMA=EM
      CALL CONE(ANGLE,CPCONE,ISDET)
      PCONE=0.5*G*EM2*CPCONE+1.0
      EMS=BS(6)
      DSC=ANGLE(3)*RC
C
      DO 3 I=1,6
      J=3*(I-1)+1
    3 AA(I)=A(J)+A(J+1)*COSP+A(J+2)*COS2P
C
      CPX=(AA(1)*T+AA(2)*T*EM2I+AA(3)*EM2I)*AC
     1   +(AA(4)*T+AA(5)*T*EM2I+AA(6)*EM2I)*AC**2
      GOTO 40
C
C
C
C   AXIAL FLOW COMPONENT
    4 EMA=EM*COSA
      FS6=FS(6)
      FS(6)=EMA
      CALL CONE(ANGLE,CPCONE,ISDET)
      PCONE=0.5*G*EMA**2*CPCONE+1.0
      CPCONE=(PCONE-1.0)/(0.5*G*EM2)
      EMS=BS(6)
      DSC=ANGLE(3)*RC
      FS(6)=FS6
C
    5 IF (ALF .LT. 1.E-4) GOTO 40
C
C   NORMAL FLOW COMPONENT
      EMC2=EM2*(SINA)**2
      IF (EMC2-1.0) 10,10,20
C   SUBSONIC NORMAL COMPONENT
   10 PSTAG=(1.0+0.5*GM1*EMC2)**(G/GM1)
      GOTO 30
C   SUPERSONIC NORMAL COMPONENT
   20 PSTAG=(0.5*GP1*EMC2)**(G/GM1)*(GP1/(2.*G*EMC2-GM1))**(1./GM1)
   30 CPSTAG=(PSTAG-1.0)/(0.5*G*EM2)*COSP*DABS(DBLE(COSP))
C
      IF (CPSTAG .LT. 0.0) CPSTAG=0.0
      IF (DCR .LT. 1.E-4) GOTO 40
C   CROSS PRODUCT TERM - EMPIRICAL FIT FROM CP #792.
      SCD=dsin(DBLE(DCR))*dcos(DBLE(DCR))
      X=0.5*3.141592654/(SCD*dsqrt(DBLE(EM2-1.0)))
      BK=1.95+0.07*dcos(DBLE(X))
      CPX=2.0*BK*SCD*COSP*SINA*COSA
      GOTO 40
C
C   CONE FLOW IS DETACHED OR UNDEFINED (DCR .LT. 0.0)
C   USE IMPACT METHODS
C
C   FIRST GET IMPACT ANGLE (IN MERIDIAN PLANE)
   35 CONTINUE
      DELI=ALFP+DCR
      IF (DELI .GT. 0.0) GOTO 36
C
C   EXPANSION FLOW
      ANGLE(2)=DABS(DBLE(DELI))*57.29577951
      FS(6)=EMP
      IPRINT=0
      ISDET=2
      CALL EXPAND(ANGLE,MER,IPRINT,ISDET,CP)
      EMSURF=BS(6)
      EM2=EMP**2
      PSURF=0.5*G*EM2*CP+1.0
      IF (PSURF .LT. PMIN) PSURF=PMIN
      GOTO 50
C
C   COMPRESSION FLOW, USE TANGENT-CONE EMPIRICAL
   36 CK=2.*GP1/(G+3.)*EMP*dsin(DBLE(DELI))
      EMNS=(CK+dexp(DBLE(-CK)))**2
      CP=(8.*GP1*EMNS/((3.+5.)*EMNS+2.))*dsin(DBLE(DELI))**2
      PSURF=0.5*G*EM2*CP+1.0
      IF (PSURF .LT. PMIN) PSURF=PMIN
      PCONE=PSURF
      DPSK=PCONE-(2.*G*EMNS-GM1)/GP1
      GOTO 50
C
C   COMBINED SURFACE PRESSURE
   40 PSURF=0.5*G*EM2*(CPCONE+CPSTAG+CPX)+1.0
C
C   LIMIT MINIMUM PSURF
      IF (PSURF .LT. PMIN) PSURF=PMIN
C
C   SHOCK ANGLE DSR, RELATIVE TO AXIS
C
C   USE IMPACT METHODS TO OBTAIN DPSK
C   (ADJUST TO ALPHA = ZERO RESULTS)
C
      DELI=DCR
      IS=1
      FDP=1.0
      EMC=EMA
      GOTO 46
C
C   CALCULATE VALUE FROM NCONE
   45 CONTINUE
      EMNS=(EMA*dsin(DBLE(DSC)))**2
      PS=(2.*G*EMNS-GM1)/GP1
      FDP=PS/P2
      EMC=EMP
C
C   NOW CALCULATE VALUE AT ACTUAL IMPACT ANGLE
      DELI=ALFP+DCR
      DPSK=0.0
      IF (DELI .LE. 0.0) GOTO 50
      IS=2
   46 EMD=EMC*dsin(DBLE(DELI))
      CK=2.*GP1/(G+3.)*EMD
      EMNS=(CK+dexp(DBLE(-CK)))**2
      P2=(2.*G*EMNS-GM1)/GP1
      GOTO (45,47), IS
   47 DPSK=PSURF-P2*FDP
   50 IF (DPSK .LT. 0.0) DPSK=0.0
      PSHK=PSURF-DPSK
      IF (PSHK .LT. 1.0) PSHK=1.0
C   SURFACE MACH NUMBER
      EMSURF=dsqrt(DBLE((EM2*(GP1*PSHK+GM1)-2.*GP1*GM1)
     1      /(PSHK*(GM1*PSHK+GP1))))
C
      EM2=EMP**2
      DSR=(GP1*PSHK+GM1)/(2.*G*EM2)
      IF (DSR .GT. 1.0) DSR=1.0
      IF (DSR .LT. 0.0) DSR=1.0/EM2
      DSR=dasin(dsqrt(DBLE(DSR)))
      DSR=DSR-ALFP
C
C
C   CALCULATE BS ARRAY
      EM2=EM**2
      BS(6)=EMSURF
      BS(2)=FS(2)*PSURF
      CP=(PSURF-1.0)/(0.5*G*EM2)
      ANGLE(3)=DSR/RC
      TST1=(1.+0.5*GM1*EM2)/(1.+0.5*GM1*EMSURF**2)
      BS(3)=FS(3)*TST1
      BS(1)=FS(1)*PSURF/TST1
      BS(4)=FS(4)*dsqrt(DBLE(TST1))
      IF (BS(3).GE.AV1) BS(5)=2.27E-8*BS(3)**1.5/(BS(3)+198.6)
      IF (BS(3).LT.AV1) BS(5)=AV2*BS(3)**AV3
      BS(7)=BS(6)*BS(4)
      BS(8)=BS(1)*BS(7)/BS(5)
C
      IF (IPRCK .NE. 1) RETURN
      WRITE(6,100) CPCONE,CPSTAG,CPX,CP
  100 FORMAT( 9HCPCONE = ,F10.5,5X,9HCPSTAG = ,F10.5,
     1       5X,6HCPX = ,F10.5,5X,5HCP = ,F10.5,/)
      WRITE (6,200) FS,BS
  200 FORMAT( 10HFS ARRAY  ,8F15.6,/ 10HBS ARRAY  ,8F15.6)
      RETURN
      END
      SUBROUTINE AERO
C
C
C **** THIS ROUTINE CONTROLS THE AERODYNAMIC PROGRAM
C
C
      COMMON /FLIGHT/MACH,ALT,PSTAG,TSTAG,V,RENO,PFS,TFS,AFS,RHOFS,VIS
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /FSBS/FS,BS
      COMMON /TAGS/ITAG4,ITAG9,ITAG10
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /REF/SREF,MAC,SPAN,XCG,YCG,ZCG
      COMMON /ABDATA/NAB,ALPHA(20),BETA(20),ROL(20),CDELTA(20),QI(20),
     1               RI(20),PI(20)
      COMMON /INTERF/INT,ISHE(20),NSHE(100),I9,ISHEF,INF(20,22),
     1               DINF(20,6),LTOTAB(20)
C
      DIMENSION IPG(20),FS(8),BS(8)
C
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      REAL*8 MACH,MAC
      Character *4 TITLE(15)
C
      Character *4 GAS1,GAS2,GAS3,GAS4,GTYPE
      DATA GAS1, GAS2, GAS3, GAS4 /4H  *A,4HIR* ,4H*HEL,4HIUM*/
C
C ** READ AERO SYSTEM CONTROL CARD
      READ (TAPEIN,10) TITLE
   10 FORMAT( ///15A4 )
      WRITE (TAPEOT,20) TITLE
   20 FORMAT ( 31H***** AERODYNAMIC PROGRAM *****,/ 15A4)
C
C ** READ AERO FLAG CARD
      READ (TAPEIN,30) IPG
   30 FORMAT( /// (10I7) )
C
      DO 80 I=1,20
      IF (IPG(I) .EQ. 0) GOTO 90
      IF (IPG(I) .EQ. 1) WRITE (TAPEOT,40) I
      IF (IPG(I) .EQ. 2) WRITE (TAPEOT,50) I
      IF (IPG(I) .EQ. 3) WRITE (TAPEOT,60) I
      IF (IPG(I) .EQ. 4) WRITE (TAPEOT,70) I
      IF (IPG(I) .EQ. 5) WRITE (TAPEOT,71) I
      IF (IPG(I) .EQ. 6) WRITE (TAPEOT,72) I

   40 FORMAT ( 15X,I2,31H FLOW FIELD ANALYSIS (OPTION 1))
   50 FORMAT ( 15X,I2,31H SHIELDING ANALYSIS  (OPTION 2))
   60 FORMAT ( 15X,I2,31H INVISCID PRESSURES  (OPTION 3))
   70 FORMAT ( 15X,I2,31H VISCOUS FORCES      (OPTION 4))
   71 FORMAT ( 15X,I2,31H SPECIAL ROUTINES    (OPTION 5))
   72 FORMAT ( 15X,I2,33H STREAM LINES ANALYSIS (OPTION 6))

   80 CONTINUE
C
C ** READ FLIGHT CONDITION CARD
   90 READ (TAPEIN,100) MACH,ALT,PSTAG,TSTAG,IGAS,NAB
  100 FORMAT( // 4G7.1, 2I7 )
C  Convert Altitude in Metres to Foots
      ALT = ALT / 0.3048
C ** READ REFERENCE DIMENSION CARD
      READ (TAPEIN,110) SREF,MAC,SPAN,XCG,YCG,ZCG
  110 FORMAT( // 6F7.0 )
      DO i = 1,3
         READ (tapein, "()")
      END DO
      DO 130 I=1,NAB
      READ (TAPEIN,120) ALPHA(I),BETA(I),ROL(I),CDELTA(I),QI(I),RI(I),
     _                  PI(I)
  120 FORMAT( 7F7.0 )
  130 CONTINUE
C
C ** SET GAS CONSTANTS
      IF (IGAS .EQ. 1) GOTO 140
C ***** AIR *****
      GAM=1.40
      GASCP=6.00793E+3
      PRAN=0.71
      AV1=225.0
      AV2=8.0382436E-10
      AV3=1.0
      GTYPE(1)=GAS1
      GTYPE(2)=GAS2
      GOTO 150
C
C ***** HELIUM *****
  140 GAM=5./3.
      GASCP=3.1250E+4
      PRAN=2./3.
      AV1=1.0E+5
      AV2=7.17884E-9
      AV3=0.647
      GTYPE(1)=GAS3
      GTYPE(2)=GAS4
C
  150 CONTINUE
C ** DETERMINE FREE STREAM PROPERTIES
      IF (ALT .GE. -1000.0) GOTO 160
      PFS=PSTAG
      TFS=TSTAG
      GOTO 180
  160 CONTINUE
      IF (PSTAG .GT. 0.0) GOTO 170
C ** USE  U S 1962 ATMOSPHERE
      CALL ATMOS(ALT,TFS,PFS,AFS,RHOFS)
      GOTO 190
C ** USE WIND TUNNEL CONDITIONS (GAMMA=GAM) E0.44,43,29C,26 OF TR-1135
  170 PFS=PSTAG*(1.+(GAM-1.)*MACH*MACH/2.)**(-GAM/(GAM-1.))*2116.217
      TFS=(TSTAG+459.6)/(1.0+(GAM-1.0)*MACH*MACH/2.0)
  180 CONTINUE
      AFS=dsqrt(DBLE((GAM-1.0)*GASCP*TFS))
      RHOFS=GAM*PFS/((GAM-1.0)*GASCP*TFS)
  190 IF (TFS.GE.AV1) VIS=2.27E-8*TFS**1.5/(TFS+198.6)
      IF (TFS.LT.AV1) VIS=AV2*TFS**AV3
      V=MACH*AFS
      RENO=RHOFS*V/VIS
C ** INITIALIZE FREE STREAM DATA ARRAY
      FS(1)=RHOFS
      FS(2)=PFS
      FS(3)=TFS
      FS(4)=AFS
      FS(5)=VIS
      FS(6)=MACH
      FS(7)=MACH*FS(4)
      FS(8)=FS(1)*FS(7)/FS(5)
C
      J=0
  200 J=J+1
      IF (IPG(J) .EQ. 0) GOTO 260
      IPROG=IPG(J)
C
C     GOTO (210,220,230,240,241,243), IPROG
      GOTO (210,220,230,230,241,230), IPROG
C
  210 CALL FLOW
      GOTO 250
  220 CALL SHIELD
      GOTO 250
  230 CALL PRES
      GOTO 250
C 240 CALL VISCUS
C     GOTO 250
  241 CALL SPEC
      GOTO 250
C
C 243 CALL STREAM
C     GOTO 250
C
  250 IF (ERROR .EQ. 0) GOTO 200
      GOTO 280
  260 CONTINUE
C
      WRITE (TAPEOT,270)
  270 FORMAT ( 37H *** AERODYNAMIC ANALYSIS IS COMPLETE  )
C
C
  280 RETURN
      END
      SUBROUTINE AIRCFT
C
C *********************************************************************
C ****** MAIN PROGRAM FOR AIRCRAFT TYPE VEHICLE GEOMETRY GENERATION
C ****** OPTION. THIS OPTION MAY ALSO BE USED TO CONVERT GEOMETRY
C ****** DATA FOR THE NASA (HARRIS) WAVE DRAG PROGRAM TO ELEMENT
C ****** DATA FORMAT FOR USE BY THE HYPERSONIC ARBITRARY-BODY
C ****** PROGRAM OR BY THE ARBITRARY-BODY GRAPHICS PROGRAMS.
C *********************************************************************
C
C     *** THIS PROGRAM WRITTEN BY A.E.GENTRY AND D.N.SMYTH ***
C         DOUGLAS AERO RESEARCH GROUP, LONG BEACH
C
C   NOTE- THE INPUT DATA MUST BE EXACTLY AS REQUIRED FOR THE
C         CONFIGURATION DATA FOR THE HARRIS PROGRAM (INCLUDING
C         THE IDENTIFICATION CARD). MULTIPLE CONFIGURATIONS
C         CAN BE STACKED ONE BEHIND THE OTHER.
C
C *******************************************************************
C
      DIMENSION
     1    XAF(30),WAFORG(20,4),TZORD(20,30),WAFORD(20,30),
     2    NRADX(4),NFORX(4),XFUS(4,30),ZFUS(4,30),FUSARD(4,30),
     3         YFUSY(4,30,30),ZFUSZ(4,30,30),
     4    PODORG(9,6),XPOD(9,30),PODR(9,30),IOR(9),IEL(9),NEL(9),
     5    FINORG(6,2,4),XFIN(6,10),FINORD(6,10),
     6    CANORG(2,2,4),XCAN(2,10),CANORD(2,10),CANOR1(2,10),
     7   XOC(30),AFORG(20,7),AFCAM(20,30),AFORD(20,30)
C
      COMMON /ACFT/IPRINT,ITAPE,ITYPE,PI,DX,CASE
C
      COMMON /ARFOIL/ NAF,NAFORD,NCAM,NACA,ITIP,IROOT,
     1                XOC,AFORG,AFCAM,AFORD,SURFID,
     2                ISURF,IFLAP,NHNGE
C
      COMMON /FUSD/J2,J6,NFUS,NRADX,NFORX,XFUS,ZFUS,YFUSY,ZFUSZ,FUSARD
C
      COMMON /NACELD/NP,NPODOR,PODORG,XPOD,PODR,IOR,IEL,NEL
C
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /GFLAG/IOUT,ISTAT,IORIEN,COMPIN

      Character *4 CARD(17), SURF1, SURF2(6), SURF3(2), SURFID
      Integer COMPIN
C
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER CASE, TYPE, TYCH
C
      DATA TYCH/99/
      DATA SURF1/4HWING/,
     1     SURF2(1),SURF2(2),SURF2(3),SURF2(4),SURF2(5),SURF2(6)/
     2     4HFIN1,4HFIN2,4HFIN3,4HFIN4,4HFIN5,4HFIN6/,
     3     SURF3(1),SURF3(2)/4HCAN1,4HCAN2/
C     IPRINT=1
      IPRINT=0
C
      ITAPE=IOUT
      ITYPE=3
      PI=3.1415926
      TYPE=1
C
C
C ** PROGRAM OPERATION STARTS HERE ----
C
C   READ IDENTIFICATION CARD, CONTROL CARD, AND REFERENCE AREA
C   CARD (IF REQUIRED)
   10 IF( TYPE .EQ. TYCH ) GOTO 780
      READ (TAPEIN,20) (CARD(I),I=1,17),ISTAT3,IHARIS,CASE,TYPE
   20 FORMAT ( /// 17A4 // 4i7 )
C  CHECK FOR NASA-HARRIS INPUT COORDINATES.
      DX=1.0
      IF (IHARIS .EQ. 1) DX=-1.0
C
      WRITE (TAPEOT,30) (CARD(I),I=1,17),CASE
   30 FORMAT ( 48H*** OUTPUT GEOMETRY DATA FROM AIRCRAFT GEOMETRY ,
     _ 11HOPTION ****,/ 5X,13HCONFIGURATION,5X,17A4,6X,5HCASE ,I2,
     _ //,6X,1HX,9X,1HY,9X,1HZ,4X,1HS,5X,1HX,9X,1HY,9X,1HZ,4X,1HS,/1H )
      READ (TAPEIN,40) J0, J1, J2, J3, J4, J5, J6, J7
      READ (TAPEIN,40) NWAF,NWAFOR
      READ (TAPEIN,40) NFUS
      READ (TAPEIN,40) (NRADX(I),NFORX(I),I=1,NFUS)
      READ (TAPEIN,40) NP, NPODOR, NF, NFINOR, NCAN, NCANOR
   40 FORMAT( /10i7 )
      IF (J0 .EQ. 1) READ (TAPEIN,50) REFA
   50 FORMAT (F7.2,73X)
C
C *** CONTROL FLAG CARD DATA CHECK
      IF (IABS(J1) .NE. 1) GOTO 60
      I=9
      IF (NWAF.LT.2 .OR. NWAF.GT.20) GOTO 750
      I=10
      IF (NWAFOR.LT.3 .OR. NWAFOR.GT.30) GOTO 750
   60 IF (IABS(J2) .NE. 1) GOTO 80
      I=11
      IF (NFUS.LT.1 .OR. NFUS.GT.4) GOTO 750
      DO 70 J=1,NFUS
      I=I+1
      IF (NRADX(J).LT.3 .OR. NRADX(J).GT.30) GOTO 750
      I=I+1
      IF (NFORX(J).LT.2 .OR. NFORX(J).GT.30) GOTO 750
   70 CONTINUE
   80 IF (J3 .NE. 1) GOTO 90
      I=20
      IF (NP.LT.1 .OR. NP.GT.9) GOTO 750
      I=21
      IF (NPODOR.LT.2 .OR. NPODOR.GT.30) GOTO 750
   90 IF (J4 .NE. 1) GOTO 100
      I=22
      IF (NF.LT.1 .OR. NF.GT.6) GOTO 750
      I=23
      IF (NFINOR.LT.3 .OR. NFINOR.GT.10) GOTO 750
  100 IF (J5 .NE. 1) GOTO 110
      I=24
      IF (NCAN.LT.1 .OR. NCAN.GT.2) GOTO 750
      I=25
      N=IABS(NCANOR)
      IF (N.LT.3 .OR. N.GT.10) GOTO 750
  110 CONTINUE
C
C *** END OF CONTROL FLAG DATA CHECK
C
C
C
C *** WING ***
C ************
      IF (J1.EQ.0 .OR. J1.EQ.2) GOTO 260
C ** READ PERCENT-CHORD LOCATIONS
      READ (TAPEIN,120) (XAF(I),I=1,NWAFOR)
  120 FORMAT( //10F7.0,10X )
C ** READ LOCATION OF CHORD LEADING EDGES AND LENGTH
      read( TAPEIN, '(/)' )
      DO 140 I=1,NWAF
      READ (TAPEIN,130) (WAFORG(I,J),J=1,4)
  130 FORMAT( 4F10.0 )
  140 CONTINUE
C ** READ IN CAMBER LINE DATA
      NCAM=0
      IF (J1 .EQ. -1) GOTO 170
      NCAM=1
      read( TAPEIN, '()' )
      DO 160 J=1,NWAF
      READ (TAPEIN,150) (TZORD(J,I),I=1,NWAFOR)
  150 FORMAT( 10F7.0 )
  160 CONTINUE
      GOTO 200
C ** CAMBER IS NOT INPUT. ZERO OUT VALUES
  170 DO 190 J=1,NWAF
      DO 180 I=1,NWAFOR
      TZORD(J,I)=0.0
  180 CONTINUE
  190 CONTINUE
C
C
C ** READ IN AIRFOIL ORDINATE DATA
  200 read( TAPEIN, '()' )
      DO 210 J=1,NWAF
      READ (TAPEIN,150) (WAFORD(J,I),I=1,NWAFOR)
  210 CONTINUE
C
C ** INITIALIZE DATA FOR WING SURFASE GENERATION
      NAF=NWAF
      NAFORD=NWAFOR
      SURFID=SURF1
      DO 240 I=1,NAF
      DO 220 J=1,3
  220 AFORG(I,J)=WAFORG(I,J)
      AFORG(I,4)=AFORG(I,1)-WAFORG(I,4)*DX
      AFORG(I,5)=WAFORG(I,2)
      AFORG(I,6)=WAFORG(I,3)
      AFORG(I,7)=0.0
C
      DO 230 K=1,NAFORD
      AFCAM(I,K)=TZORD(I,K)*100./WAFORG(I,4)
  230 AFORD(I,K)=WAFORD(I,K)
  240 CONTINUE
      DO 250 K=1,NAFORD
  250 XOC(K)=XAF(K)
C
      NACA=0
      ITIP=0
      IROOT=0
      ISURF=0
      IFLAP=0
C
      CALL SURF
C
C
C *** FUSELAGE ***
C ****************
  260 IF (J2.EQ.0 .OR. J2.EQ.2) GOTO 360
C
C ** START CYCLE ON FUSELAGE SEGMENTS (NFUS TIMES)
      READ( TAPEIN, '()' )
      DO 350 I=1,NFUS
C
      NFOX=NFORX(I)
      NRAX=NRADX(I)
C ** READ X-VALUES OF FUSELAGE STATIONS FOR A SEGMENT
      READ( TAPEIN, '()' )
      READ (TAPEIN,270) (XFUS(I,J),J=1,NFOX)
  270 FORMAT( / (10F7.0,10X) )
C
C ** CHECK CIRCULAR AND CAMBER FLAGS
      IF (J2.EQ.1 .AND. J6.NE.2) GOTO 300
C
C ** ZERO OUT CAMBER WHEN NOT REQUIRED
  280 DO 290 J=1,NFOX
  290 ZFUS(I,J)=0.0
      IF (J2 .EQ. 1) GOTO 310
      IF (J2.EQ.-1 .AND. J6.NE.0) GOTO 330
      IF (J2.EQ.1 .AND. J6.EQ.1) GOTO 330
C
C ** READ FUSELAGE CAMBER DATA
  300 READ( TAPEIN, '()' )
      READ (TAPEIN,270) (ZFUS(I,J),J=1,NFOX)
      IF (J2 .EQ. -1) GOTO 330
C
C ** READ IN FUSELAGE CROSS-SECTION COORDINATES
  310 DO 320 J=1,NFOX
      READ (TAPEIN,270) (YFUSY(I,J,N),N=1,NRAX)
      READ (TAPEIN,270) (ZFUSZ(I,J,N),N=1,NRAX)
  320 CONTINUE
      GOTO 340
C
C ** READ IN FUSELAGE AREAS WHEN CIRCULAR
C Note: In this version of HABP read in fuselage radiuses instead of areas
C       and corresponding changes made in subroutine SURF
  330 READ (TAPEIN,270) (FUSARD(I,J),J=1,NFOX)
C
C
  340 CONTINUE
C ** END OF FUSELAGE SEGMENT DO-LOOP
  350 CONTINUE
C
      CALL FUSE
C
      IFLAP=0
C
C *** POD ***
C ***********
  360 IF (J2.EQ.0 .OR. J3.EQ.2) GOTO 400
C
      DO 390 I=1,NP
C ** READ POD ORIGIN DATA
      READ (TAPEIN,370) (PODORG(I,J),J=1,3),
     1     IOR(I),(PODORG(I,J),J=4,6),IEL(I),NEL(I)
  370 FORMAT (3F7.0,3X,I1,3X,3F7.0,6X,I1,5X,I2)
C ** READ X-ORDINATES FOR POD RADII
      READ (TAPEIN,380) (XPOD(I,J),J=1,NPODOR)
  380 FORMAT (10F7.0,10X)
C ** READ POD-RADII DISTRIBUTION
      READ (TAPEIN,380) (PODR(I,J),J=1,NPODOR)
  390 CONTINUE
C
C ** CALL POD SUBROUTINE
      CALL NACEL
C
      IFLAP=0
C
C *** FIN ***
C ***********
  400 IF (J4.EQ.0 .OR. J4.EQ.2) GOTO 490
C
      NAF=2
      NAFORD=NFINOR
      NCAM=0
      NACA=0
      ITIP=0
      IROOT=0
      ISURF=0
      IFLAP=0
C ** READ FIN DATA (NF FINS)
      DO 430 NN=1,NF
C
C ** READ ORDINATE DATA AND LENGTH
      READ (TAPEIN,410) ((FINORG(NN,I,J),J=1,4),I=1,2)
  410 FORMAT( ///////8F7.0,24X )
C 410 FORMAT (8F7.0,24X)
C ** READ PERCENT-CHORD LOCATION
      READ (TAPEIN,420) (XFIN(NN,I),I=1,NFINOR)
  420 FORMAT( /10F7.0,10X )
C 420 FORMAT (10F7.0,10X)
C ** READ FIN AIRFOIL ORDINATES
      READ (TAPEIN,420) (FINORD(NN,I),I=1,NFINOR)
C
  430 CONTINUE
C
C ** INITIALIZE DATA FOR FIN SURFACE GENERATION.
      DO 480 NN=1,NF
      SURFID=SURF2(NN)
      DO 460 I=1,NAF
      DO 440 J=1,3
  440 AFORG(I,J)=FINORG(NN,I,J)
      AFORG(I,4)=AFORG(I,1)-FINORG(NN,I,4)*DX
      AFORG(I,5)=AFORG(I,2)
      AFORG(I,6)=AFORG(I,3)
      AFORG(I,7)=90.0
C
      DO 450 K=1,NAFORD
      AFCAM(I,K)=0.0
  450 AFORD(I,K)=FINORD(NN,K)
  460 CONTINUE
      DO 470 K=1,NAFORD
  470 XOC(K)=XFIN(NN,K)
C
C
      CALL SURF
  480 CONTINUE
C ** END OF FIN DO LOOP
C
C
C ** CANARD OR HORIZONTAL TAIL
C *************
  490 IF (J5.EQ.0 .OR. J5.EQ.2) GOTO 600
C
      N=IABS(NCANOR)
      NAF=2
      NAFORD=N
      NACA=0
      ITIP=0
      IROOT=0
      ISURF=0
      IFLAP=0
C ** READ IN ALL CANARD DATA (NCAN CANARDS)
      DO 540 NN=1,NCAN
C ** READ ORDINATE DATA AND LENGTH
      READ (TAPEIN,500) ((CANORG(NN,I,J),J=1,4),I=1,2)
  500 FORMAT( ///////8F7.0,24X )
C ** READ PERCENT-CHORD LOCATIONS
      READ (TAPEIN,510) (XCAN(NN,J),J=1,N)
  510 FORMAT( /10F7.0,10X )
C ** READ Upper AIRFOIL ORDINATES
      READ (TAPEIN,510) (CANORD(NN,J),J=1,N)
C
C ** IF AIRFOIL IS NOT SIMMETRICAL READ Lower ORDINATES
      NCAM=0
      IF (NCANOR .GT. 0) GOTO 520
      NCAM=1
      READ (TAPEIN,510) (CANOR1(NN,J),J=1,N)
      GOTO 540
C
C ** SET LOWER SURFACE EQUAL TO UPPER FOR SYMMETRICAL
  520 DO 530 J=1,N
  530 CANOR1(NN,J)=CANORD(NN,J)
C
  540 CONTINUE
C
C ** INITIALIZE DATA FOR CANARD SURFACE GENERATION.
      DO 590 NN=1,NCAN
      SURFID=SURF3(NN)
      DO 570 I=1,NAF
      DO 550 J=1,3
  550 AFORG(I,J)=CANORG(NN,I,J)
      AFORG(I,4)=AFORG(I,1)-CANORG(NN,I,4)*DX
      AFORG(I,5)=AFORG(I,2)
      AFORG(I,6)=AFORG(I,3)
      AFORG(I,7)=0.0
C
      DO 560 K=1,NAFORD
      AFORD(I,K)=(CANORD(NN,K)+CANOR1(NN,K))*0.5
  560 AFCAM(I,K)=CANORD(NN,K)- AFORD(I,K)
  570 CONTINUE
      DO 580 K=1,NAFORD
  580 XOC(K)=XCAN(NN,K)
C
C
      CALL SURF
  590 CONTINUE
C ** END OF CANARD DO LOOP.
C
C
C ** ARBITRARY AIRFOIL SURFACE
C ***********
  600 IF (J7 .NE. 1) GOTO 740
C
C ** READ CONTROL CARD
  610 READ (TAPEIN,620) ISURF,NAF,NAFORD,NCAN,NACA,ITIP,IROOT,ISIMC,
     1                  ISIMT,MORE,SURFID
C
  620 FORMAT (22X,I3,2(3X,I2),7(4X,I1),2X,A4,4X)
C
C *** CHECK SURFACE TYPE, ISURF = +1(UPPER ONLY), -1(LOWER ONLY),
C
C                                 ABS .GT. 1,(WITH CONTROL SURFACE).
      IFLAP=0
      NHNGE=IABS(ISURF)
      IF (NHNGE .LE. 1) GOTO 630
C
C *** CONTROL SURFACE INPUT INDICATED. CHECK IF CONSTRAINTS MET.
C     NAFORD MUST BE ODD AND NHNGE EVEN. IF THESE CONDITIONS ARE
C     NOT SATISFIED, FLAP IS NEGLECTED.
C
      ISURF=ISURF/NHNGE
      IF ((NAFORD/2+NAFORD/2) .NE. (NAFORD-1)) GOTO 630
      IF ((NHNGE/2+NHNGE/2) .NE.NHNGE) GOTO 630
C
C *** CONSTRAINTS SATISFIED.
      IFLAP=1
  630 CONTINUE
C ** READ CHORD LOCATIONS
      READ (TAPEIN,640) (XOC(J),J=1,NAFORD)
  640 FORMAT (10F7.0,10X)
C
C ** READ AIRFOIL SECTION ORIENTATION DATA
      DO 650 I=1,NAF
      READ (TAPEIN,640) (AFORG(I,J),J=1,7)
  650 CONTINUE
C
C ** CHECK FOR CAMBER DATA
      IF (NCAM .NE. 1) GOTO 680
      IN=NAF
      IF (ISIMC .EQ. 1) IN=1
      DO 660 I=1,IN
  660 READ (TAPEIN,640) (AFCAM(I,J),J=1,NAFORD)
      IF (IN .EQ. NAF) GOTO 700
      DO 670 I=2,NAF
      DO 670 J=1,NAFORD
  670 AFCAM(I,J)=AFCAM(1,J)
      GOTO 700
C ** NO CAMBER DATA INPUT, SET TO ZERO
  680 DO 690 I=1,NAF
      DO 690 J=1,NAFORD
  690 AFCAM(I,J)=0.0
C
  700 CONTINUE
C
C ** READ IN THICKNESS DISTRIBUTION
      IN=NAF
      IF (ISIMT .EQ. 1) IN=1
      DO 710 I=1,IN
  710 READ (TAPEIN,640) (AFORD(I,J),J=1,NAFORD)
      IF (IN .EQ. NAF) GOTO 730
      DO 720 I=2,NAF
      DO 720 J=1,NAFORD
  720 AFORD(I,J)=AFORD(1,J)
C
  730 CALL SURF
C
C ** CHECK FOR STACKED DATA
      IF (MORE .EQ. 1) GOTO 610
C
C ** CHECK IF A DUMMY STATUS 3 ELEMENT WANTED
  740 IF (IFLAP .EQ. 1) GOTO 10
      IF (ISTAT3 .NE. 1) CALL STATS3
C
C *** END OF ALL CONFIGURATION COMPONENTS (GO TO STARTING STATEMENT)
      GOTO 10
C
  750 WRITE (TAPEOT,760) I
  760 FORMAT ( //, 37H**** FATAL ERROR *** PROGRAM STOPPED.,
     1        ///,5X,34HCONTROL FLAG CARD PARAMETER NUMBER,I3,4H IS ,
     2        28HOUTSIDE THE ALLOWABLE RANGE.)
C
C *** AFTER END OF FILE ON INPUT - STOP
  770 STOP
  780 RETURN
      END
      SUBROUTINE ATMOS(A3,A8,A4,A1,A6)
C
C *** THIS ROUTINE CALCULATES ATMOSPHERIC PROPERTIES OF THE
C     US STANDART ATMOSPHERE,1962,ASSUMING AN INVERSE SQUARE
C     GRAVITATIONAL FIELD. THIS ASSUMPTION YIELDS DATA THAT
C     AGREES WITH THE COESA DOCUMENT WITHIN 1 PER CENT AT
C     ALL ALTITUDES UP TO 700 KILOMETERS (2296588 FEET). THE
C     DATA IS ARRANGED IN THE ATMOSPHERE ARRAY , A, AS
C     FOLLOWS
C     A(1)  = CS, SPEED OF SOUND, FT/SEC
C     A(2)  = (1/CS)(DCS/DZ), SOUND DERIVATIVE, 1/FT
C     A(3)  = Z, GEOMETRIC ALTITUDE, FT (GIVEN)
C     A(4)  = P, PRESSURE, LB/FT2
C     A(5)  = DP/DZ, PRESSURE DERIVATIVE, LB/FT3
C     A(6)  = RHO, DENSITY, SLUGS/FT3
C     A(7)  = (1/RHO)(DRHO/DZ),DENSITY DERIVATIVE, 1/FT
C     A(8)  = T, TEMPERATURE, DEG RANKINE
C     A(9)  = DT/DZ,TEMPERATURE DERIVATIVE, DEG RANKINE/FT
C
C     VARIOUS CONSTANTS USED
C      EARTH RADIUS                = 20890855 FT
C      SPECIFIC HEAT RATIO FOR AIR =1.4
C     SEA LEVEL VALUES
C      CRAVITATIONAL ACCELERATION  = 32.1740484 FT/SEC2
C      MOLECULAR WEIGHT            = 28.9644
C      G0*M0/R0                    = 0.018743418 DEG RANK/FT
C
      DIMENSION A(9),HG(10),ZM(14),WM(14),TM(23),PM(22)
C
C  SET ARRAYS AND CONSTANT VALUES
      DATA G0,WM0,R0,GMRS/32.1740484, 28.9644, 20890855.0, 0.018743418/,
     _    HG/ -16404., 0.0, 36089., 65617., 104987., 154199., 170604.,
     _        200131., 259186., 291160. /,
     _    ZM/ 295276., 328084., 360892., 393701., 492126., 524934.,
     _        557743., 623360., 754593., 984252., 1312336., 1640420.,
     _       1968504., 2296588./,
     _     WM/ 28.9644, 28.88, 28.56, 28.07, 26.92, 26.66, 26.4, 25.85,
     _         24.7   , 22.66, 19.94, 17.94, 16.84, 16.17 /
C
      DATA TM/ 577.17,  518.67,  389.97,  389.97,  411.57,  487.17,
     _         487.17,  454.77,  325.17,  325.17,  379.17,  469.17,
     _     649.17, 1729.17, 1999.17, 2179.17, 2431.17, 2791.17,
     _    3295.17, 3889.17, 4357.17, 4663.17, 4861.17 /,
     _     PM/   3711.0839,     2116.2165,     472.67563,     114.34314,
     _           18.128355,     2.3162178,     1.2321972, 3.8030279E-01,
     _       2.1671352E-02, 3.4313478E-03, 6.2773411E-04, 1.5349091E-04,
     _       5.2624212E-05, 1.0561806E-05, 7.7083076E-06, 5.8267151E-06,
     _       3.5159854E-06, 1.4520255E-06, 3.9290563E-07, 8.4030242E-08,
     _       2.2835256E-08, 7.1875452E-09 /
C
      A(3)=A3
C
C  CALCULATE G, Z, AND CHECK
   10 Z=A(3)
      G=G0*(R0/(R0+Z))**2
      IF (Z .GT. 295276.0) GOTO 50
C
C  TMS LINEAR WITH GEOPOTENTIAL. CALCULATE H AND SEARCH
      H= R0*Z/(R0+Z)
      DO 20 I=2,10
      J=I-1
      IF (HG(I) .GE. H) GOTO 30
   20 CONTINUE
C
C  CALCULATE TMS SLOPE, TMS, AND SET MOL WT STUFF
   30 ELH=(TM(J+1)-TM(J))/(HG(J+1)-HG(J))
      TMS=TM(J)+ELH*(H-HG(J))
      ELZ=ELH*G/G0
      DMDZ=0.0
      EM=WM0
C
C  CHECK TMS SLOPE AND CALCULATE PRESSURE
      IF (ELH .EQ. 0.0) GOTO 40
C
C  NON - ZERO SLOPE PRESSURE EQUATION
      A(4)=PM(J)*(TM(J)/TMS)**(GMRS/ELH)
      GOTO 80
C
C  ZERO SLOPE PRESSURE EQUATION
C
   40 A(4)=PM(J)*dexp(DBLE(GMRS*(HG(J)-H)/TMS))
      GOTO 80
C  TMS LINEAR WITH Z. SEARCH MATRIX
   50 DO 60 I=2,14
      J=I+8
      K=I-1
      IF (ZM(I) .GE. Z) GOTO 70
   60 CONTINUE
C
C  CALCULATE TMS, SLOPE, AND STUFF
   70 ELZ=(TM(J+1)-TM(J))/(ZM(K+1)-ZM(K))
      TMS=TM(J)+ELZ*(Z-ZM(K))
      DMDZ=(WM(K+1)-WM(K))/(ZM(K+1)-ZM(K))
      EW=WM(K)+DMDZ*(Z-ZM(K))
      ZLZ=Z-TMS/ELZ
C
C  PRESSURE EQUATION FOR TMS LINEAR WITH Z
      A(4)=PM(J)*dexp(DBLE(GMRS/ELZ*(R0/(R0+ZLZ))**2*((Z-ZM(K))*
     1     (R0+ZLZ)/(R0+Z)/(R0+ZM(K))-dlog(DBLE(TMS*(R0+ZM(K))/
     2     TM(J)/(R0+Z))))))
C
C  CALCULATE SOUND SPEED AND DERIVATIVE
   80 A(1)=49.022164*dsqrt(DBLE(TMS))
      A(2)=0.5*ELZ/TMS
C  CALCULATE DENSITY, DERIVATIVE, AND PRESSURE DERIVATIVE
      A(6)=GMRS*A(4)/G0/TMS
      A(7)=-(A(6)*G/A(4)+ELZ/TMS)
      A(5)=-A(6)*G
C
C  CALCULATE TEMPERATURE, DERIVATIVE, AND LEAVE
      A(8)=EM*TMS/WM0
      A(9)=(EM*ELZ+TMS*DMDZ)/WM0
   90 A8=A(8)
      A4=A(4)
      A1=A(1)
      A6=A(6)
      RETURN
      END
      SUBROUTINE BLUNT(PFS,MACH,TFS,VIS,RHOFS,RB,RENO,TAU,IVISIN)
C
C
C  THIS SUBROUTINE CALCULATES THE VISCOUS FORCES ON A BLUNT
C  FACED BODY FOLLOWING THE APPROACH SUGGESTED BY L. GOLDBERG IN
C  G. E. REPORT R66SD21 (SEE ALSO R65SD50). THE STRAIGHT VISCOUS
C  FORCES ARE CALCULATED USING A SIMPLE CORRELATION FORMULA BASED ON
C  THE RESULTS OF SCALA AND GILBERT. THE LOW DENSITY OR VISCOUS
C  INTERACTION EFFECTS ARE BASED ON NUMERICAL RESULTS OF HIGHER
C  ORDER BOUNDARY-LAYER SOLUTIONS. THE SHEAR EFFECTS ARE A COMPLICATED
C  FUNCTION OF THE INVERSE DENSITY RATIO AND THE SHOCK REYNOLDS
C  NUMBER. IN THE PRESENT CALCULATIONS THESE LOW DENSITY
C  EFFECTS ARE DETERMINED FROM A SET OF EXPONENTIAL FUNCTION
C  CURVES WHICH HAVE BEEN MATCHED TO THE NUMERICAL RESULTS.
C  CALCULATION OPTIONS ARE CONTROLLED BY THE FLAG IVISIN,
C
C        IVISIN      GAS       VISCOUS-INTERACTION
C           0        IDEAL           NO
C           1        IDEAL           YES
C           2        REAL            NO
C           3        REAL            YES
C
C  THE LAST TWO OPTIONS ARE NOT YET AVAILABLE.
C ***************D. N. SMYTH PROGRAM AUTHOR ***************************
C
C
      COMMON /GASD/ GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
C
*      REAL*8 MACH
      REAL MACH
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      DATA AOD,BOD,A1,B1,ODK,XOEV,EVK,EPS/
     1     1.0,3.2907,0.667,1.1111,-2.0,-0.3,-1.80,0.01/
      G=GAM
      GCP=GASCP
      GP1=G+1.
      GM1=G-1.
C
      IF (IVISIN .LT. 2) GOTO 10
C
C   REAL GAS SOLUTION (TO BE ADDED).
C
C   IDEAL GAS SOLUTION. ALL EQUATIONS FROM NASA TR-1135,
C   INVERSE DENSITY RATIO ACROSS NORMAL SHOCK.
   10 RORAI=(GM1+2./MACH**2)/GP1
C
C   TEMPERATURE BEHIND NORMAL SHOCK.
      T2=TFS*(2.*G*MACH**2-GM1)*(GM1*MACH**2+2.)/(GP1*MACH)**2
C
C   CALCULATE VISCOSITY.
      IF (T2.LT.AV1) VIS2=AV2*T2**AV3
      IF (T2.GE.AV1) VIS2=2.27E-8*T2**1.5/(T2+198.6)
C
C   REYNOLDS NUMBER BEHIND NORMAL SHOCK.
      RES=RENO*RB*VIS/VIS2
C
C   CALCULATE SHEAR COEFFICIENT.
   20 CFO=2./(dsqrt(DBLE(RES))*(1.-0.495*dsqrt(DBLE(RORAI))))
C
C   CHECK IF LOW DENSITY VISCOUS-INTERACTION EFFECTS DESIRED.
      TWBL=1.
      IF ((IVISIN.EQ.0) .OR. (IVISIN.EQ.2)) GOTO 70
C
C   DETERMINE LOW DENSITY EFFECTS. CALCULATE INDEPENDENT VARIABLE, EX.
      EX=dlog10(DBLE(RES*RORAI**3))
C
C   CHECK BOUNDARIES
      IF (EX .GT. 3.0) GOTO 70
      TWBL=0.0
      IF (EX .LT. -6.0) GOTO 70
C
C
   30 F1=A1-B1*EX
      IF (EX .GT. -3.0) GOTO 40
      Y2=F1
      GOTO 60
C
C
   40 DXEV=EX-XOEV
      IF (dabs(DBLE(DXEV)) .LT. EPS) GOTO 50
      Y2=F1+(1.-F1)/(1.-dexp(DBLE(EVK*DXEV)))
      GOTO 60
C
C
   50 Y2=F1+B1/(EVK*(1.+0.5*EVK*DXEV))
   60 DXOD=EX-(AOD+BOD*dlog10(DBLE(RORAI)))
      TWBL=Y2/(1.+dexp(DBLE(ODK*DXOD)))
C
C
   70 TAU=TWBL*CFO
C
C
C   THE FOLLOWING CARDS ARE FOR CHECKOUT ONLY (SET IPRINT = 1).
C
      IPRINT=0
C
      IF (IPRINT .NE. 1) RETURN
      WRITE (TAPEOT,80) RORAI,RES,EX,CFO,TAU
   80 FORMAT ( 2X,7HRORAI =,E13.6,5X,5HRES =,E13.6,5X,11H(E**3)RES =,
     1        E13.6,5X,5HCFO =,E13.6,5X,5HTAU =,E13.6)
      WRITE (TAPEOT,90) PFS,TFS,RHOFS,VIS,RENO
   90 FORMAT ( 2X,7H  PFS =,E13.6,5X,5HTFS =,E13.6,5X,11H    RHOFS =,
     1        E13.6,5X,5HVIS =,E13.6,4X,6HRENO =,E13.6)
      RETURN
      END
      SUBROUTINE CADA(M,X,Y,T,S,C)
C
C   REVISED VERSION OF CIRCULAR ARC DATA ANALYSIS INC PLENTY OF OPTION
C   AL CHECK OUT STUFF.IT CALCS FROM M(X,Y) PTS THE ARC LENGTH S,
C   ANGLE T, AND CURVATURE C.
C
      DIMENSION X(100),Y(100),T(100),S(100),C(100)
C
C   FIRST SOME CONSTS.
C
      Z1=1.0
      Z2=2.0
      PI=3.1415926
      ZR=180.0/PI
      ZT=0.000002
      M1=M-1
C
C   NOW DO MAIN LOOP
C
      DO 60 J=2,M1
      X12=X(J)-X(J-1)
      Y12=Y(J)-Y(J-1)
      X23=X(J+1)-X(J)
      Y23=Y(J+1)-Y(J)
      X13=X(J+1)-X(J-1)
      Y13=Y(J+1)-Y(J-1)
      A12=ATAN2(Y12,X12)
      IF ((X12.LT.0.000).AND.(Y12.LT.0.000)) A12=Z2*PI*A12
      A23=ATAN2(Y23,X23)
      IF ((X23.LT.0.000).AND.(Y23.LT.0.000)) A23=Z2*PI*A23
      A13=ATAN2(Y13,X13)
      IF ((X13.LT.0.000).AND.(Y13.LT.0.000)) A13=Z2*PI*A13
      DL12=Z2*(A23-A13)
      DL23=Z2*(A13-A12)
      DL13=Z2*(A23-A12)
      T1=A12-A23+A13
      T2=A23-A13+A12
      T3=A13-A12+A23
      D12=SQRT(X12*X12+Y12*Y12)
      D23=SQRT(X23*X23+Y23*Y23)
      F12=Z1
      IF (DL12 .LT. ZT) GOTO 10
      V12=DL12/Z2
      F12=V12/SIN(V12)
   10 S12=D12*F12
      F23=Z1
      IF (DL23 .LT. ZT) GOTO 20
      V23=DL23/Z2
      F23=V23/SIN(V23)
   20 S23=D23*F23
      C13=-DL13/(S12+S23)
      IF (J .NE. 2) GOTO 30
      T(1)=T1
      S(1)=0.000
      C(1)=C13
   30 T(J)=T2
      S(J)=S(J-1)+S12
      C(J)=C13
      IF (J .NE. M1) GOTO 40
      T(M)=T3
      S(M)=S(M1)+S23
      C(M)=C(M1)
   40 T1D=T1*ZR
      T2D=T2*ZR
      T3D=T3*ZR
      AD12=A12*ZR
      AD23=A23*ZR
      AD13=A13*ZR
   60 CONTINUE
      RETURN
      END
      SUBROUTINE COMPR(ANGLE,MER,IPRINT,CPSTAG,ISDET,IFIRST,CP)
C
C ** USING THE FREE STREAM MACH NUMBER AND THE EQUIVALENT WEDGE
C    ANGLE, THIS ROUTINE COMPUTED THE CONDITIONS BEHIND THE SHOCK
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /FSBS/FS,BS
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      DIMENSION FS(8),ANGLE(3),BS(8),R(3)
C
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
!     REAL*8 MACHSQ,MACHO,MACH1
      Character *4 TITLE(15)

      MER=0
      G=GAM
      IF (ISDET .EQ. 1) GOTO 210
      IF (dabs(DBLE(ANGLE(2))) .LT. 0.00001) GOTO 240
      IF (ANGLE(2) .GT. 55.0) GOTO 10
      IF (dabs(DBLE(ANGLE(2))) .LE. 2.0) GOTO 260
C
C ** SET UP CUBIC TO BE SOLVED FOR SIN**2 THETA (SHOCK-ANGLE) -
C    CONSTANTS DEFINED IN EQUATION 150B OF TR 1135
      B=-(FS(6)**2+2.)/FS(6)**2-G*dsin(DBLE(ANGLE(2)/57.29578))**2
      C=(2.0*FS(6)**2+1.0)/FS(6)**4+((G+1.)**2/4.+(G-1.)/FS(6)**2)*
     1  dsin(DBLE(ANGLE(2)/57.29578))**2
      D=-dcos(DBLE(ANGLE(2)/57.29578))**2/FS(6)**4
C
C ** CHECK FOR SHOCK DETACHMENT
      IF (((-B**2/9.+C/3.)**3+((B/3.)**3-(B*C-3.*D)/6.)**2)
     1      .GE. 0.0) GOTO 10
C
C ** SHOCK NOT DETACHED, COMPUTE THREE REAL ROOTS
C
      Y=B**2-3.*C
      Z=(9.*B*C-2.*B**3-27.*D)/(2.*Y**1.5)
      W=dacos(DBLE(Z))
      Z=W/3.
      Y=2.*dsqrt(DBLE(Y))
      R(1)=(Y*dcos(DBLE(Z))-B)/3.
      R(2)=-(Y*dcos(DBLE(Z+60./57.29578))+B)/3.
      R(3)=-(Y*dcos(DBLE(Z-60./57.29578))+B)/3.
      GOTO 20
C
C  CUBIC SOLUTION WAS NOT FOUND BECAUSE THE SHOCK HAS DETACHED.
C  FLOW PROPERTIES WILL BE CALCULATED BY THE METHOD OF KAUFMAN.
   10 ETAC=1.0
      ISF=0
      CALL NEWTPM (ANGLE,EMN,CP,ETAC,IPRINT,MER,CPSTAG,
     1             ISE,IFIRST)
      IF (MER-1) 230,210,210
C
C  A SOLUTION TO THE CUBIC WAS FOUND. CHECK FOR DESIRED SOLUTION.
C  SMALLEST ROOT REQUIRES A DECREASE IN ENTROPY WHICH IS NOT ALLOWED.
C  LARGEST ROOT IS NOT ATTAINED IN PRACTICAL CASES. THEREFORE PICK
C  MIDDLE ANSWER.
   20 IF (R(1)-R(2)) 30,110,40
   30 K=1
      GOTO 50
   40 K=2
   50 IF (R(2)-R(3)) 60,120,70
   60 M=1
      GOTO 80
   70 M=2
   80 IF (K .EQ. M) GOTO 120
      IF (R(1)-R(3)) 90,130,100
   90 GOTO (130,110), K
  100 GOTO (110,130), K
  110 ANGLE(3)=R(1)
      GOTO 140
  120 ANGLE(3)=R(2)
      GOTO 140
  130 ANGLE(3)=R(3)
C
C  CHECK IF ANGLE IS NEGATIVE AND PRINT ERROR NOTE IF REQUIRED
  140 IF (ANGLE(3) .GE. 0.0) GOTO 170
      IF (IPRINT .NE. 1) GOTO 160
      WRITE (TAPEOT,150)
  150 FORMAT ( ' NEGATIVE VALUE FOUND FOR SIN**2 THETA ',
     1        'IN CUBIC . TO CONTINUE, IT IS SET TO ZERO.' )
  160 ANGLE(3)=0.0
  170 IF (ANGLE(3) .LE. 1.0) GOTO 200
      IF (IPRINT .NE. 1) GOTO 190
      WRITE (TAPEOT,180)
  180 FORMAT ( 41H IN CUBIC , SIN**2 THETA GREATER THAN ONE,
     1 31H TO CONTINUE, IT IS SET TO ONE.  )
  190 ANGLE(3)=1.0
C
C  CALCULATE CONDITIONS BEHIND THE SHOCK USING THE SELECTED SIN**2 THETA
  200 EMN=FS(6)**2*ANGLE(3)
C  DENSITY   EQ, 129 OF TR 1135
  210 IF (EMN .LT. 1.01) EMN=1.01
      BS(1)=FS(1)*(G+1.)*EMN/((G-1.)*EMN+2)
C  PRESSURE  EQ, 128
      BS(2)=FS(2)*(2.*G*EMN-(G-1.))/(G+1.)
C  TEMPERATURE  EQ, 130
      R(3)=(2.*G*EMN-(G-1.))*(2.+(G-1.)*EMN)/((G+1.)**2*EMN)
      BS(3)=FS(3)*R(3)
C  SPEED OF SOUND
      BS(4)=FS(4)*dsqrt(DBLE(R(3)))
C  VISCOSITY
      IF (BS(3).GE.AV1) BS(5)=2.27E-8*BS(3)**1.5/(BS(3)+198.6)
      IF (BS(3).LT.AV1) BS(5)=AV2*BS(3)**AV3
C  MACH NUMBER  EQ,132
      BS6SQ=(((G+1.)*FS(6))**2*EMN-4.*(EMN-1.)*(G*EMN+1.))/
     1      ((2.*G*EMN-(G-1.))*(2.+(G-1.)*EMN))
      IF (BS6SQ .LT. 1.0) BS(6)=1.01
      IF (BS6SQ .GE. 1.0) BS(6)=dsqrt(DBLE(BS6SQ))
C  VELOCITY
      BS(7)=BS(4)*BS(6)
C  REYNOLDS NUMBER PER FOOT
      BS(8)=BS(1)*BS(7)/BS(5)
      MER=0
C  SHOCK ANGLE
      ANGLE(3)=dsqrt(DBLE(ANGLE(3)))
      IF (dabs(DBLE(ANGLE(3))) .GT. 1.0) ANGLE(3)=1.0
      ANGLE(3)=dasin(DBLE(ANGLE(3)))*57.29578
C
      CP=4.*(EMN-1.)/((G+1.)*FS(6)**2)
C
  230 RETURN
C
C  ANGLE(2) IS ZERO, SET BS(1)=FS(1), CP=0.0, AND EXIT
C
  240 DO 250 I=1,8
  250 BS(I)=FS(I)
      CP=0.0
      RETURN
C  USE WEAK OBLIQUE SHOCK RELATIONSHIP (LIERMAN AND ROSHKO, P.92)
  260 ANGLE(3)=1.0/FS(6)**2+0.5*(G+1.)/dsqrt(DBLE(FS(6)**2-1.0))*
     1ANGLE(2)/57.29578
      GOTO 200
      END
      SUBROUTINE CONE(ANGLE,CP,ISDET)
C
C  THIS IS IMPROVED APPROXIMATE CONE FLOW SOLUTION
C  DEVELOPED BY D.N.SMYTH
C  SECOND ORDER THEORY USED FOR SMALL VALUES OF SIMILARITY PARAMETER
C  APPROXIMATE SOLUTION OF HAMMITT AND MURTHY FOR LARGE VALUES
C  MIDRANGE GIVEN BY SUITABLE TRANSITION FUNCTION
C
      COMMON /FSBS/FS,BS
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      DIMENSION ANGLE(3),FS(8),BS(8)
C     REAL*8 MACH
      INTEGER CASE,PAGE,ERROR
      Character *4 TITLE(15)
      DATA RC/.17453292E-1/

C  Suppress compiler warning: 'unused dummy argument ISDET'
      ISDET = 0

      G=GAM
      EM=FS(6)
      ANGLE(2)=dabs(DBLE(ANGLE(1)))
      DCR=ANGLE(2)*RC
C
C  TEST FOR ZERO CONE ANGLE
      IF (DCR .GT. 1.E-4) GOTO 7
C  CONE ANGLE TOO SMALL. SET PROPERTIES AND RETURN.
      CP=0.0
      DO 6 I=1,8
    6 BS(I)=FS(I)
      ANGLE(3)=asin(1.0/EM)/RC
      RETURN
C
C
    7 CONTINUE
      SINDC=dsin(DBLE(DCR))
      EMSIN=EM*SINDC
      EMSQ=EM**2
      KSOL=2
C
C
C  CALCULATE UPPER TRANSITION POINT, EMSINF.
      EMSINF=1.40
      IF (EM .GE. 10.0) GOTO 8
      EMSINF=0.325
      IF (EM .GT. 1.5) EMSINF=1.40-1.075*dexp(DBLE((EM-1.5)*(-0.8)))
    8 IF (EMSIN .LT. EMSINF) GOTO 20
      KSOL=1
C
C  CALCULATE CONE SURFASE PROPERTIES USING METHOD OF
C  HAMMITT AND MURTHY.
    9 SINSQ=SINDC**2
      SIN2=dsin(DBLE(2.*DCR))
      H2=(G-1.)*SINSQ+2./EMSQ
      H1=2.-(G+5.)*SINSQ
      HX=H2*H1/SIN2**2
      IF (HX .GT. -1.0) GOTO 12
C
C  FLOW DETACHED. USE TAN-CONE EMPIRICAL
      CK=2.*(G+1.)/(G+3.)*EMSIN
      DSR=(CK+dexp(DBLE(-CK)))/EM
      IF (DSR .GT. 1.0) DSR=1.0
      DSR=asin(DSR)
      KSOL=1
      GOTO 11
   12 CONTINUE
      IF (dabs(DBLE(H1)) .LE. 1.E-3) GOTO 10
      RAD=dsqrt(DBLE(1.0+HX))
      DSR=DCR-SIN2*(1.0-RAD)/H1
      GOTO 11
   10 DSR=DCR+0.5*H2/SIN2*(1.0-0.25*HX*(1.0-0.5*HX))
   11 EMNSSQ=EMSQ*dsin(DBLE(DSR))**2
      HS2=(DSR-DCR)**2
      EMC=dsqrt(DBLE((EMSQ-EMNSSQ)*(1.0+2.0*HS2)/(1.0+0.5*(G-1.)*
     1    (EMNSSQ*(1.0+2.0*HS2)-2.0*HS2*EMSQ))))
      ELIM=(G-1.)/(G+1.)
      PSP1=2.0*G/(G+1.)*EMNSSQ-ELIM
      T1TS=(PSP1+ELIM)/(1.0+ELIM*PSP1)/PSP1
      TCT1=(1.0+(G-1.)*0.5*EMSQ)/(1.0+(G-1.)*0.5*EMC**2)
      PCPS=(TCT1*T1TS)**(G/(G-1.))
      PCP1=PCPS*PSP1
      CP=2.0*(PCP1-1.0)/(G*EMSQ)
      GOTO (40,31), KSOL
C
C
C  CALCULATE LOWER TRANSITION POINT, EMSINO.
   20 EMSINO=0.2
      IF (EM .GT. 3.0) EMSINO=0.3
      IF (EMSIN .GT. EMSINO) GOTO 30
      KSOL=1
C
C  CALCULATE CONE SURFACE PROPERTIES USING 2ND-ORDER THEORY.
   21 BETA=dsqrt(DBLE(EMSQ-1.))
      TANDC=dtan(DBLE(DCR))
      TANSQ=TANDC**2
      BETA2=5.0*EMSQ-1.0
      AM=3.25*EMSQ+0.5+(G+1.)*(EMSQ/BETA)**2
      PHI=0.69314718-dlog(DBLE(BETA))-dlog(DBLE(TANDC))
      CP=TANSQ*(2.*PHI-1.0+TANSQ*(3.*(BETA*PHI)**2-BETA2*PHI+AM))
      IF (KSOL .EQ. 2) GOTO 22
      DSR=dasin(DBLE(1./EM))
      PCP1=G*EMSQ*CP*0.5+1.0
      TCT1=PCP1**((G-1.)/G)
      EMC=dsqrt(DBLE(2./(G-1.)*((1.0+(G-1.)*0.5*EMSQ)/TCT1-1.0)))
      GOTO 40
   22 DCP2=TANDC*(4.*(PHI-1.0)+TANSQ*(6.*PHI*(2.*PHI-1.0)*
     1     BETA**2-BETA2*(4.*PHI-1.0)+4.*AM))/(EM*dcos(DBLE(DCR)**3))
      GOTO 32
C
C  CALCULATE CONE SURFACE PROPERTIES USING TRANSITION SOLUTION
C  (THAT IS, A COMBINATION OF BOTH 2ND-ORDER AND HAMMITT-MURTHY).
   30 DXF = EMSINF - EMSINO
      DX = EMSIN - EMSINO
      SINDC=EMSINF/EM
      DCR=dasin(DBLE(SINDC))
      GOTO 9
   31 CPHM=CP
      DCR=dasin(DBLE(EMSINO/EM))
      GOTO 21
   32 A = (CPHM - CP - DCP2*DXF)/DXF**2
      CP=CP+DX*(DCP2+A*DX)
      PCP1=0.5*G*EMSQ*CP+1.0
      EMNSF=EM*dsin(DBLE(DSR))
      EMNS=(EMNSF-1.)*(EMSIN/EMSINF)**2+1.0
      EMNSSQ=EMNS**2
      EMSSQ=((G+1.)*EM*EMNS)**2-4.*(EMNSSQ-1.)*(G*EMNSSQ+1.)
      DSR=dasin(DBLE(EMNS/EM))
      EMSSQ=EMSSQ/((2.*G*EMNSSQ-(G-1.))*((G-1.)*EMNSSQ+2.))
      PSPC=(2.*G*EMNSSQ-(G-1.))/(G+1.)/PCP1
      EMC=dsqrt(DBLE(((1.+0.5*(G-1.)*EMSSQ)*PSPC**((G-1.)/G)-1.)*
     1    2./(G-1.)))
      TCT1=(1.+(G-1.)*0.5*EMSQ)/(1.+(G-1.)*0.5*EMC**2)
   40 CONTINUE
C
C  CALCULATE FLOW ARRAY BS
      ANGLE(3)=DSR/RC
      BS(1)=FS(1)*PCP1/TCT1
      BS(2)=FS(2)*PCP1
      BS(3)=FS(3)*TCT1
      BS(4)=FS(4)*dsqrt(DBLE(TCT1))
      IF (BS(3) .GE. AV1) BS(5)=2.27E-8*BS(3)**1.5/(BS(3)+198.6)
      IF (BS(3) .LT. AV1) BS(5)=AV2*BS(3)**AV3
      BS(6)=EMC
      BS(7)=BS(6)*BS(4)
      BS(8)=BS(1)*BS(7)/BS(5)
C
C
      RETURN
      END
      SUBROUTINE CONEA(DCR,EM,G,ALF,PHI,ALFP,EMP,DSR,EMSURF,PSURF,IT)
C
C   CIRCULAR CONE AT ANGLE OF ATTACK.
C   BASED ON ARC CP #792 AND EXTENDED BY D.N.SMYTH.
C
      COMMON /FSBS/ FS,BS
C
      DIMENSION FS(8),BS(8),ANGLE(3)
      DIMENSION AA(6),A(18)
C
      DATA A/ -0.07657,1.4775,0.064669,
     1         0.42339,0.13241,0.035871,
     2        -0.002083,-0.075797,-0.01923,
     3         0.29898,-0.10011,0.29589,
     4        -0.99727,-0.41751,0.068791,
     5        -0.039442,0.10422,0.063801/
C
      GM1=G-1.0
      GP1=G+1.0
      PMIN=0.3
      CPCONE=0.0
      CPSTAG=0.0
      CPX=0.0
      DPSK=0.0
      COSA=COS(ALF)
      SINA=SIN(ALF)
      COSP=COS(PHI)
      SINP=SIN(PHI)
      EM2=EM**2
      CPMIN=(PMIN-1.0)/(0.5*G*EM2)
C
      IF (DCR .LT. 0.0) GOTO 35
      IF (DCR .LT. 1.E-4) GOTO 5
      IF (DCR .LT. 0.0872665) GOTO 4
      IF (IT .EQ. 1) GOTO 4
C
C   JONES' METHOD (AIAA JL., FEB, 1972, PP234-236).
      EM2I=1.0/EM2
      COS2P=COS(2.*PHI)
      T=SIN(2.9*DCR)*TAN(DCR)
      AC=ALF/DCR
      EMA=EM
      CALL NCONE(DCR,EM,G,DSC,EMS,PCONE)
      CPCONE=(PCONE-1.0)/(0.5*G*EM2)
C
      DO 3 J=1,6
      I=3*(J-1)+1
    3 AA(J)=A(I)+A(I+1)*COSP+A(I+2)*COS2P
C
      CPX=(AA(1)*T+AA(2)*T*EM2I+AA(3)*EM2I)*AC
     1   +(AA(4)*T+AA(5)*T*EM2I+AA(6)*EM2I)*AC**2
      GOTO 40
C
C
C
C   AXIAL FLOW COMPONENT
    4 EMA=EM*COSA
      CALL NCONE(DCR,EMA,G,DSC,EMS,PCONE)
      CPCONE=(PCONE-1.0)/(0.5*G*EM2)
    5 IF (ALF .LT. 1.E-4) GOTO 40
C
C   NORMAL FLOW COMPONENT
      EMC2=EM2*(SINA)**2
      IF (EMC2-1.0) 10,10,20
C   SUBSONIC NORMAL COMPONENT
   10 PSTAG=(1.0+0.5*GM1*EMC2)**(G/GM1)
      GOTO 30
C   SUPERSONIC NORMAL COMPONENT
   20 PSTAG=(0.5*GP1*EMC2)**(G/GM1)*(GP1/(2.*G*EMC2-GM1))**(1./GM1)
   30 CPSTAG=(PSTAG-1.0)/(0.5*G*EM2)*COSP*ABS(COSP)
C
      IF (CPSTAG .LT. CPMIN) CPSTAG=CPMIN
      IF (DCR .LT. 1.E-4) GOTO 40
C   CROSS PRODUCT TERM-EMPIRICAL FIT FROM CP #792.
      SCD=SIN(DCR)*COS(DCR)
      X=0.5*3.1415926/(SCD*SQRT(EM2-1.0))
      BK=1.95+0.07*COS(X)
      CPX=2.0*BK*SCD*COSP*SINA*COSA
      GOTO 40
C
C   CONE FLOW IS DETACHED OR UNDEFINED (DCR .LT. 0.0)
C   USE IMPACT METHODS
C
C   FIRST GET IMPACT ANGLE (IN MERIDIAN PLANE)
   35 CONTINUE
      DELI=ALFP+DCR
      IF (DELI .GT. 0.0) GOTO 36
C
C   EXPANSION FLOW
      ANGLE(2)=ABS(DELI)*57.29578
      FS(6)=EMP
      IPRINT=0
      ISDET=2
      CALL EXPAND(ANGLE,MER,IPRINT,ISDET,CP)
      EMSURF=BS(6)
      EM2=EMP**2
      PSURF=0.5*G*EM2*CP+1.0
      IF (PSURF .LT. PMIN) PSURF=PMIN
      GOTO 50
C
C   COMPRESSION FLOW, USE TANGENT-CONE EMPIRICAL
   36 CK=2.*GP1/(G+3.)*EMP*SIN(DELI)
      EMNS=(CK+EXP(-CK))**2
      CP=(8.*GP1*EMNS/((3.+5.)*EMNS+2.))*SIN(DELI)**2
      PSURF=0.5*G*EM2*CP+1.0
      IF (PSURF .LT. PMIN) PSURF=PMIN
      PCONE=PSURF
      DPSK=PCONE-(2.*G*EMNS-GM1)/GP1
      GOTO 50
C
C   COMBINED SURFACE PRESSURE
   40 PSURF=0.5*G*EM2*(CPCONE+CPSTAG+CPX)+1.0
C
C   LIMIT MINIMUM PSURF
      IF (PSURF .LT. PMIN) PSURF=PMIN
C
C   SHOCK ANGLE DSR, RELATIVE TO AXIS
C
C   USE IMPACT METHODS TO OBTIAN DPSK
C   (ADJUST TO ALPHA = ZERO RESULTS)
C
      DELI=DCR
      IS=1
      FDP=1.0
      EMC=EMA
      GOTO 46
C
C   CALCULATE VALUE FROM NCONE
   45 CONTINUE
      EMNS=(EMA*SIN(DSC))**2
      PS=(2.*G*EMNS-GM1)/GP1
      FDP=PS/P2
      EMC=EMP
C
C   NOW CALCULATE VALUE AT ACTUAL IMPACT ANGLE
      DELI=ALFP+DCR
      DPSK=0.0
      IF (DELI .LE. 0.0) GOTO 50
      IS=2
   46 EMD=EMC*SIN(DELI)
      CK=2.*GP1/(G+3.)*EMD
      EMNS=(CK+EXP(-CK))**2
      P2=(2.*G*EMNS-GM1)/GP1
      GOTO (45,47), IS
   47 DPSK=PSURF-P2*FDP
   50 IF (DPSK .LT. 0.0) DPSK=0.0
      PSHK=PSURF-DPSK
      IF (PSHK .LT. 1.0) PSHK=1.0
C   SURFACE MACH NUMBER
      EMSURF=SQRT((EM2*(GP1*PSHK+GM1)-2.*GP1*GM1)
     1       /(PSHK*(GM1*PSHK+GP1)))
C
      EM2=EMP**2
      DSR=(GP1*PSHK+GM1)/(2.*G*EM2)
      IF (DSR .GT. 1.0) DSR=1.0
      IF (DSR .LT. 0.0) DSR=1.0/EM2
      DSR=asin(SQRT(DSR))
      DSR=DSR-ALFP
C
C
      RETURN
      END
      SUBROUTINE CPINPT(INP,LTOTAB)
C
C
      COMMON /EXEC/ CASE,TITLE,PAGE,ERROR
      COMMON /GDATA/ LTOT,J,SYMFCT,IORN,IGTYPE,L
      COMMON /ABDATA/ NAB,ALPHA(20),BETA(20),ROL(20),CDELTA(20),QI(20),
     1               RI(20),PI(20)
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK

C  Array AA is removed from common /SURFN2/ and placed in new common
C  /SURFN/. To establish a correspondence with length of common /SURFN2/ 
C  in subroutine FLNTRP here added auxiliary array a(570). 
      COMMON /SURFN2/INORM,ISURF,IX,IY,IZ,U1,UL,V1,VL,CR,CT,CMX,N2,
     1   N3,XO,YO,ZO,AP11,AP12,AP13,AP21,AP22,AP23,AP31,AP32,AP33,
     2   flowc(7),xi(500),yi(500),b(503,7),xkf(503),
     3   XB(4),YB(4),ZB(4),
     4   NDSET,IABSET,IR,LORG(20),ISR(20),NS,ISFR,IVIS,IFTYP,IFLOW,
     5   BX(2,20),BY(2,20),NB, a(570)
*    2   FLOWC(7),XI(500),YI(500),B(503,7),XKF(503),AA(5999),

      REAL*8 aa(253009)
      common /surfn/ aa
C
      DIMENSION ELEM(25),LCOND(3),DINFL(6)
      DIMENSION INP(20),LTOTAB(20)
      DIMENSION TITLEM(10),IMTAB(9),LOAB(20),TITLES(10),TITLEA(10),
     1          TITLER(10),E4(12),E2(13),DAT(6),IDTYP(5),
     2          E3(17),ISF(5),FDATA(34),XP(4,6)
C
      INTEGER ERROR,PAGE,CASE,SYMFCT
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      Character *4 TITLE(15)
C
      EQUIVALENCE (FDATA(1),LCOND(1)),(FDATA(4),ELEM(1)),
     1            (FDATA(29),DINFL(1))
      DATA RC/0.1745329E-1/
C   FOR CHECKOUT SET IPRINT = 1
      IPRINT=0
C
C
      WRITE (TAPEOT,5)
    5 FORMAT ( 45HPREVIOUSLY SAVED SURFACE DATA WILL BE USED TO,
     1        17H CALCULATE FORCES)
C
C   BEGIN ALPHA-BETA CYCLE
      REWIND TAPEF
      DO 2000 IAB=1,NAB
      ICT=0
      ISYM=1
      IF (INP(IAB) .EQ. 0) GOTO 2000
C
C   INPUT REGION ID INFO AND NORMALIZATION FLAGS
   10 READ (TAPEIN,20) LASTR,NDSET,IABSET,IR,INORM,ISURF,IPF,
     1     (ISR(I),I=1,10),ISF
   20 FORMAT( / 7I7 // 10I7 // 5I7 )
C
      WRITE (TAPEOT,32) LASTR,NDSET,IABSET,IR,INORM,ISURF,IPF,
     1      (ISR(I),I=1,10),ISF
   32 FORMAT ( 5X,6HLASTR=,I2,4X,6HNDSET=,I2,4X,7HIABSET=,I2,4X,
     1        4HIR =,I2,4X,6HINORM=,I2,4X,6HISURF=,I2,4X,
     2        / 4HIPF=,I2,4X,4HISR=,10I3,4X,4HISF=,5I2,/)
C
C   READ BOUNDARY POINTS FOR NORMALIZATION
      READ( TAPEIN, '( / )' )
      DO 38 I=1,4
   38 READ (TAPEIN,50) XB(I),YB(I),ZB(I)
   50 FORMAT( 3F7.0 )
C
C   READ IN MASTER DIRECTORY
      ITAG10=1
      READ( 10, REC=ITAG10 ) TITLEM
C      CALL READMS(10,TITLEM,10,ITAG10)
      ITAG10=2
      READ( 10, REC=ITAG10 ) IMTAB
C      CALL READMS(10,IMTAB,9,ITAG10)
C
C   CHECK DATA SET NUMBER
      IF (IMTAB(1) .GE. NDSET) GOTO 40
      WRITE (TAPEOT,39) NDSET,IMTAB(1)
   39 FORMAT ( 9H**NDSET =,I2,31H IS GREATER THAN THE NUMBER OF ,
     1        44HDATA SETS ACTUALLY ON UNIT 10. PROGRAM HALT.  )
      STOP
C
C
C   READ IN FLOW DATA SET DIRECTORY
   40 ITAG10=IMTAB(NDSET+4)
      READ( 10, REC=ITAG10 ) E4
C      CALL READMS(10,E4,12,ITAG10)
      DO 41 I=1,10
   41 TITLES(I)=E4(I)
      MACH=E4(11)
      NABS=E4(12)
      ITAG10=ITAG10+1
      READ( 10, REC=ITAG10 ) LOAB
C      CALL READMS(10,LOAB,20,ITAG10)
C
C   READ IN FLOW REGION DIRECTORY FOR REQUESTED ALPHA-BETA SET
      ITAG10=LOAB(IABSET)
      READ( 10, REC=ITAG10 ) E2
C      CALL READMS(10,E2,13,ITAG10)
      DO 42 I=1,10
   42 TITLEA(I)=E2(I)
      ALPHAS=E2(11)
      BETAS=E2(12)
      NREG=E2(13)
      ITAG10=ITAG10+1
      READ( 10, REC=ITAG10 ) LORG
C      CALL READMS(10,LORG,20,ITAG10)
C
C
C
C
C   READ IN REQUESTED FLOW REGIONS
C
C
C
      ITAG10=LORG(IR)
      READ( 10, REC=ITAG10 ) E3
C      CALL READMS(10,E3,17,ITAG10)
      DO 91 I=1,10
   91 TITLER(I)=E3(I)
      DO 92 I=1,5
      IDTYP(I)=E3(I+10)
   92 CONTINUE
      IFTYR=IDTYP(1)
      IFLOW=IDTYP(2)
      IVIS=0
      IF (IFTYP .EQ. 4) IVIS=4
   94 NSREG=E3(16)
      ITAG10=ITAG10+1
      READ( 10, REC=ITAG10 ) DAT
C      CALL READMS(10,DAT,6,ITAG10)
      XO=DAT(1)
      YO=DAT(2)
      ZO=DAT(3)
      PSIO=DAT(4)
      THETO=DAT(5)
      PHIO=DAT(6)
C
      SINT=dsin(DBLE(THETO*RC))
      COST=dcos(DBLE(THETO*RC))
      COSPS=dcos(DBLE(PSIO*RC))
      SINPS=dsin(DBLE(PSIO*RC))
      SINP=dsin(DBLE(PHIO*RC))
      COSP=dcos(DBLE(PHIO*RC))
      AP11=COST*COSPS
      AP12=COST*SINPS
      AP13=-SINT
      AP21=-COSP*SINPS+SINP*SINT*COSPS
      AP22=COSP*COSPS+SINP*SINT*SINPS
      AP23=SINP*COST
      AP31=SINP*SINPS+COSP*SINT*COSPS
      AP32=-SINP*COSPS+COSP*SINT*SINPS
      AP33=COSP*COST
C
C   SET INDICES FOR NORMALIZING DATA
      IF (INORM .LE. 0) GOTO 100
      GOTO (110,130,140,150), INORM
C
C   NORMALIZE W.R.T.  A,R
  100 IX=4
      IY=5
      IZ=6
      GOTO 190
C
C   NORMALIZE W.R.T.  X,Y
  110 IX=1
      IY=2
      IZ=3
      GOTO 190
C
C   NORMALIZE W.R.T.  X,Z
  130 IX=1
      IY=3
      IZ=2
      GOTO 190
C
C   NORMALIZE W.R.T.  Y,Z
  140 IX=2
      IY=3
      IZ=1
      GOTO 190
C
C   NORMALIZE W.R.T.  A,PHI
  150 IX=4
      IY=6
      IZ=5
      GOTO 190
C
C   CALCULATE NORMALIZING LENGTHS
  190 CONTINUE
      DO 95 I=1,4
      XX=XB(I)-XO
      YY=YB(I)-YO
      ZZ=ZB(I)-ZO
      XP(I,1)=XX*AP11+YY*AP12+ZZ*AP13
      XP(I,2)=XX*AP21+YY*AP22+ZZ*AP23
      XP(I,3)=XX*AP31+YY*AP32+ZZ*AP33
      XP(I,4)=XP(I,1)
      XP(I,5)=dsqrt(DBLE(XP(I,2)**2+XP(I,3)**2))
      IF (XP(I,2) .EQ. 0.0) GOTO 194
      XP(I,6)=datan2(DBLE(XP(I,2)),DBLE(-XP(I,3)))
      GOTO 95
  194 XP(I,6)=0.0
      IF (XP(I,3) .GT. 0.0) XP(I,6)=3.141592654
   95 CONTINUE
C
C
      U1=XP(1,IX)
      UL=XP(2,IX)-U1
      CR=UL
      IF (ISURF .EQ. 1) GOTO 96
      V1=XP(3,IY)
      VL=XP(4,IY)-V1
      GOTO 97
C
   96 UL=XP(3,IX)
      CT=XP(4,IX)-XP(3,IX)
      V1=XP(1,IY)
      VL=XP(3,IY)-V1
   97 CONTINUE
C
C
C
C   ESTABLISH SUB-REGION COUNTERS
      IF (ISR(1) .GT. 0) GOTO 210
      NS=NSREG
      DO 200 I=1,NS
  200 ISR(I)=I
      GOTO 230
  210 NS=0
      DO 220 I=1,10
      IF (ISR(I) .LE. 0) GOTO 230
  220 NS=NS+1
C
  230 IF (NS .LE. NSREG) GOTO 250
      WRITE (TAPEOT,240) NS,NSREG
  240 FORMAT( 28HSURFACE INTERPOLATION,  THE ,I2,13H SUB-REGIONS ,
     1 36HREQUESTED IS GREATER THAN AVAILABLE,/ 12HCOUNTER SET ,
     2 11HTO NSREG = ,I2,20H AND CASE CONTINUES.)
C
      NS=NSREG
  250 CONTINUE
C
C
      REWIND TAPEE
      INTAPE=TAPEC
      ITAPES=TAPED
C
      I=0
      ISFR=0
      ICYCLE=0
      NTOT=0
      IF (IPF .NE. 0) GOTO 1520
 1100 CONTINUE
      ERROR=0
      CALL SFNTR2
      IF (ERROR .EQ. 1) GOTO 1520
C
C   START CYCLE ON THE ELEMENTS
 1110 REWIND INTAPE
      REWIND ITAPES
      ISAVET=ITAPES
      ICYCLE=ICYCLE+1
      IF (IPRINT .NE. 1) GOTO 1111
      WRITE (TAPEOT,9030) INTAPE,ITAPES,LTOT
 9030 FORMAT ( 23HAT LOOP 1500,INTAPE = ,I3,5X,9HITAPES = ,I3,
     1        5X,7HLTOT = ,I5)
 1111 CONTINUE
      DO 1500 II=1,LTOT
      IF (ICYCLE .GT. 1) GOTO 1050
      READ (TAPEE,END=1510) IG4,ELEM
      LCOND(2)=ELEM(1)
      GOTO 1090
 1050 CONTINUE
      READ (INTAPE,END=1510) IG4,FDATA
C
C   CHECK IF ELEMENT ALREADY PROCESSED ON PREVIOUS CYCLE
      IF (LCOND(1) .NE. 0) GOTO 1200
 1090 CONTINUE
      IF (ISYM .EQ. 1) GOTO 1095
C   REFLECT ELEMENT TO -Y SIDE AND CHANGE ORDER OF POINTS 2 AND 4
      IG4=-IG4
      ELEM(5)=-ELEM(5)
      ELEM(8)=-ELEM(8)
      ELEM(15)=-ELEM(15)
      ELEM(16)=-ELEM(16)
      ELEM(17)=-ELEM(17)
      ELEM(18)=-ELEM(18)
      ELT=ELEM(12)
      ELEM(12)=ELEM(14)
      ELEM(14)=ELT
      ELT=ELEM(16)
      ELEM(16)=ELEM(18)
      ELEM(18)=ELT
      ELT=ELEM(20)
      ELEM(20)=ELEM(22)
      ELEM(22)=ELT
C
C   INTERPOLATE FOR SURFACE PROPERTIES AT CENTROIDS.
 1095 CONTINUE
      IC=0
      IT=1
      CALL VALU2(1,ELEM(7),ELEM(8),ELEM(9),XN,YN,ZN,IC,IT,INR,
     1    DINFL(1),DINFL(2),DINFL(3),DINFL(4),DINFL(5),DINFL(6))
C
      LCOND(1)=0
      IF (INR .EQ. 0) GOTO 1200
      LCOND(1)=1
      NTOT=NTOT+1
C
C   SAVE RESULTS ON TEMPORARY UNIT
 1200 CONTINUE
      WRITE (ITAPES) IG4,FDATA
C
C   GO TO NEXT ELEMENT
 1500 CONTINUE
 1510 CONTINUE
C
C
 1520 I=I+1
      IF (I .GT. 5) GOTO 1600
      ISFR=ISF(I)
      IF (IPRINT .NE. 1) GOTO 1525
      WRITE (TAPEOT,9010) I,ISFR,ICYCLE,NTOT,ERROR
 9010 FORMAT( 4HI = ,I3,5X,7HISFR = ,I3,5X,9HICYCLE = ,I3,
     1       7HNTOT = ,I5,5X,8HERROR = ,I3)
 1525 CONTINUE
      IF (ISFR .EQ. 0) GOTO 1600
      IF (ICYCLE .EQ. 0) GOTO 1100
      IF (NTOT .EQ. LTOT) GOTO 1600
C
C   SWICH TAPES (ONLY IF ERROR = 0)
      IF (ERROR .NE. 0) GOTO 1100
      I1=ITAPES
      ITAPES=INTAPE
      INTAPE=I1
      GOTO 1100
C
C   SAVE RESULTS ON TAPEF
 1600 CONTINUE
      IF (ICYCLE .GT. 0) GOTO 1560
      WRITE (TAPEOT,1550)
 1550 FORMAT( 47HSURFACE  INTERPOLATION (CPINT) CANNOT BE MADE,/
     1 54H CHECK THAT PROPER FLOW FIELD DATA HAS BEEN SPECIFIED.,
     2 16H RUN IS STOPPED.)
      STOP
C
 1560 REWIND ISAVET
      IF (IPRINT .NE. 1) GOTO 1601
      WRITE (TAPEOT,9020) LTOT,INTAPE,ISAVET
 9020 FORMAT( 7HLTOT = ,I5,5X,9HINTAPE = ,I3,5X,9HISAVET = ,I3)
 1601 CONTINUE
      DO 1610 L=1,LTOT
      READ (ISAVET,END=1620) IG4,FDATA
      WRITE (TAPEF) IG4,FDATA,NDSET,IABSET,NS,IPF,ISFR
      ICT=ICT+1
      IF (IPRINT .NE. 1) GOTO 1610
      WRITE (TAPEOT,9000) IG4,LCOND,ELEM,DINFL
 9000 FORMAT( 6HIG4 = ,I5,5X,8HLCOND = ,3I4,/
     1  8H ELEM = ,10E12.4,/ 7X,10E12.4,/ 7X,5E12.4,/
     2  9H DINFL = ,6E12.4)
 1610 CONTINUE
 1620 CONTINUE
C
C   CHECK FOR SYMMETRY REQUIREMENTS
      IF (SYMFCT.EQ.1 .OR. BETAS.EQ.0.0 .OR. ISYM.EQ.2) GOTO 1900
      REWIND TAPEE
      ISYM=2
      GOTO 10
C
 1900 LTOTAB(IAB)=ICT
C   END OF ALPHA-BETA LOOP
 2000 CONTINUE
C
      REWIND TAPEE
      REWIND TAPEF
C
      RETURN
      END
      SUBROUTINE ELLIP
C
C     THIS SUBROUTINE PREPARES THE REQUIRED SURFACE ELEMENTS FOR
C     CIRCULAR OR ELLIPTICAL ARC SECTIONS. EACH CROSS-SECTION
C     IS CONSIDERED SEPARATELY. DUMMY POINTS ARE COMPUTED SO THAT EACH
C     SECTION IS FORCED TO HAVE AN EVEN NUMBER OF POINTS AND SO THAT
C     POINTS IN A ROW ARE CORRECTLY MATCHED WITH POINTS IN AN ADJACENT
C     ROW WHEN THESE ROWS CONTAIN AN UNEQUAL NUMBER OF POINTS.
C
C  THE PARAMETER DISCON WHICH IS SPECIFIED BY THE PROGRAMMER IS VALUED
C     DEPENDING ON HOW THE POINTS ARE TO BE MATCHED
C          DISCON = 1 ALL THETAO AND THETAL ARE THE SAME. DELTHE MUST
C                     DIVIDE THE ANGULAR INCREMENT THETAL - THETAO
C                     EVENLY .
C                 = 2 ALL THETAL ARE EQUAL BUT THETAO VARIES
C                 = 3 ALL THETAO ARE EQUAL BUT THETAL VARIES
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      DIMENSION AX(100),THETOX(100),THETLX(100),DELTHX(100),
     1 NN(100),DELZX(100),DELYX(100),AA(100),BB(100)
C
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER PAGE,ERROR,CASE
      INTEGER STAT,STATT,STATD,STATC,TYPE,STATA,STATB,SEQ,DISCON
      Character *4 TITLE(15)
      Character *4 SECT
C
      RADD(BBI,AAI,THP)=dsqrt(DBLE(BBI*BBI*dcos(DBLE(THP))*
     1             dcos(DBLE(THP))+AAI*AAI*dsin(DBLE(THP))*
     2                                     dsin(DBLE(THP))))
      WRITE (TAPEOT,10)
   10 FORMAT (//'*** ELLIPTICAL GEOMETRY DATA IS BEGIN ',
     _        'GENERATED ***' )
C  SET COUNTERS
      TYPE=3
      NREC=0
C  READ IN TITLE CARD
   20 READ (TAPEIN,30) (TITLE(L),L=1,12),DISCON,IPRINT,CASE,SECT,ITYPE
   30 FORMAT (//12A4,11X,2I1,t65,I2,1A4,I2)
      IF (ITYPE .NE. 4) GOTO 470
      LINE=100
      SEQ= 1
C  READ IN ALL DATA CARDS FOR THE SECTION And Fill Arrays
      REWIND TAPEB
      I=1
      READ ( TAPEIN, '(/)' )
   40 READ (TAPEIN,50) X,THETO,THETL,NN(I),A,B,DELZ,DELY,LAST,Case,
     @         Sect,ITYPE
   50 FORMAT ( 3F7.0,I7,4F7.0,I7,t65,I2,1a4,i2 )
      IF (ITYPE .NE. 5) GOTO 470
      AX(I)=X
      THETO=THETO/57.2957795
      THETL=THETL/57.2957795
      THETOX(I)=THETO
      THETLX(I)=THETL
      DELTH=(THETL-THETO)/dfloat(NN(I))
      DELTHX(I)=DELTH
      AA(I)=A
      BB(I)=B
      DELZX(I)=DELZ
      DELYX(I)=DELY
C  End Arrays Filling
      IF (LAST .EQ. 0) GOTO 60
      N=I
      GOTO 70
   60 I=I+1
      GOTO 40
   70 I=1
      M=0
   80 IF (I .GT. N) GOTO 110
C
      IF (NN(I)-M) 100,100,90
   90 M=NN(I)
  100 I=I+1
      GOTO 80
C
  110 GOTO (120,180,270) ,DISCON
C
  120 M=M+1
C
      DO 170 I=1,N
C
      DO 160 J=1,M
C
      XA=AX(I)
      THETA=THETOX(I)+(dfloat(J-1))*DELTHX(I)
      THETAP=dabs(DBLE(THETA-1.570796))
      RAD=RADD(BB(I),AA(I),THETAP)
      IF (RAD .NE. 0.0) RAD=AA(I)*BB(I)/RAD
      YA=RAD*dsin(DBLE(THETA))
      ZA=-RAD*dcos(DBLE(THETA))
      YA=YA+DELYX(I)
      ZA=ZA+DELZX(I)
C
      IF (J .EQ. 1) GOTO 130
      STATA=0
      GOTO 150
C
  130 IF (I .EQ. 1) GOTO 140
      STATA=1
      GOTO 150
C
  140 STATA=2
  150 WRITE (TAPEB) XA,YA,ZA,STATA
  160 CONTINUE
  170 CONTINUE
C
      GOTO 360
C
C
  180 DO 260 I=1,N
C
      LIM=M+1-NN(I)
C
      DO 220 J=1,LIM
      XA=AX(I)
      THETA=THETOX(I)
      THETAP=dabs(DBLE(THETA-1.570796))
      RAD=RADD(BB(I),AA(I),THETAP)
      IF (RAD .NE. 0.0) RAD=AA(I)*BB(I)/RAD
      YA=RAD*dsin(DBLE(THETA))
      ZA=-RAD*dcos(DBLE(THETA))
      YA=YA+DELYX(I)
      ZA=ZA+DELZX(I)
      IF (J .EQ. 1) GOTO 190
      STATA=0
      GOTO 210
C
  190 IF (I .EQ. 1) GOTO 200
      STATA=1
      GOTO 210
C
  200 STATA=2
  210 WRITE (TAPEB) XA,YA,ZA,STATA
C
  220 CONTINUE
      K=0
      LIM=LIM+1
      NM=M+2
      DO 250 J=LIM,NM
      XA=AX(I)
      THETA=THETLX(I)-(dfloat(NN(I)-K))*DELTHX(I)
      THETAP=dabs(DBLE(THETA-1.570796))
      RAD=RADD(BB(I),AA(I),THETAP)
      IF (RAD .NE. 0.0) RAD=AA(I)*BB(I)/RAD
      YA=RAD*dsin(DBLE(THETA))
      ZA=-RAD*dcos(DBLE(THETA))
      YA=YA+DELYX(I)
      ZA=ZA+DELZX(I)
C
      IF (J .EQ. 1) GOTO 230
      STATA=0
      GOTO 240
C
  230 STATA=1
C
  240 WRITE (TAPEB) XA,YA,ZA,STATA
      K=K+1
  250 CONTINUE
C
  260 CONTINUE
      M=M+2
      GOTO 360
C
  270 M=M+2
      DO 350 I=1,N
      NM=NN(I)+1
C
      DO 310 J=1,NM
      XA=AX(I)
      THETA=THETOX(I)+(dfloat(J-1))*DELTHX(I)
      THETAP=dabs(DBLE(THETA-1.570796))
      RAD=RADD(BB(I),AA(I),THETAP)
      IF (RAD .NE. 0.0) RAD=AA(I)*BB(I)/RAD
      YA=RAD*dsin(DBLE(THETA))
      ZA=-RAD*dcos(DBLE(THETA))
      YA=YA+DELYX(I)
      ZA=ZA+DELZX(I)
      IF (J .EQ. 1) GOTO 280
      STATA=0
      GOTO 300
C
  280 IF (I .EQ. 1) GOTO 290
      STATA=1
      GOTO 300
C
  290 STATA=2
  300 WRITE (TAPEB) XA,YA,ZA,STATA
C
  310 CONTINUE
      NM=NM+1
C
      DO 340 J=NM,M
      XA=AX(I)
      THETA=THETLX(I)
      THETAP=dabs(DBLE(THETA-1.570796))
      RAD=RADD(BB(I),AA(I),THETAP)
      IF (RAD .NE. 0.0) RAD=AA(I)*BB(I)/RAD
      YA=RAD*dsin(DBLE(THETA))
      ZA=-RAD*dcos(DBLE(THETA))
      YA=YA+DELYX(I)
      ZA=ZA+DELZX(I)
      IF(J .EQ. 1) GOTO 320
      STATA=0
      GOTO 330
C
  320 STATA=1
  330 WRITE (TAPEB) XA,YA,ZA,STATA
C
  340 CONTINUE
C
  350 CONTINUE
C
C
C *** Alter Last Point Status ********************************************
  360 STATA=3
      IF (LAST.EQ.0 .OR. LAST.EQ.2) STATA=4
C
      BACKSPACE TAPEB
      READ (TAPEB) XA,YA,ZA,STAT
      BACKSPACE TAPEB
      WRITE (TAPEB) XA,YA,ZA,STATA
C *************************************************************************
C
      REWIND TAPEB
      K=1
C
  370 READ (TAPEB) X,Y,Z,STAT
C
      IF (STAT .GT. 2) GOTO 410
      READ (TAPEB) XX,YY,ZZ,STATT
C
      IF (STATT .GT. 2) GOTO 390
C
  380 CALL PUNCH(X,Y,Z,STAT,XX,YY,ZZ,STATT,SECT,TYPE,LINE,SEQ,
     1           LAST,IPRINT,NREC)
C
      GOTO (370,20,450), K
C
C
  390 IF (STATT .EQ. 3) GOTO 400
      STATT=0
      K=2
      GOTO 380
C
  400 K=3
      GOTO 380
C
C
  410 XB=X
      YB=Y
      ZB=Z
      STATB=STAT
      GOTO 430
  420 BACKSPACE TAPEB
  430 BACKSPACE TAPEB
      READ (TAPEB) XA,YA,ZA,STATA
      IF (STATA.EQ.1 .OR. STATA.EQ.2) GOTO 440
      GOTO 420
  440 STATC=0
      CALL PUNCH(XB,YB,ZB,STATC,XA,YA,ZA,STATA,SECT,TYPE,LINE,SEQ,
     1           LAST,IPRINT,NREC)
      STATD=0
      IF (STAT .EQ. 3) STATD=3
      READ (TAPEB) XC,YC,ZC,STATT
      READ (TAPEB) XD,YD,ZD,STATT
      CALL PUNCH(XC,YC,ZC,STATC,XD,YD,ZD,STATD,SECT,TYPE,LINE,SEQ,
     1           LAST,IPRINT,NREC)
      IF (STAT .NE. 3) GOTO 20
C
C
  450 CONTINUE
  460 GOTO 480
  470 ERROR=1
  480 RETURN
      END
      FUNCTION ERF(X)
C  THIS FUNCTION ROUTINE IS REQUIRED BY CDC MODELS OF THE ARBITRARY-
C  BODY PROGRAM. IT IS USED WITH THE ERROR FUNCTION SUBPROGRAM (ERRF).
C  THESE ROUTINES ARE NOT REQUIRED IN THE IBM/360 MODEL BECAUSE THEY
C  ARE ALREADY AVAILABLE IN THE 360 FORTRAN LIBRARY.
C
      CALL ERRF(X,Y)
      ERF=Y
      RETURN
      END
      SUBROUTINE ERRF(X,Y)
C  THIS ROUTINE IS REQUIRED BY CDC MODELS OF THE ARBITRARY-BODY
C  PROGRAM.  THIS ROUTINE IS NOT REQUIRED IN THE IBM/360 MODEL
C  BECAUSE IT IS ALREADY AVAILABLE IN THE IBM FORTRAN LIBRARY.
C
      DIMENSION C(7)
      DATA C/1.,7.05230784E-2,4.22820123E-2,9.2705272E-3,
     1  1.520143E-4,2.765672E-4,4.30638E-5/
      IF (X .EQ. 0.0) GOTO 70
      Z=dabs(DBLE(X))
      Y=dsign( DBLE(1.0D+00), DBLE(X) )
      IF (Z .GE. 4.17) RETURN
      P=C(7)
      DO 50 J=1,6
      K=7-J
   50 P=C(K)+P*Z
      Y=Y*(1.0-P**(-16))
      RETURN
   70 Y=0.0
      RETURN
      END
      SUBROUTINE EXPAND (ANGLE,MER,IPRINT,ISDET,CP)
C
C  GIVEN THE FREE STREAM CONDITIONS (FS) AND THE TURNING ANGLE IN
C  DEGREES (ANGLE(2)), THIS SUBROUTINE PERFORMS AN ISENTROPIC PRANTL-
C  MEYER EXPANSION(ANGLE(2).GT.0.) OR COMPRESSION(ANGLE(2).LT.0.)
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /FSBS/FS,BS
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      DIMENSION FS(8),BS(8),ANGLE(3),A(2),C(2)
C
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      REAL*8 NU1,NU2,NU1D,NU2D
      Character *4 TITLE(15)
C
C  Suppress compiler warning: 'unused dummy argument ISDET'
      ISDET = 0
C  CHECK IF FREE STREAM MACH NO, .GE. 1.0
      IF (FS(6) .GE. 1.0) GOTO 10
C  INPUT MACH NO, SUBSONIC. FOR PROGRAM CONTINUITY SET = 1.0 AND GO ON
      EMSQ=1.0
      GOTO 20
C
C  SQUARF FREE STREAM MACH NO.
   10 EMSQ=FS(6)**2
C  DEFINE GAMMA RATIO FUNCTION GR.
   20 G=GAM
      GR=dsqrt(DBLE((G+1.)/(G-1.)))
C  CALCULATE PRANDTL-MEYER ANGLE FOR FREE STREAM CONDITIONS USING
C  EQUATION 171C OF TR 1135  (RADIANS)
      NU1=GR*datan(dsqrt(DBLE(EMSQ-1.))/GR)-datan(dsqrt(DBLE(EMSQ-1.)))
C
C  CALCULATE PRANDTL-MEYER ANGLE AFTER THE EXPANSION (RADIANS)
      NU1D=NU1*57.29578
      NU2D=NU1D+ANGLE(2)
      NU2=NU2D/57.29578
C
C  CHECK IF FLOW COMPRESSED TO SUBSONIC.
C
      IF (NU2D .GT. 0.) GOTO 30
C  NU2D .LE. 0.0, RETURN SONIC CONDITIONS
C
      BS(6)=1.0
      MER=2
      GOTO 190
C
C  CHECK IF FLOW NAS EXPANDED TO AN INFINITE MACH NUMBER (TAKEN
C  AS 100. FOR ALL PRACTICAL PURPOSES). IF SO, RETURN ZERO PRESSURE.
30    IF (NU2D.LT.(0.97815*(GR-1.)*90.0)) GOTO 40
      MER=2
      BS(6)=100.0
      GOTO 190
C
C
C  START OF ITERATION TO FIND MACH NO, DOWNSTREAM
C  SET INITIAL CONDITIONS AND TOLERANSE
   40 I=0
      A(2)=0.0
      C(2)=0.0
      EPS=1.E-4
      JPATH=1
C  JPATH CONTROLS THE LOGICAL PATH DURING THE ITERATION CYCLE.
C  CALCULATE APPROXIMATE DOWNSTREAM MACH NO.
      BS(6)=FS(6)*(1.+(NU2-NU1)*(1.+5.*(G-1.)*EMSQ)/
     1                           dsqrt(DBLE(EMSQ-1.)))
      IF (BS(6) .GT. 1.0) GOTO 50
      BS(6)=1.01
C  SET ITERATION COUNTER AND CHECK FOR MAXIMUM
   50 I=I+1
C
C  CHECK NUMBER OF ITERATIONS COUNTER
   60 IF (I .LE. 20) GOTO 80
      WRITE (TAPEOT,70) I
   70 FORMAT ( I4,42H ITERATIONS IN EXPANSION ROUTINE. THE LAST,
     1 25H VALUE HAS BEEN ACCEPTED. )
      GOTO 190
C
   80 A(2)=BS(6)
C
      R=(NU2+datan(dsqrt(DBLE(BS(6)**2-1.0))))/GR
      R=dtan(DBLE(R))
      BS(6)=dsqrt(DBLE(1.0+(R*GR)**2))
C
      C(2)=BS(6)
C
C  CHECK IF FLOW ITERATION IS TO BE PRINTED OUT
      IF (IPRINT .NE. 1) GOTO 100
      WRITE (TAPEOT,90) A(2),C(2)
   90 FORMAT ( 17X,3HMA=,F8.4,4X,3HMC=,F8.4)
C
C  CHECK IF ITERATION ACCURACY HAS BEEN REACHED
  100 DCA2=C(2)-A(2)
      IF (dabs(DBLE(DCA2/C(2))) .LE. EPS) GOTO 190
C
      GOTO (110,150,160), JPATH
  110 JPATH=2
C  SET ASSUMED VALUE BY AN ARBITRARY INCREMENT
C  EXPERIENCE HAS SHOWN THAT ONE-12TH OF C(2) TO BE A GOOD VALUE.
  120 DA=C(2)/12.
  130 A(1)=A(2)
      C(1)=C(2)
      DCA1=DCA2
      IF (DCA1 .GT. 0.0) GOTO 140
      BS(6)=C(1)-DA
C  MAKE SURE THAT 2ND GUESS IS NOT OUT OF RANGE.
      IF (BS(6) .GT. 1.0) GOTO 50
      BS(6)=(C(1)-1.0)/2.+1.0
      GOTO 50
  140 BS(6)=C(1)+DA
      GOTO 50
  150 IF ((DCA2/DCA1) .GT. 0.0) GOTO 120
      JPATH=3
  160 IF ((DCA2/DCA1) .GT. 0.0) GOTO 130
C  CALCULATE MACH NUMBER AFTER EXPANSION USING 2 PREVIOUS ESTIMATES
      IF ((C(2)-C(1)) .NE. 0.0) GOTO 170
      DADC=0.0
      GOTO 180
  170 DADC=(A(2)-A(1))/(C(2)-C(1))
  180 BS(6)=(A(1)-C(1)*DADC)/(1.-DADC)
      A(1)=A(2)
      C(1)=C(2)
      DCA1=DCA2
      DA=DA/2.
      GOTO 50
C
C
C  CALCULATE FINAL CHARACTERISTICS BEHIND EXPANSION FAN
  190 ONEOM=1.0/BS(6)
      ANGLE(3)=asin(ONEOM)*57.29578
      Z=(2.0+(G-1.)*EMSQ)/(2.0+(G-1.)*BS(6)**2)
      BS(1)=FS(1)*Z**(1./(G-1.))
      BS(2)=FS(2)*Z**(G/(G-1.))
      BS(3)=FS(3)*Z
      BS(4)=FS(4)*dsqrt(DBLE(Z))
      IF (BS(3).GE.AV1) BS(5)=2.27E-8*BS(3)**1.5/(BS(3)+198.6)
      IF (BS(3).LT.AV1) BS(5)=AV2*BS(3)**AV3
      BS(7)=BS(6)*BS(4)
      BS(8)=BS(1)*BS(7)/BS(5)
C
      CP=(Z**(G/(G-1.))-1.0)/(0.5*G*EMSQ)
C
      RETURN
C
      END
      SUBROUTINE FFAIRF
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /TAGS/ITAG4,ITAG9,ITAG10
      COMMON /FFIELD/TITLEM,TITLES,TITLEA,TITLER,
     1        IMTAB(9),IDTYP(5),LOSET(5),LOAB(20),LORG(20),L,
     2        DINF(6),IRW,LCNEXT,IREG,MACH,NAB,ALPHA,BETA,NREG,
     3        NSREG,ITFLAG
C
      Character*4 TITLE(15), TITLEM(10), TITLES(10), TITLEA(10),
     1            TITLER(10)
C
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      RETURN
      END
      SUBROUTINE FFBODY
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /FFIELD/TITLEM,TITLES,TITLEA,TITLER,
     1        IMTAB(9),IDTYP(5),LOSET(5),LOAB(20),LORG(20),L,
     2        DINF(6),IRW,LCNEXT,IREG,MACH,NAB,ALPHA,BETA,NREG,
     3        NSREG,ITFLAG
      COMMON /SOSEIN/ AMF,ALFWD,PHIT,G,IFLG(5),NP,AMP,ALFP,
     1       A(100),R(100)
      COMMON /SOSEOT/AMANS(100),AMDX(100),AMDY(100),AMDZ(100),
     1    PANS(100),TD(100),AMS(100),AMSX(100),AMSY(100),AMSZ(100),
     2    PSHK(100),TS(100),NSP,NS,JS(10),IS(10),LS(10),IN(10),
     3    XANS(100),YANS(100),XS(100),YS(100)
C
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      DIMENSION NE(10),DAT(6)
      DIMENSION COMPID(10),PHI(40),YPA(40),DATA(12),LOSF(5)
      REAL MACH
      REAL LOC(25)
C
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      Character*4 TITLE(15), TITLEM(10), TITLES(10), TITLEA(10),
     1            TITLER(10)
C
      DATA RC/1.745329252E-2/
C
      TFX(XO,X,Y,Z)=XO+AP11*X+AP21*Y+AP31*Z
C
      TFY(YO,X,Y,Z)=YO+AP12*X+AP22*Y+AP32*Z
C
      TFZ(ZO,X,Y,Z)=ZO+AP13*X+AP23*Y+AP33*Z
C
      G=GAM
C
C   READ IN SHOCK EXPANSION FLOW FIELD CONTROL CARD
      DO i = 1,3
         READ (tapein, "()")
      END DO
      READ (TAPEIN,10) IFLG,X1,X2
   10 FORMAT( /5I7 // 2F7.0 )
C
C   GO GET MERIDIAN CUTS. RAW DATA ON TAPEB
C   AND BY MERIDIAN ON TAPEC.
C   IF IFLG(2) = 1, USE PREVIOUSLY CALCULATED DATA
      IF (IFLG(2) .EQ. 1) GOTO 20
      CALL MERID
C
C   NOW ORDER MERIDIAN DATA. SAVE FINAL RESULTS ON TAPEB.
      CALL MOUT
C
   20 REWIND TAPEB
      READ (TAPEB) COMPID,NC,NE,NPL,MPTOT,
     1             PSIO,THEO,PHIO,XPO,YPO,ZPO,ITYPE1,
     2             (PHI(I),I=1,NPL),(YPA(I),I=1,NPL)
C
C   NOW READY TO CALCULATE FLOW FIELD DATA
C   USING SHOCK EXPANSION METHOD.
C
C   PREPARE VELOCITY AND TRANSFORMATION MATRICES.
C
      ALPHAR=RC*ALPHA
      BETAR=RC*BETA
      COSA=COS(ALPHAR)
      SINA=SIN(ALPHAR)
      COSB=COS(BETAR)
      SINB=SIN(BETAR)
      COSPS=COS(RC*PSIO)
      SINPS=SIN(RC*PSIO)
      COST=COS(RC*THEO)
      SINT=SIN(RC*THEO)
C
C   DIRECTION COSINES OF FREE STREAM FLOW
      AMF=MACH
      AMFX=-COSA*COSB
      AMFY=SINB
      AMFZ=SINA*COSB
C
C   CALCULATE DIRECTION COSINES OF FREE STREAM
C   IN MERIDIAN AXIS COORDS.
C
C   COMPONENTS OF TRANSFORMATION MATRIX
      AA11=COST*COSPS
      AA12=COST*SINPS
      AA13=-SINT
C
      AA21=-SINPS
      AA22=COSPS
      AA23=0.0
C
      AA31=-SINT*COSPS
      AA32=-SINT*SINPS
      AA33=-COST
C
C   DIRECTION COSINES IN MERIDIAN AXIS COORDS.
      VX=AA11*AMFX+AA12*AMFY+AA13*AMFZ
      VY=AA21*AMFX+AA22*AMFY+AA23*AMFZ
      VZ=AA31*AMFX+AA32*AMFY+AA33*AMFZ
C
C   CALCULATE LOCATION OF WINDWARD PLANE
      PHIW=0.0
      IF (VY.EQ.0.0 .AND. VZ.LE.0.0) GOTO 30
      PHIW=3.1415926
      IF (VY .EQ. 0.0) GOTO 30
      PHIW=ATAN2(VY,VZ)
   30 CONTINUE
C
C   CALCULATE ANGLE OF ATTACK IN WINDWARD PLANE
      ALFWD=ACOS(-VX)
C
C   BEGIN CYCLE ON SPECIFIC PLANES (NPL OF THEM)
C   THIS IS CYCLE ON SUB-REGIONS
      NSREG=NPL
      LCNEXT=LCNEXT+NSREG
      DO 1500 N=1,NPL
C
C   TRANSFORMATION MATRIX FOR GIVEN PLANE (PHI + YPA).
      AP11=AA11
      AP12=AA12
      AP13=AA13
C
      COSP=COS(PHI(N))
      SINP=SIN(PHI(N))
C
      AP21=COSP*AA21-SINP*AA31
      AP22=COSP*AA22-SINP*AA32
      AP23=-SINP*AA33
C
      AP31=SINP*AA21+COSP*AA31
      AP32=SINP*AA22+COSP*AA32
      AP33=COSP*AA33
C
      XO=XPO
      YO=YPO+YPA(N)
      ZO=ZPO
C
C   LOCATION FROM WINDWARD PLANE
      PHIT=(PHI(N)-PHIW)
C   MACH NO. IN PHIT PLANE, AMP.
      EMC=VZ*COS(PHIT)+VY*SIN(PHIT)
      AMP=AMF*SQRT(VX**2+EMC**2)
C   ANGLE OF AMP TO AXIS
      ALFP=ATAN2(-EMC,-VX)
C   READ IN MERIDIAN DATA
      READ (TAPEB) NP
      DO 90 J=1,NP
      READ (TAPEB) IC,COMID,JJ,XI,YI,ZI,R(J),A(J)
   90 CONTINUE
C
C
      CALL SOSE
C
C   SET UP FLOW FIELD REGIONS (NS OF THEM).
C
C   CYCLE ON SECONDARY FLOWS
      IG10=LORG(IREG)+4+N
      NSECF=NS-1
      DO 95 K=10,25
   95 LOC(K)=0
C
      ISF=0
      IR=0
C
C   GATHER, TRANSFORM AND STORE FLOW FIELD DATA.
  100 IR=IR+1
      ITAG10=LCNEXT
      DO 105 K=1,9
  105 LOC(K)=0
C
C   SET COUNTERS FOR BOUNDARY 1
      LOC(1)=LCNEXT
      I1=IS(IR)
      I2=NP
      IF (NS .GT. IR) I2=IS(IR+1)-1
      IL1=0
      DO 107 I=I1,I2
      IF (IL1 .NE. 0) GOTO 106
      IF (X1 .GE. XANS(I)) IL1=I
  106 IF (X2 .GE. XANS(I)) GOTO 108
  107 CONTINUE
      IL2=I2
      GOTO 109
  108 IL2=I
  109 IF (IL1 .LT. I1) IL1=I1
      I1=IL1
      I2=IL2
      LOC(6)=I2-I1+1
      IB=1
      GOTO 200
C
C   SET COUNTERS FOR BOUNDARY 2
  110 I1=JS(IR)
      I2=LS(IR)
      IL3=0
      DO 117 I=I1,I2
      IF (IL3 .NE. 0) GOTO 116
      IF (X1 .GE. XS(I)) IL3=I
  116 IF (X2 .GE. XS(I)) GOTO 118
  117 CONTINUE
      IL4=I2
      GOTO 119
  118 IL4=I
  119 IF (IL3 .LT. I1) IL3=I1
      I1=IL3
      I2=IL4
      IK=1
      LOC(2)=LOC(1)+LOC(6)
      LOC(7)=I2-I1+1
      GOTO 300
C
C   SET COUNTERS FOR BOUNDARY 3
  120 I1=IL1
      I2=I1
      IB=2
      GOTO 200
  130 I1=IL3
      I2=I1
      IK=2
      LOC(3)=LOC(2)+LOC(7)
      LOC(8)=2
      GOTO 300
C
C   SET COUNTERS FOR BOUNDARY 4
  140 I1=IL2
      I2=I1
      IB=3
      LOC(4)=LOC(3)+LOC(8)
C   THE FOLLOWING CARD IS A DUMMY TEST UNTIL INTERSECTIONS
C   BECONE ACTIVE. CARD SHOULD BE
C     IF (NS .GT. IR) GOTO 160
      IF (NS .EQ. 0) GOTO 160
      GOTO 200
  150 I1=IL4
      I2=I1
      IK=4
      LOC(9)=2
      GOTO 300
  160 I1=JS(IR+1)
      I2=IN(IR)
      IK=3
      LOC(9)=I2-I1+1
      GOTO 300
  170 I1=LS(IR)
      I2=I1
      IK=4
      LOC(9)=LOC(9)+1
      GOTO 300
C
C
  200 CONTINUE
      DO 210 I=I1,I2
      DATA(1)=TFX(XO,XANS(I),0.0,YANS(I))
      DATA(2)=TFY(YO,XANS(I),0.0,YANS(I))
      DATA(3)=TFZ(ZO,XANS(I),0.0,YANS(I))
      DATA(4)=XANS(I)
      DATA(5)=YANS(I)
      DATA(6)=PHI(N)
      DATA(7)=AMANS(I)
      DATA(8)=AMDX(I)
      DATA(9)=AMDZ(I)
      DATA(10)=AMDY(I)
      DATA(11)=PANS(I)
      DATA(12)=TD(I)
C
      WRITE( 10, REC=ITAG10 ) DATA
C     CALL WRITMS(10,DATA,12,ITAG10)
      ITAG10=ITAG10+1
C
  210 CONTINUE
      GOTO (110,130,150), IB
C
C
  300 CONTINUE
      DO 310 I=I1,I2
      DATA(1)=TFX(XO,XS(I),0.0,YS(I))
      DATA(2)=TFY(YO,XS(I),0.0,YS(I))
      DATA(3)=TFZ(ZO,XS(I),0.0,YS(I))
      DATA(4)=XS(I)
      DATA(5)=YS(I)
      DATA(6)=PHI(N)
      DATA(7)=AMS(I)
      DATA(8)=AMSX(I)
      DATA(9)=AMSZ(I)
      DATA(10)=AMSY(I)
      DATA(11)=PSHK(I)
      DATA(12)=TS(I)
C
      WRITE( 10, REC=ITAG10 ) DATA
C     CALL WRITMS(10,DATA,12,ITAG10)
      ITAG10=ITAG10+1
C
  310 CONTINUE
      GOTO (120,140,170,400), IK
C
C   CHECK FOR SECONDARY FLOWS. FIRST SAVE COUNTERS
  400 CONTINUE
      WRITE( 10, REC=IG10 ) LOC
C     CALL WRITMS(10,LOC,25,IG10)
C
      IF (NSECF .EQ. 0) GOTO 500
C
C   SECONDARY FLOW. SET LOCATIONS AND COUNTERS.
      ISF=ISF+1
      IG10=ITAG10
      LCNEXT=IG10+1
C
      NSECF=NSECF-1
      LOSF(ISF)=IG10
      GOTO 100
C
  500 CONTINUE
      LCNEXT=ITAG10
      IF (ISF .EQ. 0) GOTO 1500
C
C   RESET LOCATIONS FOR SECONDARY FLOWS
      IG10=LORG(IREG)+4+N
C
      READ( 10, REC=IG10 ) LOC
C     CALL READMS(10,LOC,25,IG10)
C
      DO 510 I=1,ISF
  510 LOC(20+I)=LOSF(I)
C
      WRITE( 10, REC=IG10 ) LOC
C     CALL WRITMS(10,LOC,25,IG10)
C
 1500 CONTINUE
C
C   SAVE ORIENTATION DATA
      DAT(1)=XPO
      DAT(2)=YPO
      DAT(3)=ZPO
      DAT(4)=PSIO
      DAT(5)=THEO
      DAT(6)=PHIO
      IG10=LORG(IREG)+1
      WRITE( 10, REC=IG10 ) DAT
C     CALL WRITMS(10,DAT,6,IG10)
C
C   SET IDTYP(1) FOR NON-UNIFORM FLOW FIELD
      IDTYP(2)=2
C
      RETURN
      END
      SUBROUTINE FFINPT
C
C   THIS ROUTINE IS USED TO PERMIT HAND LOADING OF FLOW FIELD DATA ON
C   UNIT 10.
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /TAGS/ITAG4,ITAG9,ITAG10
      COMMON /FFIELD/TITLEM,TITLES,TITLEA,TITLER,
     1        IMTAB(9),IDTYP(5),LOSET(5),LOAB(20),LORG(20),L,
     2        DINF(6),IRW,LCNEXT,IREG,MACH,NAB,ALPHA,BETA,NREG,
     3        NSREG,ITFLAG
C
      DIMENSION IFC(5),IFD(5),LOSF(5),DAT(6),DATA(12),DATB(25)
      DIMENSION LOFF(5),LOCD(5)
C
      REAL mach
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      Character*4 TITLE(15), TITLEM(10), TITLES(10), TITLEA(10),
     1            TITLER(10)
C
C
      DO i = 1,3
         READ (tapein, "()")
      END DO
      READ (TAPEIN,10) IDTYP(2)
   10 FORMAT( /i7 )
      ITAB=IDTYP(2)
      IF (ITAB.LT.1 .OR. ITAB.GT.4) GOTO 900
      GOTO (210,220,230,240), ITAB
C
C   UNIFORM FLOW FIELD - SAME FOR ALL X,Y,Z.
  210 IF (IRW .NE. 0) GOTO 212
      DO i = 1,2
         READ (tapein, "()")
      END DO
      READ (TAPEIN,211) DINF
  211 FORMAT( /6f7.0 )
      IG10=LCNEXT
      WRITE( 10, REC=IG10 ) DINF
C     CALL WRITMS(10,DINF,6,IG10)
C   SET POINTER TO START OF DATA
      LOFF(1)=LCNEXT
      LCNEXT=IG10+1
      WRITE (TAPEOT,216)
  216 FORMAT (1x,43HDATA ARE BEGIN READ INTO UNIFORM FLOW FIELD  )
      GOTO 213
  212 IG10=LCNEXT
      WRITE (TAPEOT,217)
  217 FORMAT (1x,40HDATA ARE BEGIN READ FROM FLOW-FIELD UNIT )
      READ( 10, REC=IG10 ) DINF
C     CALL READMS(10,DINF,6,IG10)
  213 WRITE (TAPEOT,214) TITLEM,IMTAB,TITLES,MACH,NAB,LOAB,
     1  TITLEA,ALPHA,BETA,NREG,LORG,TITLER,IDTYP
  214 FORMAT (1x,7HTITLEM=,10A4/4x,7H IMTAB=,9I4,/1H ,7HTITLES=,10A4,
     1 7H MACH =,F6.3,5H NAB=,I3,/1H ,4X,5HLOAB=,20I3,/1H ,7HTITLEA=,
     2 10A4/5x,6HALPHA=,F6.3,6H BETA=,F6.3,8H NREG  =,I3,/1H ,4X,5HLORG=,
     3 20I3,/1H ,7HTITLER=,10A4,7H IDTYP=,5I2)
      WRITE (TAPEOT,215) DINF
  215 FORMAT (1x,5HDINF=,6F10.2)
      GOTO 600
C
C
C
C   NON-UNIFORM FLOW-FIELD DATA ARE INPUT OR READ
  220 IF (IRW .NE. 0) GOTO 227
C
C   READ ORIENTATION CARD
      DO i = 1,3
         READ (tapein, "()")
      END DO
      READ (TAPEIN,221) NSREG,ITFLAG,DAT
  221 FORMAT( /2I7 // 6F7.0 )
C   SET SUB-REGION COUNTERS
      IF (NSREG .LE. 0) NSREG=1
      ISR=0
C
      IG10=LORG(IREG)+1
      WRITE( 10, REC=IG10 ) DAT
C     CALL WRITMS(10,DAT,6,IG10)
      IG10=LCNEXT+NSREG-1
  100 ISR=ISR+1
      LCNEXT=LORG(IREG)+4+ISR
      ISF=0
      DO 249 I=1,5
  249 LOSF(I)=0
  110 CONTINUE
C
C   READ IN FLOW FIELD CONTROL CARD
      DO i = 1,2
         READ (tapein, "()")
      END DO
      READ (TAPEIN,229) IFC,IFD,ISECF
  229 FORMAT( /5i7 // 5i7 // i7 )
C
C   PRESET LOCATIONS AND COUNTERS
      DO 250 I=1,5
      LOFF(I)=0
      LOCD(I)=0
      DATB(I+5)=IFC(I)
      DATB(I+15)=IFD(I)
  250 CONTINUE
C
      LOFF(1)=IG10+1
      IFR=IFC(1)
      IC=1
C   READ IN FLOW FIELD DATA. IC=1 BOUNDARY 1, IC=2 BOUNDARY 2,
C   IC=3 BOUNDARY 3, IC=4 BOUNDARY 4, IC=5 REMAINING FLOW FIELD DATA
      DO i = 1,2
         READ (tapein, "()")
      END DO
  222 DO 224 I=1,IFR
      READ (TAPEIN,223) DATA
  223 FORMAT( /6F7.0 )
      IG10=IG10+1
  224 WRITE( 10, REC=IG10 ) DATA
C 224 CALL WRITMS(10,DATA,12,IG10)
      IF (IC .NE. 1) GOTO 225
      IC=2
      LOFF(2)=IG10+1
      IFR=IFC(2)
      IF (IFR .EQ. 0) GOTO 225
      GOTO 222
  225 IF (IC .NE. 2) GOTO 226
      IC=3
      IFR=IFC(3)
      IF (IFR .EQ. 0) GOTO 226
      LOFF(3)=IG10+1
      GOTO 222
  226 IF (IC .NE. 3) GOTO 241
      IC=4
      IFR=IFC(4)
      IF (IFR .EQ. 0) GOTO 241
      LOFF(4)=IG10+1
      GOTO 222
  241 IF (IC .NE. 4) GOTO 242
      IC=5
      IFR=IFC(5)
      IF (IFR .EQ. 0) GOTO 242
      LOFF(5)=IG10+1
      GOTO 222
  242 CONTINUE
C
C   SAVE LOCATIONS AND COUNTERS FOR SUB-REGION
      DO 260 I=1,5
      DATB(I)=LOFF(I)
  260 DATB(I+10)=LOCD(I)
C
      WRITE( 10, REC=LCNEXT ) DATB
C     CALL WRITMS(10,DATB,25,LCNEXT)
C
C   CHECK FOR SECONDARY FLOW
      IF (ISECF .EQ. 0) GOTO 300
C
C   SECONDARY FLOW
      IG10=IG10+1
      LCNEXT=IG10
      ISF=ISF+1
      LOSF(ISF)=LCNEXT
      GOTO 110
C
C
  300 CONTINUE
      IF (ISF .EQ. 0) GOTO 500
C
C   RESET LOCATIONS FOR SECONDARY FLOWS
      LCNEXT=LORG(IREG)+4+ISR
C
      READ( 10, REC=LCNEXT ) DATB
C     CALL READMS(10,DATB,25,LCNEXT)
      DO 310 I=1,ISF
  310 DATB(I+20)=LOSF(I)
C
      WRITE( 10, REC=LCNEXT ) DATB
C     CALL WRITMS(10,DATB,25,LCNEXT)
C
C
  500 CONTINUE
      IF (ISR .LT. NSREG) GOTO 100
C
      LCNEXT=IG10+1
      GOTO 600
C
C
C   FLOW FIELD DATA WILL BE READ FROM UNIT 10
  227 WRITE (TAPEOT,217)
      WRITE (TAPEOT,214) TITLEM,IMTAB,TITLES,MACH,NAB,LOAB,
     1  TITLEA,ALPHA,BETA,NREG,LORG,TITLER,IDTYP
      IG10=LORG(IREG)+1
      READ( 10, REC=IG10 ) DAT
C     CALL READMS(10,DAT,6,IG10)
      WRITE (TAPEOT,228) DAT
  228 FORMAT (1x,
     1  3HXO=,F7.3,3X,3HYO=,F7.3,3X,3HZO=,F7.3,
     2  3X/5HPSIO=,F7.3,3X,6HTHETO=,F7.3,6X,5HPHIO=,F7.3)
C
C   READ IN SUB-REGIONS
      DO 800 ISR=1,NSREG
      IG10=LORG(IREG)+4+ISR
      ISF=0
  700 CONTINUE
C
      READ( 10, REC=IG10 ) DATB
C     CALL READMS(10,DATB,25,IG10)
      DO 710 I=1,5
      LOFF(I)=DATB(I)+0.001
      IFC(I)=DATB(I+5)+0.001
      LOCD(I)=DATB(I+10)+0.001
      IFD(I)=DATB(I+15)+0.001
  710 CONTINUE
C
C
C   COUNT NUMBER OF SECONDARY FLOWS (SUB-REGIONS ONLY)
      IF (ISF .NE. 0) GOTO 750
      NSECF=0
      DO 720 I=1,5
      LOSF(I)=DATB(I+20)+0.001
      IF (LOSF(I) .EQ. 0) GOTO 730
      NSECF=NSECF+1
  720 CONTINUE
  730 CONTINUE
      WRITE (TAPEOT,740) IREG,ISR,NSECF
  740 FORMAT (1x,11HFLOW REGION,I3,/1x,10HSUB-REGION,I3,
     1   20X,25HNUMBER OF SECONDARY FLOWS,I3)
C
  750 WRITE (TAPEOT,760) LOFF,IFC,LOCD,IFD
  760 FORMAT (1x,4HLOFF,5I10,/1H ,4H IFC,5I10,/
     1        1x,4HLOCD,5I10,/1H ,4H IFD,5I10)
C
      IG10=LOFF(1)-1
      IFR=IFC(1)
      IC=1
  231 WRITE (TAPEOT,237) IC
  237 FORMAT (1x,9HBOUNDARY ,I2,5H DATA )
      WRITE( TAPEOT, "('     X     Y      Z       A     R    PHI',
     1       '   M   Vx/V8 Vy/V8 Vz/V8  P/P8  T/T8')" )
  236 DO 232 I=1,IFR
      IG10=IG10+1
      READ( 10, REC=IG10 ) DATA
C     CALL READMS(10,DATA,12,IG10)
      DATA(6) = DATA(6) * 180. /( 4*ATAN(1.) )
  232 WRITE (TAPEOT,233) DATA
  233 FORMAT( f8.2, f6.2, f7.2, f8.2, f6.2, f5.0, f6.2, 3f6.3, 2f6.2 )
      DATA(6) = DATA(6) * ( 4*ATAN(1.) ) / 180.
      IF (IC .NE. 1) GOTO 234
      IC=2
      IFR=IFC(2)
      IF (IFR .NE. 0) GOTO 231
  234 IF (IC .NE. 2) GOTO 235
      IC=3
      IFR=IFC(3)
      IF (IFR .NE. 0) GOTO 231
  235 IF (IC .NE. 3) GOTO 239
      IC=4
      IFR=IFC(4)
      IF (IFR .NE. 0) GOTO 231
  239 IF (IC .NE. 4) GOTO 245
      IC=5
      IFR=IFC(5)
      IF (IFR .EQ. 0) GOTO 245
      WRITE (TAPEOT,238)
  238 FORMAT (1x,25HREMAINING FLOW-FIELD DATA  )
      GOTO 236
C
  245 CONTINUE
C
C   CHECK FOR SECONDARY FLOWS
      IF (ISF .EQ. NSECF) GOTO 800
      ISF=ISF+1
      WRITE (TAPEOT,770) ISF
  770 FORMAT (1x,14HSECONDARY FLOW,I3)
C
C   SET LOCATIONS
      IG10=LOSF(ISF)
      GOTO 700
C
  800 CONTINUE
C
  230 CONTINUE
      GOTO 600
  240 CONTINUE
  600 CONTINUE
C
C
C
      RETURN
  900 WRITE (TAPEOT,910)
  910 FORMAT (1H ,47H** ITAB PARAMETER INPUT TO FFINPT IS WRONG*STOP )
      STOP
      END
      SUBROUTINE FFSPEC
C
C   THIS ROUTINE IS USED TO PERMIT THE GENERATION AND STORAGE OF
C   UNIFORM FLOW FIELDS USING THE SIMPLE COMPRESSION, EXPANSION,
C   ETC., FEATURES OF THE PROGRAM.
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /FLIGHT/EACH,ALT,PSTAG,TSTAG,V,RENO,PFS,TFS,AFS,RHOFS,VIS
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /FSBS/ FS,BS
      COMMON /FFIELD/TITLEM,TITLES,TITLEA,TITLER,
     1        IMTAB(9),IDTYP(5),LOSET(5),LOAB(20),LORG(20),L,
     2        DINF(6),IRW,LCNEXT,IREG,MACH,NAB,ALPHA,BETA,NREG,
     3        NSREG,ITFLAG
      DIMENSION FS(8),BS(8),ANGLE(3)
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      REAL MACH
      REAL*8 EACH
      Character*4 TITLE(15), TITLEM(10), TITLES(10), TITLEA(10),
     1            TITLER(10)
C
C
      DO i = 1,2
         READ (tapein, "()")
      END DO
      READ (TAPEIN,10) ISORCE
   10 FORMAT( /i7 )
      ITAB=ISORCE
      IF (ITAB.LT.1 .OR. ITAB.GT.4) GOTO 900
C
C
      READ (TAPEIN,20) DINF
   20 FORMAT( /6F7.0 )
C
C   INITIALIZE FLAGS
      MER=0
      IPRINT=0
      CPSTAG=2.0
      ISDET=0
      IFIRST=0
      IDTYP(2)=1
      ANGLE(2)=ABS(DINF(5))
C
C   INITIALIZE FREE STREAM DATA ARRAY
      FS(1)=RHOFS
      FS(2)=PFS
      FS(3)=TFS
      FS(4)=AFS
      FS(5)=VIS
      FS(6)=DINF(1)
      FS(7)=DINF(1)*FS(4)
      FS(8)=FS(1)*FS(7)/FS(5)
C
C
      GOTO (210,220,230,240), ITAB
C
C   WEDGE COMPRESSION FLOW FIELD
  210 CALL COMPR(ANGLE,MER,IPRINT,CPSTAG,ISDET,IFIRST,CP)
      WRITE (TAPEOT,215)
  215 FORMAT (1x,46H  FLOW FIELD IS BEGIN GENERATED AND STORED BY ,
     1  20HCOMPRESSION ROUTINE.  )
      GOTO 800
C
C   PRANDTL-MEYER EXPANSION
  220 CALL EXPAND(ANGLE,MER,IPRINT,ISDET,CP)
      WRITE (TAPEOT,225)
  225 FORMAT (1x,46H  FLOW FIELD IS BEGIN GENERATED AND STERED BY ,
     1  32HPRANDTL-MEYER EXPANSION ROUTINE.  )
      GOTO 800
C
C   CONICAL FLOW FIELD
  230 ANGLE(1)=DINF(5)
      CALL CONE(ANGLE,CP,0)
      WRITE (TAPEOT,235)
  235 FORMAT (1x,46H  FLOW FIELD IS BEGIN GENERATED AND STORED BY ,
     1  13HCONE ROUTINE.  )
      GOTO 800
C
C   NEWTONIAN PRANDTL-MEYER FIELD
  240 ISE=0
      ETAC=1.0
      IPRCK=0
      CALL NEWTPM(ANGLE,EMN,CP,ETAC,IPRCK,MER,CPSTAG,ISE,IFIRST)
      WRITE (TAPEOT,245)
  245 FORMAT (1x,46H  FLOW FIELD IS BEGIN GENERATED AND STORED BY ,
     1  32HNEWTONIAN PRANDTL-MEYER ROUTINE.  )
C
C
  800 CONTINUE
      DINF(1)=BS(6)
      DINF(5)=BS(2)/PFS
      DINF(6)=BS(3)/TFS
C
C
C   STORE DATA
      IG10=LCNEXT
      WRITE( 10, REC=IG10 ) DINF
C     CALL WRITMS(10,DINF,6,IG10)
  213 WRITE (TAPEOT,214) TITLEM,IMTAB,TITLES,MACH,NAB,LOAB,
     1  TITLEA,ALPHA,BETA,NREG,LORG,TITLER,IDTYP
  214 FORMAT (1x,7HTITLEM=,10A4,7H IMTAB=,9I4,/1H ,7HTITLES=,10A4,
     1 7H MACH =,F6.3,5H NAB=,I3,/1H ,4X,5HLOAB=,20I4,/1H ,7HTITLEA=,
     2 10A4,7H ALPHA=,F6.3,6H BETA=,F6.3,8H NREG  =,I3,/1H ,4X,5HLORG=,
     3 20I4,/1H ,7HTITLER=,10A4,7H IDTYP=,5I2)
      WRITE (TAPEOT,216) DINF
  216 FORMAT (1x,5HDINF=,6F10.2)
C
C   SET POINTER TO NEXT EMPTY RECORD NUMBER
      LCNEXT=IG10+1
C
      RETURN
C
  900 WRITE (TAPEOT,910) ITAB
  910 FORMAT (1x,9H***ITAB =,I2,28H INPUT TO SPECIAL FLOW FIELD ,
     1     53H ROUTINE.  IT MUST BE BETWEEN 1 AND 4.  PROGRAM STOP. )
      STOP
      END
      SUBROUTINE FFSURF
C
C
C   THIS ROUTINE IS USED TO TRANSFER SURFACE DATA (GENERATED AND
C   STORED ON UNIT 4 BY FORCE) TO THE FLOW FIELD UNIT 10.
C
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /FFIELD/TITLEM,TITLES,TITLEA,TITLER,
     1        IMTAB(9),IDTYP(5),LOSET(5),LOAB(20),LORG(20),L,
     2        DINF(6),IRW,LCNEXT,IREG,MACH,NAB,ALPHA,BETA,NREG,
     3        NSREG,ITFLAG
C
      DIMENSION IFC(5),IFD(5),LOSF(5),DAT(6),DATA(12),DATB(25)
      DIMENSION IPANL(10),ELEM(25),E2(25),E1(25)
      DIMENSION LOFF(5),LOCD(5)
C
      Integer E(25), EP(25)
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      Character*4 TITLE(15), TITLEM(10), TITLES(10), TITLEA(10),
     1            TITLER(10)
C
C
C
C   CHECK READ OR WRITE FLAG
      IF (IRW .NE. 0) GOTO 227
C
C   READ FLOW FIELD CONTROL AND PLANE ORIENTATION CARD
      DO i = 1,3
         READ (tapein, "()")
      END DO
      READ (TAPEIN,20) NSREG,IFC1,ITFLAG,DAT
   20 FORMAT( /3i7 // 6f7.0 )
C
C   SET SUB-REGION COUNTERS
      IF (NSREG .LE. 0) NSREG=1
      ISR=0
C
      IG10=LORG(IREG)+1
      WRITE( 10, REC=IG10 ) DAT
C     CALL WRITMS(10,DAT,6,IG10)
      IG10=LCNEXT+NSREG-1
C
   25 ISR=ISR+1
      LCNEXT=LORG(IREG)+4+ISR
C
      DO 30 I=1,5
      LOSF(I)=0
      LOFF(I)=0
      LOCD(I)=0
      IFC(I)=0
      DATB(I+5)=0
   30 DATB(I+15)=0
      IFC(1)=IFC1
C
      LOFF(1)=IG10+1
      IC=1
      IDTYP(1)=2
      IDTYP(2)=2
C
C
C   CHECK IF DATA IS TO BE OBTAINED FROM INPUT UNIT OR UNIT 4
      IF (IFC(1) .EQ. 0) GOTO 39
C   READ IN DATA FROM INPUT UNIT
      IFR=IFC(1)
      IF( isr .EQ. 1 ) THEN
         DO i = 1,4
            READ (tapein, "()")
         END DO
      ENDIF
      DO 38 I=1,IFR
      READ (TAPEIN,35) DATA
   35 FORMAT( 6f7.0 )
      IG10=IG10+1
      WRITE( 10, REC=IG10 ) DATA
C     CALL WRITMS(10,DATA,12,IG10)
   38 CONTINUE
      K=IFR
      GOTO 140
C
C
C   READ PANEL NUMBERS TO BE GROUPED TO FORM SURFACE COMPONENT
   39 CONTINUE
      IF( isr .EQ. 1 ) THEN
         DO i = 1,3
            READ (tapein, "()")
         END DO
      ENDIF
      READ (TAPEIN,40) IPANL
   40 FORMAT( 10i7 )
C   OBTAIN POINTER INFO FROM UNIT 4
      IG4=2
      READ( 4, REC=IG4 ) E
C      CALL READMS(4,E,25,IG4)
      NREM=E(4)
      K=0
C
C   START PANEL DO LOOP
      DO 100 I=1,10
      IF (IPANL(I) .EQ. 0) GOTO 140
      WRITE (TAPEOT,50) IPANL(I)
   50 FORMAT (1x,49HSURFACE DATA ARE BEGIN TRANSFERED FROM UNIT 4 TO ,
     1  17HUNIT 10.  IPANL =,I3,/1H ,28HDATA ARRAY FOLLOWS FOR EACH ,
     2   6HPOINT. )
      IG4=IPANL(I)*5
      READ( 4, REC=IG4 ) EP
C      CALL READMS(4,EP,25,IG4)
      ISTART=EP(3)-NREM
      N=EP(4)
C
C   START ELEMENT DO LOOP WITHIN A PANEL
      DO 99 II=1,N
      IG4=ISTART+NREM*II
      READ( 4, REC=IG4 ) ELEM
C      CALL READMS(4,ELEM,25,IG4)
C
      IG41=IG4+1
C
      READ( 4, REC=IG41 ) E2
C      CALL READMS(4,E2,25,IG41)
      IG4S=E2(NAB)
C
      READ( 4, REC=IG4S ) E1
C      CALL READMS(4,E1,25,IG4S)
C
      DATA(1)=ELEM(7)
      DATA(2)=ELEM(8)
      DATA(3)=ELEM(9)
      DATA(4)=0.0
      DATA(5)=0.0
      DATA(6)=0.0
      DATA(7)=E1(7)
      DATA(8)=E1(8)
      DATA(9)=E1(9)
      DATA(10)=E1(10)
      DATA(11)=E1(11)
      DATA(12)=E1(12)
      WRITE (TAPEOT,52) II,IG4S,DATA
   52 FORMAT (1H ,2I5,3X,6E12.5,/1H ,13X,6E12.5)
C
      IG10=IG10+1
C
      WRITE( 10, REC=IG10 ) DATA
C     CALL WRITMS(10,DATA,12,IG10)
      K=K+1
C
C
   99 CONTINUE
  100 CONTINUE
  140 CONTINUE
      IFC(1)=K
C
C   SAVE LOCATIONS AND COUNTERS FOR SUB-REGION
      DO 260 I=1,5
      DATB(I)=LOFF(I)
      DATB(I+5)=IFC(I)
  260 DATB(I+15)=LOCD(I)
C
C
      WRITE( 10, REC=IG10 ) DATB
C     CALL WRITMS(10,DATB,25,LCNEXT)
C
      LCNEXT=IG10+1
      IF (ISR .LT. NSREG) GOTO 25
      GOTO 600
C
C   FLOW FIELD DATA WILL BE READ FROM UNIT 10
  227 WRITE (TAPEOT,217)
  217 FORMAT (1x,48HSURFACE DATA ARE BEGIN READ FROM FLOW-FIELD UNIT )
      WRITE (TAPEOT,214) TITLEM,IMTAB,TITLES,MACH,NAB,LOAB,
     1      TITLEA,ALPHA,BETA,NREG,LORG,TITLER,IDTYP
  214 FORMAT ( 11H ** TITLEM=,10A4,7H IMTAB=,9I4,/1H ,7HTITLES=,10A4,
     1 7H MACH =,F6.3,5H NAB=,I3,/1H ,4X,5HLOAB=,20I4,/1H ,7HTITLEA=,
     2 10A4,7H ALPHA=,F6.3,6H BETA=,F6.3,8H NREG  =,I3,/1H ,4X,5HLORG=,
     3 20I4,/1H ,7HTITLER=,10A4,7H IDTYP=,5I2)
      IG10=LORG(IREG)+1
      READ( 10, REC=IG10 ) DAT
C      CALL READMS(10,DAT,6,IG10)
      WRITE (TAPEOT,228) DAT
  228 FORMAT (1x,
     1  3HXO=,F7.3,3X,3HYO=,F7.3,3X,3HZO=,F7.3,3X,
     2  5HPSIO=,F7.3,3X,6HTHETO=,F7.3,6X,5HPHIO=,F7.3)
C
C   READ IN SUB-REGIONS
      DO 800 ISR=1,NSREG
      IG10=LORG(IREG)+4+ISR
      ISF=0
  700 CONTINUE
C
      READ( 10, REC=IG10 ) DATB
C      CALL READMS(10,DATB,25,IG10)
      DO 710 I=1,5
      LOFF(I)=DATB(I)+0.001
      IFC(I)=DATB(I+5)+0.001
      LOCD(I)=DATB(I+10)+0.001
      IFD(I)=DATB(I+15)+0.001
  710 CONTINUE
C
C
C   COUNT NUMBER OF SECONDARY FLOWS (SUB-REGIONS ONLY)
      IF (ISF .NE. 0) GOTO 750
      NSECF=0
      DO 720 I=1,5
      LOSF(I)=DATB(I+20)+0.001
      IF (LOSF(I) .EQ. 0) GOTO 730
      NSECF=NSECF+1
  720 CONTINUE
  730 CONTINUE
      WRITE (TAPEOT,740) IREG,ISR,NSECF
  740 FORMAT (1x,11HFLOW REGION,I3,/1x,10HSUB-REGION,I3,
     1        20X,25HNUMBER OF SECONDARY FLOWS,I3)
C
  750 WRITE (TAPEOT,760) LOFF,IFC,LOCD,IFD
  760 FORMAT (1x,4HLOFF,5I20,/1H ,4H IFC,5I20,
     1       /1x,4HLOCD,5I20,/1H ,4H IFD,5I20)
C
      IG10=LOFF(1)-1
      IFR=IFC(1)
      IC=1
  231 WRITE (TAPEOT,237) IC
  237 FORMAT (1x,9HBOUNDARY ,I2,5H DATA )
  236 DO 232 I=1,IFR
      IG10=IG10+1
      READ( 10, REC=IG10 ) DATA
C      CALL READMS(10,DATA,12,IG10)
  232 WRITE (TAPEOT,233) DATA
  233 FORMAT (1H ,12F10.4)
      IF (IC .NE. 1) GOTO 234
      IC=2
      IFR=IFC(2)
      IF (IFR .EQ. 0) GOTO 234
      GOTO 231
  234 IF (IC .NE. 2) GOTO 235
      IC=3
      IFR=IFC(3)
      IF (IFR .EQ. 0) GOTO 235
      GOTO 231
  235 IF (IC .NE. 3) GOTO 239
      IC=4
      IFR=IFC(4)
      IF (IFR .EQ. 0) GOTO 239
      GOTO 231
  239 IF (IC .NE. 4) GOTO 245
      IC=5
      IFR=IFC(5)
      IF (IFR .EQ. 0) GOTO 245
      WRITE (TAPEOT,238)
  238 FORMAT (1x,25HREMAINING FLOW-FIELD DATA  )
      GOTO 236
C
  245 CONTINUE
C
C   CHECK FOR SECONDARY FLOWS
      IF (ISF .EQ. NSECF) GOTO 800
      ISF=ISF+1
      WRITE (TAPEOT,770) ISF
  770 FORMAT (1x,14HSECONDARY FLOW,I3)
C
C   SET LOCATIONS
      IG10=LOSF(ISF)
      GOTO 700
C
  800 CONTINUE
C
  600 CONTINUE
C
C
C
      RETURN
      END
      SUBROUTINE FLNTRP
C
C
      COMMON /EXEC/ CASE,TITLE,PAGE,ERROR
      COMMON /GDATA/ LTOT,JJ,SYMFCT,IORN,IGTYPE,LL
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /ABDATA/ NAB,ALPHA(20),BETA(20),ROL(20),CDELTA(20),QI(20),
     1                RI(20),PI(20)
      COMMON /INTERF/ INT,ISHE(20),NSHE(100),I9,ISHEF,INF(20,22),
     1                DINF(20,6),LTOTAB(20)
      INTEGER ERROR,SYMFCT,PAGE,CASE
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      DIMENSION ELEM(25)
C     DIMENSION ELEM(25),XIN(4),YIN(4),ZIN(4)
      DIMENSION TITLEM(10),TITLES(10),TITLEA(10),TITLER(10)
      Character *4 TITLE(15)
      DIMENSION IFL(4),IMTAB(9),LOAB(20),LORG(20),LOFF(5),LOCD(5),
     1          IDTYP(5),IFC(4,6),ITFLAG(4),XO(4),YO(4),ZO(4),
     2          PSIO(4),THETO(4),PHIO(4),COST(4),SINT(4),COSS(4),
     3          SINS(4),IX(4),IY(4),A1(4),A2(4),
     4          XI(103),YI(103),FI(103),XB(4,100),XX(4,103),YY(4,103),
     5          COORDS(6),FLOW(103,6),XKF(103),B(103,6),
     6          CFB(4,2,53),CFF(4,103,6),RB(2),XP(6),LCOND(3),
     7          DINFL(6),DAT(6),FIC(4,2),FLOWC(4,6),E1(25),E2(13),
     8          E3(17),E4(12),E5(25),E6(6),E7(3),
     9          ISR(4),ISF(4),IFD(4,6),LOSF(5)
*    5          COORDS(6),FLOW(103,6),XKF(103),A(5429),B(103,6),

*  Array A(5429) removed from common /SURFN2/.
      common /surfn2/ wk(5768)
*      COMMON /SURFN2/ WK(11197)
      REAL*8 aa(253009), bb(103,6)
      common /surfn/ aa
      EQUIVALENCE (WK(1),XI(1)),(WK(104),YI(1)),(WK(207),FI(1)),
     1    (WK(310),XX(1,1)),(WK(722),YY(1,1)),(WK(1134),FLOW(1,1)),
     2    (WK(1752),B(1,1)),(WK(2370),XKF(1)),(WK(2473),CFF(1,1,1)),
     3   (wk(4945),xb(1,1)),(wk(5345),cfb(1,1,1))
*    3   (WK(4945),XB(1,1)),(WK(5345),CFB(1,1,1)),(WK(5769),A(1))
      REAL*8 MACH
      DATA RC,NX,MX,MX1,D,KD
     1     /0.1745329E-1,103,6,1,1.0,2000/
      TFX(XOO,X,Y,Z)=XOO+AP11*X+AP21*Y+AP31*Z
      TFY(YOO,X,Y,Z)=YOO+AP12*X+AP22*Y+AP32*Z
      TFZ(ZOO,X,Y,Z)=ZOO+AP13*X+AP23*Y+AP33*Z
C
C  Suppress compiler warning: 'unused local variable D'
      D = D
C
      REWIND TAPEF
C   CYCLE ON ALPFA, BETA
      DO 2000 IAB=1,NAB
C
C   DATA SET NUMBER AND ALPHA-BETA SET NUMBER
      NDSET=INF(IAB,2)
      IABSET=INF(IAB,3)
C
      WRITE (TAPEOT,3000) IAB,NDSET,(INF(IAB,I),I=1,10)
 3000 FORMAT ( 30HFLOW INTERPOLATION SUBROUTINE ,/
     1  6HIAB = ,I3,5X,8HNDSET = ,I3,5X,6HINF = ,10I3)
      WRITE (TAPEOT,3010) ALPHA(IAB),BETA(IAB)
 3010 FORMAT ( 'ALPHA =', F7.2, ',   BETA =', F7.2)
C   DEFINE FLOW FIELD REGIONS
      NFR=0
      J=8
      DO 10 I=1,4
      J=J+3
      IF (INF(IAB,J) .EQ. 0) GOTO 20
      NFR=NFR+1
      IFL(NFR)=INF(IAB,J)
      ISR(NFR)=INF(IAB,J+1)
      ISF(NFR)=INF(IAB,J+2)
   10 CONTINUE
C
C   CHECK IF DEFAULT TO FREE STREAM
   20 IF (NFR .EQ. 0) GOTO 1010
      WRITE (TAPEOT,3020) NFR,(IFL(NR),NR=1,NFR)
 3020 FORMAT ( 35HNUMBER OF FLOW REGIONS REQUESTED = ,I3,10X,
     1        4(5X,I3))
C
C   READ IN MASTER DIRECTORY
      ITAG10=1
      READ( 10, REC=ITAG10 ) TITLEM
C      CALL READMS(10,TITLEM,10,ITAG10)
      ITAG10=2
      READ( 10, REC=ITAG10 ) IMTAB
C      CALL READMS(10,IMTAB,9,ITAG10)
C
C   CHECK DATA SET NUMBER
      IF (IMTAB(1) .GE. NDSET) GOTO 40
C
C
C
C   READ IN FLOW DATA SET DIRECTORY
   40 ITAG10=IMTAB(NDSET+4)
      READ( 10, REC=ITAG10 ) E4
C      CALL READMS(10,E4,12,ITAG10)
      DO 41 I=1,10
   41 TITLES(I)=E4(I)
      MACH=E4(11)
      NABS=E4(12)
      ITAG10=ITAG10+1
      READ( 10, REC=ITAG10 ) LOAB
C      CALL READMS(10,LOAB,20,ITAG10)
C
C   READ IN FLOW REGION DIRECTORY FOR REQUESTED ALPHA-BETA SET
      ITAG10=LOAB(IABSET)
      READ( 10, REC=ITAG10 ) E2
C      CALL READMS(10,E2,13,ITAG10)
      DO 42 I=1,10
   42 TITLEA(I)=E2(I)
      ALPHAS=E2(11)
      BETAS=E2(12)
      NREG=E2(13)
      ITAG10=ITAG10+1
      READ( 10, REC=ITAG10 ) LORG
C      CALL READMS(10,LORG,20,ITAG10)
C
C   CHECK IF STORED A-B SET CONSISTENT WITH REQUEST
      IF (ALPHA(IAB) .NE. ALPHAS) GOTO 50
      IF (BETA(IAB) .EQ. BETAS) GOTO 60
C
C   A-B NOT CONSISTENT
   50 STOP
C
C
C
C   READ IN REQUESTED FLOW REGIONS
C   FIRST CHECK IF REQUESTED REGIONS AVAILABLE
   60 CONTINUE
      DO 70 NR=1,NFR
      IF (IFL(NR) .GT. NREG) GOTO 80
   70 CONTINUE
      GOTO 90
C
C
   80 WRITE (6,85) NR,NDSET
   85 FORMAT ( 26HREQUESTED FLOW REGION NO. ,I2,12H OF DATA SET,I3,
     1        15H NOT AVAILABLE.)
      STOP
C
C   READ IN FLOW FIELD REGIONS AND CALCULATE COEFFICIENTS
   90 CONTINUE
      DO 1000 NR=1,NFR
      IR=IFL(NR)
      ITAG10=LORG(IR)
      READ( 10, REC=ITAG10 ) E3
C      CALL READMS(10,E3,17,ITAG10)
      DO 91 I=1,10
   91 TITLER(I)=E3(I)
      DO 92 I=1,5
      IDTYP(I)=E3(I+10)
   92 CONTINUE
      NSREG=E3(16)
      ITFLAG(NR)=E3(17)
C
C   CHECK FLOW-FIELD DATA TYPE FLAG
      IF (IDTYP(1) .EQ. 1) GOTO 98
      WRITE (TAPEOT,97)
   97 FORMAT( 45H**IN ATTEMPTING TO READ FLOW FIELD DATA FROM ,
     1 52HUNIT 10 IDTYP(1) WAS NOT EQUAL TO 1 AS IT SHOULD BE.,
     2 14H PROGRAM STOP.  )
      STOP
   98 IF (IDTYP(2) .EQ. 1) GOTO 1600
      ITAG10=ITAG10+1
      READ( 10, REC=ITAG10 ) DAT
C      CALL READMS(10,DAT,6,ITAG10)
      XO(NR)=DAT(1)
      YO(NR)=DAT(2)
      ZO(NR)=DAT(3)
      PSIO(NR)=DAT(4)
      THETO(NR)=DAT(5)
      PHIO(NR)=DAT(6)
C
C   LOCATE SUB-REGION
      IS=0
      IG10=LORG(IR)+4+ISR(NR)
   93 CONTINUE
      READ( 10, REC=IG10 ) E1
C      CALL READMS(10,E1,25,IG10)
      DO 94 I=1,5
      LOFF(I)=E1(I)
      IFC(NR,I)=E1(I+5)
      LOCD(I)=E1(I+10)
      IFD(NR,I)=E1(I+15)
   94 CONTINUE
C
      IF (IS .NE. 0) GOTO 96
      DO 95 I=1,5
   95 LOSF(I)=E1(I+20)
C
C   CHECK IF SECONDARY FLOW
      IF (ISF(NR) .EQ. 0) GOTO 96
      IS=ISF(NR)
      IG10=LOSF(IS)
      GOTO 93
C
   96 CONTINUE
C
      WRITE (TAPEOT,3030)TITLEM,IMTAB,TITLES,MACH,NABS,LOAB,
     1   TITLEA,ALPHAS,BETAS,NREG,LORG,TITLER,IDTYP,LOFF
 3030 FORMAT( 7HTITLEM=,10A4/4x,7H IMTAB=,9I4,/ 7HTITLES=,10A4,
     1 7H MACH =,F6.3,3x,6H NABS=,I3,/ 4X,5HLOAB=,20I3,/ 7HTITLEA=,
     2 10A4/4x,7HALPHAS=,F6.3,7H BETAS=,F6.3,8H NREG = ,I3,/ 4X,
     3 5HLORG=,20I3,/ 7HTITLER=,10A4/4x,6HIDTYP=,5I2,3x,7H LOFF =,5I4)
      WRITE (TAPEOT,3040) (IFC(NR,I),I=1,5),ITFLAG(NR),XO(NR),
     1      YO(NR),ZO(NR),PSIO(NR),THETO(NR),PHIO(NR)
 3040 FORMAT( 6HIFC = ,5I3,3x,9HITFLAG = ,I3/5HXO = ,F7.3,
     1 3x,6H YO = ,F7.3,3x,6H ZO = ,F7.3,/
     2 7HPSIO = ,F7.3,4x,8HTHETO = ,F7.3,4x,7HPHIO = ,F7.3)
      INORM=ITFLAG(NR)
      IF (INORM-1) 100,110,120
C
C   NORMALIZE W.R.T.  A,R
  100 IX(NR)=4
      IY(NR)=5
      GOTO 190
C
C   NORMALIZE W.R.T.  X,Y
  110 IX(NR)=1
      IY(NR)=2
      GOTO 190
C
  120 IF (INORM-3) 130,140,100
C   NORMALIZE W.R.T.  X,Z
  130 IX(NR)=1
      IY(NR)=3
      GOTO 190
C
C   NORMALIZE W.R.T.  Y,Z
  140 IX(NR)=2
      IY(NR)=3
      GOTO 190
C
C
C
C   BRING THE FLOW DATA INTO CORE
C   START WITH BOUNDARY ONE
  190 IC=0
      IB=0
      MF=1
      LS=2
      IXX=IX(NR)
      IYY=IY(NR)
      A1(NR)=0.0
      A2(NR)=0.0
      DO 195 J=1,6
  195 FLOWC(NR,J)=0.0
      GOTO 205
  200 A1(NR)=XI(1)
      A2(NR)=XI(NB1)
  205 IB=IB+1
      NB1=IFC(NR,IB)
      N3=NB1+3
      ITAG10=LOFF(IB)
      FIC(NR,IB)=0.0
C
      DO 210 I=1,NB1
      IC=IC+1
      READ( 10, REC=ITAG10 ) E4
C      CALL READMS(10,E4,12,ITAG10)
      ITAG10=ITAG10+1
      DO 207 II=1,6
  207 COORDS(II)=E4(II)
      DO 208 II=1,6
  208 FLOW(IC,II)=E4(II+6)
      XI(I)=COORDS(IXX)
      YI(I)=1.0
      FI(I)=COORDS(IYY)
      FIC(NR,IB)=FIC(NR,IB)+FI(I)
      DO 206 J=1,6
  206 FLOWC(NR,J)=FLOWC(NR,J)+FLOW(IC,J)
      XB(NR,IC)=COORDS(IXX)
      XX(NR,IC)=COORDS(IXX)
      YY(NR,IC)=COORDS(IYY)
  210 CONTINUE
C
      WRITE (TAPEOT,3050) IB,(XI(I),YI(I),FI(I),I=1,NB1)
 3050 FORMAT ( 5HIB = ,I2,/( F20.6))
C   CHECK IF COEFFICIENTS ALREADY AVAILABLE
      IF (LOCD(IB) .NE. 0) GOTO 250
      FIC(NR,IB)=FIC(NR,IB)/NB1
      DO 215 I=1,NB1
  215 FI(I)=FI(I)-FIC(NR,IB)
C
C   CALCULATE BOUNDARY COEFFICIENTS
      CALL ROWFM1(NB1,MF,XI,YI,FI,XKF,NX,MX1,LS,TAPEB)
C
      CALL SOLVIT(aa,N3,MF,KD,TAPEB,TAPEC,TAPED,TAPEB,bb,NX,MX,NERR)
**  Copy spline coefficients from REAL*8 bb to REAL*4 b.
      do i=1,nx
         do j=1,mx
            b(i,j) = bb(i,j)
         enddo
      enddo
C   CHECK IF MATRIX SINGULAR
      IF (NERR .EQ. 0) GOTO 230
      WRITE (6,220)
  220 FORMAT ( 16HMATRIX SINGULAR.)
C
C
C   PUT COEFFICIENT INTO PROPER ARRAY AND STORE
  230 CONTINUE
      DO 240 I=1,N3
  240 CFB(NR,IB,I)=B(I,1)
C
      ITAG10=IMTAB(2)
      LOCD(IB)=ITAG10
      I6=N3+3
      IFD(NR,IB)=I6
      I2=0
  241 I1=I2+1
      I2=I2+25
      IF (I2 .GT. N3) I2=N3
      II=0
      DO 242 I=I1,I2
      II=II+1
  242 E5(II)=B(I,1)
C
      WRITE( 10, REC=ITAG10 ) E5
C      CALL WRITMS(10,E5,25,ITAG10)
C
      ITAG10=ITAG10+1
      IF (I2 .LT. N3) GOTO 241
      E7(1)=A1(NR)
      E7(2)=A2(NR)
      E7(3)=FIC(NR,IB)
C
      WRITE( 10, REC=ITAG10 ) E7
C      CALL WRITMS(10,E7,3,ITAG10)
C
      IMTAB(2)=ITAG10+1
      WRITE (TAPEOT,3055) IB,(B(I,1),I=1,N3),A1(NR),A2(NR),FIC(NR,IB)
 3055 FORMAT ( 8HBOUNDARY,I2,13H COEFFICIENTS,//( 7F18.6))
C
      GOTO 300
C
C   READ IN BOUNDARY ONE COEFFICIENTS
  250 ITAG10=LOCD(IB)
      I6=N3+3
      I2=0
  251 I1=I2+1
      I2=I2+25
      IF (I2 .GT. N3) I2=N3
C
      READ( 10, REC=ITAG10 ) E5
C      CALL READMS(10,E5,25,ITAG10)
C
      ITAG10=ITAG10+1
      II=0
      DO 252 I=I1,I2
      II=II+1
  252 CFB(NR,IB,I)=E5(II)
      IF (I2 .LT. N3) GOTO 251
C
      READ( 10, REC=ITAG10 ) E7
C      CALL READMS(10,E7,3,ITAG10)
C
      A1(NR)=E7(1)
      A2(NR)=E7(2)
      FIC(NR,IB)=E7(3)
C
C
C   NOW DO BOUNDARY TWO
  300 IF (IB .EQ. 1) GOTO 200
C
C   BOTH BOUNDARIES COMPLETE. READ ADDITIONAL DATA (IF ANY).
      NB1=IFC(NR,5)
      IF (NB1 .EQ. 0) GOTO 320
      ITAG10=LOFF(5)
      DO 310 I=1,NB1
      IC=IC+1
      READ( 10, REC=ITAG10 ) E4
C      CALL READMS(10,E4,12,ITAG10)
      ITAG10=ITAG10+1
      DO 301 J=1,6
  301 COORDS(J)=E4(J)
      DO 302 J=1,6
  302 FLOW(IC,J)=E4(J+6)
      XX(NR,IC)=COORDS(IXX)
      YY(NR,IC)=COORDS(IYY)
      DO 305 J=1,6
  305 FLOWC(NR,J)=FLOWC(NR,J)+FLOW(IC,J)
  310 CONTINUE
C
C   NORMALIZE DATA POINTS
  320 IFC(NR,6)=IC
      AX=1.0/(A2(NR)-A1(NR))
C
C **NOTE. BOUNDARY ONE POINTS HAVE RN=0.0
C         BOUNDARY TWO POINTS HAVE RN=1.0
C
      NB1=IFC(NR,1)
      DO 330 I=1,NB1
      XI(I)=(XX(NR,I)-A1(NR))*AX
  330 YI(I)=0.0
      N1=NB1+1
      NB1=NB1+IFC(NR,2)
      DO 340 I=N1,NB1
      XI(I)=(XX(NR,I)-A1(NR))*AX
  340 YI(I)=1.0
C
      N2=IFC(NR,6)
      IF (IFC(NR,5) .EQ. 0) GOTO 501
C
C   FIELD POINTS
      N1=N2-IFC(NR,5)+1
      DO 500 I=N1,N2
      IB=0
      IC=0
C
C   CALCULATE BOTH BOUNDARY VALUES
  410 IB=IB+1
      N=IFC(NR,IB)
      N3=N+3
      RB(IB)=CFB(NR,IB,1)+CFB(NR,IB,2)*XX(NR,1)+FIC(NR,IB)
      J3=3
      DO 450 J=1,N
      J3=J3+1
      UIJ=0.0
      IC=IC+1
      IF (XX(NR,I) .EQ. XX(NR,IC)) GOTO 430
      TR1=(XX(NR,I)-XX(NR,IC))**2
      UIJ=TR1*dlog(DBLE(TR1))
  430 RB(IB)=RB(IB)+UIJ*CFB(NR,IB,J3)
  450 CONTINUE
      IF (IB .EQ. 1) GOTO 410
C
C   BOTH BOUNDARIES CALCULATE, NORMALIZE POINT
      XI(I)=(XX(NR,I)-A1(NR))*AX
      YI(I)=(YY(NR,I)-RB(1))/(RB(2)-RB(1))
  500 CONTINUE
C
  501 WRITE (TAPEOT,3060) NR
 3060 FORMAT( 36HNORMALIZED FLOW FIELD DATA REGION = ,I3,10X,
     1       21HXI, YI, (FI(J),J=1,6),//)
      WRITE (TAPEOT,3070) (XI(I),YI(I),(FLOW(I,J),J=1,6),I=1,N2)
 3070 FORMAT( 8F16.6)
C   RELOAD COORDINATE ARRAYS
  502 DO 503 I=1,N2
      YY(NR,I)=YI(I)
  503 XX(NR,I)=XI(I)
C
C   CHECK IF FLOW FIELD COEFFICIENTS AVAILABLE
      N3=N2+3
      IF (LOCD(5) .NE. 0) GOTO 550
      DO 505 J=1,6
      FLOWC(NR,J)=FLOWC(NR,J)/N2
      DO 504 I=1,N2
  504 FLOW(I,J)=FLOW(I,J)-FLOWC(NR,J)
  505 CONTINUE
C
C   CALCULATE COEFFICIENTS FOR FLOW FIELD DATA
      NB1=N2
      LS=0
      CALL ROWFM1(NB1,MX,XI,YI,FLOW,XKF,NX,MX,LS,TAPEB)
C
      CALL SOLVIT(aa,N3,MX,KD,TAPEB,TAPEC,TAPED,TAPEB,bb,NX,MX,NERR)
**  Copy spline coefficients from REAL*8 bb to REAL*4 b.
      do i=1,nx
         do j=1,mx
            b(i,j) = bb(i,j)
         enddo
      enddo
C
      IF (NERR .NE. 0) WRITE (6,220)
C
C   PUT COEFFICIENTS IN PROPER ARRAYS AND STORE
      DO 520 I=1,N3
      DO 510 J=1,6
  510 CFF(NR,I,J)=B(I,J)
  520 CONTINUE
C
      ITAG10=IMTAB(2)
      LOCD(5)=ITAG10
      I6=N3*6
      I2=0
  521 I1=I2+1
      I2=I2+4
      IF (I2 .GT. N3) I2=N3
      II=0
      DO 523 I=I1,I2
      DO 522 J=1,6
      II=II+1
  522 E5(II)=B(I,J)
  523 CONTINUE
C
      WRITE( 10, REC=ITAG10 ) E5
C      CALL WRITMS(10,E5,24,ITAG10)
C
      ITAG10=ITAG10+1
      IF (I2 .LT. N3) GOTO 521
      DO 524 J=1,6
  524 E6(J)=FLOWC(NR,J)
C
      WRITE( 10, REC=ITAG10 ) E6
C      CALL WRITMS(10,E6,6,ITAG10)
C
      IFD(NR,5)=I6+6
      IMTAB(2)=ITAG10+1
      WRITE (TAPEOT,3065) ((B(I,J),J=1,6),I=1,N3),(FLOWC(NR,J),J=1,6)
 3065 FORMAT( 17HFLOW COEFFICIENTS,//( 6F18.6))
C
C   RESET DIRECTORIES
      DO 526 I=1,5
      E1(I+10)=LOCD(I)
  526 E1(I+15)=IFD(NR,I)
      WRITE( 10, REC=ITAG10 ) E1
C      CALL WRITMS(10,E1,25,IG10)
      ITAG10=2
      WRITE( 10, REC=ITAG10 ) IMTAB
C      CALL WRITMS(10,IMTAB,9,ITAG10)
      GOTO 600
C
C   READ IN FLOW FIELD COEFFICIENTS
  550 ITAG10=LOCD(5)
      I6=N3*6
      I2=0
  551 I1=I2+1
      I2=I2+4
      IF (I2 .GT. N3) I2=N3
C
      READ( 10, REC=ITAG10 ) E5
C      CALL READMS(10,E5,25,ITAG10)
C
      ITAG10=ITAG10+1
      II=0
      DO 553 I=I1,I2
      DO 552 J=1,6
      II=II+1
  552 CFF(NR,I,J)=E5(II)
  553 CONTINUE
      IF (I2 .LT. N3) GOTO 551
C
      READ( 10, REC=ITAG10 ) E6
C      CALL READMS(10,E6,6,ITAG10)
C
      DO 554 J=1,6
  554 FLOWC(NR,J)=E6(J)
C
C
C
  600 CONTINUE
C
      COST(NR)=dcos(DBLE(THETO(NR)*RC))
      SINT(NR)=dsin(DBLE(THETO(NR)*RC))
      COSS(NR)=dcos(DBLE(PSIO(NR)*RC))
      SINS(NR)=dsin(DBLE(PSIO(NR)*RC))
 1000 CONTINUE
C
C   COEFFICIENTS FOR ALL REQUESTED REGIONS ARE IN CORE
C   START CYCLE ON ELEMENT DATA
 1010 CONTINUE
      WRITE (TAPEOT,3080)
 3080 FORMAT( 48HINTERPOLATED DATA, NR, XP(IXX), YP(IYY), AN, RN,,
     1       17H(DINFL(I), I=1,6),//)
      WRITE (TAPEOT,3082) LTOT
 3082 FORMAT( 7HLTOT = ,I5,//)
      ISYM=1
      ICT=0
      REWIND TAPEE
 1011 DO 1500 II=1,LTOT
      READ (TAPEE,END=1510) IG4,ELEM
      LCOND(2)=ELEM(1)
      IF (ISYM .EQ. 1) GOTO 1090
      IG4=-IG4
C   REFLECT ELEMENT TO -Y SIDE AND CHANGE ORDER OF PTS 2 AND 4
      ELEM(5)=-ELEM(5)
      ELEM(8)=-ELEM(8)
      ELEM(15)=-ELEM(15)
      ELEM(16)=-ELEM(16)
      ELEM(17)=-ELEM(17)
      ELEM(18)=-ELEM(18)
      ELT=ELEM(12)
      ELEM(12)=ELEM(14)
      ELEM(14)=ELT
      ELT=ELEM(16)
      ELEM(16)=ELEM(18)
      ELEM(18)=ELT
      ELT=ELEM(20)
      ELEM(20)=ELEM(22)
      ELEM(22)=ELT
 1090 IF (NFR .EQ. 0) GOTO 1155
      XP(1)=ELEM(7)
      XP(2)=ELEM(8)
      XP(3)=ELEM(9)
C   SET FLOW FIELD REGION NUMBER
      NR=1
C
C   TRANSFORM COORDS TO FLOW ORIENTATION
 1100 CONTINUE
      AA11=COST(NR)*COSS(NR)
      AA12=COST(NR)*SINS(NR)
      AA13=-SINT(NR)
      AA21=-SINS(NR)
      AA22=COSS(NR)
      AA23=0.0
      AA31=-SINT(NR)*COSS(NR)
      AA32=-SINT(NR)*SINS(NR)
      AA33=-COST(NR)
      DX=XP(1)-XO(NR)
      DY=XP(2)-YO(NR)
      DZ=XP(3)-ZO(NR)
C   AXIAL COORD
      XP(4)=AA11*DX+AA12*DY+AA13*DZ
C
C   RADIAL COORD
      YP=AA21*DX+AA22*DY
      ZP=AA31*DX+AA32*DY+AA33*DZ
      XP(5)=dsqrt(DBLE(YP**2+ZP**2))
C   ANGULAR COORD
      IF (YP .NE. 0.0) GOTO 1102
      PHI=0.0
      IF (ZP .EQ. 0.0) GOTO 1103
 1102 PHI=datan2(DBLE(YP),DBLE(ZP))
 1103 XP(6)=PHI-PHIO(NR)
      SINP=dsin(DBLE(PHI))
      COSP=dcos(DBLE(PHI))
C
      AP11=AA11
      AP12=AA12
      AP13=AA13
      AP21=COSP*AA21-SINP*AA31
      AP22=COSP*AA22-SINP*AA32
      AP23=-SINP*AA33
      AP31=SINP*AA21+COSP*AA31
      AP32=SINP*AA22+COSP*AA32
      AP33=COSP*AA33
C   NORMALIZE COORDS FOR FLOW REGION. FIRST FIND BOUNDARIES.
      IXX=IX(NR)
      IYY=IY(NR)
      IB=0
      IC=0
 1110 IB=IB+1
      N1=IFC(NR,IB)
      N3=N1+3
      RB(IB)=CFB(NR,IB,1)+CFB(NR,IB,2)*XP(IXX)+FIC(NR,IB)
      J3=3
C
      DO 1150 J=1,N1
      J3=J3+1
      IC=IC+1
      UIJ=0.0
      IF (XP(IXX) .EQ. XB(NR,IC)) GOTO 1130
      TR1=(XP(IXX)-XB(NR,IC))**2
      UIJ=TR1*dlog(DBLE(TR1))
 1130 RB(IB)=RB(IB)+UIJ*CFB(NR,IB,J3)
 1150 CONTINUE
      IF (IB .EQ. 1) GOTO 1110
C
C   BOTH BOUNDARIES CALCULATED, FORM NORMALIZED COORDS.
      AN=(XP(IXX)-A1(NR))/(A2(NR)-A1(NR))
      RN=(XP(IYY)-RB(1))/(RB(2)-RB(1))
      WRITE (TAPEOT,3083) RB
 3083 FORMAT( 8HRB(1) = ,F18.6,10X,8HRB(2) = ,F18.6)
C   TEST IF NORMALIZED COORDS WITHING REGION
      IF (AN .LT. 0.0) GOTO 1152
      IF ((RN .GE. 0.0) .AND. (RN .LE. 1.0)) GOTO 1200
C
C   POINT NOT WITHIN REGION, GO TO NEXT REGION (IF SPECIFIED).
 1152 CONTINUE
      NR=NR+1
      IF (NR .LE. NFR) GOTO 1100
C
C   NOT WITHIN ANY SPECIFIED REGION. DEFAULT TO FREE STREAM.
 1155 LCOND(1)=0
      LCOND(3)=0
      DO 1160 K=1,6
 1160 DINFL(K)=0.0
      GOTO 1400
C
C   INTERPOLATE FOR FLOW FIELD VARIABLES
 1200 CONTINUE
      N1=IFC(NR,6)
      N3=N1+3
      XKF(1)=1.0
      XKF(2)=AN
      XKF(3)=RN
      J3=3
C
      DO 1250 J=1,N1
      J3=J3+1
      UIJ=0.0
      TR1=0.0
      TR2=0.0
      IF (AN .EQ. XX(NR,J)) GOTO 1210
      TR1=(AN-XX(NR,J))**2
 1210 IF (RN .EQ. YY(NR,J)) GOTO 1220
      TR2=(RN-YY(NR,J))**2
 1220 RBIJ=TR1+TR2
      IF (RBIJ .EQ. 0.0) GOTO 1230
      UIJ=RBIJ*dlog(DBLE(RBIJ))
 1230 XKF(J3)=UIJ
 1250 CONTINUE
C
C   CALCULATE FUNCTIONS
      DO 1300 K=1,6
      DINFL(K)=FLOWC(NR,K)
      DO 1290 J=1,N3
      DINFL(K)=DINFL(K)+XKF(J)*CFF(NR,J,K)
 1290 CONTINUE
 1300 CONTINUE
C   TRANSFORM DIRECTION COSINES
      VX=DINFL(2)
      VY=DINFL(3)
      VZ=DINFL(4)
      VT=dsqrt(DBLE(VX**2+VY**2+VZ**2))
      DINFL(2)=TFX(0.0,VX,VY,VZ)/VT
      DINFL(3)=TFY(0.0,VX,VY,VZ)/VT
      DINFL(4)=TFZ(0.0,VX,VY,VZ)/VT
C
C   SAVE RESULTS
      LCOND(1)=1
      LCOND(3)=NR
      WRITE (TAPEOT,3084) VX,VY,VZ
 3084 FORMAT (6H VX = ,F12.6,10H     VY = ,F12.6,10H     VZ = ,F12.6)
 1400 CONTINUE
      WRITE (TAPEOT,3085) LCOND,(ELEM(I),I=4,10)
 3085 FORMAT ( 3I5,2X,7F14.6)
      WRITE (TAPEOT,3090) NR,XP(IXX),XP(IYY),AN,RN,(DINFL(I),I=1,6)
 3090 FORMAT ( I3,10F12.6)
      IF (LCOND(3) .NE. 0) GOTO 3100
      IFLNR=0
      ISRNR=0
      ISFNR=0
      GOTO 3110
 3100 IFLNR=IFL(NR)
      ISRNR=ISR(NR)
      ISFNR=ISF(NR)
 3110 CONTINUE
      WRITE(TAPEF) IG4,LCOND,ELEM,DINFL,NDSET,IABSET,IFLNR,ISRNR,ISFNR
      ICT=ICT+1
C
C   GO TO NEXT ELEMENT
 1500 CONTINUE
 1510 CONTINUE
C   CHECK FOR SYMMETRY REQUIRMENTS
      IF (SYMFCT.EQ.1 .OR. BETAS.EQ.0.0 .OR. ISYM.EQ.2) GOTO 2010
      REWIND TAPEE
      ISYM=2
      GOTO 1011
C
C   UNIFORM FLOW FIELD IS ON DATA STORAGE UNIT. LOAD INTO DINF ARRAY.
 1600 ITAG10=LORG(IR)+5
      READ( 10, REC=ITAG10 ) DINFL
C      CALL READMS(10,DINFL,6,ITAG10)
      DO 1610 I=1,6
 1610 DINF(IAB,I)=DINFL(I)
      GOTO 2000
C
 2010 LTOTAB(IAB)=ICT
C   THIS MEANS THAT TAPEF MUST BE FILLED ON THE SAME RUN THAT THE
C   FORCES ARE CALCULATED SINCE THERE IS NO OTHER WAY TO FILL UP THE
C   LTOTAB ARRAY WITH THE PROPER ELEMENT COUNTS.
C   END OF ALPHA-BETA LOOP
 2000 CONTINUE
C
      REWIND TAPEE
      REWIND TAPEF
C
      RETURN
      END
      SUBROUTINE FLOW
C
C   THIS IS THE EXECUTIVE CONTROL PROGRAM FOR THE FLOW FIELD ANALYSIS
C   ROUTINES
C
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /TAGS/ITAG4,ITAG9,ITAG10
      COMMON /FFIELD/TITLEM,TITLES,TITLEA,TITLER,
     1        IMTAB(9),IDTYP(5),LOSET(5),LOAB(20),LORG(20),L,
     2        DINF(6),IRW,LCNEXT,IREG,MACH,NAB,ALPHA,BETA,NREG,
     3        NSREG,ITFLAG
      Real*4 TITLE(15), TITLEM(10), TITLES(10), TITLEA(10),
     1            TITLER(10)
C     Character*4 TITLE(15), TITLEM(10), TITLES(10), TITLEA(10),
C    1            TITLER(10)
      COMMON /FLIGHT/EACH,ALT,PSTAG,TSTAG,V,RENO,PFS,TFS,AFS,RHOFS,VIS
      COMMON /FSBS/FS(8),BS(8)
C
      DIMENSION E(12), E2(13), E3(17)
C
      REAL MACH
      REAL*8 EACH
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1     TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      character tmp( 80 )
C
C
C Set New A-B Flag to 0
      iabflg = 0
      WRITE (TAPEOT,5)
    5 FORMAT (//'** FLOW-FIELD OPTION **' )
C
C   MASTER DIRECTORY INFORMATION
C
      DO i = 1,4
         READ (tapein, "( 80a )") tmp
      END DO
      READ (TAPEIN,10) MFLAG,TITLEM
   10 FORMAT( /i7//10a4 )
C
C   CHECK UNIT STATUS.  MFLAG=0 SET UP COMPLETE NEW UNIT,
C   MFLAG=1 USE OLD UNIT POINTERS.
      IG10=1
      IF (MFLAG .NE. 0) GOTO 30
C
C   INITIALIZE MASTER DIRECTORY TABLE ARRAYS, ETC.
C   MASTER DIRECTORY NAME
      WRITE( 10, REC=IG10 ) TITLEM
C     CALL WRITMS(10,TITLEM,10,IG10)
      DO 20 I=1,9
   20 IMTAB(I)=0
      IMTAB(1)=0
      IMTAB(2)=4
      IMTAB(5)=4
      LCNEXT=4
      LOSET(1)=4
      GOTO 33
C
C
C   OLD DATA UNIT. READ POINTERS FROM MASTER DIRECTORY TABLE (IMTAB)
   30 CONTINUE
      READ( 10, REC=IG10 ) TITLEM
C     CALL READMS(10,TITLEM,10,IG10)
      IG10=2
      READ( 10, REC=IG10 ) IMTAB
C     CALL READMS(10,IMTAB,9,IG10)
      LCNEXT=IMTAB(2)
C
   33 DO 35 I=1,5
   35 LOSET(I)=IMTAB(I+4)
      NDSET=IMTAB(1)
C
C
C   SET DIRECTORY
C
C   INPUT LAST SET FLAG (LASTS), NEW SET FLAG (NEWS), DATA SET NUMBER
C   (NSET), MACH NUMBER, SET TITLE (TITLES)
      DO i = 1,2
         READ (tapein, "()")
      END DO
   40 READ (TAPEIN,50) LASTS,NEWS,NSET,MACH,TITLES
   50 FORMAT( 3I7,F7.0//10A4 )
C
C   CHECK DATA SET STATUS.
      IF (NEWS .NE. 0) GOTO 70
C
      DO 60 I=1,20
   60 LOAB(I)=0
      NDSET=1
      IMTAB(5)=LCNEXT
      LOSET(1)=LCNEXT
      LCNEXT=LCNEXT+3
      GOTO 90
C
C   READ POINTERS OF EXISTING SET TO GET TO LOWER DIRECTORY TABLES.
   70 IF (NEWS .NE. 1) GOTO 80
      IG10=IMTAB(NSET+4)
      READ( 10, REC=IG10 ) E
C     CALL READMS(10,E,12,IG10)
      DO 71 I=1,10
   71 TITLES(I)=E(I)
      MACH=E(11)
      NAB=E(12)
      IG10=IG10+1
      READ( 10, REC=IG10 ) LOAB
C     CALL READMS(10,LOAB,20,IG10)
      GOTO 90
C
C   ADD NEW SET TABLE DATA TO OLD
   80 NDSET=NDSET+1
      DO 81 I=1,20
   81 LOAB(I)=0
      LOSET(NSET)=LCNEXT
      IMTAB(NSET+4)=LCNEXT
      LCNEXT=LCNEXT+3
C
C
C   INPUT LAST ALPHA-BETA FLAG (LASTAB), NEW ALPHA-BETA SET FLAG
C   (NEWAB), ALPHA-BETA SET NUMBER (IAB), ALPHA-BETA VALUES,
C   ALPHA-BETA SET TITLE (TITLEA).
   90 if( iabflg .EQ. 0 ) then
        DO i = 1,2
           READ (tapein, "()")
        END DO
      endif
      iabflg = 1
      READ (TAPEIN,100) LASTAB,NEWAB,IAB,ALPHA,BETA,TITLEA
  100 FORMAT( 3I7, 2F7.0, 10A4 )
C  90 READ (TAPEIN,100) LASTAB,NEWAB,IAB,ALPHA,BETA,TITLEA
C
C   CHECK ALPHA-BETA SET STATUS
      IF (NEWAB .GT. 0) GOTO 120
C
C   INITIALIZE ALPHA-BETA DIRECTORY
      DO 110 I=1,20
  110 LORG(I)=0
C
      NAB=1
      LOAB(IAB)=LCNEXT
      LCNEXT=LCNEXT+3
      GOTO 140
C
C
C   READ POINTERS OF EXISTING ALPHA-BETA DIRECTORY
  120 IF (NEWAB .NE. 1) GOTO 130
      IG10=LOAB(IAB)
      READ( 10, REC=IG10 ) E2
C     CALL READMS(10,E2,13,IG10)
      DO 121 I=1,10
  121 TITLEA(I)=E2(I)
      ALPHA=E2(11)
      BETA=E2(12)
      NREG=E2(13)
      IG10=IG10+1
      READ( 10, REC=IG10 ) LORG
C     CALL READMS(10,LORG,20,IG10)
      GOTO 140
C
C
C   ADD NEW ALPHA-BETA DIRECTORY
  130 NAB=NAB+1
      DO 131 I=1,20
  131 LORG(I)=0
      LOAB(IAB)=LCNEXT
      LCNEXT=LCNEXT+3
C
  140 DO 141 I=1,5
  141 IDTYP(I)=0
C
C   INPUT LAST REGION GROUP FLAG (LASTR), NEW REGTON SET FLAG (NEWR),
C   REGION SET NUMBER (IREG), DATA TYPE FLAGS (IDTYP),
C   REGION TITLE (TITLER).
      DO i = 1,2
         READ (tapein, "()")
      END DO
      READ (TAPEIN,150) LASTR,NEWR,IREG,IDTYP(1),ISORCE,IRW,TITLER
  150 FORMAT ( 6I7//10A4 )
C   CHECK REGION SET STATUS
      IF (NEWR .NE. 0) GOTO 170
C
C   INITIALIZE FLOW FIELD DATA
      NREG=1
      NSREG=0
      ITFLAG=0
      IG10=LCNEXT
      DO 161 I=1,10
  161 E3(I)=TITLER(I)
      DO 162 I=1,5
  162 E3(I+10)=IDTYP(I)
      E3(16)=NSREG
      E3(17)=ITFLAG
      WRITE( 10, REC=IG10 ) E3
C     CALL WRITMS(10,E3,17,IG10)
      LORG(IREG)=IG10
      LCNEXT=IG10+5
      GOTO 190
C
C   READ POINTERS OF EXISTING FLOW FIELD DATA SET
  170 IF (NEWR .NE. 1) GOTO 180
      IG10=LORG(IREG)
      READ( 10, REC=IG10 ) E3
C     CALL READMS(10,E3,17,IG10)
      DO 171 I=1,10
  171 TITLER(I)=E3(I)
      DO 172 I=1,5
  172 IDTYP(I)=E3(I+10)
      NSREG=E3(16)
      ITFLAG=E3(17)
      GOTO 190
C
C   ADD NEW FLOW FIELD TABLE ITEM
  180 NSREG=0
      ITFLAG=0
      IG10=LCNEXT
      DO 182 I=1,10
  182 E3(I)=TITLER(I)
      DO 183 I=1,5
  183 E3(I+10)=IDTYP(I)
      E3(16)=NSREG
      E3(17)=ITFLAG
      WRITE( 10, REC=IG10 ) E3
C     CALL WRITMS(10,E3,17,IG10)
      NREG=NREG+1
      LORG(IREG)=IG10
      LCNEXT=IG10+5
C
C
  190 CONTINUE
C   SELECT TYPE OF DATA TO BE READ IN OR GENERATED
C     IDTYP(1) = 1 (FLOW FIELD),     =2 (SURFACE DATA),
C              = 3 (STREAMLINES),    =4 (SHOCK SHAPE).
      IF (IDTYP(1).GT.0 .AND. IDTYP(1).LE.4) GOTO 200
      WRITE (TAPEOT,202) IDTYP(1)
  202 FORMAT (1x,18H**IDTYP(1) INPUT =,I5,17H IS OUT OF RANGE.,
     1        14H PROGRAM STOP. )
      STOP
C
  200 ITAB=IDTYP(1)
      GOTO (210,220,210,240), ITAB
C   FLOW FIELD DATA
  210 IF (ISORCE.GT.0 .AND. ISORCE.LE.4) GOTO 212
      WRITE (TAPEOT,211) ISORCE
  211 FORMAT (1x,16H**ISORCE UNPUT =,I5,17H IS OUT OF RANGE.,
     1        14H PROGRAM STOP. )
      STOP
  212 ITAB=ISORCE
      GOTO (213,214,215,216), ITAB
C
C   HAND INPUT DATA
  213 CALL FFINPT
      GOTO 600
C
C   SHOCK-EXPANSION GENERATED DATA
  214 CALL FFBODY
      GOTO 600
C
C   FUTURE ADDITION
  215 CALL FFAIRF
      GOTO 600
C
C   SIMPLE FLOW FIELDS
  216 CALL FFSPEC
      GOTO 600
C
C   SURFACE VELOCITY VECTOR DATA
  220 CALL FFSURF
      GOTO 600
C
C
C   SHOCK SHAPE DATA (NOT ACTIVE NOW)
  240 CONTINUE
      GOTO 600
C
C
  600 CONTINUE
C
      IF (IRW .NE. 0) GOTO 612
C   COMPLETE  FLOW FIELD DATA TABLE
      IG10=LORG(IREG)
      DO 601 I=1,10
  601 E3(I)=TITLER(I)
      DO 602 I=1,5
  602 E3(I+10)=IDTYP(I)
      E3(16)=NSREG
      E3(17)=ITFLAG
      WRITE( 10, REC=IG10 ) E3
C     CALL WRITMS(10,E3,17,IG10)
      WRITE (TAPEOT,610) TITLER,IDTYP,NSREG,ITFLAG
  610 FORMAT (1X,10H** TITLER=,10A4 / 7X,6HIDTYP=,5I2, 4X,6HNSREG=,
     1        I3,4X,7HITFLAG=,I3)
C
C   CHECK FOR LAST REGION
  612 IF (LASTR .EQ. 0) GOTO 140
      IF (IRW .NE. 0) GOTO 622
C
C   COMPLETE REGION DIRECTORY
      IG10=LOAB(IAB)
      DO 613 I=1,10
  613 E2(I)=TITLEA(I)
      E2(11)=ALPHA
      E2(12)=BETA
      E2(13)=NREG
      WRITE( 10, REC=IG10 ) E2
C     CALL WRITMS(10,E2,13,IG10)
      WRITE (TAPEOT,620) TITLEA,ALPHA,BETA,NREG,LORG
  620 FORMAT (1H ,10H** TITLEA=,10A4/7x,6HALPHA=,F6.3,4x,5HBETA=,F6.3,
     1        4x, 7HNGROUP=,I3,/1H ,8H** LORG=,20I3)
      IG10=IG10+1
      WRITE( 10, REC=IG10 ) LORG
C     CALL WRITMS(10,LORG,20,IG10)
C
C
C
C   CHECK FOR LAST ALPHA-BETA
  622 IF (LASTAB .EQ. 0) GOTO 90
      IF (IRW .NE. 0) GOTO 632
C
C   COMPLETE SET DIRECTORY
      IG10=LOSET(NSET)
      DO 623 I=1,10
  623 E(I)=TITLES(I)
      E(11)=MACH
      E(12)=NAB
      WRITE( 10, REC=IG10 ) E
C     CALL WRITMS(10,E,12,IG10)
      WRITE (TAPEOT,630) TITLES,MACH,NAB,LOAB
  630 FORMAT (1H ,10H** TITLES=,10A4/7x,5HMACH=,F5.2,4x,4HNAB=,I3/
     1        9H ** LOAB=,20I3)
      IG10=IG10+1
      WRITE( 10, REC=IG10 ) LOAB
C     CALL WRITMS(10,LOAB,20,IG10)
C
C   CHECK FOR LAST MASTER SET
  632 IF (LASTS .EQ. 0) GOTO 40
      IF (IRW .NE. 0) GOTO 650
      IMTAB(1)=NDSET
      IMTAB(2)=LCNEXT
      IG10=2
      WRITE( 10, REC=IG10 ) IMTAB
C     CALL WRITMS(10,IMTAB,9,IG10)
      WRITE (TAPEOT,640) IMTAB
  640 FORMAT (1H ,9H** IMTAB=,9I4)
C
C
  650 RETURN
      END
      SUBROUTINE FORCE(NEXT,IG4S)
C
C
C***********************************************************************
C**THIS SUBROUTINE CALCULATES THE PRESSURE COEFFICIENT ON EACH SURFACE**
C**ELEMENT, RESOLVES IT INTO THE REQUIRED DIRECTIONS, AND ADDS UP THE **
C**CONTRIBUTIONS TO FIND THE TOTAL VEHICLE COEFFICIENTS.              **
C***********************************************************************
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /GDATA/LTOT,J,SYMFCT,IORN,IGTYPE,L
      COMMON /ABDATA/NAB,ALPHA(20),BETA(20),ROL(20),CDELTA(20),QI(20),
     1               RI(20),PI(20)
      COMMON /INTERF/INT,ISHE(20),NSHE(100),I9,ISHEF,INF(20,22),
     1               DINF(20,6),LTOTAB(20)
      COMMON /FLIGHT/MACH,ALT,PSTAG,TSTAG,V,RENO,PFS,TFS,AFS,RHOFS,VIS
      COMMON /REF/SREF,MAC,SPAN,XCG,YCG,ZCG
      COMMON /FARRAY/F
      COMMON /MDATA/IMPACT,ISHAD,IPRINT,PDATA,ISAVE,IPIN
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /FSBS/FS,BS
      DIMENSION ANGLE(3),FS(8),BS(8)
      DIMENSION F(11),PDATA(6),DINFL(6),LCOND(3),FSS(8)
      DIMENSION IG4S(1000)
      DIMENSION E(25),E1(25),E2(25),E3(25),INFLOW(5)
      INTEGER ERROR,SYMFCT,SYMFCO,PAGE,CASE
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      REAL*8 MACH,MAC,NX,NY,NZ,MACHSQ
      Character *4 TITLE(15)
C
C
      DATA RC/.17453292E-1/
C     RAD(A)=A/.572957795E+02
C   SET UP STARTING CONSTANTS
      IFIRST=0
      CA=0.0
      CY=0.0
      CN=0.0
      CLL=0.0
      CLM=0.0
      WML=0.0
      WMR=0.0
      CLN=0.0
      DELTAS=0.0
      AREAT=0.0
      NPRT=51
      NPCK=51
      IDERIV=0
      IPRCK=0
      IF (IPRINT .EQ. 2) IPRCK=1
      SYMFCO=0
      ISHE1=0
      CPSTAG=PDATA(1)
      QQINF=PDATA(2)
      ETAC=PDATA(3)
      ENPM=PDATA(4)
      IMPACI=PDATA(5)
      ISHADI=PDATA(6)
C
C   CALCULATE DIRECTION COSINES OF VELOCITY VECTOR
      ALPHAR=ALPHA(J)/.572957795E+02
      BETAR=BETA(J)/.572957795E+02
      ROLL=ROL(J)
      PHIR=ROLL/.572957795E+02
      VXO=-V*dcos(DBLE(ALPHAR))*dcos(DBLE(BETAR))
      VYO=V*(dsin(DBLE(PHIR))*dsin(DBLE(ALPHAR))*dcos(DBLE(BETAR))+
     1       dcos(DBLE(PHIR))*dsin(DBLE(BETAR)))
      VZO=V*(dcos(DBLE(PHIR))*dsin(DBLE(ALPHAR))*dcos(DBLE(BETAR))-
     1       dsin(DBLE(PHIR))*dsin(DBLE(BETAR)))
C
      Q=QI(J)
      R=RI(J)
      P=PI(J)
      LTS=LTOT
      IF (INT.NE.0 .AND. INF(J,1).GT.1) LTS=LTOTAB(J)
      IF (IPIN .GT. 0) LTS=LTOTAB(J)
C
C   INITIALIZE FREE STREAM DATA ARRAY
      FS(1)=RHOFS
      FS(2)=PFS
      FS(3)=TFS
      FS(4)=AFS
      FS(5)=VIS
      FS(6)=MACH
      FS(7)=MACH*FS(4)
      FS(8)=FS(1)*FS(7)/FS(5)
      GP1=GAM+1.0
      GM1=GAM-1.0
      DO 9 I=1,8
    9 FSS(I)=FS(I)
      ICKF=0
      INL=0
C
C*****START OF ELEMENT DO LOOP *****
   10 DO 589 L=1,LTS
C   CHECK FOR SHIELDING OPTION
      IF (ISHE1 .EQ. 1) GOTO 15
C   CHECK FOR INTERFERENCE
      IF (INT.NE.0 .AND. INF(J,1).GT.1) GOTO 16
      IF (IPIN .GT. 0) GOTO 16
C   GET GEOMETRY DATA FROM NORMAL STORAGE ARRAYS
      IG4=IG4S(L)
      READ( 4, REC=IG4 ) E
C      CALL READMS(4,E,25,IG4)
      N=E(2)
      M=E(3)
      NX=E(4)
      NY=E(5)
      NZ=E(6)
      XCENT=E(7)
      YCENT=E(8)
      ZCENT=E(9)
      AREA=E(10)
C   OBTAIN POINTER ARRAYS FOR SURFACE DATA SAVE
      IG41=IG4+1
      READ( 4, REC=IG41 ) E2
C      CALL READMS(4,E2,25,IG41)
      IG42=IG4+2
      READ( 4, REC=IG42 ) E3
C      CALL READMS(4,E3,25,IG42)
C   CHECK ON SYMMETRY REQUIREMENTS (CHANGE SINGS IF REQUIRED)
      IF (SYMFCO .EQ. 0) GOTO 60
      NY=-NY
      YCENT=-YCENT
      INL=1
      GOTO 60
C   READ GEOMETRY DATA FROM SHIELDING DATA UNIT
   15 READ (TAPEA) E
      GOTO 18
C   READ GEOMETRY DATA FROM FLOW FIELD UNIT
   16 READ (TAPEF) IG4,LCOND,E,DINFL,INFLOW
      IG41=IABS(IG4)+1
      IF (LCOND(1) .EQ. 2) GOTO 16
C   DUMP GEOMETRY DATA INTO WORKING VARIABLES
   18 N=E(2)+0.00001
      M=E(3)+0.0001
      NX=E(4)
      NY=E(5)
      NZ=E(6)
      XCENT=E(7)
      YCENT=E(8)
      ZCENT=E(9)
      AREA=E(10)
   60 CONTINUE
      IF (IPIN .GT. 0) GOTO 68
C
C   DETERMINE LOCAL EXTERNAL FLOW CONDITIONS
      IF (INT .NE. 0) GOTO 61
      IF (L .GT. 1) GOTO 69
      GOTO 68
C   INCLUDE INTERFERENCE FLOW FIELD EFFECTS
C   CHECK IF FLOW FIELD IS NON-UNIFORM
   61 IF (INF(J,1) .GT. 1) GOTO 62
      IF (L .GT. 1) GOTO 69
      DO 65 I=1,9
   65 DINFL(I)=DINF(J,I)
C
C   FLOW FIELD IS NON-UNIFORM. LOCAL FLOW FIELD DATA FROM SAVE UNIT (10)
C   WILL BE USED.
C   CHECK IF LOCAL CONDITIONS ARE NOT FREE-STREAM
   62 IF (LCOND(1) .NE. 0) GOTO 64
      IF (ICKF .EQ. 1) GOTO 68
      ICKF=1
C   SET LOCAL CONDITIONS TO FREESTREAM VALUES
      DO 63 I=1,8
   63 FS(I)=FSS(I)
      GOTO 68
   64 ICKF=0
C   USE LOCAL FLOW FIELD DATA FROM STORAGE UNIT TO
C   SET UP LOCAL FREE STREAM (FS) TABLE
      FS(2)=DINFL(5)*PFS
      FS(3)=DINFL(6)*TFS
      FS(1)=GAM*FS(2)/((GAM-1.0)*GASCP*FS(3))
      FS(4)=dsqrt(DBLE((GAM-1.0)*GASCP*FS(3)))
      IF (FS(3) .GE. AV1) FS(5)=2.27E-8*FS(3)**1.5/(FS(3)+198.6)
      IF (FS(3) .LT. AV1) FS(5)=AV2*FS(3)**AV3
      FS(6)=DINFL(1)
      FS(7)=FS(6)*FS(4)
      FS(8)=FS(1)*FS(7)/FS(5)
      VXI=FS(7)*DINFL(2)
      VYI=FS(7)*DINFL(3)
      VZI=FS(7)*DINFL(4)
      GOTO 71
C
   68 VXI=VXO
      VYI=VYO
      VZI=VZO
   71 VX=VXI
      VY=VYI
      VZ=VZI
C
   69 CONTINUE
C
      IF (Q.EQ.0.0 .AND. R.EQ.0.0 .AND. P.EQ.0.0) GOTO 70
C   CALCULATE VELOCITY COMPONENTS WITH VEHICLE ROTATION
      VX=VXI+(Q*(ZCENT-ZCG)-R*(YCENT-YCG))
      VY=VYI+(R*(XCENT-XCG)+P*(ZCENT-ZCG))
      VZ=VZI-(P*(YCENT-YCG)+Q*(XCENT-XCG))
C
   70 VLOCAL=dsqrt(DBLE(VX*VX+VY*VY+VZ*VZ))
C   COMPUTE  COSINE OF ANGLE BETWEEN UNIT VECTORS
      COSDEL=-(NX*VX+NY*VY+NZ*VZ)/VLOCAL
      IF (COSDEL.GT.-1.0001 .AND. COSDEL.LT.-1.0) COSDEL=-1.0
      IF (COSDEL.GT.1.0 .AND. COSDEL.LT.1.0001) COSDEL=1.0
      IF (COSDEL.GE.-1.0 .AND. COSDEL.LE.1.0) GOTO 90
      WRITE (6,80)
   80 FORMAT ( 44H***** FORCE ROUTINE WILL ATTEMPT TO FIND THE,
     162H ARCCOSINE OF AN ARGUMENT WHOSE ABSOLUTE VALUE IS GREATER THAN,
     210H ONE *****,/ 15X,30H*** JOB WILL BE TERMINATED *** )
      ERROR=1
      GOTO 620
C
C   COMPUTE ANGLE BETWEEN UNIT VECTORS
   90 THETA=dacos(DBLE(COSDEL))
C
C
C
C   COMPUTE NEWTONIAN IMPACT ANGLE
      IF (IMPACT.NE.10 .AND. ENPM.NE.0.0) THETA=THETA/ENPM
      DELTAR=1.570796327-THETA
      IF (DELTAR.GT.-0.00001 .AND. DELTAR.LT.0.00001) DELTAR=0.0
C
C   CALCULATE NEWTONIAN IMPACT ANGLE IN DEGREES
      DELTA=DELTAR*.572957795E+02
      ANGLE(2)=DELTA
C
      DO 111 I=1,8
  111 BS(I)=0.0
      TX=NY*VZ-NZ*VY
      TY=NZ*VX-NX*VZ
      TZ=NX*VY-NY*VX
      SX=TY*NZ-TZ*NY
      SY=TZ*NX-TX*NZ
      SZ=TX*NY-TY*NX
      STOTAL=dsqrt(DBLE(SX*SX+SY*SY+SZ*SZ))
      IF (STOTAL .EQ. 0.0) GOTO 115
      SX=SX/STOTAL
      SY=SY/STOTAL
      SZ=SZ/STOTAL
  115 CONTINUE
C
C   CHECK IF SURFACE DATA TO BE USED
      IF (IPIN-1) 119,116,117
C
C   CP IS AVAILABLE AS DINFL(5)
  116 CP=DINFL(5)
      CPI=CP
      BS(2)=(0.5*GAM*CP*MACH**2+1.0)*PFS
      BS(3)=1.0
      BS(6)=MACH
      GOTO 415
C
C   SURFACE PROPERTIES AVAILABLE IN DINFL ARRAY
  117 CP=(DINFL(5)-1.0)*2.0/(GAM*MACH**2)
      CPI=CP
      BS(2)=DINFL(5)*PFS
      BS(3)=DINFL(6)*TFS
      BS(6)=DINFL(1)
      GOTO 415
  119 CONTINUE
C
C
C   CHECK TO SEE IF SURFACE IS IN A SHADOW REGION
      IF (DELTAR .LT. 0.0) GOTO 320
C
C
C***********************************************************************
C*************** SELECT IMPACT PRESSURE METHOD *************************
C***********************************************************************
      GOTO (120,130,140,150,160,170,180,190,200,210,240,250,280,290,300
     1     ),IMPACT
C
C   CALCULATE PRESSURE USING MODIFIED NEWTONIAN THEORY
  120 CP=CPSTAG*COSDEL*COSDEL
      GOTO 410
C
C   CALCULATE PRESSURE USING NEWTONIAN - PRANDTL-MEYER METHOD
  130 ISE=1
      CALL NEWTPM (ANGLE,EMN,CP,ETAC,IPRCK,MER,CPSTAG,
     1             ISE,IFIRST)
      GOTO 410
C
C   CALCULATE PRESSURE USING TANGENT WEDGE
  140 ISDET=2
      CALL COMPR (ANGLE,MER,IPRCK,CPSTAG,ISDET,IFIRST,CP)
      GOTO 410
C
C   CALCULATE PRESSURE USING TANGENT WEDGE - INFINITE MACH METHOD
  150 EMNS=0.5*(GAM+1.)*FS(6)*dsin(DBLE(DELTAR))+
     1     dexp(DBLE(-0.25*(GAM+1.)*FS(6)*dsin(DBLE(DELTAR))))
      CP=4./(GAM+1.)*(EMNS**2-1.)/(FS(6)*FS(6))
      GOTO 410
C
C   CALCULATE PRESSURE USING TANGENT CONE EMPIRICAL METHOD
  160 ANGLE(1)=DELTA
      CALL CONE (ANGLE,CP,2)
      GOTO 410
C
C   CALCULATE PRESSURE USING CONE AT ANGLE OF ATTACK
  170 CONTINUE
C   JONES METHOD IS USED
      IT=0
C   CALCULATE LOCATION OF WINDWARD PLANE
  175 PHIW=0.0
      IF (VY.EQ.0.0 .AND. VZ.GE.0.0) GOTO 176
      PHIW=3.1415926536
      IF (VY .EQ. 0.0) GOTO 176
      PHIW=datan2(DBLE(-VY),DBLE(VZ))
  176 CONTINUE
C
C   ANGLE OF ATTACK IN WINDWARD PLANE
      ALFWD=dacos(DBLE(-VX/FS(7)))
C
C   CONE ANGLE
      DCR=asin(DBLE(NX))
C
C   MERIDIAN ANGLE
      IF (NY .NE. 0.0) GOTO 177
      PHI=0.0
      IF (NZ .EQ. 0.0) GOTO 178
  177 PHI=datan2(DBLE(NY),DBLE(-NZ))
C
C   LOCATION FROM WINDWARD PLANE
  178 PHIT=PHI-PHIW
C
C   MACH NUMBER IN PHIT PLANE
      VC=VZ*dcos(DBLE(PHI))-VY*dsin(DBLE(PHI))
      AMP=FS(6)*dsqrt(DBLE(VX**2+VC**2))/FS(7)
C
C   ANGLE OF AMP TO AXIS
      IF (VC .NE. 0.0) GOTO 179
      ALFP=0.0
      IF (VX .EQ. 0.0) GOTO 181
  179 ALFP=datan2(DBLE(VC),DBLE(-VX))
C
C
  181 ANGLE(1)=DCR/RC
      IF (IPRCK .EQ. 1)
     1   WRITE (6,1000) PHIW,PHI,PHIT,ALFWD,ALFP,DCR,AMP
 1000 FORMAT ( 7X,4HPHIW,11X,3HPHI,12X,4HPHIT,11X,5HALFWD,
     1    10X,4HALFP,11X,3HDCR,12X,3HAMP,/ 7F15.6)
      CALL ACONE (ANGLE,CP,ALFWD,PHIT,ALFP,AMP,IT,IPRCK)
C
      GOTO 410
C
C   CALCULATE PRESSURE USING VAN DYKE UNIFIED THEORY
  180 CP=0.5*(GAM+1.)*DELTAR**2+dsqrt(DBLE((0.25*(GAM+1.)**2*DELTAR**4)
     1  +4.0*DELTAR**2/((FS(6)*FS(6))-1.0)))
      GOTO 410
C
C   CALCULATE BLUNT BODY VISCOUS EFFECTS
  190 CP=0.0
      IVISIN=1
C
C   THE VISCOUS FORCE COEFFICIENT TAU IS CALCULATED IN
C   SUBROUTINE BLUNT, WHICH ONLY NEEDS TO BE CALLED ONCE
C   FOR EACH SECTION.
C
      IF(L.EQ.1)CALL BLUNT(PFS,FS(6),TFS,VIS,RHOFS,ETAC,RENO,TAU,IVISIN)
      SHEAR=TAU*dcos(DBLE(DELTAR))
      GOTO 220
C
C   CALCULATE PRESSURE USING SHOCK-EXPANSION METHOD
  200 CALL SHKEXP (N,M,IPRCK,NX,NY,NZ,DELTA,PFS,FS(6),
     1     DELTAR,IMPACI,CPSTAG,TFS,CP,ISHADI,IFIRST,L,IPRINT,
     2     RHOFS,AFS,VIS,V,RENO,0)
      IF (ERROR .EQ. 3) GOTO 620
      GOTO 410
C
C   CALCULATE PRESSURE USING FREE MOLECULAR FLOW
  210 FN=CPSTAG
      FT=ENPM
      TBTIN=ETAC
      S=dsqrt(DBLE(GAM/2.))*FS(6)
      SSIND=S*dsin(DBLE(DELTAR))
      ERFS=ERF(SSIND)
      CP=(1.0/(S*S))*((((2.0-FN)/1.7724539*SSIND+FN/2.0*
     1   dsqrt(DBLE(TBTIN)))*
     2   dexp(DBLE(-SSIND*SSIND)))+(((2.0-FN)*(SSIND*SSIND+0.5)+FN/2.0*
     3   1.7724539*dsqrt(DBLE(TBTIN))*SSIND)*(1.0+ERFS)))
C   CALCULATE SHEAR FORCE COEFFICIENT FOR FREE MOLECULAR FLOW
      SHEAR=dcos(DBLE(DELTAR))*FT/(1.7724539*S)*
     1      (dexp(DBLE(-SSIND*SSIND))+1.7724539*SSIND*(1.0+ERFS))
      SKIN=SHEAR
  220 IF (SHEAR .GT. 1.0E-25) GOTO 230
      SHEARX=0.0
      SHEARY=0.0
      SHEARZ=0.0
      GOTO 410
  230 SHEARX=SHEAR*SX
      SHEARY=SHEAR*SY
      SHEARZ=SHEAR*SZ
      GOTO 410
C
C   SET PRESSURE COEFFICIENT TO INPUT VALUE
  240 CP=CPSTAG
      GOTO 410
C
C
C   CALCULATE PRESSURE USING HANKEY FLAT SURFACE EMPIRICAL CORRELATION
  250 IF (DELTA .GE. 10.0) GOTO 260
      HANKEY=(0.195+0.222594/FS(6)**0.3-0.4)*DELTA+4.0
      GOTO 270
  260 HANKEY=1.95+0.3925/(FS(6)**0.3*dtan(DBLE(DELTAR)))
  270 CP=HANKEY*COSDEL*COSDEL
      GOTO 410
C
C   CALCULATE PRESSURE USING DELTA WING CORRELATION (SMYTH)
  280 DELDLW=DELTAR
      IF (DELDLW .LT. 0.01745) DELDLW=0.01745
      EMNS=FS(6)*dsin(DBLE(DELDLW))
      EMNS=1.09*EMNS+dexp(DBLE(-0.49*EMNS))
      CP=1.0/(FS(6)*FS(6))*1.66667*(EMNS*EMNS-1.0)
      GOTO 410
C
C   CALCULATE PRESSURE USING MODIFIED DALHEM-BUCK RELATIONSHIP
  290 XLNM=dlog(DBLE(FS(6)))
      A1=(6.-.3*FS(6))+dsin(DBLE((XLNM-.588)/1.2*3.1415926))
      A2=1.15+0.5*dsin(DBLE((XLNM-0.916)/3.29*3.1415926))
      IF (DELTAR .EQ. 0.0) CP=0.0
      IF (DELTAR .EQ. 0.0) GOTO 410
      CP=1.0/(dabs(dsin(DBLE(4.0*DELTAR))))**0.75+1.0
      IF (CP .GT. 5.0) CP=5.0
      IF (CP.LT.2.0 .OR. DELTA.GT.22.5) CP=2.0
      CP=CP*COSDEL*COSDEL*(A1/DELTA**A2+1.0)
      GOTO 410
C
C   CALCULATE PRESSURE USING BLAST WAVE ANALYSIS
  300 IF (CPSTAG .GT. 0.5) GOTO 310
      CP=(0.067*(FS(6)*FS(6))*ETAC/(ENPM-XCENT)+0.44)
     1   /(GAM/2.0*(FS(6)*FS(6)))
      GOTO 410
  310 CP=(0.121*(FS(6)*FS(6))*ETAC/(ENPM-XCENT)**0.667+0.56)
     1   /(GAM/2.0*(FS(6)*FS(6)))
      GOTO 410
C
C***********************************************************************
C*************** SELECT SHADOW PRESSURE METHOD *************************
C***********************************************************************
  320 GOTO (330,340,350,170,370,380,200,390,210),ISHAD
C
C   CALCULATE PRESSURE IN SHADOW REGIONS
C
C   CALCULATE PRESSURE USING CP=0 IN SHADOW REGIONS
  330 CP=0.0
      GOTO 410
C
C   CALCULATE PRESSURE USING NEWTONIAN - PRANDTL-MEYER
  340 ISE=1
      CALL NEWTPM (ANGLE,EMN,CP,ETAC,IPRCK,MER,CPSTAG,
     1     ISE,IFIRST)
      GOTO 410
C
C   CALCULATE PRESSURE USING PRANDTL-MEYER EXPANSION FROM FREE STREAM
  350 ANGLE(2)=dabs(DBLE(DELTA))
      ISDET=2
      CALL EXPAND (ANGLE,MER,IPRCK,ISDET,CP)
      GOTO 410
C
C
C
C   CALCULATE PRESSURE USING VAN DYKE UNIFIED THEORY
  370 CP=-1.4/(GAM*FS(6)**2)
      B=dsqrt(DBLE(FS(6)**2-1.0))
      DELMX=2.*(1.-(1.-0.7*(B/FS(6))**2)**((GAM-1.)*0.5/GAM))
     1      /(B*(GAM-1.))
      IF (dabs(DBLE(DELTAR)) .GE. DELMX) GOTO 410
      CP=2./(GAM*B**2)*((1.-.5*(GAM-1.)*B*dabs(DBLE(DELTAR)))
     1   **(2.*GAM/(GAM-1.))-1.0)
      GOTO 410
C
C   CALCULATE PRESSURE USING BASE PRESSURE RELATIONSHIP (CP=-1/MM**2)
  380 CP=-1.0/(FS(6)*FS(6))
      GOTO 410
C
C   SET PRESSURE COEFFICIENT TO INPUT VALUE
  390 CP=ETAC
      GOTO 410
C
C
C ****************
  410 CONTINUE
C ****************
C
C   CORRECT CP FOR LOCAL Q
      CP=CP*QQINF*VLOCAL*VLOCAL/(V*V)
C   CORRECT CP TO FREE STREAM CONDITIONS IF INTERFERENCE WAS USED
      IF (INT .EQ. 0) GOTO 415
      IF (LCOND(1) .EQ. 0) GOTO 415
      CPI=CP
      CP=((CP*GAM/2.*(FS(6)*FS(6))+1.)*DINFL(5)-1.)/
     1   (GAM/2.*MACH*MACH)
  415 CONTINUE
C
C   CHECK IF LOCAL FLOW PROPERTIES (BS ARRAY) ARE NEEDED.
      IF (ISAVE .EQ. 0) GOTO 416
C
      IF (DELTAR .GE. 0)
     1 GOTO (417,418,416,417,416,416,417,416,416,416,
     2       417,417,417,417,417), IMPACT
C
      GOTO (417,418,416,416,417,417,416,417,417), ISHAD
C
  418 IF (MER .EQ. 0) GOTO 416
C
C  CALCULATE APPROXIMATE LOCAL CONDITIONS, BS, GIVEN ONLY CP
  417 CONTINUE
      IF (dabs(DBLE(CP)) .LT. 0.00001) GOTO 402
      IF (CP) 403,402,401
C
C   CP=0.0, SET BS = FS
  402 DO 391 I=1,8
  391 BS(I)=FS(I)
      GOTO 416
C
C   APPROXIMATE LOCAL FLOW ASSUMING EXPANSION FROM FS.
C   PRESSURE (FROM DEFINITION OF CP)
  403 MACHSQ=MACH**2
      P2P1=0.5*GAM*MACHSQ*CP+1.0
      BS(2)=PFS*P2P1
      P2P1=BS(2)/FS(2)
C   TEMPERATURE
      T2T1=(P2P1)**(GM1/GAM)
      BS(3)=FS(3)*T2T1
C   SPEED OF SOUND
      BS(4)=FS(4)*dsqrt(DBLE(T2T1))
C   DENSITY
      BS(1)=FS(1)*P2P1/T2T1
C   MACH NUMBER
      BS(6)=dsqrt(DBLE(2.0/GM1*((1.0+0.5*GM1*FS(6)**2)/T2T1-1.0)))
C   VELOCITY
      BS(7)=BS(6)*BS(4)
C   VISCOSITY
      IF (BS(3).GE.AV1) BS(5)=2.27E-8*BS(3)**1.5/(BS(3)+198.6)
      IF (BS(3).LT.AV1) BS(5)=AV2*BS(3)**AV3
C   REYNOLDS NUMBER
      BS(8)=BS(1)*BS(7)/BS(5)
C
      GOTO 416
C
C   CALCULATE LOCAL CONDITIONS, BS, GIVEN ONLY CP.
C   APPROXIMATED ASSUMING OBLIQUE SHOCK WAVE.
C
C
C   PRESSURE (FROM DEFINITION OF CP)
  401 MACHSQ=MACH*MACH
      P2P1=0.5*GAM*MACHSQ*CP+1.0
      BS(2)=PFS*P2P1
      P2P1=BS(2)/FS(2)
C   DENSITY  (EQ. 158)
      R2R1=(GP1*P2P1+GM1)/(GM1*P2P1+GP1)
      BS(1)=FS(1)*R2R1
C   TEMPERATURE  (EQ. 159)
      T2T1=P2P1/R2R1
      BS(3)=FS(3)*T2T1
C   SPEED OF SOUND
      BS(4)=FS(4)*dsqrt(DBLE(T2T1))
C
C   VISCOSITY
      IF (BS(3).GE.AV1) BS(5)=2.27E-8*BS(3)**1.5/(BS(3)+198.6)
      IF (BS(3).LT.AV1) BS(5)=AV2*BS(3)**AV3
C   MACH NUMBER  (EQ. 157)
      BS(6)=dsqrt(DBLE((MACHSQ*(GP1*P2P1+GM1)-2.0*(P2P1**2-1.0))
     1     /(P2P1*(GM1*P2P1+GP1))))
      IF (BS(6) .LT. 1.0) BS(6)=1.01
C
C   VELOCITY
      BS(7)=BS(4)*BS(6)
C   REYNOLDS NUMBER PER FOOT
      BS(8)=BS(1)*BS(7)/BS(5)
C
  416 CONTINUE
C
C **********************************************************************
C ******* PRESSURE CALCULATION PART OF PROGRAM HAS BEEN COMPLETED ******
C **********************************************************************
C
C
C
C   SELECT FORCE METHOD TO MEET SYMMETRY REQUTREMENTS
      IF (SYMFCT .EQ. 1) GOTO 420
      IF (R.NE.0.0 .OR. P.NE.0.0) GOTO 420
      IF (BETA(J).EQ.0.0 .AND. ROLL.EQ.0.0) GOTO 450
C
C   CALCULATE SIX-COMPONENT FORCE CONTRIBUTIONS OF ELEMENT
  420 DELCA=NX*(CP*AREA/SREF)
      DELCY=NY*(CP*AREA/SREF)
      DELCN=-NZ*(CP*AREA/SREF)
      IF (IMPACT.EQ.8 .AND. DELTAR.GE.0.0) GOTO 430
      IF ((IMPACT.EQ.10.AND.DELTAR.GE.0.0) .OR.
     1    (ISHAD.EQ.9.AND.DELTAR.LT.0.0)) GOTO 430
      GOTO 440
  430 DELCA=DELCA-SHEARX*(AREA/SREF)
      DELCY=DELCY-SHEARY*(AREA/SREF)
      DELCN=DELCN+SHEARZ*(AREA/SREF)
  440 DELCLL=DELCY*(ZCENT-ZCG)/SPAN
     1       +DELCN*(YCENT-YCG)/SPAN
      DELCLM=DELCN*(XCENT-XCG)/MAC
     1       +DELCA*(ZCENT-ZCG)/MAC
      DELCLN=DELCY*(XCENT-XCG)/SPAN
     1       -DELCA*(YCENT-YCG)/SPAN
      GOTO 480
  450 DELCA=NX*(CP*AREA/SREF)*2.0
      DELCY=0.0
      DELCN=-NZ*(CP*AREA/SREF)*2.0
      IF (IMPACT.EQ.17 .OR. ISHAD.EQ.10) GOTO 470
      IF (IMPACT.EQ.8 .AND. DELTAR.GE.0.0) GOTO 460
      IF ((IMPACT.EQ.10.AND.DELTAR.GE.0.0) .OR.
     1    (ISHAD.EQ.9.AND.DELTAR.LT.0.0)) GOTO 460
      GOTO 470
  460 DELCA=DELCA-SHEARX*2.0*(AREA/SREF)
      DELCN=DELCN+SHEARZ*2.0*(AREA/SREF)
  470 DELCLL=0.0
      DELCLM=(DELCN*(XCENT-XCG)/MAC
     1       +DELCA*(ZCENT-ZCG)/MAC)
      DELCLN=0.0
C
C   SUM UP SIX-COMPONENT FORCE CONTRIBUTIONS
  480 CA=CA+DELCA
      CY=CY+DELCY
      CN=CN+DELCN
      CLL=CLL+DELCLL
      CLM=CLM+DELCLM
      CLN=CLN+DELCLN
      AREAT=AREAT+AREA
  490 IF (IPRINT .EQ. 0) GOTO 580
C   CHECK TO PRINT HEADER AT TOP OF PAGE
  500 IF (NPRT .LT. NPCK) GOTO 560
  510 NPRT=0
      CALL HEADER
      WRITE (TAPEOT,520) (GTYPE(I),I=1,2)
  520 FORMAT ( 63X,2A4)
  530 CONTINUE
      WRITE (TAPEOT,540) MACH,ALT,SREF,SPAN,IMPACT,IMPACI,
     1  XCG,YCG,ZCG,MAC,ISHAD,ISHADI
  540 FORMAT( 'ELEMENT DATA' / '   M=', F5.2, ',   H=',F7.0,',   Sref=',
     1 F6.1, ',   SPAN=', F5.1, ',  IMPACT=', I2, ',   IMPACI=', I2 /
     2 '   XCG=',F6.1, ',   YCG=', F4.1, ',   ZCG=', F4.1, ',   MAC=',
     3 F6.1, ',   ISHAD=', I1, ',   ISHADI=',I3)
      WRITE (TAPEOT,550) ALPHA(J),BETA(J),CPSTAG,ETAC,DELTAS,
     1      IDERIV,Q,R,P
  550 FORMAT ( 3X, 'ALFA =',F6.2, ', BETA =', F6.2,
     1 ',  K =',F7.4, ', ETAC =',F7.3, ', DELTA E =',F6.2,/
     2 3X,8HIDERIV =,I3, ',  Q =',E12.5, ',  R =',E12.5,',  P =',E12.5,/
     3 '  L    DEL CA    DEL CY    DEL CN    DEL CLL   DEL CLM   DEL C',
     4 'LN    CP' /
     5 '         CA        CY        CN        CLL       CLM       CLN',
     6 '     DELTA' /
     7 '        XCENT     YCENT     ZCENT     AREA' )

      NPRT=NPRT+15
C
C   PRINT ELEMENT DATA
  560 WRITE (TAPEOT,570) L,DELCA,DELCY,DELCN,DELCLL,DELCLM,DELCLN,CP,
     1  CA,CY,CN,CLL,CLM,CLN,DELTA,XCENT,YCENT,ZCENT,AREA
  570 FORMAT ( I4,7G10.3 / 4X,7G10.3 / 4X,4G10.3)
      NPRT=NPRT+4
      IF (INT .EQ. 0) GOTO 580
      IF (LCOND(1) .EQ. 0) GOTO 580
      WRITE (TAPEOT,565) LCOND,CPI,DINFL,INFLOW
      NPRT=NPRT+2
  565 FORMAT( 8X,6HLCOND=,I2,I4,I3,6H  CPI=,E13.5,8H  DINFL=,6F9.5,/
     1   8X,16HFLOW DATA SET = ,I2,4X,17HALPHA-BETA SET = ,I2,
     2  4X,14HFLOW REGION = ,I2,4X,13HSUB-REGION = ,I2,
     3  4X,17HSECONDARY FLOW = ,I2)
C
C   SET UP AND SAVE ELEMENT RESULTS ON GEOMETRY STORAGE UNIT.
C   ONLY DATA FOR ELEMENTS ACTUALLY ON UNIT 4 ARE SAVED.
C   DATA FOR REFLECTED ELEMENTS, PARTIAL ELEMENTS, ETS., ARE NOT SAVED.
  580 IF (ISAVE .EQ. 0) GOTO 589
      IF (IG4 .LE. 0) GOTO 589
      E1(1)=IG4
      E1(2)=E(1)
      E1(3)=0.0
      E1(4)=0.0
      E1(5)=CP
      E1(6)=DELTA
      E1(7)=BS(6)
      E1(8)=SX
      E1(9)=SY
      E1(10)=SZ
      E1(11)=BS(2)/PFS
      E1(12)=BS(3)/TFS
      E1(13)=DELCA
      E1(14)=DELCY
      E1(15)=DELCN
      E1(16)=DELCLL
      E1(17)=DELCLM
      E1(18)=DELCLN
      E1(19)=0.0
      E1(20)=0.0
      E1(21)=0.0
      E1(22)=0.0
      E1(23)=0.0
      E1(24)=0.0
      E1(25)=0.0
C   CHECK IF SPACE IS AVAILABLE FOR STORING ELEMENT DATA
      IF (NEXT .LE. 3000) GOTO 585
      WRITE (TAPEOT,583)
  583 FORMAT ( 42HSPACE ON UNIT 4 FOR SURFACE DATA HAS BEEN ,
     1 37HEXCEEDED. NO MORE DATA WILL BE SAVED. )
      ISAVE=0
      GOTO 589
  585 CONTINUE
      WRITE( 4, REC=NEXT ) E1
C      CALL WRITMS(4,E1,25,NEXT)
C   RESET POINTER ARRAY FOR SAVED DATA
      IF (INL .EQ. 1) GOTO 587
      E2(J)=NEXT
      WRITE( 4, REC=IG4) E2
C      CALL WRITMS(4,E2,25,IG4)
      GOTO 588
  587 E3(J)=NEXT
      WRITE( 4, REC=IG42 ) E3
C      CALL WRITMS(4,E3,25,IG42)
  588 NEXT=NEXT+1
      IF (IPRINT .EQ. 0) GOTO 589
C     WRITE (TAPEOT,591) E1,E2
C 591 FORMAT ( 3HE1=,8E12.5,/ 3X,8E12.5,/ 3X,9E12.5,/
C    1 3HE2=,8E12.5,/ 3X,8E12.5,/ 3X,9E12.5)
C     NPRT=NPRT+6
  589 CONTINUE
C ****** END OF DO LOOP FOR ALL ELEMENTS
C
C
C   CHECK IF SHIELDING WAS DONE AND COMPLETED
      IF (ISHE1 .EQ. 1) GOTO 610
C   CHECK IF SHIELDING IS TO BE DONE BUT IS NOT COMPLETED
      IF (ISHEF .NE. 0) GOTO 600
C   CHECK IF NO SYMMETRY
      IF (SYMFCT .EQ. 1) GOTO 610
C   CHECK IF ROTATION RATES ARE USED
      IF (R.NE.0.0 .OR. P.NE.0.0) GOTO 590
C   CHECK IF YAW OR ROLL ARE ZERO
      IF (BETA(J).EQ.0.0 .AND. ROLL.EQ.0.0) GOTO 610
C   CHECK IF SYMMETRY CALCULATIONS ARE COMPLETED
  590 IF (SYMFCO .EQ. 1) GOTO 610
C   CHECK IF INTERFERENCE TABLES WERE USED (SYMMETRY ALREADY DONE)
      IF (INT.NE.0 .AND. INF(J,1).GT.1) GOTO 610
C   SET SYMMETRY RE-CYCLE FLAG
      SYMFCO=1
      GOTO 10
C
C
  600 I9=I9+1
      LTS=NSHE(I9)
      IF (LTS .EQ. 0) GOTO 610
      ISHE1=1
      GOTO 10
C
C
  610 CONTINUE
C   SET UP ARRAY OF FINAL DATA
      F(1)=ALPHA(J)
      F(4)=CA
      F(5)=CY
      F(6)=CN
      F(7)=BETA(J)
      F(9)=CLM
      F(10)=CLL
      F(11)=CLN
C   RESOLVE NORMAL AND AXIAL FORCES IN LIFT AND DRAG DIRECTION
      CD = CA*cos(ALPHAR)*cos(BETAR) -
     _     CY*sin(PHIR)*sin(ALPHAR)*cos(BETAR) -
     _     CY*cos(PHIR)*sin(BETAR) +
     _     CN*cos(PHIR)*sin(ALPHAR)*cos(BETAR) -
     _     CN*sin(PHIR)*sin(BETAR)
      CL=-CA*sin(ALPHAR)-CY*sin(PHIR)*cos(ALPHAR)+CN*cos(PHIR)
     1      *cos(ALPHAR)
C   CALCULATE SIDE FORCE COEFFICIENT - WIND AXIS
      CYPRIM = CA*cos(ALPHAR)*sin(BETAR) -
     _         CY*sin(PHIR)*sin(ALPHAR)*sin(BETAR) +
     _         CY*cos(PHIR)*cos(BETAR) +
     _         CN*cos(PHIR)*sin(ALPHAR)*sin(BETAR) +
     _         CN*sin(PHIR)*cos(BETAR)
C
C   SET UP REMAINING PARAMETERS
      F(2)=CD
      F(3)=CL
      IF (CD .EQ. 0.0) CD=0.000001
      F(8)=CL/CD
C
C
  620 RETURN
      END
      SUBROUTINE FUSE
C
      DIMENSION XFUS(4,30),NFORX(4),ZFUS(4,30),FUSARD(4,30),X(2),
     1          YFUSY(4,30,30),ZFUSZ(4,30,30),Y(2),Z(2),NRADX(4)
C
      COMMON /ACFT/ IPRINT,ITAPE,ITYPE,PI,DX,CASE
C
      COMMON /FUSD/J2,J6,NFUS,NRADX,NFORX,XFUS,ZFUS,YFUSY,ZFUSZ,FUSARD
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      INTEGER STAT1,STAT2
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER CASE
C
C  I  IS THE FUSELAGE SEGMENT NUMBER
C  J  IS THE AXIAL STATION NUMBER
C  N  IS THE SURFACE POINT NUMBER
C
C ** THERE ARE TWO MAIN PARTS TO THIS ROUTINE
C    ONE SETS UP THE COORDS FOR AN ARBITRARY BODY
C    THE OTHER IS FOR A BODY OF REVOLUTION GIVEN THE AREA DISTRIBUTION.
C
      K=0
      I=0
C ** TEST FOR BODY TYPE
      IF (J2 .NE. 1) GOTO 90
      IF (J6 .EQ. 1) GOTO 90
C
C ** ARBITRARY BODY
   10 I=I+1
      IF (I .GT. NFUS) RETURN
      ISEQ=0
      STAT1=2
      STAT2=0
      J=0
   20 J=J+1
      IF (J .GT. NFORX(I)) GOTO 10
      XO=XFUS(I,J)*DX
      N=0
   30 K=0
   40 N=N+1
      IF (N .LE. NRADX(I)) GOTO 50
C
C ** SET UP DUMMY POINT.
      K=2
      STAT1=0
      STAT2=0
      Y(K)=Y(1)
      Z(K)=Z(1)
      X(K)=X(1)
      GOTO 60
C
   50 K=K+1
      Y(K)=YFUSY(I,J,N)
      Z(K)=ZFUSZ(I,J,N)
      X(K)=XO
      IF (K .EQ. 1) GOTO 40
C
C
C ** WRITE DATA
   60 ISEQ=ISEQ+1
      WRITE (ITAPE,70) X(1),Y(1),Z(1),STAT1,
     1         X(2),Y(2),Z(2),STAT2,CASE,I,ITYPE,ISEQ
C
C  70 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,'FUS',I1,I1,I4)
   70 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,'FUS',I1,1X,I2,4X,I4)
C
      IF (IPRINT .EQ. 1)
     1  WRITE (TAPEOT,80) X(1),Y(1),Z(1),STAT1,
     2                    X(2),Y(2),Z(2),STAT2,CASE,ITYPE,I,ISEQ
C
   80 FORMAT (1H ,3F10.4,I1,3F10.4,I1,2X,I2,5X,I1,'FUS',I1,I4)
C
C
      IF (STAT1 .NE. 0) STAT1=0
      IF (STAT2 .NE. 0) STAT2=0
C ** CHECK FOR PROPER CYCLING
      IF (N .LT. NRADX(I)) GOTO 30
C
C ** HAVE COMPLETED AXIAL STATION. SET STATUS AND GO TO NEXT ONE.
      STAT1=1
      GOTO 20
C
C
C ** BODY OF REVOLUTION
   90 I=I+1
      IF (I .GT. NFUS) RETURN
      STAT1=2
      STAT2=0
      ISEQ=0
C
      DPHI=PI/(NRADX(I)-1)
      J=0
  100 J=J+1
      IF (J .GT. NFORX(I)) GOTO 90
      XO=XFUS(I,J)*DX
      N=0
      PHI=-PI/2.-DPHI
C In original HABP are inputed areas of circular fuselage cross-sections,
C   R=dsqrt(FUSARD(I,J)/PI)
C but in this version - radiuses
      r=fusard(i,j)
  110 K=0
  120 N=N+1
      IF (N .LE. NRADX(I)) GOTO 130
C
C ** SET UP DUMMY POINT.
      K=2
      STAT1=0
      STAT2=0
      Y(K)=Y(1)
      Z(K)=Z(1)
      X(K)=X(1)
      GOTO 140
C
  130 K=K+1
      X(K)=XO
      PHI=PHI+DPHI
      Y(K)=R*cos(PHI)
      Z(K)=ZFUS(I,J)+R*sin(PHI)
      IF (K .EQ. 1) GOTO 120
C
C
C ** WRITE DATA
  140 ISEQ=ISEQ+1
      WRITE (ITAPE,70) X(1),Y(1),Z(1),STAT1,
     1         X(2),Y(2),Z(2),STAT2,CASE,I,ITYPE,ISEQ
C
C
      IF (IPRINT .EQ. 1)
     1WRITE (TAPEOT,80) X(1),Y(1),Z(1),STAT1,
     2                  X(2),Y(2),Z(2),STAT2,CASE,ITYPE,I,ISEQ
C
      IF (STAT1 .GT. 0) STAT1=0
      IF (STAT2 .GT. 0) STAT2=0
C
C ** CHECK FOR PROPER CYCLING
      IF (N .LT. NRADX(I)) GOTO 110
C
C ** HAVE COMPLETED AXIAL STATION. SET STATUS AND CONTINUE.
      STAT1=1
      GOTO 100
C
      END
      SUBROUTINE gaussj(a,n,np,b,m,mp)
      INTEGER m,mp,n,np,NMAX
      REAL*8 a(n,n),b(np,mp)
      PARAMETER (NMAX=500)
      INTEGER i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
      REAL*8 big,dum,pivinv
      do 11 j=1,n
        ipiv(j)=0
11    continue
      do 22 i=1,n
        big=0.
        do 13 j=1,n
          if(ipiv(j).ne.1)then
            do 12 k=1,n
              if (ipiv(k).eq.0) then
                if (dabs(a(j,k)).ge.big)then
                  big=dabs(a(j,k))
                  irow=j
                  icol=k
                endif
              else if (ipiv(k).gt.1) then
                pause 'Singular Matrix in GAUSSJ:  IPIV(K) > 1'
              endif
12          continue
          endif
13      continue
        ipiv(icol)=ipiv(icol)+1
        if (irow.ne.icol) then
          do 14 l=1,n
            dum=a(irow,l)
            a(irow,l)=a(icol,l)
            a(icol,l)=dum
14        continue
          do 15 l=1,m
            dum=b(irow,l)
            b(irow,l)=b(icol,l)
            b(icol,l)=dum
15        continue
        endif
        indxr(i)=irow
        indxc(i)=icol
        if (a(icol,icol).eq.0.)
     +    pause 'Singular Matrix in GAUSSJ:  A( ICOL,ICOL ) .EQ. 0.0'
        pivinv=1./a(icol,icol)
        a(icol,icol)=1.
        do 16 l=1,n
          a(icol,l)=a(icol,l)*pivinv
16      continue
        do 17 l=1,m
          b(icol,l)=b(icol,l)*pivinv
17      continue
        do 21 ll=1,n
          if(ll.ne.icol)then
            dum=a(ll,icol)
            a(ll,icol)=0.
            do 18 l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
18          continue
            do 19 l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
19          continue
          endif
21      continue
22    continue
      do 24 l=n,1,-1
        if(indxr(l).ne.indxc(l))then
          do 23 k=1,n
            dum=a(k,indxr(l))
            a(k,indxr(l))=a(k,indxc(l))
            a(k,indxc(l))=dum
23        continue
        endif
24    continue
      return
      END
      SUBROUTINE GEOM
C
C **** THIS ROUTINE CONTROLS THE EXECUTION OF THE GEOMETRY GENERATION
C **** ROUTINES
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /GFLAG/IOUT,ISTAT3,IORIN,COMPIN
      COMMON /TAGS/ITAG4,ITAG9,ITAG10
C
      DIMENSION XA(250),XB(250),YA(250),YB(250),ZA(250),ZB(250),
     _          XI(4),ETA(4),XIN(4),YIN(4),ZIN(4),XPA(4),YPA(4),ZPA(4)
      DIMENSION IGEOM(10),EO(25)
      Integer E(25), EP(25), PANEL(50)
      Integer COMPIN
      DIMENSION ELEM(25),IORN(50),SYMFCT(50),IFA(50)
C
      REAL*8 NX,NY,NZ
      LOGICAL RFLAG,AFLAG,BFLAG
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     _        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER PAGE,ERROR,CASE
      INTEGER STAT,STATT,TYPE,PRINTS,SYMFCT,SEQ
      Character *4 SECT, sects, CONFIG(15)
      Character *4 TITLE(15)
C
C
      ISTAT3=0
C
C  READ GEOMETRY CONTROL CARD
      READ (TAPEIN,10) IOUT,IREW,PRINTS,IQUAD,I3MAX,NEW,NPMAX,CONFIG
   10 FORMAT ( // 7I7 // 15A4 )
      OPEN( IOUT, FILE = 'IOUT' )
C  INITIALIZE ELEMENT DATA STORAGE UNIT IF REQUIRED
      DO 13 I=1,25
      E(I)=0.0
      EP(I)=0
   13 EO(I)=0.0
      IF (NEW .EQ. 1) GO TO 15
      IG4=1
      WRITE( 4, REC=IG4 )  CONFIG
C     CALL WRITMS(4,CONFIG,15,IG4)
      IF (NPMAX .EQ. 0) NPMAX=50
C  NREM IS THE NUMBER OF RECORDS PER ELEMENT
      NREM=3
      NEXT=(NPMAX+1)*5
      NP=0
      E(1)=NEXT
      E(2)=NP
      E(3)=NPMAX
      E(4)=NREM
      GOTO 19
   15 IG4=1
      READ( 4, REC=IG4 )  CONFIG
C     CALL READMS(4,CONFIG,15,IG4)
      IG4=2
      READ( 4, REC=IG4 )  E
C     CALL READMS(4,E,25,IG4)
      NEXT=E(1)
      NP=E(2)
      NPMAX=E(3)
      NREM=E(4)
   19 CONTINUE
C
C  CHECK IF QUADRILATERALS ONLY ARE TO BE CALCULATED
      IF (IQUAD .EQ. 1) GOTO 110
      IF (IREW.EQ.0 .AND. IOUT.NE.5 .AND. IOUT.NE.1) REWIND IOUT
C  READ COMPONENT IDENTIFICATION CARD
   20 ISTAT3=ISTAT3+1
      READ (TAPEIN,30) PANEL(ISTAT3),LAST,IORN(ISTAT3),IGEOM,
     1    SYMFCT(ISTAT3),IFA(ISTAT3),NADJ1,NADJ2,NADJ3,NADJ4
   30 FORMAT (//A4,3x,2I7//10I7//6I7)
      IORIEN=IORN(ISTAT3)
      COMPIN=PANEL(ISTAT3)
C
C******************************
C  READ OR GENERATE ELEMENTS FOR EACH VEHICLE Panel
      DO 90 I=1,10
      IF (IGEOM(I) .EQ. 0) GOTO 100
      IG=IGEOM(I)

C *** Program Modules Manager ***
      GOTO (40,50,60,70), IG
   40 CALL IELE
      GOTO 80
   50 CALL ELLIP
      GOTO 80
C *** Turned Off for Debugging ***
C  60 CALL CUBIC
   60 GOTO 80
   70 CALL AIRCFT
C *** End Program Modules Manager ***

   80 IF (ERROR .NE. 0) GOTO 420
   90 CONTINUE
C
  100 IF (LAST .EQ. 0) GOTO 20
C  THE GENERATION OF ALL ELEMENT DATA IS COMPLETED
      I3MAX=ISTAT3
C
  110 IF (IQUAD .EQ. 2) GOTO 420
      IF (IOUT.NE.5 .AND. IOUT.NE.1) REWIND IOUT
      IG4=I3MAX+1
C
C
C******************************
C  ELEMENT DATA WILL NOW BE CONVERTED TO QUADRILATERALS
C     SET UP STARTING CONSTANTS
      ISTAT3=0
  120 CONTINUE
      ISTAT3=ISTAT3+1
      IF (ISTAT3 .LE. NPMAX) GOTO 125
      WRITE (TAPEOT,122)
  122 FORMAT ( 46H**NUMBER OF PANELS EXCEEDS NPMAX**PROGRAM STOP  )
      STOP
  125 IFACT=IFA(ISTAT3)
      IORIEN=IORN(ISTAT3)
C
      N=-1
      NN=-1
      KLCT=0
      NPRT=10
      L=0
      IGT=0
      AREAT=0.0
      VOL=0.0
C  READ SCALE FACTOR CARD IF REQUIRED
      IF (IFACT .EQ. 1) READ (TAPEIN,130) XSC,YSC,ZSC,DELX,DELY,DELZ
  130 FORMAT (6F10.0)
      IA=0
      IB=0
      IF (IORIEN .EQ. 2) IB=1
      IF (IORIEN .EQ. 3) IA=1
      IF (IORIEN .GT. 1) IORIEN=1
      IF (  TYPE .GT. 0) IGT=1
C
C     READ IN ALL SURFACE DATA
      READ (IOUT,140) X,Y,Z,STAT,XX,YY,ZZ,STATT,CASE,SECT,TYPE,SEQ
  140 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,1A4,1X,I2,4X,I4)
      STAT=IABS(STAT)
      STATT=IABS(STATT)
      IF (TYPE .NE. 3) GOTO 430
      IF ((STAT.EQ.0.OR.STATT.EQ.0).AND.(STAT.NE.2.AND.STATT.NE.2))
     1  SECTS=SECT
      RFLAG=.FALSE.
      GOTO 180
  150 IF (RFLAG) GOTO 160
      RFLAG=.TRUE.
      X=XX
      Y=YY
      Z=ZZ
      STAT=STATT
      GOTO 170
  160 RFLAG=.FALSE.
      READ (IOUT,140) X,Y,Z,STAT,XX,YY,ZZ,STATT,CASE,SECT,TYPE,SEQ
      STAT=IABS(STAT)
      STATT=IABS(STATT)
      IF(TYPE .NE. 3) GOTO 430
      IF ((STAT.EQ.0.OR.STATT.EQ.0).AND.(STAT.NE.2.AND.STATT.NE.2))
     1  SECTS=SECT
  170 IF (STAT .EQ. 0 .OR. STAT .EQ. 3) GOTO 260
      IF (STAT .EQ. 2) GOTO 270
      IF (.NOT. AFLAG) GOTO 270
      MC=M
  180 M=1
      IF (STAT .EQ. 2) GOTO 240
      IF (.NOT. BFLAG) GOTO 220
  190 DO 200 J=1,MC
      XA(J)=XB(J)
      YA(J)=YB(J)
  200 ZA(J)=ZB(J)
  210 XB(1)=X
      YB(1)=Y
      ZB(1)=Z
      GOTO 150
  220 IF (AFLAG) GOTO 230
      BFLAG=.TRUE.
      GOTO 190
  230 AFLAG=.FALSE.
      GOTO 210
  240 AFLAG=.TRUE.
      BFLAG=.FALSE.
      N=N+1
      NN=NN+1
  250 XA(M)=X
      YA(M)=Y
      ZA(M)=Z
      GOTO 150
  260 M=M+1
      IF (AFLAG) GOTO 250
      XB(M)=X
      YB(M)=Y
      ZB(M)=Z
      IF (STAT .NE. 3) GOTO 150
  270 MMIN=MIN0(M,MC)-1
      NN2=1
      MC=M
      N=N+1
      NN=NN+1
      KLCT=KLCT+1
      JJ=0
C
C  BEGIN COMPUTATION OF SURFACE ELEMENT CHARACTERISTICS
      DO 390 I=1,MMIN
      IIA=I+IA
      IIB=I+IB
      IF (IFACT .EQ. 1) GOTO 280
      XIN(1)=XA(IIA)
      XIN(2)=XA(IIA+1)
      XIN(3)=XB(IIB+1)
      XIN(4)=XB(IIB)
      YIN(1)=YA(IIA)
      YIN(2)=YA(IIA+1)
      YIN(3)=YB(IIB+1)
      YIN(4)=YB(IIB)
      ZIN(1)=ZA(IIA)
      ZIN(2)=ZA(IIA+1)
      ZIN(3)=ZB(IIB+1)
      ZIN(4)=ZB(IIB)
      GOTO 290
C
  280 XIN(1)=XA(IIA)   * XSC + DELX
      XIN(2)=XA(IIA+1) * XSC + DELX
      XIN(3)=XB(IIB+1) * XSC + DELX
      XIN(4)=XB(IIB)   * XSC + DELX
      YIN(1)=YA(IIA)   * YSC + DELY
      YIN(2)=YA(IIA+1) * YSC + DELY
      YIN(3)=YB(IIB+1) * YSC + DELY
      YIN(4)=YB(IIB)   * YSC + DELY
      ZIN(1)=ZA(IIA)   * ZSC + DELZ
      ZIN(2)=ZA(IIA+1) * ZSC + DELZ
      ZIN(3)=ZB(IIB+1) * ZSC + DELZ
      ZIN(4)=ZB(IIB)   * ZSC + DELZ
C  FORM DIAGONAL VECTORS
  290 T1X=XIN(3)-XIN(1)
      T2X=XIN(4)-XIN(2)
      T1Y=YIN(3)-YIN(1)
      T2Y=YIN(4)-YIN(2)
      T1Z=ZIN(3)-ZIN(1)
      T2Z=ZIN(4)-ZIN(2)
C
C  FORM CROSS PRODUCT  N=T2*T1
      NX=T2Y*T1Z-T1Y*T2Z
      NY=T1X*T2Z-T2X*T1Z
      NZ=T2X*T1Y-T1X*T2Y
      VN=dsqrt(NX*NX+NY*NY+NZ*NZ)
      IF (VN .EQ. 0.0) GOTO 300
C
C  FORM UNIT NORMAL VECTOR
      NX=NX/VN
      NY=NY/VN
      NZ=NZ/VN
C
C  COMPUTE AVERAGE POINT
  300 AVX=0.25*(XIN(1)+XIN(2)+XIN(3)+XIN(4))
      AVY=0.25*(YIN(1)+YIN(2)+YIN(3)+YIN(4))
      AVZ=0.25*(ZIN(1)+ZIN(2)+ZIN(3)+ZIN(4))
C
C  COMPUTE PROJECTION DISTANCE
      D=NX*(AVX-XIN(1))+NY*(AVY-YIN(1))+NZ*(AVZ-ZIN(1))
      PD=abs(D)
C
      T=sqrt(T1X*T1X+T1Y*T1Y+T1Z*T1Z)
      IF (T .EQ. 0.0) GOTO 310
      T1X=T1X/T
      T1Y=T1Y/T
      T1Z=T1Z/T
C
  310 T2X=NY*T1Z-NZ*T1Y
      T2Y=NZ*T1X-NX*T1Z
      T2Z=NX*T1Y-NY*T1X
C
C  COMPUTE COORDINATES OF CORNER POINTS IN REFERENCE COORD. SYSTEM
      DO 320 J=1,4
      XPA(J)=XIN(J)+NX*D
      YPA(J)=YIN(J)+NY*D
      ZPA(J)=ZIN(J)+NZ*D
      D=-D
      XDIF=XPA(J)-AVX
      YDIF=YPA(J)-AVY
      ZDIF=ZPA(J)-AVZ
C
C  TRANSFORM CORNER POINTS TO ELEMENT COORDINATE SYSTEM (XI,ETA) WITH
C  AVERAGE POINT AS ORIGIN
      XI(J)=T1X*XDIF+T1Y*YDIF+T1Z*ZDIF
  320 ETA(J)=T2X*XDIF+T2Y*YDIF+T2Z*ZDIF
      ETACK=ETA(2)-ETA(4)
      IF (ETACK .NE. 0.0) GOTO 330
      XI0=0.0
      GOTO 340
C
C  COMPUTE CENTROID
  330 XI0=.333333333*(XI(4)*(ETA(1)-ETA(2))+XI(2)
     1    *(ETA(4)-ETA(1)))/(ETA(2)-ETA(4))
  340 ETA0=-.333333333*ETA(1)
C
C  OBTAIN CORNER POINTS IN SYSTEM WITH CENTROID AS ORIGIN
      DO 350 J=1,4
      XI(J)=XI(J)-XI0
  350 ETA(J)=ETA(J)-ETA0
C
C  TRANSFORM CENTROID TO REFERENCE COORDINATE SYSTEM
      XCENT=AVX+T1X*XI0+T2X*ETA0
      YCENT=AVY+T1Y*XI0+T2Y*ETA0
      ZCENT=AVZ+T1Z*XI0+T2Z*ETA0
C
C  CONSTANTS FOR USE IN COMPUTING AREA OF ELEMENT
      XI3M1=XI(3)-XI(1)
      ETA2M4=ETA(2)-ETA(4)
C
C  COMPUTE AREA AND VOLUME OF ELEMENTS
      AREA=0.5*XI3M1*ETA2M4
      AREAT=AREAT+AREA
      DELVOL=AREA*NY*YCENT
      VOL=VOL+DELVOL
      L=L+1
      II=I
      IF (PRINTS .EQ. 0) GOTO 380
C
C
C  PRINT RESULTS OF CALCULATIONS TO DETERMINE ELEMENT CHARACTERISTICS
      IF (NPRT .GE. 9) GOTO 360
      NPRT=NPRT+1
      IF (I .EQ. 1) GOTO 370
      WRITE (TAPEOT,355) I,XIN,NX,XCENT,AREA,L,YIN,NY,YCENT,DELVOL,
     1     ZIN,NZ,ZCENT,VOL
  355 FORMAT ( 7X, I4, 1P4E14.5,0PF10.6,1P2E14.5,I6,2(/11X,4E14.5,
     1 0PF10.6,1P2E14.5)  )
      GOTO 380
  360 NPRT=0
      CALL HEADER
      WRITE (TAPEOT,365)
  365 FORMAT ( 28H  INPUT SURFACE ELEMENT DATA/ 6X,1HN,3X,1HM,7X,
     1 1HX,3(13X,1HX),11X,2HNX,9X,5HXCENT,9X,4HAREA,8X,1HL/ 5X,
     2 4(13X,1HY),11X,2HNY,9X,5HYCENT,7X,7HDELTA V/ 5X,4(13X,1HZ),
     3 11X,2HNZ,9X,5HZCENT,7X,6HVOLUME/ )
C
  370 WRITE (TAPEOT,375) N,I,XIN,NX,XCENT,AREA,L,YIN,NY,YCENT,DELVOL,
     1     ZIN,NZ,ZCENT,VOL
  375 FORMAT ( 3X,2I4, 1P4E14.5,0PF10.6,1P2E14.5,I6,2(/11X,4E14.5,
     1 0PF10.6,1P2E14.5)  )
C
C  SET UP DATA TO BE SAVED AND USED IN FORCE CALCULATIONS
  380 ELEM(1)=L
      ELEM(2)=N
      ELEM(3)=I
      ELEM(4)=NX
      ELEM(5)=NY
      ELEM(6)=NZ
      ELEM(7)=XCENT
      ELEM(8)=YCENT
      ELEM(9)=ZCENT
      ELEM(10)=AREA
      ELEM(11)=XIN(1)
      ELEM(12)=XIN(2)
      ELEM(13)=XIN(3)
      ELEM(14)=XIN(4)
      ELEM(15)=YIN(1)
      ELEM(16)=YIN(2)
      ELEM(17)=YIN(3)
      ELEM(18)=YIN(4)
      ELEM(19)=ZIN(1)
      ELEM(20)=ZIN(2)
      ELEM(21)=ZIN(3)
      ELEM(22)=ZIN(4)
      ELEM(23)=0.0
      ELEM(24)=0.0
      ELEM(25)=0.0
C  SAVE ELEMENT DATA ON GEOMETRY SAVE UNIT
      IG4=NEXT
      WRITE( 4, REC=IG4 )  ELEM
C     CALL WRITMS(4,ELEM,25,IG4)
      IF (L .EQ. 1) ISTART=IG4
      IF (NREM .EQ. 1) GOTO 385
      NREMM=NREM-1
      DO 384 J=1,NREMM
      IG4=IG4+1
C     CALL WRITMS(4,EO,25,IG4)
  384 WRITE( 4, REC=IG4 )  EO

  385 NEXT=NEXT+NREM
  390 CONTINUE
C
C  CHECK TO IDENTIFY END OF INPUTS ELEMENTS
  400 IF (STAT .LT. 2) GOTO 410
      NPRT=NPRT+1
      WRITE (TAPEOT,405) SECTS,AREAT,L,VOL
  405 FORMAT ( 10H SECTION =,1A2,33H   TOTAL AREA OF INPUT ELEMENTS =
     1,F12.3,6X,26HTOTAL NUMBER OF ELEMENTS = ,I5/ 12X,
     2 33H TOTAL VOLUME OF INPUT ELEMENTS =,F12.3/ 3(20X,
     3 9H********* ))
C
      NN=NN-1
      N=-1
C  TEST FOR END OF CASE
  410 IF (STAT .NE. 3) GOTO 180
C
C  RECORD TABLE OF CONTENTS DATA ON GEOMETRY SAVE UNIT
      EP(1)=ISTAT3
      EP(2)=PANEL(ISTAT3)
      EP(3)=ISTART
      EP(4)=L
      EP(5)=IORN(ISTAT3)
      EP(6)=SYMFCT(ISTAT3)
      EP(7)=N
      EP(8)=I
      EP(9)=NADJ1
      EP(10)=NADJ2
      EP(11)=NADJ3
      EP(12)=NADJ4
      IG4=ISTAT3*5
      WRITE( 4, REC=IG4 )  EP
C      CALL WRITMS(4,EP,25,IG4)
      IG4=IG4+1
      WRITE( 4, REC=IG4 )  EO
C     CALL WRITMS(4,EO,25,IG4)
      IG4=IG4+1
      WRITE( 4, REC=IG4 )  EO
C     CALL WRITMS(4,EO,25,IG4)
      IG4=IG4+1
      WRITE( 4, REC=IG4 )  EO
C     CALL WRITMS(4,EO,25,IG4)
      IG4=IG4+1
      WRITE( 4, REC=IG4 )  EO
C     CALL WRITMS(4,EO,25,IG4)
      IF (ISTAT3 .GT. NP) NP=ISTAT3
      IF (ISTAT3 .LT. I3MAX) GOTO 120
      E(1)=NEXT
      E(2)=NP
      IG4=2
      WRITE( 4, REC=IG4 )  E
C     CALL WRITMS(4,E,25,IG4)
      EO(1)=NEXT
      IG4=3
      WRITE( 4, REC=IG4 )  EO
C     CALL WRITMS(4,EO,25,IG4)
  420 GOTO 490
C
C  ERROR CHECK ON READING CARDS
  430 WRITE (TAPEOT,440)
  440 FORMAT ( 50H***** SURFACE DATA ROUTINE HAS ATTEMPTED TO READ A
     1,42H NON SURFACE CARD - CHECK YOUR CARDS *****  )
      ERROR=1
C
  490 RETURN
      END
      SUBROUTINE GETT(IU,IT,N1,A1,N2,A2)
C
      DIMENSION A1(N1),A2(N2)
C
      GOTO (10,20,30,40), IT
C
C   READ A1
   10 READ(IU) A1
      RETURN
C
C   READ N1 AND A1
   20 READ(IU) N1,A1
      RETURN
C
C   READ A1 AND A2
   30 READ(IU) A1,A2
      RETURN
C
C   READ IDUM AND A1
   40 READ(IU) IDUM,A1
      RETURN
      END
      SUBROUTINE HEADER
C
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER PAGE,ERROR,CASE
      Character *4 TITLE(15)
C
C  PRINT OUT HEADER AT TOP OF EACH PAGE OF OUTPUT
      WRITE (TAPEOT,10) CASE,PAGE,TITLE
   10 FORMAT ( 46HSUPERSONIC-HYPERSONIC ARBITRARY-BODY PROGRAM, ,
     1 13HMARK IV MOD 0,/ 6HCASE  ,2X,I2,85X,5HPAGE ,I4 / 14A4,
     2 1A3)
C
C  STEP PAGE NUMBER BY ONE
      PAGE=PAGE+1
C
      RETURN
      END
      SUBROUTINE IELE
C
C ** THIS ROUTINE IS USED TO TRANSFER ELEMENT DATA (TYPE 3 CARDS)
C    FROM AN INPUT TO THE ELEMENT DATA SAVE UNIT
C
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /GFLAG/IOUT,ISTAT3,IORIN,COMPIN
C      DIMENSION TITLE(15),XYZ1(3),XYZ2(3)
      DIMENSION TITLE(15)
      INTEGER STAT,STATT,TYPE,CASE,ERROR,PAGE,SEQ
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      Character *4 SECT
C
      IS3=0
C
C ** READ ELEMENT CONTROL CARD
      READ (TAPEIN,10) I3MAX,IN,IREW,I3
   10 FORMAT (//4I7)
      IF (IN .EQ. 0) IN=TAPEIN
      IF (IN.NE.5 .AND. IREW.EQ.1) REWIND IN
C
      WRITE (TAPEOT,20) IN,IOUT,I3MAX
   20 FORMAT( 44HTYPE 3 CARDS ARE BEGIN TRANSFERED FROM UNIT ,I2,
     1       9H TO UNIT ,I2,5X,6HI3MAX=,I4 )
C
      IF (I3MAX .EQ. 0) I3MAX=1
C
   25 read( in, '( / )' )
   30 READ( IN,40 ) x,y,z,STAT,xx,yy,zz,STATT,CASE,SECT,TYPE,SEQ
   40 FORMAT( 3F10.0,I2,3F10.0,I2,t65,I2,1A4,I2,4X,I4 )
      IF (STAT .LE. 0) STAT=0
      IF (STATT .LE. 0) STATT=0
C
      IF (STAT.NE.3 .AND. STATT.NE.3) GOTO 50
      IS3=IS3+1
      IF (IS3.EQ.I3MAX .AND. I3.EQ.0) GOTO 60
      IF (STAT .EQ. 3) STAT=0
      IF (STATT .EQ. 3) STATT=0
C
   50 WRITE (IOUT,51) x,y,z,STAT,xx,yy,zz,STATT,CASE,SECT,TYPE,SEQ
   51 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,A4,1X,I2,4HAERO,I4)
      IF (IS3 .EQ. I3MAX) GOTO 70
      GOTO 30
C
   60 WRITE (IOUT,51) x,y,z,STAT,xx,yy,zz,STATT,CASE,SECT,TYPE,SEQ
C
C
   70 RETURN
      END
      SUBROUTINE MERID
C
C   GENERALIZED CUTTING PLANE OF MERIDIAN TYPE
C   -- THAT IS, CUTTING PLANE IS PARALLEL TO AXIS
C
C
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      DIMENSION ELEM(25),XN(4),YN(4),ZN(4),YP(4),ZP(4),PHI(37),
     1     A(4),MP(4),NPI(10),MPI(10),NINT(40),XREC(6),XP(4),
     2     XI(10,2),YI(10,2),ZI(10,2),RI(10,2),XA(10,2),
     3     NT(10),NI(10), YPA(40),IPANL(10)
      Integer E(25), EP(25), COMID, COMPID(10)
      DIMENSION TITLE(15)
C
*      INTEGER CASE,PAGE,ERROR,SYMFCT,NREC(40,50)
      INTEGER CASE,PAGE,ERROR,SYMFCT,NREC(40,100)
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      REAL LR
      EQUIVALENCE (ELEM(11),XN(1)),(ELEM(15),YN(1)),
     1            (ELEM(19),ZN(1))
      DATA PI,RC/3.1415926,1.74532925E-2/
C
C
C
C
C   READ IN PANEL ID AND CUTTING PLANE CONTROL CARD
      DO i = 1,2
         READ (tapein, "()")
      END DO
      READ (TAPEIN,7) IPANL,NPL,INPHI,ISYM
    7 FORMAT( /10i7//3i7 )
      IPRNT=1
      IPRINT=0
      REWIND TAPEB
      REWIND TAPEC
C
C
C   READ IN CUTTING PLANE ORIGIN AND ORIENTATION
C
C
      DO i = 1,2
         READ (tapein, "()")
      END DO
      READ (TAPEIN,30) XPO,YPO,ZPO,PSIO,THEO,PHIO
   30 FORMAT( /6f7.0 )
C   CONSTANTS RELATING TO CUTTING PLANE AXIS
      SINPS=SIN(RC*PSIO)
      COSPS=COS(RC*PSIO)
      COST=COS(RC*THEO)
      SINT=SIN(RC*THEO)
      STSPS=SINPS*SINT
      STCPS=COSPS*SINT
      CTCPS=COST*COSPS
      CTSPS=COST*SINPS
C
C
      IF (NPL .GT. 36) NPL=36
      IF (INPHI .LT. 2) GOTO 130
C
C   PARALLEL CUTTING PLANES. READ IN CONSTANT PHI VALUE.
      DO i = 1,2
         READ (tapein, "()")
      END DO
      READ (TAPEIN,50) PHICD
   50 FORMAT( /f7.0 )
      PHI(1)=RC*PHICD
      TANP=TAN(PHI(1))
C
      IF (INPHI .EQ. 3) GOTO 90
C   EQUAL SPACING, READ IN END VALUES.
      DO i = 1,3
         READ (tapein, "()")
      END DO
      READ (TAPEIN,60) (XN(I),YN(I),ZN(I),I=1,2)
   60 FORMAT( 3f7.0 )
C
C   FOR SPACING, MUST HAVE AT LEAST TWO PLANES
      IF (NPL .LT. 2) NPL=2
C
C   PROJECT INTO VIEWING PLANE AND FIND AXIS LOCATIONS.
      DO 70 N=1,2
      XX=XN(N)-XPO
      YY=YN(N)-YPO
      ZZ=ZN(N)-ZPO
C
      YP(N)=-XX*SINPS+YY*COSPS
      ZP(N)=XX*STCPS+YY*STSPS+ZZ*COST
   70 YPA(N)=YP(N)+ZP(N)*TANP
      DYPA=(YPA(2)-YPA(1))/(NPL-1)
C
      NINT(1)=0
      NPL1=NPL
      DO 80 N=2,NPL1
      PHI(N)=PHI(1)
      NINT(N)=0
   80 YPA(N)=YPA(N-1)+DYPA
      GOTO 110
C
C
C   VARIABLE PLANE SPACING, READ IN POSITIONS,
C   PROJECT INTO VIEWING PLANE AND FIND AXIS LOCATIONS.
   90 NPL1=NPL
      DO i = 1,3
         READ (tapein, "()")
      END DO
      DO 100 N=1,NPL
      READ (TAPEIN,60) XN(1),YN(1),ZN(1)
      XX=XN(1)-XPO
      YY=YN(1)-YPO
      ZZ=ZN(1)-ZPO
      YP(1)=-XX*SINPS+YY*COSPS
      ZP(1)=XX*STCPS+YY*STSPS+ZZ*COST
      YPA(N)=YP(1)+ZP(1)*TANP
      PHI(N)=PHI(1)
      NINT(N)=0
  100 CONTINUE
  110 IF (IPRNT .EQ. 1)
     1   WRITE (TAPEOT,120) NPL,PHICD,(YPA(N),N=1,NPL)
  120 FORMAT (1x,I3,32H PARALLEL CUTTING PLANES  PHI = ,F10.6,/
     1        1x, (6F20.6))
      GOTO 180
C
C
C
  130 CONTINUE
      IF (INPHI .EQ. 0) GOTO 160
      DO i = 1,3
         READ (tapein, "()")
      END DO
      READ (TAPEIN,140) (PHI(I),I=1,NPL)
  140 FORMAT( 10f7.0 )
      DPHI=PHIO*RC
      DO 150 I=1,NPL
      NINT(I)=0
      YPA(I)=0.0
  150 PHI(I)=PHI(I)*RC+DPHI
      NPL1=NPL
      GOTO 180
  160 CONTINUE
      NPL1=NPL+1
      DPHI=360./(NPL)*RC
      PHI(1)=PHIO*RC
      NINT(1)=0
      YPA(1)=0.0
      DO 170 I=2,NPL1
      NINT(I)=0
      YPA(I)=0.0
  170 PHI(I)=PHI(I-1)+DPHI
C
      PHI(NPL1)=PHI(1)
  180 MPTOT=0
      DO 190 I=1,10
  190 NT(I)=0
C
C   RETRIEVE ELEMENT DATA FROM STORAGE
      IG4=2
      READ( 4, REC=IG4 ) E
C     CALL READMS(4,E,25,IG4)
      NPE=E(2)
      NREM=E(4)
C
C
C   START OF PANEL CYCLE
      DO 675 JJ=1,10
      NT(JJ)=MPTOT+1
      IF (IPANL(JJ) .EQ. 0) GOTO 680
      IF (IPANL(JJ) .GT. NPE) GOTO 900
      IG4=IPANL(JJ)*5
      READ( 4, REC=IG4 ) EP
C     CALL READMS(4,EP,25,IG4)
      COMID=EP(2)
      ISTART=EP(3)
      LL=EP(4)
      SYMFCT=EP(6)
      COMPID(JJ)=COMID
      ISTART=ISTART-NREM
C
C   START OF ELEMENT DO LOOP
      DO 670 J=1,LL
      IG4=ISTART+NREM*J
      READ( 4, REC=IG4 ) ELEM
C     CALL READMS(4,ELEM,25,IG4)
      JE=J
C
C   PROJECT FOUR CORNER POINTS INTO T2,T3 PLANE
C     (IN COORDS RELATIVE TO CUTTING PLANE AXIS).
C   FIRST CHECK IF DUMMY, ZERO AREA ELEMENT - IF SO,SKIP OVER.
      IF (ELEM(10) .LE. 1.0E-5) GOTO 670
C
C   ALWAYS PROJECT LINES 2-3 AND 3-4
      NII=2
      NR=2
      NF=4
      ICOL=ELEM(2)+0.01
      IROW=ELEM(3)+0.01
C   CHECK IF NEW ROW
      IF (IROW .NE. 1) GOTO 250
      NR=1
      NF=1
C   CHECK IF NEW COLUMN
  250 IF (ICOL .NE. 1) GOTO 260
      NII=1
      NR=1
  260 CONTINUE
C
C   PRESET NPI ARRAY
      DO 270 K=1,10
  270 NPI(K)=0
C
      IO=0
      DO 360 N=NR,4
      XX=XN(N)-XPO
      YY=YN(N)-YPO
      ZZ=ZN(N)-ZPO
C
      XP(N)=XX*CTCPS+YY*CTSPS-ZZ*SINT
      YP(N)=-XX*SINPS+YY*COSPS
      ZP(N)=XX*STCPS+YY*STSPS+ZZ*COST
C
      MP(N)=0
      IF (INPHI .GT. 1) GOTO 290
      IF ((ZP(N).EQ.0.0) .AND. (YP(N).EQ.0.0)) GOTO 350
      IF (JE .GT. LL) GOTO 280
      IF ((ZP(N).LT.0.0) .AND. (YP(N).EQ.0.0)) GOTO 360
  280 CONTINUE
C
      A(N)=ATAN2(YP(N),-ZP(N))
      IF (A(N) .LE. 0.0) A(N)=2.*PI+A(N)
      IF (INPHI .NE. 0) GOTO 320
      MP(N)=A(N)/DPHI+1
      GOTO 360
C
C   MP CALCULATIONS FOR PARALLEL PLANES
  290 CONTINUE
      A(N)=YP(N)+ZP(N)*TANP
      IF (INPHI .EQ. 3) GOTO 300
      PM=(A(N)-YPA(1))/DYPA
      IF (PM .LE. 0.0) GOTO 360
      MP(N)=PM+1
      IF (MP(N) .GT. NPL) MP(N)=NPL
      GOTO 360
C
  300 CONTINUE
      DO 310 K=1,NPL1
      IP=K
      IF (YPA(K) .GT. A(N)) GOTO 340
  310 CONTINUE
      MP(N)=IP
      GOTO 360
C
C
  320 DO 330 K=1,NPL1
      IP=K
      IF (PHI(K) .GT. A(N)) GOTO 340
  330 CONTINUE
      IF (JE .GT. LL) GOTO 360
      IP=IP+1
  340 MP(N)=IP-1
      GOTO 360
  350 IO=IO+1
  360 CONTINUE
C
C   CHECK FOR CONTINUITY IN ANGLE (REFLECTED SYMMETRIC ELEMENTS ONLY).
      IF (JE .LE. LL) GOTO 380
      DO 370 N=NR,4
      IF (MP(N) .EQ. 1) MP(N)=NPL1
  370 CONTINUE
  380 CONTINUE
C
C   CHECK FOR ORIGIN POINTS (ASSUMED IN PAIRS)
      IF (IO .EQ. 0) GOTO 420
      N1=1
      N2=2
      N3=3
      N4=4
  390 IF (MP(N1) .NE. 0) GOTO 410
      IF (MP(N2) .EQ. 0) GOTO 400
C
      MP(N1)=MP(N2)
      MP(N4)=MP(N3)
      GOTO 420
C
  400 MP(N1)=MP(N4)
      MP(N2)=MP(N3)
      GOTO 420
C
  410 NN=N1
      N1=N2
      N2=N3
      N3=N4
      N4=NN
      IF (N4 .NE. 4) GOTO 390
C
  420 CONTINUE
C
C
C   TEST FOR INTERSECTIONS AND FIND THEM IF INDICATED
      MPIN=1
      NUMP=1
      ICT=1
      MPMAX=0
      IP1=NII
C
  430 IP2=IP1+1
      IF (IP2 .GT. 4) IP2=1
C
      IF (MP(IP2)-MP(IP1)) 460,440,450
C
C   CHECK FOR LAST CORNER POINT
  440 IF (IP2 .EQ. NF) GOTO 600
C
C   GO TO NEXT CORNER POINT
      IP1=IP2
      GOTO 430
C
C
C   INTERSECTION OF NMP = MP(IP1)+1 WITH LINE SEGMENT
  450 NMP=MP(IP1)+1
      IMP=1
      GOTO 470
C
C
C   INTERSECTION OF NMP = MP(IP1) WITH LINE SEGMENT
  460 NMP=MP(IP1)
      IMP=-1
C
C
C   CHECK FOR FIRST INTERSECTION
  470 IF (MPMAX .EQ. 0) GOTO 540
C
C   PREVIOUS INTERSECTIONS, CHECK FOR 'TURNING CORNER
C       AND COMING BACK'.
      IF (IMP) 480,480,500
C
  480 IF (MP(IP1)-MP(IP1-1)) 530,490,520
C
  490 IF (MP(IP1-1)-MP(IP1-2)) 530,520,520
C
  500 IF (MP(IP1)-MP(IP1-1)) 520,510,530
C
  510 IF (MP(IP1-1)-MP(IP1-2)) 520,520,530
C
C   YES, REVERSING DIRECTION
  520 ICT=-1
      GOTO 550
C
  530 NUMP=NUMP+ICT
      IF (ICT .GT. 0) GOTO 540
C
C
C   CHECK FOR INITIAL CUTTING PLANE
      IF (NUMP .GE. MPIN) GOTO 550
C
C   HAVE COME BACK ACROSS INITIAL PLANE
C   CHANGE SIGN OF ICT AND INCREASE MPMAX
      ICT=1
      NUMP=MPMAX+1
      MPIN=NUMP
C
  540 IF (NUMP .GT. MPMAX) MPMAX=NUMP
C
C
C   CALCULATE INTERSECTION
  550 NPI(NUMP)=NPI(NUMP)+1
      NP=NPI(NUMP)
      MPI(NUMP)=NMP
      DY=YP(IP2)-YP(IP1)
      DZ=ZP(IP2)-ZP(IP1)
      CSP=cos(PI-PHI(NMP))
      SNP=sin(PI-PHI(NMP))
C
      LR=0.0
      RI(NUMP,NP)=0.0
      DYDZ=DY**2+DZ**2
      IF (DYDZ .LE. 1.0E-6) GOTO 560
      DYP=YP(IP1)-YPA(NMP)
      DZP=ZP(IP1)
      RIMAG=(DZP*DY-DYP*DZ)/(CSP*DY-SNP*DZ)
      IF (INPHI .LT. 2) RIMAG=ABS(RIMAG)
      RI(NUMP,NP)=RIMAG
      YPI=SNP*RI(NUMP,NP)+YPA(NMP)
      ZPI=CSP*RI(NUMP,NP)
      LR=SQRT(((YPI-YP(IP1))**2+(ZPI-ZP(IP1))**2)/DYDZ)
      RI(NUMP,NP)=ABS(RIMAG)
C
  560 CONTINUE
      XA(NUMP,NP)=XP(IP1)+(XP(IP2)-XP(IP1))*LR
      XI(NUMP,NP)=XN(IP1)+(XN(IP2)-XN(IP1))*LR
      YI(NUMP,NP)=YN(IP1)+(YN(IP2)-YN(IP1))*LR
      ZI(NUMP,NP)=ZN(IP1)+(ZN(IP2)-ZN(IP1))*LR
      NINT(NMP)=NINT(NMP)+1
      RJ=JE
      WRITE (TAPEB) RJ,XI(NUMP,NP),YI(NUMP,NP),ZI(NUMP,NP),RI(NUMP,NP)
     1             ,XA(NUMP,NP)
      MPTOT=MPTOT+1
      NREC(NMP,NINT(NMP))=MPTOT
C
C
C   CALCULATE TO NEXT INTERSECTION
  570 NMP=NMP+IMP
      IF (IMP) 580,580,590
  580 IF (MP(IP2)-NMP) 530,440,440
  590 IF (MP(IP2)-NMP) 440,530,530
C
C
C   ALL INTERSECTIONS FOUND ON CURRENT ELEMENT. SAVE THE RESULTS.
  600 CONTINUE
      IF (MPMAX .EQ. 0) GOTO 650
C
      IF (IPRINT .EQ. 0) GOTO 650
C
      WRITE (TAPEOT,610)
C 610 FORMAT (1x,4H  ID,T14,3HNO.,T24,2HMP,T45,1HX,T65,1HY,
C    1        T85,1HZ,T105,1HR,T125,1HA/)
  610 FORMAT( /' ID    NO.    MP    ',
     1         '      X         Y         Z         R         A' )
C
      DO 620 K=1,MPMAX
      NPIK=NPI(K)
  620 WRITE (TAPEOT,630) COMPID(JJ),JE,MPI(K),
     1       (XI(K,IP),YI(K,IP),ZI(K,IP),RI(K,IP),
     2        XA(K,IP),IP=1,NPIK)
  630 FORMAT( A4, 3X, I3, 3X, I3, 4X, 5F10.4 / 20X, 5F10.4 )
C 630 FORMAT (1H ,1X,A4,6X,I3,7X,I3,4X,5F20.6,/1H ,28X,5F20.6)
C
C
C   RIGHT OUT ELEMENT CORNER POINTS
      WRITE (TAPEOT,640) (I,XN(I),YN(I),ZN(I),I=1,4)
  640 FORMAT( 13x, I3, 4X, 3F10.4 )
C
C
C   CHECK FOR SYMMETRY
  650 IF (SYMFCT .NE. 0) GOTO 670
      IF (ISYM .EQ. 0) GOTO 670
      IF (JE .GT. LL) GOTO 670
      DO 660 N=NR,4
  660 YN(N)=-YN(N)
      JE=LL+J
      GOTO 260
C
C
  670 CONTINUE
  675 CONTINUE
C
C
C   END OF PANEL DO LOOP
C
C   ARRANGE INTERSECTIONS AS PER MERIDIAN
C   FIRST CHECK IF ANY INTERSECTIONS FOUND
  680 IF (MPTOT .GT. 0) GOTO 700
      WRITE (TAPEOT,690)
  690 FORMAT (1x,41HNO INTERSECTIONS FOUND FOR CONFIGURATION ,
     1        /1x,16HCASE TERMINATED.)
      STOP
C
  700 CONTINUE
      NF=NINT(1)
C     IF (INPHI .EQ. 0) NINT(1)=NINT(NPL1)
      WRITE (TAPEC) COMPID,JJ,NT,NPL,MPTOT,
     1    PSIO,THEO,PHIO,XPO,YPO,ZPO,INPHI,
     2    (PHI(I),I=1,NPL),(NINT(I),I=1,NPL),(YPA(I),I=1,NPL)
      NINT(1)=NF
      DO 830 I=1,NPL
      II=I
  710 NF=NINT(II)
      IF (NF .EQ. 0) GOTO 820
      K=0
      K1=0
      K2=1
      K3=0
      REWIND TAPEB
C
C   ZERO OUT COMPONENT COUNTERS
      DO 720 L=1,JJ
  720 NI(L)=0
C
      DO 810 J=1,NF
      NN=NREC(II,J)
  730 K=K+1
      IF (EOF(TAPEB)) goto 830
      READ (TAPEB) XREC
  731 IF (K .NE. NN) GOTO 730
      IF (K3 .EQ. 1) GOTO 780
C
C   CHECK ON COMPONENT
  740 K1=K1+1
      IF (K1 .GT. JJ) GOTO 810
      NI(K1)=0
      NT1=NT(K1)
      IF (NT1 .LE. 0) GOTO 740
C
  750 K2=K2+1
      IF (K2 .EQ. K1) GOTO 750
      IF (K2 .LE. JJ) GOTO 760
      NT2=MPTOT+1
      GOTO 770
  760 NT2=NT(K2)
      IF (NT2 .EQ. 0) GOTO 750
  770 K3=0
C
C   TEST IF RECORD WITHIN RANGE
  780 IF ((NN.GE.NT1) .AND. (NN.LT.NT2)) GOTO 790
C
C   NOT IN RANGE - GO TO NEXT COMPONENT
      GOTO 740
C
  790 IF (K3 .EQ. 1) GOTO 800
      NI(K1)=J
      K3=1
C
  800 WRITE (TAPEC) K1,XREC
  810 CONTINUE
C
C   ALL ELEMENTS IN CURRENT MERIDIAN STORED.
C   SAVE COMPONENTS COUNTERS
      WRITE (TAPEC) (NI(L),L=1,JJ)
C
  820 IF (II .NE. 1) GOTO 830
      IF (INPHI .GT. 1) GOTO 830
      IF (NF .NE. 0) GOTO 830
      II=NPL1
      GOTO 710
  830 CONTINUE
C
      RETURN
C
  900 WRITE (TAPEOT,910)
  910 FORMAT (1H ,43H**PANEL NUMBER IS GREATER THAN THE MAXIMUM ,
     1 34H STORED ON UNIT 10 ** PROGRAM STOP )
      STOP
      END
      SUBROUTINE MONITR
C
C  THIS ROUTINE IS USED TO TRANSFER THE INPUT DATA TO A SCRATCH UNIT
C
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER PAGE,ERROR,CASE
      Character *4 TITLE(15), CARD(20), blank
      DATA BLANK/4H    /

      CASE=0
      DO 5 I=1,15
    5 TITLE(I)=BLANK
C
   10 CALL HEADER
      WRITE (TAPEOT,20)
   20 FORMAT (50HSUPERSONIC-HYPERSONIC ARBITRARY-BODY PROGRAM INPUT,
     1 5H DATA  )
      WRITE (TAPEOT,25)
   25 FORMAT ( '0        1         2         3         4         ',
     1         '5        6         7         8',/
     2         '12345678901234567890123456789012345678901234567890',
     3         '123456789012345678901234567890'/)
      I=10
C-------
C Next One Line - for MicroSoft Fortran
   30 if( eof(TAPEIN) ) then
C Next Two Lines - for NDP Fortran
C  30 ieof = eof(TAPEIN)
C     if( ieof .EQ. 1 ) then
         goto 60
      else
         READ (TAPEIN,40) CARD
      endif
C     IF(CARD(1) .EQ. 2H99) GOTO 60
C-------
   40 FORMAT (20A4)
   41 WRITE( 1,40 ) CARD
      WRITE (TAPEOT,50) CARD
   50 FORMAT( 20A4 )
      I=I+1
      IF (I .EQ. 51) GOTO 10
      GOTO 30
C
   60 REWIND 1
      TAPEIN=1
      RETURN
      END
      SUBROUTINE MOUT
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      DIMENSION TITLE(15)
      DIMENSION PHI(40),NINT(40),COMPID(10),NI(10),NE(10),
     1    RJ(100),X(100),Y(100),Z(100),R(100),A(100),YPA(40),AX(100),
     2    J(100),JX(100),IOR(10),ID(100),DORD(4)
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER CASE,PAGE,ERROR
      DATA RC/1.74532925E-2/
      DATA DORD/1HA,1HX,1HY,1HZ/
C
      IOV=0
      IOG=-1
      COMPB=1
      IPRINT=1
      DO 9 I=1,10
    9 IOR(I)=0
C
      DO 20 I=1,40
      PHI(I)=0.0
      YPA(I)=0.0
   20 CONTINUE
      REWIND TAPEC
      REWIND TAPEB
C
C   IOR(I) - FLAG TO ORDER INDIVIDUAL COMPONENT (RANDOM)
C   IOG -    FLAG TO ORDER COMPONENTS BY GROUPS
C   COMPB -  BASE COMPONENT (OTHERS ADDED TO THIS ONE)
C
C  POINTS FOR A PARTICULAR MERIDIAN ARE BROUGHT INTO CORE
C  INDIVIDUAL COMPONENTS ARE THEN ORDERED (IF REQUIRED, NON-ZERO IOR)
C  NEXT, GROUPS ARE ORDER (IF REQUIRED, NON-ZERO, POSITIVE IOG)
C  NOTE, A NEGATIVE IOG WILL CAUSE RANDOM ORDERING OF THE WHOLE SET.
C
      READ (TAPEC) COMPID,NC,NE,NPL,MPTOT,
     1     PSIO,THEO,PHIO,XPO,YPO,ZPO,ITYP1,
     2     (PHI(I),I=1,NPL),(NINT(I),I=1,NPL),(YPA(I),I=1,NPL)
C
      WRITE (TAPEB) COMPID,NC,NE,NPL,MPTOT,
     1     PSIO,THEO,PHIO,XPO,YPO,ZPO,ITYP1,
     2     (PHI(I),I=1,NPL),(YPA(I),I=1,NPL)
C
C
      IF (IPRINT .EQ. 1)
     1   WRITE (TAPEOT,30) NPL,MPTOT,
     2         PHIO,PSIO,THEO,XPO,YPO,ZPO
   30 FORMAT( T5,15HCONFIGURATION  ,4x,
     1 17HNUMBER OF CUTS = ,I2,4x,15HTOTAL POINTS = ,I4,/
     2  5HPHIO=,F6.2,3X, 5HPSIO=,F6.2,3X,
     3  5HTHEO=,F6.2,3X,   3HXO=,F6.2,3X,
     4    3HYO=,F6.2,3X,   3HZO=,F6.2 )
C
      DO 500 KK=1,NPL
C
C   BRING MERIDIAN DATA INTO CORE
      NF=NINT(KK)
      NT=NF
      NTA=NT
      NEL=0
      PHID=PHI(KK)/RC
      IF (IPRINT .EQ. 1)
     1   WRITE (TAPEOT,40) KK,PHID,YPA(KK),NINT(KK)
   40 FORMAT( /'PLANE NUMBER ', I2, ',   PHI=', F6.2,
     1        ',   YPA=', F6.2, ',   NUMBER OF INTERSECTIONS = ', I3 )
      IF (NF .EQ. 0) GOTO 500
      DO 50 I=1,NF
      J(I)=I
      JX(I)=I
   50 READ (TAPEC) ID(I),RJ(I),X(I),Y(I),Z(I),R(I),AX(I)
C
C   READ IN COMPONENT COUNTERS
      READ (TAPEC) (NI(I),I=1,NC)
C
C
      IF (IOV .GT. 0) GOTO (70,90,110), IOV
C
C   ORDERING WILL USE AXIAL COORD.
      DO 60 I=1,NF
   60 A(I)=AX(I)
      ORD=DORD(1)
      GOTO 130
C
C   ORDERING WILL USE X COORD.
   70 DO 80 I=1,NF
   80 A(I)=X(I)
      ORD=DORD(2)
      GOTO 130
C
C   ORDERING WILL USE Y COORD.
   90 DO 100 I=1,NF
  100 A(I)=-Y(I)
      ORD=DORD(3)
      GOTO 130
C
C   ORDERING WILL USE Z COORD.
  110 DO 120 I=1,NF
  120 A(I)=-Z(I)
      ORD=DORD(4)
C
C
  130 CONTINUE
C   FIRST ORDER RANDOM SETS (W.R.T. AXIAL COORD. A)
      N1=1
      I=NC
      IF (IOG .LT. 0) GOTO 160
      I=0
  140 I=I+1
      IF (IOR(I) .EQ. 0) GOTO 230
      N1=NI(I)
      IF (N1 .EQ. 0) GOTO 230
      IF (I-NC) 150,160,160
  150 I2=I
  155 I2=I2+1
      IF (I2 .GT. NC) GOTO 160
      NT=NI(I2)-1
      IF (NT) 155,155,170
  160 NT=NF
  170 NT1=NT-1
      DO 220 L=N1,NT1
      J1=J(L)
      IF (J1 .EQ. 0) GOTO 230
      L1=L+1
C
      DO 210 K=L1,NTA
  180 J2=J(K)
      IF (J2 .EQ. 0) GOTO 215
      DELA=A(J1)-A(J2)
      IF (DELA) 190,190,185
C
  185 IF(ABS(DELA) .GT. (ABS(A(J1))+1.0)*0.001) GOTO 210
C
  190 KD=K-L
      K1=K
      DO 200 II=1,KD
      K2=K1-1
      J(K1)=J(K2)
  200 K1=K2
      J(L)=J2
C
      IF (ABS(DELA) .GT. (ABS(A(J1))+1.0)*0.001) GOTO 205
C
C   TWO EQUAL POINTS. ELIMINATE J1 FROM SET.
      NT=NT-1
      NEL=NEL+1
      DO 204 II=L1,NT
      L2=II+1
  204 J(II)=J(L2)
      J(NT+1)=0
      J1=J2
      GOTO 180
  205 J1=J2
  210 CONTINUE
  215 NTA=NT
  220 CONTINUE
  230 NT=NTA
      IF (I .LT. NC) GOTO 140
C
C   CHECK IF GROUP ORDERING REQUIRED
      IF (IOG .GT. 0) GOTO 236
      L=0
      DO 235 I=1,NT
      L=L+1
  235 JX(L)=J(I)
      GOTO 460
C
C
C   NOW ORDER GROUPS
C   FIND BASE COMPONENT
  236 DO 240 I=1,NC
      IB=I
      IF (COMPID(I) .EQ. COMPB) GOTO 250
  240 CONTINUE
      IB=1
C
C   IDENTIFY ELEMENTS OF BASE COMPONENT
  250 N1=NI(IB)
      IF (N1 .GT. 0) GOTO 260
      N1=1
      GOTO 290
  260 CONTINUE
      IF (IB-NC) 270,290,290
  270 IB1=IB
  280 IB1=IB1+1
      IF (IB1 .GT. NC) GOTO 290
      N2=NI(IB1)-1
      IF (N2 .LE. 0) GOTO 280
      GOTO 300
  290 N2=NF
  300 NT=N2-N1+1
      L=0
      DO 310 I=N1,N2
      L=L+1
  310 JX(L)=J(I)
      IF (NC .LE. 1) GOTO 460
      IF (NI(IB) .EQ. 0) GOTO 460
C
C   NOW CYCLE OTHER COMPONENTS
      DO 450 IC=1,NC
      IF (IC .EQ. IB) GOTO 450
      NC1=NI(IC)
      IF (NC1 .EQ. 0) GOTO 450
      IF (IC-NC) 320,340,340
  320 IC1=IC
  330 IC1=IC1+1
      IF (IC1 .GT. NC) GOTO 340
      NC2=NI(IC1)-1
      IF (NC2 .LE. 0) GOTO 330
      GOTO 350
  340 NC2=NF
C
  350 DO 360 I=NC1,NC2
      L=L+1
  360 JX(L)=J(I)
      IF (IOG .LE. 0) GOTO 450
      LT=L
      J1=J(NC1)
      DO 370 LX=1,NT
      L1=LX
      L2=L1+1
      J2=JX(LX)
      IF (A(J1) - A(J2)) 370,390,380
  370 CONTINUE
C
C   ELEMENTS DO NOT OVERLAP
      NT=LT
      GOTO 450
C
C   SAVE REMAINING INDICES FROM BASE COMPONENT
  380 L2=L1
      IF (L2 .GT. NT) GOTO 410
  390 LJ1=JX(L2)
      LJ2=J(NC2)
      IF (A(LJ1) .EQ. A(LJ2)) NC2=NC2-1
      IX=N1-1
      DO 400 LX=L2,NT
      IX=IX+1
  400 J(IX)=JX(LX)
C
C   INSERT ELEMENTS OF COMPONENT IC
  410 DO 420 I=NC1,NC2
      JX(L1)=J(I)
  420 L1=L1+1
C
C   FILL IN REMAINING BASE ELEMENTS
      IF (L2 .GT. NT) GOTO 440
      DO 430 I=N1,IX
      JX(L1)=J(I)
  430 L1=L1+1
C
C   RESET POINT NUMBERS
  440 L=L1-1
      NT=L
C
  450 CONTINUE
  460 CONTINUE
C
      IF (IPRINT .EQ. 1)
     1   WRITE (TAPEOT,470) ORD,IOG,(IOR(I),I=1,10)
  470 FORMAT (1x,19HPOINTS ORDERED FOR ,A1,14H AS PER IOG = ,I3,
     1        14H AND IOR(I) = ,10I2 //
     2        ' ID     J     ',
     3        '      X         Y         Z         R         A' )
C
C   SAVE THE DATA ON TAPEB
      WRITE (TAPEB) NT
C
      DO 490 L=1,NT
      I=JX(L)
      JJ=RJ(I)
      IC=ID(I)
      WRITE (TAPEB) IC,COMPID(IC),JJ,X(I),Y(I),Z(I),R(I),A(I)
      IF (IPRINT .EQ. 1)
     1   WRITE (TAPEOT,480) COMPID(IC),JJ,X(I),Y(I),Z(I),R(I),AX(I)
  480 FORMAT( A4, 3X, I3, 4X, 5F10.4 )

  490 CONTINUE
C
      IF (IPRINT .EQ. 1)
     1   WRITE (TAPEOT,495) NEL
  495 FORMAT (1x,I3,40H DUPLICATE POINTS REMOVED FROM THE DATA.)
C
  500 CONTINUE
C
C
      RETURN
      END
      SUBROUTINE NACEL
C
      DIMENSION PODORG(9,6),XPOD(9,30),PODR(9,30),X(2),Y(2),Z(2),
     1          IOR(9),IEL(9),NEL(9)
C
      COMMON /ACFT/ IPRINT,ITAPE,ITYPE,PI,DX,CASE
C
      COMMON /NACELD/ NP,NPODOR,PODORG,XPOD,PODR,IOR,IEL,NEL
C
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER CASE
      INTEGER STAT1,STAT2
C
C  I  IS THE NACELLE OR POD NUMBER
C  J  IS NUMBER IDENTIFYING AXIAL LOCATION
C  N  IS THE POINT COUNTER ON THE SURFACE AT A GIVEN STATION
C
C
      I=0
   10 I=I+1
      IF (I .GT. NP) GOTO 140
      ISEQ=0
C
C ** SET COUNTERS AND CONTROLS
      STAT1=2
      STAT2=0
      J=1
C
C ** SET POD ORIGIN QUANTITES
      XO=PODORG(I,1)
      YO=PODORG(I,2)
      ZO=PODORG(I,3)
C
C ** SET UP THE ROTATION ANGLES FOR ORIENTATION
      STHETA=0.0
      CTHETA=1.0
      SPSI=0.0
      CPSI=1.0
      IF (IOR(I) .NE. 1) GOTO 30
C
      DXX=(XO-PODORG(I,4))*DX
      DYY=YO-PODORG(I,5)
      DZZ=-ZO+PODORG(I,6)
      DS1=DXX**2+DYY**2
      DS2=sqrt(DS1+DZZ**2)
      IF (DS1 .LT. 0.0001) GOTO 20
      DS1=sqrt(DS1)
      CPSI=DXX/DS1
      SPSI=DYY/DS1
C
   20 CTHETA=DS1/DS2
      STHETA=DZZ/DS2
C
C ** CALCULATE ELEMENT SPACING, DPHI.
   30 NR=12
      IF (IEL(I) .NE. 1) GOTO 40
      IF (NEL(I).GT.0 .AND. NEL(I).LE.36) NR=NEL(I)
   40 DPHI=PI/NR
C
C ** CHECK POD SYMMETRY WITH RESPECT TO X-Z ORIGIN PLANE.
      IF (abs(YO) .GT. 1.E-5) GOTO 50
      IF (IOR(I) .NE. 1) GOTO 60
      IF (abs(PODORG(I,5)) .LE. 1.E-5) GOTO 60
   50 NR=2*NR
   60 NR=NR+1
C
C ** NOTE. THE Y- AND Z-COORDITATES ARE DEFINED AS A FUNCTION
C    OF ANGLE PHI WHICH IS DEFINED TO BE -PI/2 AT THE
C    NEGATIVE Z-AXIS. THIS DEFINITION ALLOWS THE SIGN
C    OF THE DELTA-Z INCREMENT TO BE AUTOMATICALLY ACCOUNTED FOR.
   70 N=0
      PHI=-PI/2.-DPHI
C
   80 K=0
   90 N=N+1
      IF(N .LE. NR) GOTO 100
C
C ** SET DUMMY POINT.
      K=2
      STAT2=0
      X(K)=X(1)
      Y(K)=Y(1)
      Z(K)=Z(1)
      GOTO 110
C
  100 K=K+1
      PHI=PHI+DPHI
      YP=PODR(I,J)*cos(PHI)
      ZP=PODR(I,J)*sin(PHI)
C
      X(K)=DX*XO-XPOD(I,J)*CTHETA*CPSI-YP*SPSI+ZP*STHETA*CPSI
C
      Y(K)=YO-XPOD(I,J)*CTHETA*SPSI+YP*CPSI+ZP*STHETA*SPSI
C
      Z(K)=ZO+XPOD(I,J)*STHETA+ZP*CTHETA
C
      IF (K .EQ. 1) GOTO 90
C
C ** WRITE DATA
  110 ISEQ=ISEQ+1
      WRITE (ITAPE,120) X(1),Y(1),Z(1),STAT1,
     1                  X(2),Y(2),Z(2),STAT2,CASE,ITYPE,I,ISEQ
C
  120 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,5X,I1,'POD',I1,I4)
C
      IF (IPRINT .EQ. 1)
     1   WRITE (TAPEOT,130) X(1),Y(1),Z(1),STAT1,
     2                 X(2),Y(2),Z(2),STAT2,CASE,ITYPE,I,ISEQ
C
  130 FORMAT (1H ,3F10.4,I1,3F10.4,I1,2X,I2,5X,I1,'POD',I1,I4)
C
C ** RESET STATUS FLAG
      IF (STAT1 .GT. 0) STAT1=0
C
C ** CHECK FOR PROPER CYCLING
      IF (N .LT. NR) GOTO 80
C
C ** HAVE COMPLETED AN AXIAL STATION, CHECK FOR MORE
      J=J+1
      IF (J .GT. NPODOR) GOTO 10
C
C ** ONE OR MORE STATIONS LEFT. SET STATUS FLAG AND CONTINUE
      STAT1=1
      GOTO 70
  140 RETURN
      END
      SUBROUTINE NCONE(DCRI,EM,G,DSR,EMC,PCP1)
C
C   THIS IS AN IMPROVED APPROXIMATE CONE FLOW SOLUTION.
C   DEVELOPED BY D.N.SMYTH
C   SECOND ORDER THEORY USED FOR SMALL VALUES OF SIMILARITY PARAMETER
C   APPROXIMATE SOLUTION OF HAMMITT AND MURTHY FOR LARGE VALUES
C   MIDRANGE GIVEN BY SUITABLE TRANSITION FUNCTION
C
      DCR=DCRI
      ISDET=0
      RC=.17453292E-1
      SINDC=SIN(DCR)
      EMSIN=EM*SINDC
      EMSQ=EM**2
      KSOL=2
C
C
C   CALCULATE UPPER TRANSITION POINT, EMSINF.
      EMSINF=1.40
      IF (EM .GE. 10.0) GOTO 8
      EMSINF=0.325
      IF (EM.GT.1.5) EMSINF=1.40-1.075*EXP((EM-1.5)*(-0.8))
    8 IF (EMSIN .LT. EMSINF) GOTO 20
      KSOL=1
C
C   CALCULATE CONE SURFACE PROPERTIES USING METHOD OF
C   HAMMITT AND MURTHY.
    9 SINSQ=SINDC**2
      SIN2=SIN(2.*DCR)
      H2=(G-1.)*SINSQ+2./EMSQ
      H1=2.-(G+5.)*SINSQ
      HX=H2*H1/SIN2**2
      IF (ABS(H1) .LE. 1.E-3) GOTO 10
      RAD=SQRT(1.0+HX)
      DSR=DCR-SIN2*(1.0-RAD)/H1
      GOTO 11
   10 DSR=DCR+0.5*H2/SIN2*(1.0-0.25*HX*(1.0-0.5*HX))
   11 EMNSSQ=EMSQ*SIN(DSR)**2
      HS2=(DSR-DCR)**2
      EMC=SQRT((EMSQ-EMNSSQ)*(1.0+2.0*HS2)/(1.0+0.5*(G-1.)*
     1        (EMNSSQ*(1.0+2.0*HS2)-2.0*HS2*EMSQ)))
      ELIM=(G-1.)/(G+1.)
      PSP1=2.*G/(G+1.)*EMNSSQ-ELIM
      T1TS=(PSP1+ELIM)/(1.+ELIM*PSP1)/PSP1
      TCT1=(1.+(G-1.)*0.5*EMSQ)/(1.+(G-1.)*0.5*EMC**2)
      PCPS=(TCT1*T1TS)**(G/(G-1.))
      PCP1=PCPS*PSP1
      CP=2.0*(PCP1-1.0)/(G*EMSQ)
      GOTO (40,31), KSOL
C
C
C   CALCULATE LOWER TRANSITION POINT, EMSINO.
   20 EMSINO=0.2
      IF (EM .GT. 3.0) EMSINO=0.3
      IF (EMSIN .GT. EMSINO) GOTO 30
      KSOL=1
C
C   CALCULATE CONE SURFACE PROPERTIES USING 2ND-ORDER THEORY.
   21 BETA=SQRT(EMSQ-1.)
      TANDC=TAN(DCR)
      TANSQ=TANDC**2
      BETA2=5.0*EMSQ-1.0
      AM=3.25*EMSQ+0.5+(G+1.)*(EMSQ/BETA)**2
      PHI=0.69314718-ALOG(BETA)-ALOG(TANDC)
      CP=TANSQ*(2.*PHI-1.0+TANSQ*(3.*(BETA*PHI)**2-BETA2*PHI+AM))
      IF (KSOL .EQ. 2) GOTO 22
      IF (ISDET .EQ. 2) RETURN
      DSR=asin(1./EM)
      PCP1=G*EMSQ*CP*0.5+1.0
      TCT1=PCP1**((G-1.)/G)
      EMC=SQRT(2./(G-1.)*((1.0+(G-1.)*0.5*EMSQ)/TCT1-1.0))
      GOTO 40
   22 DCP2=TANDC*(4.*(PHI-1.)+TANSQ*(6.*PHI*(2.*PHI-1.)*
     1     BETA**2-BETA2*(4.*PHI-1.)+4.*AM))/(EM*COS(DCR)**3)
      GOTO 32
C
C   CALCULATE CONE SURFACE PROPERTIES USING TRANSITION SOLUTION
C   (THAT IS, A COMBINATION OF BOTH 2ND-ORDER AND HAMMITT-MURTHY).
   30 DXF=EMSINF-EMSINO
      DX=EMSIN-EMSINO
      SINDC=EMSINF/EM
      DCR=asin(SINDC)
      GOTO 9
   31 CPHM=CP
      DCR=asin(EMSINO/EM)
      GOTO 21
   32 A=(CPHM-CP-DCP2*DXF)/DXF**2
      CP=CP+DX*(DCP2+A*DX)
      IF (ISDET .EQ. 2) RETURN
      PCP1=0.5*G*EMSQ*CP+1.0
      EMNSF=EM*SIN(DSR)
      EMNS=(EMNSF-1.)*(EMSIN/EMSINF)**2+1.0
      EMNSSQ=EMNS**2
      EMSSQ=((G+1.)*EM*EMNS)**2-4.*(EMNSSQ-1.)*(G*EMNSSQ+1.)
      DSR=asin(EMNS/EM)
      EMSSQ=EMSSQ/((2.*G*EMNSSQ-(G-1.))*((G-1.)*EMNSSQ+2.))
      PSPC=(2.*G*EMNSSQ-(G-1.))/(G+1.)/PCP1
      EMC=SQRT(((1.+0.5*(G-1.)*EMSSQ)*PSPC**((G-1.)/G)-1.)*2./(G-1.))
      TCT1=(1.+(G-1.)*0.5*EMSQ)/(1.+(G-1.)*0.5*EMC**2)
   40 CONTINUE
      RETURN
      END
      SUBROUTINE NEWTPM(ANGLE,EMN,CP,ETAC,IPRINT,MER,CPSTAG,
     1                  ISE,IFIRST)
C
C  THIS SUBROUTINE CALCULATES THE SURFACE CONDITIONS USING THE BLUNT
C  BODY SHOCK-EXPANSION TECHNIQUE OF KAUFMAN. JOURNAL OF THE
C  ASTRONAUTICAL SCIENCES, VOL X, NO.2 SUMMER 1963.
C
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /FSBS/FS,BS
      DIMENSION FS(8),BS(8),ANGLE(3)
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      REAL*8 MACHO,MACH,MSUBQ,MU,MACHSQ,M1,M2
      Character *4 TITLE(15)
C
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
C
      IF (CPSTAG .LE. 0.01) CPSTAG=2.0
      IF (ETAC .LE. 0.01) ETAC=1.0
      MER=0
      IF (IFIRST .EQ. 1) GOTO 60
      IFIRST=1
      MACHO=FS(6)
C
C
C  THE FOLLOWING SECTION PERFORMS AN ITERATION TO FIND THE MATCHING
C  POINT MACH NUMBER.
C
C  SET GAMMA
      G=GAM
      EMLOW=0.91+0.3125*G
      EMUP=EMLOW+0.40
      JJ=0
      P2=0.0
      M2=0.0
C  SOLVE FOR PRESSURE RATIO  (1.0/ EQ. 100 OF TR 1135)
      PCAP=(2./((G+1.)*MACHO*MACHO))**(G/(G-1.))*
     1     ((2.*G*MACHO*MACHO-(G-1.))/(G+1.))**(1.0/(G-1.))
C
C  ASSUME MSUBQ=EMLOW
      MSUBQ=EMLOW
C
C  CALCULATE  Q  (SEE KAUFMAN)
   10 Q=(2.0/(2.0+(G-1.)*MSUBQ*MSUBQ))**(G/(G-1.))
C
C  CALCULATE  P  SUB  C  (EQ 9 OF KAUFMAN)
      PC=Q*(1.0-(G*G*MSUBQ**4*Q)/(4.0*(MSUBQ*MSUBQ-1.0)*(1.-Q)))
      CPQ=(2.0/(G*MACHO*MACHO))*(Q/PC-1.0)
      IF (IPRINT .NE. 1) GOTO 30
      WRITE (TAPEOT,20) MSUBQ,PC,CPQ
   20 FORMAT ( 17X,7HMSUBQ =,F9.6,6H  PC =,E11.4,7H  CPQ =,E11.4 )
C
C  CHECK ITERATION ACCURACY
   30 IF (dabs(MSUBQ-M2) .LT. 0.0001) GOTO 50
C
C  SET UP ITERATION TERMS
      P1=P2
      P2=PC
      M1=M2
      M2=MSUBQ
C
C  STEP ITERATION COUNTER AND CHECK CYCLE
      JJ=JJ+1
      IF (JJ .GT. 1) GOTO 40
      MSUBQ=EMUP
      GOTO 10
   40 IF (JJ .GT. 20) GOTO 50
C  ESTIMATE NEW M
      IF (dabs(DBLE(P2-P1)) .LT. 0.000001) GOTO 50
      MSUBQ=M1+(PCAP-P1)*(M2-M1)/(P2-P1)
C  CHECK NEW ESTIMATE FOR M
      IF (MSUBQ .GT. EMUP) MSUBQ=EMUP
      IF (MSUBQ .LT. EMLOW) MSUBQ=EMLOW
      GOTO 10
C
C  CALCULATE MATCHING POINT IMPACT ANGLE
   50 IF ((Q-P) .LE. 0.0) GOTO 100
      SDELTQ=sqrt((Q-PCAP)/(1.0-PCAP))
      DELTQ=asin(SDELTQ)*57.29578
C
C  CALCULATE EXPANSION ANGLE FROM MATCHING POINT
   60 DLTMU=DELTQ-ANGLE(2)
C
C  CHECK IF FLOW WILL EXPAND AT LEAST TO MATCHING POINT
      IF (DLTMU .LT. 0.0) GOTO 100
C
C  DETERMINE MACH NUMBER ON SURFACE
      FS(6)=MSUBQ
      ANGLE(2)=DLTMU
C
      ISDET=0
      CALL EXPAND(ANGLE,MER,IPRINT,ISDET,CP)
      FS(6)=MACHO
C  SET UP SURFACE MACH NUMBER
      MACH=BS(6)
C
C  CALCULATE SURFACE PRESSURE RATIO (EQ. 44 OF TR 1135)
      PPO=ETAC*(1.0+(G-1.)*MACH*MACH/2.0)**(-G/(G-1.))
C
C  CALCULATE  P / P  FREE STREAM
      PPFS=(1.0/PCAP)*PPO
C  CALCULATE PRESSURE COEFFCIENT ON SURFACE
      CP=(2.0/(G*MACHO*MACHO))*(PPFS-1.0)
      IF (IPRINT .NE. 1) GOTO 80
      WRITE (TAPEOT,70) MSUBQ,PCAP,Q,PPO,MACH,DELTQ,PC,DLTMU,PPFS,CP
   70 FORMAT ( 17X,23HSHOCK-EXPANSION  M Q  =,F7.5,8H  P CAP=,E11.4,
     1  8H  Q    =,E11.4,8H  P/PO =,E11.4,7H  MACH=,F7.3,/ 17X,
     2 23HCALCULATIONS     DELTQ=,F7.3,8H  P C  =,E11.4,8H  DLTMU=,
     3  E11.4,8H  P/PFS=,E11.4,5H  CP=,F9.5 )
C  CHECK IF FLOW CONDITIONS ARE NEEDED
   80 IF (ISE .GT. 0) GOTO 110
C
C  CALCULATE FREE STREAM TOTAL TEMPERATURE (EQ. 43 OF TR 1135)
      TSUBT=FS(3)*(1.0+(G-1.)*MACHO*MACHO/2.0)
C
C  CALCULATE TEMPERATURE AFTER EXPANSION (IN RANKINE)
      T=TSUBT/(1.0+(G-1.)*MACH*MACH/2.0)
C
C  CALCULATE SURFACE PRESSURE
      P=PPFS*FS(2)
C
C  CALCULATE DENSITY (EQ. 26 OF TR 1135)
      RHO=G*P/((G-1.)*GASCP*T)
C
C  CALCULATE LOCAL SPEED OF SOUND
      A=sqrt(G*P/RHO)
C
C  CALCULATE LOCAL VELOCITY
      V=MACH*A
C
C  CALCULATE VISCOSITY
      IF (T .GE. AV1)  MU=2.27E-8*T**1.5/(T+198.6)
      IF (T .LT. AV1)  MU=AV2*T**AV3
C
C  CALCULATE REYNOLDS NUMBER PER FOOT (EQ. B1 TR 1135)
      RE=RHO*V/MU
C
C  SET UP DATA FOR USE BACK IN OTHER SUBROUTINES
      BS(1)=RHO
      BS(2)=P
      BS(3)=T
      BS(4)=A
      BS(5)=MU
      BS(6)=MACH
      BS(7)=V
      BS(8)=RE
      IF (IPRINT .NE. 1) GOTO 110
      WRITE (TAPEOT,90) MACH,A,RE,P,TSUBT,V,T,RHO,MU
   90 FORMAT ( 34X,6HMACH =,F7.5,8H  A    =,E11.4,8H  RE   =,E11.4,
     1  8H  P    =,E11.4,7H  TTOT=,F7.1,/ 34X,6HV    =,F7.1,
     2  8H  T    =,E11.4,8H  RHO  =,E11.4,8H  MU   =,E11.4 )
C
C
      GOTO 110
C
C
C  FLOW HAS NOT REACHED THE MATCHING POINT. USE NEWTONIAN CALCULATIONS
C  AND SHOCK DETACHED METHOD SUGGESTED BY SMYTH.
  100 CP=CPSTAG*(sin(ANGLE(2)/57.29578))**2
C
C  CHECK IF FLOW CONDITIONS ARE NEEDED
      IF (ISE .GT. 0) GOTO 110
      MER=1
C
C  CALCULATE FLOW DATA FOR DETACHED CONDITIONS
C  CALCULATE SQUARE OF MACH NUMBER NORMAL TO EFFECTIVE SHOCK
      MACHSQ=(MACHO*MACHO*CP-(4./(G+1.)))/(2.*(1.-(G-1.)/(G+1.)))
C  CALCULATE EFFECTIVE DENSITY RATIO
      EPSI=((G-1.)/(G+1.))*(1.0+2.0/((G-1.)*MACHSQ))
C  CALCULATE THE EFFECTIVE SHOCK ANGLE SQUARED
      ANGLE(3)=CP/(2.0*(1.0-EPSI))
C  CALCULATE NORMAL MACH SQUARED TIMES SQUARE OF SHOCK ANGLE
      EMN=MACHSQ*ANGLE(3)
C
  110 RETURN
C
      END
      SUBROUTINE PRES
C
C  THIS IS THE EXECUTIVE ROUTINE FOR THE INVISCID PRESSURE CALCULATIONS
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /GDATA/LTOT,J,SYMFCT,IORN,IGTYPE,L
      COMMON /ABDATA/NAB,ALPHA(20),BETA(20),ROL(20),CDELTA(20),QI(20),
     1               RI(20),PI(20)
      COMMON /INTERF/INT,ISHE(20),NSHE(100),I9,ISHEF,INF(20,22),
     1               DINF(20,6),LTOTAB(20)
      COMMON /FLIGHT/MACH,ALT,PSTAG,TSTAG,V,RENO,PFS,TFS,AFS,RHOFS,VIS
      COMMON /REF/SREF,MAC,SPAN,XCG,YCG,ZCG
      COMMON /FARRAY/F
      COMMON /MDATA/IMPACT,ISHAD,IPRINT,PDATA,ISAVE,IPIN
      COMMON /GASD/GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)

C  Array AA is removed from common /SURFN2/ and placed in new common
C  /SURFN/. To establish a correspondence with length of common /SURFN2/ 
C  in subroutine FLNTRP here added auxiliary array a(570). 
      COMMON /SURFN2/INORM,ISURF,IX,IY,IZ,U1,UL,V1,VL,CR,CT,CMX,N2,
     1   N3,XO,YO,ZO,AP11,AP12,AP13,AP21,AP22,AP23,AP31,AP32,AP33,
     2   flowc(7),xi(500),yi(500),b(503,7),xkf(503),
     3   XB(4),YB(4),ZB(4),
     4   NDSET,IABSET,IR,LORG(20),ISR(20),NS,ISFR,IVIS,IFTYP,IFLOW,
     5   BX(2,20),BY(2,20),NB, a(570)
*    2   FLOWC(7),XI(500),YI(500),B(503,7),XKF(503),AA(5999),
*
      REAL*8 aa(253009)
      common /surfn/ aa
*
      DIMENSION ELEM(25)
      Integer E(25), EP(25)
      Integer COM(10)
      Character *4 TITLE(15)
C      DIMENSION F(11),IPANL(10),PDATA(6),IPR(20),FF(11),IMP(20),ISA(20),
      DIMENSION F(11),IPANL(10),PDATA(6),IPR(20),IMP(20),ISA(20),
     1          ISH(20),PDA(6,20)
      DIMENSION LCOM(41),LSUM(41)
C      Character *4 TITLE9(5)
      Integer E1(8), TITLE9(5)
      Character *69 impmet(15)
      Character *69 shamet(9)
      DIMENSION INFI(22),DINFI(6),E2(11),E4(41),E5(41),E6(41),
     1          E7(11),E8(14)
      DIMENSION IG4S(1000)
      DIMENSION INP(20)
      INTEGER ERROR,SYMFCT,PAGE,CASE
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      REAL*8 MACH,MAC
      DATA ISIZE/1000/
C     DATA TITLE9/10HFORSE DATA,10H SAVE UNIT,10H          ,
C    1 10H          ,10H          /

C      DATA TITLE9/4HFORC,4HE DA,4HTA S,4HAVE ,4HUNIT/

      DATA impmet / 'Modified Newtonian',
     _              'Modified Newtonian + Prandtl-Meyer',
     _              'Tangent-wedge (using oblique-shock)',
     _              'Tangent-wedge empirical',
     _              'Tangent-cone',
     _              'Inclined-cone method',
     _             'Van Dyke Unified Method (small disturbance theory)',
     _              'Blunt-body skin-friction shear-force contributions 
     _to the aero forces',
     _              'Shock-expansion Method using strip theory',
     _              'Free-molecular flow',
     _              'Input constant pressure coefficient',
     _              'Hankey flat-surface empirical',
     _              'Delta-wing empirical',
     _              'Dahlem-Buck empirical',
     _              'Blast-wave pressure increments' /

      DATA shamet / 'Newtonian (i.e. Cp=0.0)',
     _              'Modified Newtonian + Prandtl-Meyer',
     _              'Prandtl-Meyer expansion from free-stream',
     _              'Inclined-cone method',
     _             'Van Dyke Unified Method (small disturbance theory)',
     _              'High Mach number base pressure (Cp = -1/M^2)',
     _              'Shock-expansion Method using strip theory',
     _              'Input constant pressure coefficient',
     _              'Free-molecular flow' /

      TITLE9( 1 ) = 'FORC'
      TITLE9( 2 ) = 'E DA'
      TITLE9( 3 ) = 'TA S'
      TITLE9( 4 ) = 'AVE '
      TITLE9( 5 ) = 'UNIT'

C
C
C   SET INITIAL CONSTANTS FOR START OF CASE
      ERROR=0
      NCOM=0
      I9=0
C
      WRITE (TAPEOT,10)
   10 FORMAT ( 32H*** PRESSURE CALCULATION PROGRAM  )
C
C   READ TITLE CARD AND FLAGS
      READ (TAPEIN,20) NCOMP,IFSAVE,TITLE
   20 FORMAT( /// 2I7,15A4 )
C   SET UP CONSTANTS FOR FORCE DATA SAVE ON UNIT 9
      IF (IFSAVE .EQ. 2) GOTO 60
      IF (IFSAVE .NE. 0) GOTO 40
C
C
C   INITIALIZE CONSTANTS FOR UNIT 9 FORCE DATA SAVE UNIT
C        NTOT - TOTAL NUMBER OF COMPONENTS SAVED
C        ISUM - TOTAL NUMBER OF SUMMATION SETS
C        NEXT - NEXT EMPTY RECORD ON UNIT 9
C        LCOM - POINTERS TO COMPONENT DATA (41) 1ST RECORD IS DATA TYPE
C        LSUM - POINTERS TO SUMMATION DATA (41) 1ST RECORD IS DATA TYPE
C               (DATA TYPE=1 FORCE ONLY,  =2 FORCE + STABILITY DATA)
      NTOT=0
      ISUM=0
      NEXT=10
      DO 21 I=1,41
      LCOM(I)=0
   21 LSUM(I)=0
      GOTO 50
C
C   RETRIEVE PREVIOUSLY SAVED TABLE OF CONTENTS
   40 IG9=1
      READ( 9, REC=IG9 ) E1
C      CALL READMS (9,E1,8,IG9)
      NTOT=E1(1)
      ISUM=E1(2)
      NEXT=E1(3)
C   CHECK IF VALID RECORD
      IF (E1(4) .EQ. TITLE9(1)) GOTO 43
      WRITE (TAPEOT,42)
   42 FORMAT ( 47H***IFSAVE WAS INPUT = 1 IN PRES YET UNIT 9 HAS ,
     1 55HNEVER BEEN INITIALIZED WITH A IFSAVE = 0. PROGRAM STOP. )
      STOP
   43 IG9=2
      READ( 9, REC=IG9 ) E5
C      CALL READMS (9,E5,41,IG9)
      DO 45 I=1,40
   45 LCOM(I)=E5(I+1)
C
   50 DO 22 I=1,20
      E4(I+1)=ALPHA(I)
   22 E4(I+21)=BETA(I)
      E4(1)=NAB
      DO 24 I=1,5
   24 E1(I+3)=TITLE9(I)
      DO 25 I=1,41
   25 E6(I)=0.0
      DO 26 I=1,11
   26 E7(I)=0.0
C
C   READ COMPONENT SELECTION CARD + INTERFERENCE FLAGS
   60 READ (TAPEIN,70) IPANL
   70 FORMAT( //10I7 )
      READ (TAPEIN,71) IPM
      READ (TAPEIN,71) INT
      READ (TAPEIN,71) ISHEF
   71 FORMAT( /1I7 )
      NCOM=NCOM+1
C
C ****************
C   CHECK IF NEW PRESSURE DATA ARE TO BE READ
      IF (IPM .GT. 1) GOTO 110
      write( tapeot, 72 )
   72 format( '*** Pressure Method Data :' )
C   READ PRESSURE METHOD DATA (1 CARD OR NAB CARDS)
      DO 100 I=1,NAB
      IF (IPM.EQ.0 .OR. I.EQ.1) THEN
         READ( TAPEIN,80 ) IMPACT,ISHAD,IPRINT,IPIN,ISAVE
         if( IMPACT .NE. 0 ) then
            write( tapeot, 73 ) NAB, IMPACT, impmet( IMPACT ),
     _                               ISHAD, shamet( ISHAD )
         else
            write( tapeot, 75 ) NAB, IMPACT
         endif
   73    format( 'NAB=', i2 / '  IMPACT=', i2, ' - ', a /
     _                        '  ISHAD=', i2, ' - ', a )
   75    format( 'NAB=', i2 / '  IMPACT=', i2, ' - ' /
     _     'Use Shock-expansion Method Flow Fields' )
         READ( TAPEIN,81 ) PDATA
         write( tapeot, 74 ) PDATA
   74    format( 'PDATA(i) = ', 6f7.3 )
      ENDIF
   80 FORMAT( //5I7 )
   81 FORMAT( //10F7.0 )
      IMP(I)=IMPACT
      ISH(I)=ISHAD
      IPR(I)=IPRINT
      ISA(I)=ISAVE
      INP(I)=IPIN
C
      DO 90 K=1,6
   90 PDA(K,I)=PDATA(K)
  100 CONTINUE
  110 CONTINUE
C ****************
C
C   SET UP INTERFERENCE DATA ARRAY (DINF)
      INTF=0
      IF (INT.EQ.0 .OR. INT.EQ.3) GOTO 119
      do i=1,2
         read( tapein, '()' )
      enddo
      DO 115 I=1,NAB
      IF (I.EQ.1 .OR. INT.EQ.1)  READ (TAPEIN,111) INFI
  111 FORMAT( 10i7 )
      DO 113 J=1,22
  113 INF(I,J)=INFI(J)
      IF ((I.EQ.1 .OR. INT.EQ.1) .AND. INFI(1).EQ.0)
     1    READ (TAPEIN,112) DINFI
  112 FORMAT (10X,6F10.0)
      DO 114 J=1,6
  114 DINF(I,J)=DINFI(J)
  115 CONTINUE
  119 CONTINUE
C   CHECK IF INTERFERENCE FLAG IS TO BE TURNED ON.
      IF (INT .EQ. 0) GOTO 118
      DO 117 I=1,NAB
      IF (INF(I,1) .GT. 0) INTF=1
  117 CONTINUE
  118 CONTINUE
      IF (INTF .EQ. 1) REWIND TAPEE
C
C   OBTAIN GEOMETRY DATA FROM SAVE UNIT FOR COMPLETE COMPONENT AND
C   PLACE IN GEOMETRY DATA WORKING ARRAYS
      IG4=2
      READ( 4, REC=IG4 ) E
C      CALL READMS (4,E,25,IG4)
      NEXTG=E(1)
      NP=E(2)
      NPMAX=E(3)
      NREM=E(4)
      K=0
      NCS=0
      DO 130 I=1,10
      IF (IPANL(I) .EQ. 0) GOTO 140
      NCS=NCS+1
      IG4=IPANL(I)*5
      READ( 4, REC=IG4 ) EP
C      CALL READMS (4,EP,25,IG4)
      ISTAT3=EP(1)
      COM(I)=EP(2)
      ISTART=EP(3)
      N=EP(4)
      IORN=EP(5)
      SYMFCT=EP(6)
      ISTART=ISTART-NREM
C
      DO 120 II=1,N
      K=K+1
      IF (K .GT. ISIZE) GOTO 150
      IG4=ISTART+NREM*II
      IG4S(K)=IG4
      IF (INTF .NE. 1) GOTO 120
      READ( 4, REC=IG4 ) ELEM
C      CALL READMS (4,ELEM,25,IG4)
      WRITE (TAPEE) IG4,ELEM
  120 CONTINUE
  130 CONTINUE
C
  140 LTOT=K
      GOTO 170
  150 WRITE (TAPEOT,160) ISIZE,ISIZE
  160 FORMAT ( '*** ERROR *** NUMBER OF ELEMENTS PER COMPONENT ',
     1      'CANNON EXCEED', I5 / 14X, 'DIVIDE THE SHAPE INTO ',
     2      'MORE COMPONENTS WITH NO COMPONENT GREATER THAN ', I4,
     3      ' ELEMENTS'  )
      STOP
  170 CONTINUE
C
      ISRF=0
      DO 172 I=1,NAB
      IF (INP(I) .GT. 0) ISRF=1
  172 CONTINUE
      IF (ISRF .EQ. 0) GOTO 175
C
C   ELEMENTS MUST BE WRITTEN ON TAPEE
C   CHECK IF ALREADY DONE FOR INTERFERENCE FLOWS
      IF (INTF .EQ. 1) GOTO 175
C
      DO 174 I=1,LTOT
      IG4=IG4S(I)
      READ( 4, REC=IG4 ) ELEM
C      CALL READMS (4,ELEM,25,IG4)
      WRITE (TAPEE) IG4,ELEM
  174 CONTINUE
  175 CONTINUE
C
C
C
C   CHECK FOR INTERFERENCE USAGE
      IF (INTF .EQ. 0) GOTO 181
C   CALL FLOW FIELD PRE-PROCESSOR FOR INTERFERENCE DATA
      CALL FLNTRP
C
C
C
  181 CONTINUE
C
C
C
C   CHECK FOR INPUT SURFACE PRESSURES
      IF (ISRF .EQ. 0) GOTO 183
C   CALL PRE-PROCESSOR FOR SURFACE DATA
      CALL CPINPT(INP,LTOTAB)
  183 CONTINUE
C
C
C
C   GEOMETRY DATA LOAD IS COMPLETE
C
      ISAS=0
      IF (IFSAVE .EQ. 2) GOTO 182
      NTOT=NTOT+1
      LCOM(NTOT)=NEXT
      NEXT=NEXT+2
  182 CONTINUE
C
C **************************************************************
C   START ALPHA-BETA LOOP (DO ALL ALPHA-BETAS FOR GIVEN COMPONENT)
      DO 190 J=1,NAB
      IMPACT=IMP(J)
      ISHAD=ISH(J)
      IPRINT=IPR(J)
      ISAVE=ISA(J)
      IPIN=INP(J)
      IF (ISAVE .EQ. 1) ISAS=1
      DO 180 I=1,6
  180 PDATA(I)=PDA(I,J)
C *** GO TO FORCE PROGRAM
      CALL FORCE(NEXTG,IG4S)
      IF (ERROR .NE. 0) GOTO 460
C
C   SAVE FORCE DATA ON UNIT 9 IF REQUIRED
      IF (IFSAVE .EQ. 2) GOTO 190
      WRITE( 9, REC=NEXT ) F
C      CALL WRITMS (9,F,11,NEXT)
      NEXT=NEXT+1
      WRITE( 9, REC=NEXT ) E7
C      CALL WRITMS (9,E7,11,NEXT)
      NEXT=NEXT+1
  190 CONTINUE
C *** END OF ALPHA-BETA LOOP INTO FORCE
C **************************************************************
C
C
C   RESET COUNTERS IN GEOMETRY TABLE IF DATA WHERE SAVED
      IF (ISAS .EQ. 0) GOTO 192
      E(1)=NEXTG
      IG4=2
      WRITE( 4, REC=IG4 ) E
C      CALL WRITMS (4,E,25,IG4)
  192 CONTINUE
C
      IF (IFSAVE .EQ. 2) GOTO 450
C
C *** OUTPUT DATA ******
C   WRITE HEADER INFORMATION FOR FORCE OUTPUT PAGE
      CALL HEADER
      WRITE (TAPEOT,200) NCOM
  200 FORMAT ( 'COMPONENT NUMBER =', I3)
      WRITE (TAPEOT,210) (COM(I),I=1,NCS)
  210 FORMAT ( 'PANEL ID =' ,20(A4,2X))
      WRITE (6,230) MACH, V*0.3048, RENO
  230 FORMAT ( '  M =',F8.3, ',   V =',F9.1, ' m/sec,   RE/ft =',
     _         E13.5 )
      IF (PSTAG .LT. 0.00001) WRITE (6,240) ALT*0.3048/1000, TFS*5/9,
     _                                      AFS*0.3048, PFS*0.00048824
  240 FORMAT ( '  h = ', F7.3, ' km,   T = ', f6.2, ' K,   a = ', f6.2,
     _         ' m/sec,   p = ', f6.4, ' kgf/sm^2' )
      IF (PSTAG .GT. 0.00001) WRITE (6,250) PSTAG,TSTAG
  250 FORMAT ( 16X,7HP STAG=,F7.1,16H ATMOS   T STAG=,F7.1,6H DEG F )
      WRITE (TAPEOT,260) GTYPE
  260 FORMAT ( 2X,2A4)
      WRITE (6,270) SREF,SPAN,MAC,XCG,YCG,ZCG
  270 FORMAT ( '  S REF =',F9.2,',   SPAN =',F8.2,',   MAC  =',F8.2,/
     1  '    Xcg =',F9.2,',   Ycg =',F8.2,',   Zcg =',F8.2 )
      WRITE (TAPEOT,280)
  280 FORMAT (1H ,10HFORCE DATA,/1H ,7H  ALPHA,4X,3HC D,7X,3HC L,7X,
     1 3HC A,7X,3HC Y,7X,3HC N,/1H ,7H  BETA ,4X,3HL/D,7X,3HC M,7X,
     2 4HC LL,6X,4HC LN )
C 280 FORMAT ( '       FORCE DATA' /
C    1 '  ALPHA      Cd         Cl        Ca        Cy         Cn ' /
C    2 '  BETA       L/D        Cm        Cll       Cln' )
C
C   RETRIEVE OUTPUT DATA FROM UNIT 9 AND PRINT
      DO 300 I=1,NAB
      IG9=LCOM(NTOT)+I*2
      READ( 9, REC=IG9 ) f
C      CALL READMS (9,F,11,IG9)
      do ii=1,11
         if( abs( f(ii) ) .LT. 1.0e-04 )  f(ii) = 0.0
      enddo
      if( f(3) .EQ. 0.0 )  f(8) = 0.0
C   WRITE OUTPUT FORCE DATA
      WRITE (TAPEOT,290) F
  290 FORMAT (1H ,F7.2,5F10.5,/1H ,F7.2,4F10.5)
C 290 FORMAT ( f7.2, 2x, 5g11.4 / f7.2, 2x, 4g11.4 )
  300 CONTINUE
C ** OUTPUT DATA COMPONENT INFORMATION IN TABLE OF CONTENTS
C
C   SAVE COMPONENT INFORMATION IN TABLE OF CONTENTS
      DO 191 I=2,11
  191 E2(I)=IPANL(I-1)
      E2(1)=NTOT
      IG9=LCOM(NTOT)
      WRITE( 9, REC=IG9 ) E2
C      CALL WRITMS (9,E2,11,IG9)
      IG9=IG9+1
      WRITE( 9, REC=IG9 ) E4
C      CALL WRITMS (9,E4,41,IG9)
C
C   UPDATE MAIN TABLE OF CONTENTS
      E1(1)=NTOT
      E1(2)=ISUM
      E1(3)=NEXT
      IG9=1
      WRITE( 9, REC=IG9 ) E1
C      CALL WRITMS (9,E1,8,IG9)
      DO 310 I=2,41
  310 E5(I)=LCOM(I-1)
      E5(1)=0.0
      IG9=2
      WRITE( 9, REC=IG9 ) E5
C      CALL WRITMS (9,E5,41,IG9)
      IG9=3
      WRITE( 9, REC=IG9 ) E6
C      CALL WRITMS (9,E6,41,IG9)
      E8(1)=MACH
      E8(2)=V
      E8(3)=RENO
      E8(4)=ALT
      E8(5)=PSTAG
      E8(6)=TSTAG
      E8(7)=GTYPE(1)
      E8(8)=GTYPE(2)
      E8(9)=SREF
      E8(10)=SPAN
      E8(11)=MAC
      E8(12)=XCG
      E8(13)=YCG
      E8(14)=ZCG
      IG9=4
      WRITE( 9, REC=IG9 ) E8
C      CALL WRITMS (9,E8,14,IG9)
      WRITE (TAPEOT,430) NTOT
  430 FORMAT ( 10X, 'DATA SAVED ON UNIT 9.  SET NUMBER =', I4)
C
C   CHECK IF LAST COMPONENT HAS BEEN COMPLETED
  450 IF (NCOM .LT. NCOMP) GOTO 60
      GOTO 480
C
C
C
C
  460 WRITE (TAPEOT,470) ERROR,J
  470 FORMAT ( 10H** ERROR =,I2,26H ON RETURN FROM FORCE.  J= ,I1)
  480 RETURN
      END
      SUBROUTINE PUNCH(X1,Y1,Z1,NSTAT1,X2,Y2,Z2,NSTAT3,SECT,TYPE,
     1     LINE,SEQ,LAST,IPRINT,NREC)
C
C **** THIS SUBROUTINE PREPARES VEHICLE GEOMETRY DATA IN THE PROPER
C **** FORM FOR USE BY SDATA ROUTINE
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /GFLAG/IOUT,ISTAT3,IORIN,COMPIN
C
      DIMENSION TITLE(15)
      Character *4 SECT
C
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER PAGE,ERROR,CASE,TYPE
      INTEGER SEQ
      NSTAT2=NSTAT3
C
C  CHECK IF THIS IS LAST POINT OF THE ENTIRE VEHICLE
      IF (NSTAT3 .EQ. 3 .AND. LAST .EQ.1) NSTAT2 = 0
      IF (IPRINT .EQ. 0) GO TO 40
C
      IF (LINE .LT. 50) GO TO 20
C
C  WRITE PAGE HEADER FOR STANDARD OUTPUT TAPE
      WRITE (TAPEOT,10) CASE,(TITLE(L),L=1,12),PAGE
   10 FORMAT (5X, 'ANALITICALLY GENERATED ELEMENT DATA' /
     1 6H  CASE,3X,I2,17X,12A4,17X,5HPAGE ,I4,/
     2 5X,1HX,9X,1HY,9X,1HZ,4X,1HS,5X,1HX,9X,1HY,8X,1HZ,5X,1HS,
     3 10H CASE SECT,6X,3HSEQ )
C
      PAGE=PAGE+1
      LINE=5
C
C  WRITE GEOMETRY CARDS ON STANDARD OUTPUT TAPE
   20 WRITE (TAPEOT,30) X1,Y1,Z1,NSTAT1,X2,Y2,Z2,NSTAT2,CASE,SECT,
     1 TYPE,SEQ
   30 FORMAT( 3F10.4,I1,3F10.4,I1,2X,I2,A4,1X,I1,4HAERO,I4 )
C
      LINE=LINE+2
C
C  WRITE GEOMETRY DATA ON GEOMETRY TAPE
   40 WRITE (IOUT,50) X1,Y1,Z1,NSTAT1,X2,Y2,Z2,NSTAT2,CASE,SECT,
     1 TYPE,SEQ
   50 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,A4,1X,I2,4HAERO,I4)
C
      NREC=NREC+1
      SEQ=SEQ+1
C
      RETURN
      END
      SUBROUTINE ROWFM1(N,M,XI,YI,FI,XKD,NX,MX,LS,IF1)
C
C  CALCULATES XKD ARRAY IN AUGMENTED FORM, ROW BY ROW.
C
C   LS=0 , SURFACE SPLINE  X ! Y  VARIABLE
C   LS=1 , LINEAR SPLINE  X  CONSTANT
C   LS=2 , LINEAR SPLINE  Y  CONSTANT
C
C
      DIMENSION XI(*),YI(*),XKD(N+3+M),FI(NX,MX)
      REWIND IF1
      N3=N+3
      N3M=N3+M
C
      XKD(1)=0.0
      XKD(2)=0.0
      XKD(3)=0.0
C
C   FIRST ROW
      DO 10 J=4,N3
   10 XKD(J)=1.0
C
C   AUGMENT BY RHS
      J=N3
      DO 20 I=1,M
      J=J+1
   20 XKD(J)=0.0
C
      WRITE (IF1) (XKD(J),J=1,N3M)
C
C
C   SECOND ROW
C   CHECK FOR LINEAR SPLINE X CONSTANT
      IF (LS .NE. 1) GOTO 25
C
C   LINEAR SPLINE X CONSTANT
      XKD(2)=1.0
   25 JX=0
      DO 30 J=4,N3
      JX=JX+1
   30 XKD(J)=XI(JX)
C
      WRITE (IF1) (XKD(J),J=1,N3M)
C
C   THIRD ROW
      XKD(2)=0.0
C   CHECK FOR LINEAR SPLINE Y CONSTANT
   35 IF (LS .NE. 2) GOTO 37
      XKD(3)=1.0
   37 JX=0
      DO 40 J=4,N3
      JX=JX+1
   40 XKD(J)=YI(JX)
C
      WRITE (IF1) (XKD(J),J=1,N3M)
C
C   FOURTH THROUGH N3 ROWS
      DO 100 I=1,N
      XKD(1)=1.0
      XKD(2)=XI(I)
      XKD(3)=YI(I)
      J3=3
      DO 80 J=1,N
      J3=J3+1
      AIJ=0.0
      TR1=0.0
      TR2=0.0
      IF (I .EQ. J) GOTO 70
      IF (XI(I) .EQ. XI(J)) GOTO 50
      TR1=(XI(I)-XI(J))**2
   50 IF (YI(I) .EQ. YI(J)) GOTO 60
      TR2=(YI(I)-YI(J))**2
   60 RAIJ=TR1+TR2
      IF ( abs(RAIJ) .LT. 1.0e-06) GOTO 70
C      IF (RAIJ .EQ. 0) GOTO 70
      AIJ=RAIJ*ALOG(RAIJ)
   70 XKD(J3)=AIJ
   80 CONTINUE
C
C   AUGMENT THE ROW
      DO 90 J=1,M
      J3=J3+1
   90 XKD(J3)=FI(I,J)
C
      WRITE (IF1) (XKD(J),J=1,N3M)
C
  100 CONTINUE
C
C
      RETURN
      END
      SUBROUTINE SAVE(IU,IT,N,N1,A1,N2,A2)
C
      DIMENSION A1(N1),A2(N2)
C
      GOTO (10,20,30,40), IT
C
C   WRITE A1
   10 WRITE(IU) A1
      RETURN
C
C   WRITE N AND A1
   20 WRITE(IU) N,A1
      RETURN
C
C   WRITE A1 AND A2
   30 WRITE(IU) A1,A2
      RETURN
C
C   WRITE N, A1, AND A2
   40 WRITE(IU) N,A1,A2
      RETURN
      END
      SUBROUTINE SFNTR2
C
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK

C  Array AA is removed from common /SURFN2/ and placed in new common
C  /SURFN/. To establish a correspondence with length of common /SURFN2/ 
C  in subroutine FLNTRP here added auxiliary array a(570). 
      COMMON /SURFN2/INORM,ISURF,IX,IY,IZ,U1,UL,V1,VL,CR,CT,CMX,N2,
     1   N3,XO,YO,ZO,AP11,AP12,AP13,AP21,AP22,AP23,AP31,AP32,AP33,
     2   flowc(7),xi(500),yi(500),b(503,7),xkf(503),
     3   XB(4),YB(4),ZB(4),
     4   NDSET,IABSET,IR,LORG(20),ISR(20),NS,ISFR,IVIS,IFTYP,IFLOW,
     5   BX(2,20),BY(2,20),NB, a(570)
*    2   FLOWC(7),XI(500),YI(500),B(503,7),XKF(503),AA(5999),

      REAL*8 aa(253009), bb(503,7)
      common /surfn/ aa
C
      DIMENSION E4(12),E4B(12),E1(25),LOSF(5),FLOW(503,7),XT(6),VT(6),
     _  BP(2), FLOW1D(503*7)
C
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      Character *4 TITLE(15)
      Real*8 XT
C
      EQUIVALENCE ( FLOW(1,1), B(1,1), FLOW1D(1) )
C
      DATA RC,NX,MX,MX1,KD
     1    /0.1745329E-1,503,7,1,253009/
C
C  Suppress compiler warning: 'unused local variable RC'
      RC = RC
C  ... Ditto MX1
	  MX1 = MX1
C   SET CHECKOUT PRINT FLAG
      IPRINT=0
C
C   INITIALIZE CONSTANT ARRAY FLOWC
      DO 98 I=1,7
   98 FLOWC(I)=0.0
C
      IC=0
      NB=0
C
C   CYCLE ON SUB-REGIONS
      DO 600 II=1,NS
      ISBR=ISR(II)
      IG10=LORG(IR)+4+ISBR
      READ( 10, REC=IG10 ) E1
C      CALL READMS(10,E1,25,IG10)
      LOFF=E1(1)+0.01
      N1=E1(6)+0.01
C
      DO 500 J=1,5
  500 LOSF(J)=E1(J+20)+0.01
      IF (ISFR .EQ. 0) GOTO 510
C
      IF (LOSF(ISFR) .LE. 0) GOTO 600
C
C   READ IN SECONDARY FLOW POINTERS
      IG10=LOSF(ISFR)
      READ( 10, REC=IG10 ) E1
C      CALL READMS(10,E1,25,IG10)
      LOFF=E1(1)+0.01
      N1=E1(6)+0.01
C
C   READ IN THE DATA
  510 ITAG10=LOFF
      IBSF=0
      IB=0
      DO 310 I=1,N1
      READ( 10, REC=ITAG10 ) E4
C      CALL READMS(10,E4,12,ITAG10)
      ITAG10=ITAG10+1
C
C   TRANSFORM DATA
  301 CONTINUE
      XX=E4(1)-XO
      YY=E4(2)-YO
      ZZ=E4(3)-ZO
C
      XT(1)=XX*AP11+YY*AP12+ZZ*AP13
      XT(2)=XX*AP21+YY*AP22+ZZ*AP23
      XT(3)=XX*AP31+YY*AP23+ZZ*AP33
      XT(4)=XT(1)
      XT(5)=dsqrt(XT(2)**2+XT(3)**2)
      IF ( abs(XT(2)) .LT. 1.0e-5 )  XT(2) = 0.0
      IF (XT(2) .EQ. 0.0) GOTO 304
      XT(6)=datan2( XT(2), -XT(3) )
      GOTO 305
  304 XT(6)=0.0
      IF (XT(3) .GT. 0.0) XT(6)=3.141592654
  305 CONTINUE
      IF (IBSF .EQ. 1) GOTO 523
C
C   NORMALIZE THE DATA
      IC=IC+1
      IF (IC .LE. 500) GOTO 303
      WRITE (TAPEOT,302)
  302 FORMAT ( 48H*ROUTINE SFNTRP HAS ATTEMPTED TO LOAD MORE DATE ,
     1 62HPOINTS INTO INTERPOLATION ARRAYS THEN WE HAVE SPACE AVAILABLE.
     2 ,/ 52H*CALCULATIONS WILL CONTINUE WITH ONLY THE FIRST 100 ,
     3 7HPOINTS. )
      IC=IC-1
      GOTO 311
  303 YI(IC)=(XT(IY)-V1)/VL
      IF (ISURF .EQ. 1) GOTO 306
      XI(IC)=(XT(IX)-U1)/UL
      GOTO 307
  306 CHX=CR+(CT-CR)*YI(IC)
      XLE=U1+(UL-U1)*YI(IC)
      XI(IC)=(XT(IX)-XLE)/CHX
C
  307 CONTINUE
C   CHECK IF WITHIN SURFACE BOUNDARIES.
      IF (XI(IC) .LT. 0.0) GOTO 308
      IF (XI(IC) .GT. 1.0) GOTO 308
      IF (YI(IC) .LT. 0.0) GOTO 308
      IF (YI(IC) .GT. 1.0) GOTO 308
C
C   POINT WITHIN SURFACE BOUNDARIES. SET UP FLOW BOUNDARIES --
C   -- INITIALIZE AS SURFACE BOUNDARIES.
      IF (IB .EQ. 1) GOTO 535
      IB=1
      NB=NB+1
      BX(1,NB)=0.0
      BY(1,NB)=YI(IC)
      IF (ISFR .EQ. 0) GOTO 520
      BX(1,NB)=XI(IC)
C
  520 CONTINUE
      IF (IFTYP .EQ. 2) GOTO 530
      IF (ISFR .EQ. 5) GOTO 530
      IG10SF=LOSF(ISFR+1)
      IF (IG10SF .LE. 0) GOTO 530
      READ( 10, REC=IG10SF ) E1
C      CALL READMS(10,E1,25,IG10SF)
      LOFF=E1(1)+0.01
      READ( 10, REC=LOFF ) E4B
C      CALL READMS(10,E4B,12,LOFF)
      E4(1)=E4B(1)
      E4(2)=E4B(2)
      E4(3)=E4B(3)
      IBSF=1
      GOTO 301
  523 IBSF=0
      YIB=(XT(IY)-V1)/VL
      IF (ISURF .EQ. 1) GOTO 526
      XIB=(XT(IX)-U1)/UL
      GOTO 527
  526 CHB=CR+(CT-CR)*YIB
      XLB=U1+(UL-U1)*YIB
      XIB=(XT(IX)-XLB)/CHB
C
  527 CONTINUE
      BX(2,NB)=XIB
      BY(2,NB)=YIB
      GOTO 535
C
C
C
  530 CONTINUE
      BX(2,NB)=1.0
      BY(2,NB)=BY(1,NB)
C   POINT WITHIN BOUNDARIES. SET UP FLOW ARRAYS.
  535 CONTINUE
C
C   TRANSFORM FLOW DIRECTION COSINES
      VT(1)=E4(8)*AP11+E4(9)*AP12+E4(10)*AP13
      VT(2)=E4(8)*AP21+E4(9)*AP22+E4(10)*AP23
      VT(3)=E4(8)*AP31+E4(9)*AP32+E4(10)*AP33
      SINPH=dsin(XT(6))
      COSPH=dcos(XT(6))
      VT(4)=VT(1)
      VT(5)=VT(2)*SINPH-VT(3)*COSPH
      VT(6)=VT(2)*COSPH+VT(3)*SINPH
      FLOW(IC,1)=E4(7)
      FLOW(IC,2)=VT(IX)
      FLOW(IC,3)=VT(IY)
      FLOW(IC,4)=VT(IZ)
      FLOW(IC,5)=E4(11)
      FLOW(IC,6)=E4(12)
      FLOW(IC,7)=XT(IZ)
      GOTO 310
C
C   POINT NOT WITHIN BOUNDARIES. RESET COUNTER AND GO TO NEXT POINT.
  308 IC=IC-1
C
  310 CONTINUE
  600 CONTINUE
      IF (IC .GT. 2) GOTO 311
      WRITE (TAPEOT,1000) IC
 1000 FORMAT( 5HONLY ,I3,29H POINTS WERE FOUND IN SFNTR2 ,
     1 56HTO BE WITHIN  SURFACE BOUNDARIES.  THIS IS INSUFFICIENT ,/
     2 55H TO USE THE SURFACE SPLINE.  RUN CONTINUES, BUT USER IS,
     3 38H CAUTIONED TO CHECK RESULTS CAREFULLY.)
      WRITE (TAPEOT,1005) NDSET,IABSET,IR,ISR,ISFR
 1005 FORMAT( 40HTHIS APPLIES TO THE FOLLOWING FLOW DATA ,/
     1 12H DATA SET = ,I3,10X,17HALPFA-BETA SET = ,I3,
     2 10X,14HFLOW REGION = ,I3/
     3 15H SUB-REGIONS = ,20I3/
     4 18H SECONDARY FLOW = ,I3)
      ERROR=1
      RETURN
C
C   ALL THE SURFACE DATA ARE IN PROPER ARRAYS.
C
  311 N2=IC
C
C   CHECK BOUNDARY POINTS
      IF (NB .GT. 1) GOTO 700
      NB=2
      BX(1,2)=BX(1,1)
      BX(2,2)=BX(2,1)
      BY(1,2)=1.0
      BY(2,2)=1.0
C
C   NORMALIZE TO FLOW BOUNDARIES (IN IX ONLY).
C   FIRST ARRANGE BOUNDARY DATA IN ORDER OF ASCENDING YI VALUES
  700 IB=0
  710 IB=IB+1
      I1=1
  720 YY=BY(IB,I1)
      I2=I1+1
      J=0
      DO 730 I=I2,NB
      IF (YY .LT. BY(IB,I)) GOTO 730
      J=I
      YY=BY(IB,I)
  730 CONTINUE
C
      IF (J .EQ. 0) GOTO 740
      BY(IB,J)=BY(IB,I1)
      BY(IB,I1)=YY
C
  740 I1=I1+1
      IF (I1 .LT. NB) GOTO 720
      IF (IB .EQ. 1) GOTO 710
C
C   BOUNDARY DATA NOW IN ORDER. PROCEED WITH NORMALIZATION.
      IF (IPRINT .EQ. 0) GOTO 770
      WRITE (TAPEOT,750) NB
  750 FORMAT( 18HBOUNDARY  DATA,   ,I3,8H POINTS,/
     1    2X,1HI,9X,2HX1,12X,2HY1,12X,2HX2,12X,2HY2,/)
      WRITE (TAPEOT,760) (I,BX(1,I),BY(1,I),BX(2,I),BY(2,I),I=1,NB)
  760 FORMAT ( I3,4F14.6)
  770 CONTINUE
      IC=0
      DO 900 I=1,N2
      XX=XI(I)
      YY=YI(I)
      IB=0
  800 IB=IB+1
C
      DO 810 I1=1,NB
      J=I1
      IF (YY .LT. BY(IB,I1)) GOTO 820
  810 CONTINUE
C
  820 IF (J .EQ. 1) J=2
      DY=BY(IB,J)-BY(IB,J-1)
      IF (DY .EQ. 0.0) GOTO 900
      DX=BX(IB,J)-BX(IB,J-1)
      BP(IB)=BX(IB,J-1)+(YY-BY(IB,J-1))*DX/DY
      GOTO (830,840), IB
  830 IF (XX .LT. BP(IB)) GOTO 900
      GOTO 800
  840 IF (XX .GT. BP(IB)) GOTO 900
C
C   POINT WITHIN FLOW BOUNDARIES
      IC=IC+1
      XI(IC)=XX-BP(1)
      YI(IC)=YY
      IF (IVIS .EQ. 0) GOTO 850
      XI(IC)=XI(IC)/(BX(2,1)-BX(1,1))
      GOTO 860
  850 XI(IC)=XI(IC)/(BP(2)-BP(1))
  860 FLOW(IC,1)=FLOW(I,1)
      FLOW(IC,2)=FLOW(I,2)
      FLOW(IC,3)=FLOW(I,3)
      FLOW(IC,4)=FLOW(I,4)
      FLOW(IC,5)=FLOW(I,5)
      FLOW(IC,6)=FLOW(I,6)
      FLOW(IC,7)=FLOW(I,7)
C
      DO 300 II=1,7
  300 FLOWC(II)=FLOWC(II)+FLOW(IC,II)
C
  900 CONTINUE
      IF (IC .GT. 2) GOTO 910
      WRITE (TAPEOT,1010) IC
 1010 FORMAT( 5HONLY ,I3,29H POINTS WERE FOUND IN SFNTR2,
     1 51HTO BE WITHIN FLOW BOUNDARIES.  THIS IS INSUFFICIENT,/
     2 55H TO USE THE SURFACE SPLINE.  RUN CONTINUES, BUT USER IS,
     3 38H CAUTIONED TO CHECK RESULTS CAREFULLY.)
      WRITE (TAPEOT,1005) NDSET,IABSET,IR,ISR,ISFR
      ERROR=1
      RETURN
  910 CONTINUE
      N2=IC
      N3=N2+3
C   PRINT NORMALIZED ARRAYS
      IF (IPRINT .EQ. 0) GOTO 330
      WRITE (TAPEOT,3060) NDSET,IABSET,IR
 3060 FORMAT( /34HNORMALIZED SURFACE DATA.  NDSET = ,I2,5X,
     1  9HIABSET = ,I2,5X,9HREGION = ,I2,/
     2  '  I     XI      YI    MACH     MX       MY     MZ     P/P1   ',
     3  ' T/T1     ZI'/)
      WRITE (TAPEOT,3070) (I,XI(I),YI(I),(FLOW(I,J),J=1,7),I=1,N2)
 3070 FORMAT( I3,9F8.3 )
C
C
  330 CONTINUE
C
      DO 350 J=1,7
      FLOWC(J)=FLOWC(J)/N2
      DO 340 I=1,N2
  340 FLOW(I,J)=FLOW(I,J)-FLOWC(J)
  350 CONTINUE
C
C
C   CALCULATE COEFFICIENT ARRAY (SURFACE SPLINE).
      LS=0
      CALL ROWFM1(N2,MX,XI,YI,FLOW,XKF,NX,MX,LS,TAPEB)
C
      CALL SOLVIT(AA,N3,MX,KD,TAPEB,TAPEC,TAPED,TAPEB,bb,NX,MX,NERR)
      IF (NERR .NE. 0) WRITE (TAPEOT,220)
  220 FORMAT( 16HMATRIX SINGULAR.)
C
C   COEFFICIENTS ARE IN ARRAY B(I,J)
      IF (IPRINT .EQ. 0) GOTO 400
      WRITE (TAPEOT,3080)
 3080 FORMAT( /' S F N T R 2:  SURFACE INTERPOLATION COEFFICIENTS  B(I,J
     +)'/)
      WRITE (TAPEOT,3090) (I,(bb(I,J),J=1,7),I=1,N3)
 3090 FORMAT( I4, 7d10.3)
      WRITE (TAPEOT,3100) FLOWC
 3100 FORMAT( /4X,7F10.5)
  400 CONTINUE
C
C
**  Copy spline coefficients from REAL*8 bb to REAL*4 b.
      do i=1,n3
         do j=1,7
            b(i,j) = bb(i,j)
         enddo
      enddo
C
C
      RETURN
      END
      SUBROUTINE SHKEXP(N,M,IPRCK,NX,NY,NZ,DELTA,PFS,MACH,
     1  DELTAR,IMPACI,CPSTAG,TFS,CP,ISHADI,IFIRST,LL,IPRINT,
     2  RHOFS,AFS,VIS,V,RENO,ISMODE)
C
C **********************************************************************
C *** THIS SUBROUTINE CALCULATES LOCAL CONDITIONS ON AN ELEMENT USING**
C *** SHOCK EXPANSION THEORY.                                        **
C **********************************************************************
C
C
      COMMON /EXEC/ CASE,TITLE,PAGE,ERROR
      COMMON /GDATA/ LTOT,J,SYMFCT,IORN,IGTYPE,L
      COMMON /FSBS/ FS,BS
      COMMON /GASD/ GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      DIMENSION ANGLE(3),FS(8),BS(8),NXI(30),NYI(30),
     1          NZI(30),BSS(8,30),FSS(8)
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      REAL*8 NX,NY,NZ,NXI,NYI,NZI,NU
      REAL MACH
      Character *4 TITLE(15)
C
C  Suppress compiler warnings: 'unused dummy argument'
      VIS = VIS
      AFS = AFS
      RENO = RENO
      V = V
      MACH = MACH
C
      IORIEN=IORN
      DO 5 I=1,8
    5 FSS(I)=FS(I)
C
C   CHECK IF THIS ELEMENT IS THE FIRST ELEMENT IN A COLUMN OF ELEMENTS
      IF (IORIEN.EQ.0.AND.N.EQ.1 .OR. IORIEN.EQ.1.AND.M.EQ.1) GOTO 60
C
C **********************************************************************
C ***** CALCULATIONS FOR ELEMENTS THAT ARE NOT INITIAL ROW ELEMENTS ****
C **********************************************************************
      IF (IORIEN .EQ. 0) II=M
      IF (IORIEN.EQ.0 .AND. M.GT.MMAX) GOTO 60
      IF (IORIEN .EQ. 1) II=N
      SINNU=dsqrt((NY*NZI(II)-NZ*NYI(II))**2+(NZ*NXI(II)-NX*NZI(II))**2
     1     +(NX*NYI(II)-NY*NXI(II))**2)
      NU=asin(SINNU)*0.5729578E02
      NU=dabs(NU)
      IF (NX .LT. NXI(II)) NU=-NU
      ANGLE(2)=dabs(NU)
C
C   SET UP DATA FOR COMPR OR EXPAND
      DO 10 I=1,8
   10 FS(I)=BSS(I,II)
      ISDET=0
      IF (NU.GT.-0.00001 .AND. NU.LT.0.00001) GOTO 30
      IF (NU .LT. 0.0) GOTO 20
      CALL COMPR(ANGLE,MER,IPRCK,CPSTAG,ISDET,IFIRST,CP)
      GOTO 50
   20 CALL EXPAND(ANGLE,MER,IPRCK,ISDET,CP)
      GOTO 50
C
   30 DO 40 I=1,8
   40 BS(I)=FS(I)
   50 CP=(BS(2)/FSS(2)-1.0)/(0.5*GAM*FSS(6)*FSS(6))
      GOTO 150
C
C **********************************************************************
C ************* CALCULATION FOR INITIAL ELEMENT OF EACH ROW ************
C **********************************************************************
C
C   CHECK IF THERE ARE TOO MANY INITIAL ELEMENTS (MAXIMUM OF 100)
   60 IF ((IORIEN.EQ.0.AND.M.GT.30).OR.(IORIEN.EQ.1.AND.N.GT.30))
     1   GOTO 170
C
      MMAX=M
      IF (IORIEN .EQ. 0) II=M
      IF (IORIEN .EQ. 1) II=N
      IF (ISMODE .EQ. 1) GOTO 150
C
      ANGLE(2)=abs(DELTA)
      NU=DELTA
      ISDET=0
C
C   CHECK IF IMPACT OR SHADOW
      IF (DELTAR .LE. 0.0) GOTO 110
C
C   IMPACT FLOW *****************************
      GOTO (200,200,70,200,80,200,200,200,200,200,200,200,90),IMPACI
C
C   TANGENT WEDGE
   70 CALL COMPR(ANGLE,MER,IPRCK,CPSTAG,ISDET,IFIRST,CP)
      GOTO 150
C
C   TANGENT CONE EMPIRICAL
   80 ANGLE(1)=DELTA
      CALL CONE(ANGLE,CP,0)
      GOTO 150
C   DELTA WING EMPIRICAL FOR SHOCK-EXPANSION CALCS.
   90 DELDLW=DELTAR
      IF (DELDLW .LT. 0.01745) DELDLW=0.01745
      EMNS=FS(6)*sin(DELDLW)
      EMNS=2.*(GAM+1.)/(GAM+3.)*EMNS+exp((0.25*(GAM+1)
     1    -2.*(GAM+1.)/(GAM+3.))*EMNS)
      CP=4./(FS(6)**2*(GAM+1.))*(EMNS**2-1.0)
      P2P1I=0.5*GAM*FS(6)**2*CP+1.0
      BS(2)=P2P1I*FS(2)
      TINT2=((GAM+1.)**2*EMNS*EMNS)/((2.*GAM*EMNS*EMNS-(GAM-1.))*
     1     ((GAM-1.)*EMNS*EMNS+2.))
      BS(6)=sqrt((FS(6)**2-(4.*(EMNS-1.)*(GAM*EMNS+1.))/
     1     ((GAM+1.)**2*EMNS))*TINT2)
      BS(3)=FS(3)/TINT2
      BS(1)=RHOFS*(BS(2)/PFS)*(TFS/BS(3))
      BS(4)=sqrt((GAM-1.)*GASCP*BS(3))
      IF (BS(3).GE.AV1) BS(5)=2.27E-8*BS(3)**1.5/(BS(3)+198.6)
      IF (BS(3).LT.AV1) BS(5)=AV2*BS(3)**AV3
      BS(7)=BS(4)*BS(6)
      BS(8)=BS(1)*BS(7)/BS(5)
      GOTO 150
C   SHADOW FLOW *********************************
  110 GOTO (120,120,130,120,120,120,120),ISHADI
  120 GOTO 200
C   EXPANSION FROM FREESTREAM
  130 ISDET=0
      CALL EXPAND(ANGLE,MER,IPRCK,ISDET,CP)
C
  150 NXI(II)=NX
      NYI(II)=NY
      NZI(II)=NZ
  151 DO 152 I=1,8
  152 BSS(I,II)=BS(I)
C
C
      IF (IPRINT.NE.0) WRITE (TAPEOT,160) LL,N,M,BS(2),BS(3),BS(6),CP,
     1   NU,FS(2),FS(3),FS(6)
  160 FORMAT ( 32H  SHK-EXP. LOCAL CONDITIONS  LL=,I5,4H  N=,I4,
     1  4H  M=,I4,4H  P=,E12.5,4H  T=,E12.5,7H  MACH=,F7.3,5H  CP=,
     2  E12.5,/ 28X,13HTURN ANGLE  =,F9.4,4X,3HPI=,E12.5,4H TI=,
     3  E12.5,7H MACHI=,F7.3)
      DO 165 I=1,8
  165 FS(I)=FSS(I)
      RETURN
C
C
  170 WRITE (TAPEOT,180)
  180 FORMAT ( 48H****NUMBER OF INITIAL ELEMENTS CANNOT EXCEED 100
     1 57H FOR SHOCK-EXPANSION CALCULATIONS,  CHANGE INPUT DATA**** )
      WRITE (TAPEOT,190) IORIEN,LL,N,M
  190 FORMAT ( 10X,8HIORIEN =,I2,5X,
     1  5X,4HLL =,I5,5X,3HN =,I5,5X,3HM =,I5)
      ERROR=3
      RETURN
  200 WRITE (TAPEOT,210)
  210 FORMAT ( 47H****DURING SHOCK-EXPANSION CALCULATIONS PROGRAM,
     1 59H TRIED TO USE WRONG INITIAL ELEMENT METHOD--CHECK INPUT****)
      ERROR=3
      RETURN
C
      END
      SUBROUTINE SOLVIT(A,ND,MD,KD,NI,MM,NO,NW,BB,NNB,NMB,NERR)
*
*   This Version was Created by Igor Polyakov, Ukraine,
* in 1997 to provide usage Gauss-Jordan Matrix Inversion and Linear Equation
* Solution Program GAUSSJ.
      REAL*8 a(ND,ND), bb(nnb,nmb)
      DIMENSION  aa(200)
*   BB IS USED WHEN SOLUTIONS ARE RETURNED THROUGH CALL STATEMENT.
*     DIMENSION  BB(NNB,NMB)
*
C  Suppress compiler warnings: 'unused dummy argument'
      KD = KD
      NW = NW
      NERR = NERR
      NO = NO
      MM = MM
C
      N=ND
      M=MD
      NPM=N+M
      NEL=NPM
      NIN=NI
      REWIND NIN
*
*         Prepare Left and Right Sides Matrice Arrays for GAUSSJ:
*
*  Read in Left & Right Sides Matrice from the Unit NIN and Place Left Side
*  Matrice to Array A, and Right Side Matrice to Array BB
*     Rows Loop
      do 30 i = 1, n
         CALL GETT(NIN,1,NEL,aa(1),1,AA2)
         do 10 j = 1, n
   10    a(i,j) = aa(j)
         do 20 k = 1, m
   20    bb(i,k) = aa(n+k)
   30 continue
*
*  Gauss-Jordan Matrix Inversion and Linear Equation Solution
      call gaussj( a, n, NNB, bb, m, m )
      RETURN
      END
      SUBROUTINE SOSE
C
C   SECOND-ORDER SHOCK-EXPANSION METHOD
C   BASED ON NASA TR-1328.
C   (HIGHLY MODIFIED VERSION OF NASA TN D-5046)
C
      COMMON /SOSEIN/ AMF,ALF,PHIT,G,IFLG(5),N,AMP,ALFP,
     1       X(100),Y(100)
      COMMON /SOSEOT/AMANS(100),AMDX(100),AMDY(100),AMDZ(100),
     1    PANS(100),TD(100),AMS(100),AMSX(100),AMSY(100),AMSZ(100),
     2    PSHK(100),TS(100),NSP,NS,JS(10),IS(10),LS(10),IN(10),
     3    XANS(100),YANS(100),XS(100),YS(100)
C
      COMMON /FSBS/FS,BS
      DIMENSION FS(8),BS(8),ANGL(3)
      DIMENSION DEL(100),S(100),T(100),C(100)
      EQUIVALENCE (DEL(1),C(1))
C
      REAL MNS
      DATA RC,DC/1.745329252E-2,57.29577957/,PMIN/0.3/
      DATA MER,IPRINT,ISDET,CPSTAG/0,0,0,2.0/
      GP1=G+1.0
      GM1=G-1.0
      GR=SQRT(GP1/GM1)
      ANUMX=0.97815*(GR-1.0)*90.0*RC
      AME=AMF
      AMP2=AMP**2
      ALPHA=DC*ALF
      ALFPD=DC*ALFP
      PHI=DC*PHIT
      IN(1)=0
      JSS=0
      J=1
      NS=1
      JSJ=1
      JS(1)=1
      IS(1)=1
C
      XS(1)=X(1)
      YS(1)=Y(1)
      NSP=0
      XSMAX=3.0*X(N)
C
C   SET FLAGS FOR FLOW TYPE
      IFLG3=IFLG(3)
      IFLG4=IFLG(4)
      IF (IFLG3 .LE. 0) GOTO 7
      GOTO (1,2,3,4), IFLG3
C
C   FOSF, 2-D STARTING FLOW
    7 IT=0
      IFLG3=0
      GOTO 5
C
C   SOSE, CP #792 CONE FLOW
    1 IT=1
      IFLG3=1
      GOTO 5
C
C   SOSE, JONES CONE FLOW
    2 IT=2
      IFLG3=1
      GOTO 5
C
C   FOSE, CP #792 CONE STARTING FLOW
    3 IT=1
      IFLG3=0
      GOTO 5
C
C   FOSE, JONES CONE STARTING FLOW
    4 IT=2
      IFLG3=0
C
    5 CONTINUE
C
C
C   CALCULATE LOCAL SLOPES AND RUNNING LENGTHS
      IF (IFLG(1) .EQ. 1) GOTO 9
C
C   LINEAR SLOPES AT MIDPT
      S(1)=0.0
      DO 6 I=2,N
      DY=Y(I)-Y(I-1)
      DX=-X(I)+X(I-1)
      DS=SQRT(DX**2+DY**2)
      S(I)=S(I-1)+DS
    6 DEL(I)=DC*ATAN2(DY,DX)
      DEL(1)=DEL(2)
      GOTO 11
C
C   CIRCULAR ARC ROUTINE
C
    9 CALL CADA(N,X,Y,T,S,C)
C
C   CADA RETURNS SLOPE ANGLE (T), LENGTH (S), AND CURVATURE (C)
C   AT THE N POINTS -- SET DEL AND S AT MIDPOINTS.
C
      DEL(1)=-DC*T(1)+180.0
      DO 10 I=2,N
      DEL(I)=-DC*0.5*(T(I-1)+T(I))+180.0
   10 CONTINUE
C
C
   11 CONTINUE
      IF (IFLG(5) .NE. 1) GOTO 12
C
      WRITE (6,32)
   32 FORMAT (1x)
      IF (IFLG3 .EQ. 1) WRITE (6,33)
      IF (IFLG3 .EQ. 0) WRITE (6,34)
   33 FORMAT (1H ,29H SECOND-ORDER SHOCK-EXPANSION )
   34 FORMAT (1X,'FIRST-ORDER SHOCK-EXPANSION' )
      WRITE (6,51) AMF,ALPHA,PHI,AMP,ALFPD
   51 FORMAT( /'M=', F5.2, ',   ALFWD =', F6.2,
     1 ',   PHIT=', F6.2, ',   AMP=', F5.2, ',   ALFP=', F6.2 )
      WRITE (6,37)
   37 FORMAT( '        X           Y         DELTA          S'/ )
      WRITE (6,38) (X(I),Y(I),DEL(I),S(I),I=1,N)
   38 FORMAT( 4F12.6 )
C
C   STARTING SOLUTION
   12 CONTINUE
      I=2
      DELC=RC*DEL(I)
      DELO=-ALFP
      FSHKO=DELC-DELO
      IF (IT .NE. 0) GOTO 250
C
C   2-D STARTING FLOW
      ANGL(2)=DEL(I)+ALFPD
      FS(6)=AMP
      FS(2)=1.0
      FS(3)=1.0
      IFIRST=0
      IF (ANGL(2) .LE. 0.0) GOTO 200
C
      CALL COMPR(ANGL,MER,IPRINT,CPSTAG,ISDET,IFIRST,CP)
      GOTO 210
  200 ANGL(2)=-ANGL(2)
      CALL EXPAND(ANGL,MER,IPRINT,ISDET,CP)
C
  210 THETA=ANGL(3)-ALFPD
      THETA1=THETA*RC
      TANS=TAN(THETA1)
      AMANS(I)=BS(6)
      PSHK(J)=BS(2)
      PC=BS(2)
      DPSK=0.0
      TD(I)=BS(3)
      TS(J)=BS(3)
      COSL=AMP/AME
      ALAM=acos(COSL)
      WOVS=SIN(ALAM)
      WOVB=WOVS
      VM=AMANS(I)*SQRT(TD(I))/AME
      VSURF=SQRT(VM**2+WOVB**2)
      AMDX(I)=-VM*COS(DELC)/VSURF
      AMDY(I)=VM*SIN(DELC)/VSURF
      AMDZ(I)=WOVB/VSURF
      AMSX(J)=AMDX(I)
      AMSY(J)=AMDY(I)
      AMSZ(J)=AMDZ(I)
      AMS(J)=AMANS(I)
      T(J)=THETA
      GOTO 300
C
C   CONICAL STARTING FLOW
  250 CONTINUE
      CALL CONEA(DELC,AME,G,ALF,PHIT,ALFP,AMP,THETA1,AMANS(I),PC,IT)
      SWS=SIN(THETA1+ALFP)
      MNS=(AMP*SWS)**2
      PSHK(J)=(2.*G*MNS-GM1)/GP1
      DPSK=PC-PSHK(J)
      TANS=TAN(THETA1)
      THETA=DC*THETA1
C
C   CALCULATE FLOW PROPERTIES BEHIND THE SHOCK
C   TEMPERATURE RATIO
      TS(J)=PSHK(J)*(GM1*PSHK(J)+GP1)/(GP1*PSHK(J)+GM1)
C   SPEED OF SOUND RATIO
      ASJ=SQRT(TS(J))
C   VELOCITY COMPONENTS
      U2=1.0-2.*(MNS-1.0)/(GP1*AMP2)
      V2=2.*(MNS-1.0)/(GP1*MNS)*SWS*COS(THETA1+ALFP)
      DEL2=ATAN2(V2,U2)
      VT2=SQRT(U2**2+V2**2)
      UD=VT2*COS(DEL2+ALFP)
      VD=VT2*SIN(DEL2+ALFP)
      DNS=1./SQRT(0.5*GP1+1./MNS)
      ETA=(1.-0.25*GP1*DNS*(1.+DNS))/(1.+0.25*GP1*(1.-DNS))
      WOVS=(1.-ETA)*ALF*SIN(PHIT)*(1.-ETA*COS(PHIT)/TANS)
      WOVB=WOVS
      IF (DELC .LE. 0.0) GOTO 54
      WOVB=WOVS*SWS/SIN(DELC)
   54 CONTINUE
      WD=WOVS
      VT=SQRT(UD**2+VD**2+WD**2)
      AMS(J)=VT*AME/ASJ
      AMSX(J)=-UD/VT
      AMSY(J)=VD/VT
      AMSZ(J)=WD/VT
      T(J)=THETA
C
C   CALCULATE SURFACE PROPERTIES
      TD(I)=(1.+0.5*GM1*AME**2)/(1.+0.5*GM1*AMANS(I)**2)
      ASJ=SQRT(TD(I))
      VSURF=AMANS(I)*ASJ/AME
      WD=WOVB
      VM=SQRT(VSURF**2-WD**2)
      UD=VM*COS(DELC)
      VD=VM*SIN(DELC)
      AMDX(I)=-UD/VSURF
      AMDY(I)=VD/VSURF
      AMDZ(I)=WD/VSURF
C
  300 CONTINUE
      XANS(I)=0.5*(X(I)+X(I-1))
      YANS(I)=0.5*(Y(I)+Y(I-1))
      PANS(I)=PC
      CP=(PANS(I)-1.)/(AMF**2*0.7)
      AMU=asin(1.0/AMANS(I))+DEL(I)*RC
      XANS(1)=X(1)
      YANS(1)=Y(1)
      PANS(1)=PANS(2)
      AMANS(1)=AMANS(2)
      AMDX(1)=AMDX(2)
      AMDY(1)=AMDY(2)
      AMDZ(1)=AMDZ(2)
      TD(1)=TD(2)
C
C   SHOCK POSITION
      J=2
      XS(J)=XS(J-1)
      YS(J)=YS(J-1)
      IF (IFLG(4) .EQ. 0) GOTO 55
      TANM=TAN(AMU)
      XS(J)=(-Y(I)+Y(I-1)+X(I-1)*TANS-X(I)*TANM)/(TANS-TANM)
      YS(J)=Y(I-1)-(XS(J)-X(I-1))*TANS
      PSHK(J)=PSHK(J-1)
      TS(J)=TS(J-1)
      AMS(J)=AMS(J-1)
      AMSX(J)=AMSX(J-1)
      AMSY(J)=AMSY(J-1)
      AMSZ(J)=AMSZ(J-1)
      NSP=NSP+1
   55 CONTINUE
      AMA=AMANS(I)
      ANGLE=DC*AMU
      DPDSA=0.
      PA=PC
C
      IF (IFLG(5) .NE. 1) GOTO 60
      WRITE (6,36) AMANS(I),THETA,DPSK
   36 FORMAT( /5X,20HSTARTING FLOW -  M =,F7.4,
     1   5X,7HTHETA =,F7.3,5X,6HDPSK =,F7.4 )
      WRITE (6,39)
   39 FORMAT (/1x,26HINVISCID SOLUTION, SURFACE,//
     1 '     X     P/P(INF)    M        CP       PB     ',
     2 ' ETA     ANGLE     CPLIM   PC' )
      ETA=0.0
      WRITE (6,40) XANS(I),PANS(I),AMANS(I),CP,PANS(I),ETA,ANGLE,CP,PC
   40 FORMAT( 8f9.4, f6.2 )
C
C
C   BEGIN MAJOR LOOP
   60 CONTINUE
      DO 25 I=3,N
      D1=RC*DEL(I-1)
      D2=DEL(I)*RC
      ANG=D2-D1
      DELC=D2
      IF (IFLG3 .EQ. 0) GOTO 8
      CALL CONEA(DELC,AME,G,ALF,PHIT,ALFP,AMP,THETA1,AMC,PC,IT)
    8 ANUA=2.4495*ATAN(.40825*SQRT(AMA**2-1.))-ATAN(SQRT(AMA**2-1.))
      ANUB=ANUA-ANG
      IF (ANUB .GE. ANUA) GOTO 14
C
C   IF COMPRESSION ANGLE .LE. 1.0 DEGREE, USE ISENTROPIC EQUATIONS
C   AND NO SECONDARY SHOCK FORMATION.
      IF (ANG .LE. 0.0175) GOTO 14
C
C   CALCULATION FOR COMPRESSION AND SHOCK FORMATION
C   SET FLAG FOR SECONDARY SHOCK FORMATION
      JSS=1
      IF (IFLG(4) .NE. 0) IFLG4=1
C
      ANGL(2)=ANG*DC
      FS(6)=AMA
      FS(2)=PA
      IFIRST=0
      CALL COMPR(ANGL,MER,IPRINT,CPSTAG,ISDET,IFIRST,CP)
      SKANG=ANGL(3)*RC
      AMB=BS(6)
      PB=BS(2)
      AMUB=SIN(1./AMB)
      IF (IFLG3 .EQ. 0) GOTO 15
C
C   NOTE. REFERENCE NASA TR-1328 USED ANGLES SIGMA, D1, AND D2
C         ALL W.R.T. BODY AXES. HOWEVER THEY APPEAR ONLY AS
C         DIFFERENCES (D2-D1), (SIGMA-D1), AND (SIGMA-D2).
C         IN THE PRESENT NOTATION THESE ARE DEFINED AS
C
C                  ANG = D2 - D1
C
C                SKANG = SIGMA - D1
C
C          SKANG - ANG = SIGMA - D2
C
      TD21=TAN(ANG)
      CSD1=COS(SKANG)
      SSD1=SIN(SKANG)
      SSD2=SIN(SKANG-ANG)
      TANM=TAN(AMUB)
      XX=2.4*(TD21*CSD1-SSD1)*(AMA*SSD1)**2+SSD1
C
      YY=1.0+(1.-2.*SSD1**2+2.*TD21*SSD1*CSD1)*(AMA*SSD1)**2
C
      F=(1.+0.2*AMA**2)*SSD1*XX/(0.6*YY)
      BA=1.4*PA*AMA**2/(2.*(AMA**2-1.))
      BB=1.4*PB*AMB**2/(2.*(AMB**2-1.))
      XY=2.*BB/(Y(I-1))*(SSD1*SIN(D1)/SSD2-SIN(D2))+
     1   DPDSA*(BB*SSD1/(BA*SSD2)+(PB/PA-F)*CSD1*TANM/SSD2)
C
      DPDS=XY/(1.+TANM/TAN(SKANG-ANG))
   15 DELO=D1
      FSHKO=ANG
      THETA1=SKANG+D1
      GOTO 21
C
C
C   PRANDTL-MEYER EXPANSION (OR COMPRESSION)
   14 CONTINUE
      ANGL(2)=-(ANG)*DC
      FS(6)=AMA
      CALL EXPAND(ANGL,MER,IPRINT,ISDET,CP)
      AMB=BS(6)
      PB=PA*(CP*0.5*G*AMA**2+1.0)
C
      IF (PB .LT. PMIN) PB=PMIN
      IF (IFLG3 .EQ. 0) GOTO 27
      OMEG12=AMB/AMA*((1.+0.5*GM1*AMA**2)/(1.+0.5*GM1*AMB**2))**
     1       (0.5*GP1/GM1)
      BA=0.5*G*PA*AMA**2/(AMA**2-1.0)
      BB=0.5*G*PB*AMB**2/(AMB**2-1.0)
      DPDS=BB/Y(I-1)*(OMEG12*SIN(D1)-SIN(D2))+
     1     BB/BA*OMEG12*DPDSA
C
   21 IF (IFLG3 .EQ. 0) GOTO 27
      IF (PC .EQ. PB) GOTO 22
      ETA=DPDS*(S(I)-S(I-1))/(PC-PB)
      IF (ETA .GT. 180.) ETA=180.
      IF (ETA) 22,22,23
C
C   FIRST ORDER SHOCK EXPANSION (2-D)
   22 IF (IFLG(5) .EQ. 1)  WRITE (6,34)
   27 PANS(I)=PB
      AMANS(I)=AMB
      AMA=AMB
      PA=PB
      IF (IFLG3 .EQ. 0) PC=PB
      XANS(I)=(X(I)+X(I-1))/2.
      YANS(I)=(Y(I)+Y(I-1))/2.
      DPDSA=0.
      GOTO 24
C
C   SECOND ORDER SHOCK EXPANSION
   23 PA=PC-(PC-PB)*EXP(-ETA)
      AMA=SQRT(2./GM1*((1.+.5*GM1*AMB**2)*(PB/PA)**(GM1/G)-1.0))
      XANS(I)=(X(I)+X(I-1))*0.5
      YANS(I)=(Y(I)+Y(I-1))*0.5
      ETANS=ETA*0.5
      PANS(I)=PC-(PC-PB)*EXP(-ETANS)
      AMANS(I)=SQRT(2./GM1*((1.+.5*GM1*AMB**2)*(PB/PANS(I))**
     1         (GM1/G)-1.0))
      DPDSA=(PC-PA)/(PC-PB)*DPDS
   24 CP=2.*(PANS(I)-1.0)/(G*AMF**2)
C
C   CALCULATE SURFACE PROPERTIES
      TD(I)=(1.+0.5*GM1*AME**2)/(1.+.5*GM1*AMANS(I)**2)
      ASJ=SQRT(TD(I))
      VSURF=AMANS(I)*ASJ/AME
      WD=WOVB
      VM=SQRT(VSURF**2-WD**2)
      UD=VM*COS(D2)
      VD=VM*SIN(D2)
      AMDX(I)=-UD/VSURF
      AMDY(I)=VD/VSURF
      AMDZ(I)=WD/VSURF
C
C   SHOCK CALCULATION
      AMU=asin(1.0/AMA)+D2
      ANGLE=DC*AMU
      CPCONE=(PC-1.)/(0.7*AMF**2)
      IF (JSS .NE. 1) GOTO 70
C
C   SECONDARY SHOCK FORMATION
C   SET COUNTER (LSP) AND POSITION FOR LAST SHOCK POINT
      JSS=0
      LS(NS)=NSP
      LSP=NSP-1
C   SET COUNTER JS FOR START OF NEW SHOCK
C   AND SET POSITION EQUAL TO BODY LOCATION
      NS=NS+1
      J=J+3
      IS(NS)=I
      JS(NS)=J
      XS(J)=X(I-1)
      YS(J)=Y(I-1)
C   SET PROPERTIES EQUAL TO 2-D VALUES (FIRST POINT OF EMBEDDED SHOCK).
      PSHK(J)=PB
      MNS=(GP1*PSHK(J)+GM1)/(2.*G)
      TS(J)=PSHK(J)*(GM1*PSHK(J)+GP1)/(GP1*PSHK(J)+GM1)
      ASJ=SQRT(TS(J))
      UD=COS(D2)
      VD=SIN(D2)
      WD=WOVB
      VT=SQRT(UD**2+VD**2+WD**2)
      AMS(J)=VT*AME/ASJ
      AMSX(J)=-UD/VT
      AMSY(J)=VD/VT
      AMSZ(J)=WD/VT
      T(J)=THETA1*DC
      J=J+1
      NSP=NSP+3
      JSJ=I
C
C   SET UP SECOND POINT OF EMBEDDED SHOCK
      PSHK(J)=PSHK(J-1)
      AMS(J)=AMS(J-1)
      AMSX(J)=AMSX(J-1)
      AMSY(J)=AMSY(J-1)
      AMSZ(J)=AMSZ(J-1)
      THETA=THETA1
      DPSK=0.0
      SWS=SIN(THETA1+ALFP)
      GOTO 72
C
C
   70 IF (IFLG4 .EQ. 0) GOTO 80
      J=J+1
      FSHK=1.0
      FSHKI=D2-DELO
      IF (FSHKO .GT. 0) FSHK=FSHKI/FSHKO
      PSHK(J)=PANS(I)-DPSK*FSHK
      IF (PSHK(J) .LT. 1.0) PSHK(J)=1.0
C   CALCULATE FLOW PROPERTIES BEHIND THE SHOCK
      MNS=(GP1*PSHK(J)+GM1)/(2.*G)
      THETA=asin(SQRT(MNS/AMP2))-ALFP
      TS(J)=PSHK(J)*(GM1*PSHK(J)+GP1)/(GP1*PSHK(J)+GM1)
      ASJ=SQRT(TS(J))
      SWS=SIN(THETA)
      U2=1.0-2.*(MNS-1.0)/(GP1*AMP2)
      V2=2.*(MNS-1.0)/(GP1*MNS)*SWS*COS(THETA)
      DEL2=ATAN2(V2,U2)
      VT2=SQRT(U2**2+V2**2)
      UD=VT2*COS(DEL2+ALFP)
      VD=VT2*SIN(DEL2+ALFP)
      WD=WOVS
      VT=SQRT(UD**2+VD**2+WD**2)
      AMS(J)=VT*AME/ASJ
      AMSX(J)=-UD/VT
      AMSY(J)=VD/VT
      AMSZ(J)=WD/VT
      T(J-1)=THETA*DC
C
   72 CONTINUE
      IF (THETA .LT. AMU) GOTO 73
      J=J-1
      IFLG4=0
      GOTO 80
   73 CONTINUE
      TANM=TAN(AMU)
      TANS=TAN(THETA)
      XS(J)=(-Y(I)+YS(J-1)+XS(J-1)*TANS-X(I)*TANM)/(TANS-TANM)
      YS(J)=YS(J-1)-(XS(J)-XS(J-1))*TANS
      NSP=NSP+1
      IF (XS(J) .GT. XSMAX) GOTO 74
C   HAVE REACHED LIMIT FOR SHOCK. TURN OFF FLAG 4
      IFLG4=0
   74 CONTINUE
      IF (JSS .NE. 2) GOTO 80
C
C   TWO SHOCKS, CHECK FOR INTERSECTION
      L=LSP
   76 CONTINUE
      IF (XS(J) .LT. XS(L)) GOTO 77
      L=L-1
      GOTO 76
C
   77 IF (YS(J) .LT. YS(L)) GOTO 80
C
C   INTERSECTION EXISTS. DETERMINE SECOND POINT ON
C   FIRST SHOCK TO BE USED IN CALCULATION.
      L1=L
      L2=L+1
      IF (XS(J-1) .LT. XS(L)) GOTO 78
      L1=L-1
      L2=L
   78 CONTINUE
C
      TANM=TANS
      TANS=(YS(L2)-YS(L1))/(XS(L2)-XS(L1))
      IF (TANS .GE. TANM) GOTO 75
C
C
      XSI=(-YS(J)+YS(J-1)+XS(L1)*TANS-XS(J)*TANM)/(TANS-TANM)
C
C   SET LAST SHOCK POINT COUNTER AND RESET COORDS.
      LS(NS-1)=L2
      XS(L2)=XSI
      YS(L2)=YS(L1)-(XSI-XS(L1))*TANS
      IN(NS-1)=J-1
C
   75 JSS=0
   80 CONTINUE
C
      IF (IFLG(5) .EQ. 1)
     1 WRITE(6,40) XANS(I),PANS(I),AMANS(I),CP,PB,ETA,ANGLE,CPCONE,PC
   25 CONTINUE
C
      LS(NS)=NSP
C
C   WRITE OUT SHOCK DATA
C
      DO 110 I=1,NS
      IF (IFLG(5) .NE. 1) GOTO 89
      WRITE (6,90) I
   90 FORMAT( /1x,30HINVISCID SOLUTION, SHOCK WAVE ,I3,//1H ,
     1    12X,2HXS,12X,2HYS,11X,5HP2/P1,10X,2HM2,10X,5HTHETA,/ )
   89 CONTINUE
      J1=JS(I)
      J2=LS(I)
C
C   CHECK IF AT LEAST THREE SHOCK POINTS
      IF ((J2-J1)-1) 91,92,93
C
C   ONLY ONE SHOCK POINT. ADD ONE AT XSMAX
   91 J2=J1+1
      XS(J2)=XSMAX
      YS(J2)=YS(J1)+(XS(J1)-XS(J2))*TAN(RC*T(J1))
      T(J2)=T(J1)
      AMS(J2)=AMS(J1)
      AMSX(J2)=AMSX(J1)
      AMSY(J2)=AMSY(J1)
      AMSZ(J2)=AMSZ(J1)
      PSHK(J2)=PSHK(J1)
      TS(J2)=TS(J1)
C
C   ONLY TWO SHOCK POINTS. ADD ONE AT MIDPOINT
   92 J3=J1+2
      XS(J3)=XS(J2)
      YS(J3)=YS(J2)
      T(J3)=T(J2)
      AMS(J3)=AMS(J2)
      AMSX(J3)=AMSX(J2)
      AMSY(J3)=AMSY(J2)
      AMSZ(J3)=AMSZ(J2)
      PSHK(J3)=PSHK(J2)
      TS(J3)=TS(J2)
C
      XS(J2)=0.5*(XS(J3)+XS(J1))
      YS(J2)=0.5*(YS(J3)+YS(J1))
      T(J2)=0.5*(T(J3)+T(J1))
      AMS(J2)=0.5*(AMS(J3)+AMS(J1))
      AMSX(J2)=0.5*(AMSX(J3)+AMSX(J1))
      AMSY(J2)=0.5*(AMSY(J3)+AMSY(J1))
      AMSZ(J2)=0.5*(AMSZ(J3)+AMSZ(J1))
      PSHK(J2)=0.5*(PSHK(J3)+PSHK(J1))
      TS(J2)=0.5*(TS(J3)+TS(J1))
C
      LS(I)=J3
C
C
   93 J2=LS(I)
      IF (IFLG(5) .NE. 1) GOTO 110
      DO 100 J=J1,J2
      WRITE (6,95) XS(J),YS(J),PSHK(J),AMS(J),T(J)
   95 FORMAT (1H ,3X,3X,F10.4,4(5X,F9.4))
  100 CONTINUE
  110 CONTINUE
      RETURN
       END
      SUBROUTINE SPEC
C
      COMMON /EXEC/ CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      DIMENSION TITLE(15),IPG(20)
C   READ SUB-OPTION CONTROL CARD
      READ (TAPEIN,10) IPG
   10 FORMAT( //// 20I3 )
*   10 FORMAT(20I1)
C
      DO 80 I=1,20
      IPROG=IPG(I)
      IF (IPROG .EQ. 0) GOTO 90
      GOTO (30,40), IPROG
C
C   FORCE DATA SUMMATION OPTION
   30 CALL SUM
      GOTO 80
C
C   TRIM OPTION (TO BE ADDED LATER)
   40 CONTINUE
C
   80 CONTINUE
C
   90 RETURN
      END
      SUBROUTINE STATS3
C
C ** THIS ROUTINE PREPARES A DUMMY, ZERO-AREA ELEMENT TO PROVIDE
C    THE FINAL STATUS FLAG OF 3
C
C
      COMMON /ACFT/ IPRINT,ITAPE,ITYPE,PI,DX,CASE
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER CASE
C
C
      WRITE (ITAPE,10)
   10 FORMAT (51H    0.0       0.0       0.0   2    0.0       0.0   ,
     1 29H    0.00010         3        )
      WRITE (ITAPE,20)
   20 FORMAT (51H   -0.0001    0.0       0.0   1   -0.0001    0.0   ,
     1 29H    0.00013         3        )
      IF (IPRINT .EQ. 1) WRITE (TAPEOT,30)
      IF (IPRINT .EQ. 1) WRITE (TAPEOT,40)
   30 FORMAT(52H     0.0       0.0       0.0   2    0.0       0.0   ,
     1 29H    0.00010         3        )
   40 FORMAT(52H    -0.0001    0.0       0.0   1   -0.0001    0.0   ,
     1 29H    0.00013         3        )
C
      RETURN
      END
      SUBROUTINE SUM
C
C   THIS OPTION IS USED TO SUM UP SELECTED FORCE DATA SETS. IT ALSO
C   MAY BE USED TO PUNCH SELECTED SETS OF FORCE DATA.
C
      COMMON /EXEC/ CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /FLIGHT/ MACH,ALT,PSTAG,TSTAG,V,RENO,PFS,TFS,AFS,RHOFS,VIS
      COMMON /GASD/ GAM,GASCP,PRAN,IGAS,AV1,AV2,AV3,GTYPE(2)
      COMMON /REF/ SREF,MAC,SPAN,XCG,YCG,ZCG
C
      DIMENSION E1(8),E2(11),E4(41),F(11),FF(11),E5(41),E6(41),
     1            IPAN9(10,20),LSUM(41),LCOM(41),E7(11),ICOMP(20),
!    1  IPANL(10),IPAN9(10,20),LSUM(41),LCOM(41),E7(11),ICOMP(20),
     2  E8(14)
      DIMENSION TITLE(15)
C
      INTEGER CASE,PAGE,ERROR
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      Real*8 MACH,MAC
*     Integer TITLE9, TITLE
      DATA TITLE9/4HFORC/
*     DATA TITLE9/10HFORCE DATA/
      DATA BLANK/4H    /
C
      DO 5 I=1,15
    5 TITLE(I)=BLANK
      CASE=0
C
C   READ MASTER TABLE OF CONTENTS FOR UNIT 9
      IG9=1
      READ( 9, REC=IG9 )  E1
*      CALL READMS(9,E1,8,IG9)
C   NUMBER OF COMPONENTS ON UNIT
      NTOT=E1(1)
C   NUMBER OF SUMMATIONS ON UNIT
      NSUM=E1(2)
C   NEXT EMPTY RECORD
      NEXT=E1(3)
C   CHECK IF UNIT HAS VALID DATA
      IF (E1(4) .EQ. TITLE9) GOTO 20
      WRITE (TAPEOT,10)
   10 FORMAT(1H ,47H***UNIT 9 CALLED BY ROUTINE SUM HAS NEVER BEEN ,
     1  27HINITIALIZED.  PROGRAM STOP.   )
      STOP
C
   20 CONTINUE
C
      IG9=4
      READ( 9, REC=IG9 )  E8
*      CALL READMS(9,E8,14,IG9)
      MACH=E8(1)
      V=E8(2)
      RENO=E8(3)
      ALT=E8(4)
      PSTAG=E8(5)
      TSTAG=E8(6)
      GTYPE(1)=E8(7)
      GTYPE(2)=E8(8)
      SREF=E8(9)
      SPAN=E8(10)
      MAC=E8(11)
      XCG=E8(12)
      YCG=E8(13)
      ZCG=E8(14)
C
C   POINTERS TO FORCE DATA
      IG9=2
      READ( 9, REC=IG9 )  E5
*      CALL READMS(9,E5,41,IG9)
      DO 30 I=2,41
   30 LCOM(I-1)=E5(I)
      IFTYPE=E5(1)
C
      IG9=3
      READ( 9, REC=IG9 )  E6
*      CALL READMS(9,E6,41,IG9)
      DO 40 I=2,41
   40 LSUM(I-1)=E6(I)
      ISTYPE=E6(1)
      DO 41 I=1,11
   41 E7(I)=0.0
C
C
C   READ SUMMATION CONTROL CARD
C      ISUM = 0 (DO NOT SUM)
C             1 (SUM COMPONENTS)
C    IPUNCH = 0 (DO NOT PUNCH)
C             1 (PUNCH SUMMATIONS ONLY)
C             2 (PUNCH COMPONENTS PLUS SUMMATIONS)
C    IPRINT = 0 (DO NOT PRINT COMPONENTS, ONLY PRINT FINAL SUMMATION)
C             1 (PRINT COMPONENTS PLUS SUMMATIONS)
   50 READ (TAPEIN,55) LAST,ISUM,ISAVE,IPRINT,IPUNCH,IRUN,ICOMP
   55 FORMAT( //// 6I7 // 20I3 )
*   55 FORMAT(5I1,I4,20I2)
C
      IF (ISUM .GT. 0) NSUM=NSUM+1
      IF (ISUM .GT. 0) LSUM(NSUM)=NEXT
      NEXTS=NEXT
      NSUMS=NSUM
      NEXT=NEXT+2
C
C   OBTAIN ALPHA-BETA ARRAY FOR FIRST COMPONENT TO BE READ
      L=ICOMP(1)
      IG9=LCOM(L)+1
      READ( 9, REC=IG9 )  E4
*      CALL READMS(9,E4,41,IG9)
      NAB=E4(1)
C
C   DO LOOP FOR COMPONENTS SELECTED
      K=0
   58 K=K+1
C   COMPONENT NUMBER
      L=ICOMP(K)
      IF (L .EQ. 0) GOTO 155
      NCT=K
      IG9=LCOM(L)
      READ( 9, REC=IG9 )  E2
*      CALL READMS(9,E2,11,IG9)
      LL=E2(1)
      IF (LL .EQ. L) GOTO 100
      WRITE (TAPEOT,60)
   60 FORMAT(1H ,45H***COMPONENT NUMBER REQUESTED DOES NOT MATCH ,
     1      47HNUMBER ON UNIT 9 IN ROUTINE SUM. PROGRAM STOP.  )
      STOP
C   RECALL PANEL NUMBERS
  100 DO 110 I=1,10
      IPAN9(I,K)=E2(I+1)
  110 CONTINUE
C
C   PRINT  OR  PUNCH COMPONENTS AS REQUIRED
      IPR=0
      IF (IPRINT.EQ.0 .AND. IPUNCH.NE.2) GOTO 150
      IF (IPUNCH .EQ. 2) WRITE(TAPEG,121) L
  121 FORMAT(26HCOMPONENT DATA SET NUMBER ,I3)
      IF (IPRINT .EQ. 1) GOTO 195
  122 DO 124 I=1,NAB
      IG9=LCOM(L)+I*2
      READ( 9, REC=IG9 )  F
*      CALL READMS(9,F,11,IG9)
      IF (IPRINT .EQ. 1) WRITE(TAPEOT,290) F
      IF (IPUNCH .EQ. 2) WRITE(TAPEG,123) F(1),F(6),F(4),F(9),F(5),
     1                   F(11),F(10),F(7),IRUN
  123 FORMAT(7F9.4,F7.2,1X,I4)
  124 CONTINUE
      IF (IPUNCH .EQ. 2) WRITE(TAPEOT,125)
  125 FORMAT(1H ,5X,33HCOMPONENT DATA HAVE BEEN PUNCHED.  )
  150 IF (K .LT. 20) GOTO 58
  155 CONTINUE
      IPR=1
      IF (ISUM .EQ. 0) GOTO 440
C
C
C   DO LOOP FOR ALL ALPHA-BETA VALUES
      DO 190 J=1,NAB
C   ZERO OUT FORCE ARRAY
      DO 160 I=1,11
  160 F(I)=0.0
C
      DO 180 K=1,NCT
      L=ICOMP(K)
      IG9=LCOM(L)+J*2
      READ( 9, REC=IG9 )  FF
*      CALL READMS(9,FF,11,IG9)
      DO 170 I=2,11
      F(I)=F(I)+FF(I)
  170 CONTINUE
  180 CONTINUE
C
      IF (F(2) .EQ. 0.0) F(2)=0.000001
      F(8)=F(3)/F(2)
      F(1)=FF(1)
      F(7)=FF(7)
C
      WRITE( 9, REC=NEXT )  F
*      CALL WRITMS(9,F,11,NEXT)
      NEXT=NEXT+1
      WRITE( 9, REC=NEXT )  E7
*      CALL WRITMS(9,E7,11,NEXT)
      NEXT=NEXT+1
  190 CONTINUE
C
C
C
C *** OUTPUT DATA ***
C   WRITE HEADER INFORMATION FOR FORCE OUTPUT PAGE
  195 CALL HEADER
      IF (IPR .EQ. 0) WRITE(TAPEOT,198) L
  198 FORMAT(1H ,26HCOMPONENT DATA SET NUMBER ,I3)
      IF (IPR .NE. 1) GOTO 204
      WRITE(TAPEOT,200) NSUM
  200 FORMAT(1H ,26HSUMMATION DATA SET NUMBER ,I3)
      DO 202 I=1,NCT
      WRITE(TAPEOT,203) (IPAN9(II,I),II=1,10)
  202 CONTINUE
  203 FORMAT(1H ,5X,10I4)
  204 WRITE(TAPEOT,230) MACH,V,RENO
  230 FORMAT(1H ,7H  MACH=,F8.3,6H  VEL=,F9.1,16H FT/SEC  RE/FT =,
     1 E13.5)
      IF (PSTAG .LT. 0.000001) WRITE(6,240) ALT
  240 FORMAT(1H ,7H  ALT =,F8.0)
      IF (PSTAG .GT. 0.000001) WRITE(TAPEOT,250) PSTAG,TSTAG
  250 FORMAT(1H ,16X,7HP STAG=,F7.1,16H ATMOS   T STAG=,F7.1,6H DEG F)
      WRITE(TAPEOT,260) GTYPE
  260 FORMAT(1H ,2X,2A4)
      WRITE(TAPEOT,270) SREF,SPAN,MAC,XCG,YCG,ZCG
  270 FORMAT(1H ,9H  S REF =,F9.2,8H  SPAN =,F8.2,8H  MAC  =,F8.2,
     1 /1H ,9H  X CG  =,F9.2,8H  Y CG =,F8.2,8H  Z CG =,F8.2)
      WRITE(TAPEOT,280)
  280 FORMAT(1H ,10HFORCE DATA,/1H ,7H  ALPHA,4X,3HC D,7X,3HC L,7X,
     1 3HC A,7X,3HC Y,7X,3HC N,/1H ,7H  BETA ,4X,3HL/D,7X,3HC M,7X,
     2 4HC LL,6X,4HC LN)
      IF (IPR .EQ. 0) GOTO 122
      IF (IPUNCH .NE. 0) WRITE(TAPEG,285) NSUM
  285 FORMAT(27HSUMMATION COMPONENT NUMBER ,I3)
C
C   RETRIEVE OUTPUT DATA FROM UNIT 9 AND PRINT
      DO 300 I=1,NAB
      IG9=LSUM(NSUM)+I*2
      READ( 9, REC=IG9 )  F
*      CALL READMS(9,F,11,IG9)
C   WRITE OUTPUT FORCE DATA
      WRITE(TAPEOT,290) F
  290 FORMAT(1H ,F7.2,5F10.5,/1H ,F7.2,4F10.5)
C     if( f(6) .ne. 0.0 ) then
C        cd = - f(9) / f(6)
C     else
C        cd = 0.0
C     endif
C     WRITE(TAPEOT,290)  ( F(j), j=1,6 ), cd, ( F(j), j=7,11 )
C 290 FORMAT(1H ,F7.2, 5F10.5, f8.3, F7.2, 4F10.5 )
      IF (IPUNCH .NE. 0) WRITE(TAPEG,123) F(1),F(6),F(4),F(9),F(5),
     1                   F(11),F(10),F(7),IRUN
  300 CONTINUE
      IF (IPUNCH .NE. 0) WRITE(TAPEOT,302)
  302 FORMAT(1H ,5X,25HTHESE DATA WHERE PUNCHED.  )
C *** OUTPUT DATA COMPLETED FOR THIS COMPONENT ***
C
      IF (ISAVE .NE. 0) NEXT=NEXTS
      IF (ISAVE .NE. 0) NSUM=NSUMS
C
C   SAVE COMPONENT INFORMATION IN TABLE OF CONTENTS
      IF (ISAVE .NE. 0) GOTO 440
      DO 191 I=2,11
  191 E2(I)=ICOMP(I-1)
      E2(1)=NSUM
      IG9=LSUM(NSUM)
      WRITE( 9, REC=IG9 )  E2
*      CALL WRITMS(9,E2,11,IG9)
      IG9=IG9+1
      WRITE( 9, REC=IG9 )  E4
*      CALL WRITMS(9,E4,41,IG9)
C
C   UPDATE MAIN TABLE OF CONTENTS
      E1(1)=NTOT
      E1(2)=NSUM
      E1(3)=NEXT
      IG9=1
      WRITE( 9, REC=IG9 )  E1
*      CALL WRITMS(9,E1,8,IG9)
      DO 310 I=2,41
  310 E6(I)=LSUM(I-1)
      E6(1)=0.0
      IG9=3
      WRITE( 9, REC=IG9 )  E6
*      CALL WRITMS(9,E6,41,IG9)
C
C
      WRITE(TAPEOT,430) NSUM
  430 FORMAT(1H ,10X,37HDATA SAVED ON UNIT 9.  SUMMATION SET ,
     1 8HNUMBER =,I4)
C
C
C   CHECK IF LAST CASE HAS BEEN COMPLETED
  440 IF (LAST .EQ. 0) GOTO 50
C
      RETURN
      END
      SUBROUTINE SURF
C
C *** THIS SUBROUTINE DEFINES A GENERAL AIRFOIL SURFASE
C     IN THE BODY-AXIS COORDINATE SYSTEM. THE SURFACE IS
C     GENERATED ACCORDING TO THE NUMBER OF AIRFOIL SECTIONS, NAF,
C     THE ORIENTATION OF THE CHORD LINE (YAW-PITCH-ROLL SEQUENCE),
C     THE MEAN LINE DISTRIBUTION, AND THE THICKNESS DISTRIBUTION,
C     THE SECTION COORDINATES MAY DEFINED AS AN NASA TYPE
C     (THICKNESS DISTRIBUTION NORMAL TO MEAN LINE) OR AS A
C     SHEARD TYPE (THICKNESS NORMAL TO THE CHORD LINE).
C
C     AN OPTION TO CALCULATE THE TIP-PLANE SURFACE OR THE ROOT-
C     PLANE SURFASE, OR BOTH, IS ALSO AVAILABLE.
C     ALL INPUT QUANTITIES ENTER THROUGH THE LABELED COMMON/ARFOIL/.
C
C     NAF     - THE NUMBER OF AIRFOIL SECTIONS
C     NAFORD  - THE NUMBER OF SECTION ORDINATES
C     NCAM    - =1, CAMBER DATA INPUT
C     NACA    - =1, NASA TYPE SECTION
C     XOC     - ARRAY OF CHORD STATIONS, PERCENT CHORD
C     AFORG   - ARRAY OF CHORD ORIGIN AND ORIENTATION DATA
C     AFCAM   - ARRAY OF CAMBER DISTRIBUTION, PERCENT CHORD
C     AFORD   - ARRAY OF THICKNESS DISTRIBUTION, PERCENT CHORD
C     SURFID  - SURFACE IDENTIFICATION (CC'S 73-76 ON OUTPUT CARDS)
C     ITIP    - =1, CALCULATE TIP SURFACE.
C     IROOT   - =1, CALCULATE ROOT SURFACE.
C ****
      DIMENSION XOC(30),AFORG(20,7),AFCAM(20,30),AFORD(20,30),
     1          X(2),Y(2),Z(2),CDELTA(30),SDELTA(30)
C
      COMMON /ACFT/ IPRINT,ITAPE,ITYPE,PI,DX,CASE
C
      COMMON /ARFOIL/ NAF,NAFORD,NCAM,NACA,ITIP,IROOT,
     1                XOC,AFORG,AFCAM,AFORD,SURFID,
     2                ISURF,IFLAP,NHNGE
      COMMON /TAPE/ TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1              TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
C
      INTEGER STAT1,STAT2
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      INTEGER CASE
C
C *** DESCRIPTION OF COUNTERS AND CONTROLS
C     I  IS THE AIRFOIL SECTION NUMBER
C        I=1   IS THE ROOT
C        I=NAF IS THE TIP
C     J  IS THE CHORDWISE STATION NUMBER
C        J=1      IS THE LEADING EDGE
C        J=NAFORD IS THE TRAILING EDGE
C     K  IS THE POINT COUNTER FOR TYPE 3 CARDS (TWO POINTS PER CARD),
C     IEND  IS CONTROL FLAG FOR TIP OR ROOT SURFACE
C     INEXT IS SECTION SEQUENCE INCREMENT
C        INEXT=+1 FOR UPPER SURFACE
C        INEXT=-1 FOR LOWER SURFACE
C     ISEQ  IS COUNTER FOR OUTPUT DATA (CC'S 77-80)
C
C
C *** THE SURFACE IS FIRST TESTED FOR POSSIBLE SYMMETRY
C     ABOUT THE X-Z ORIGIN PLANE. IF SO, THE SURFACE
C     SYMMETRY FLAG (ISYMM) IS STF TO +1 OR -1 AS PER SIGN OF PHI,
C     TO BE SYMMETRICAL THREE CONDITIONS MUST BE MET
C     1.  NO CAMBER DISTRIBUTION
C     2.  THE CHORD LINE IS IN THE X-Z ORIGIN PLANE
C     3.  THE ROOL ANGLE PHI IS + OR -90.0 DEGREES
C     THE TEST IS MADE ON BOTH THE ROOT AND TIP SECTIONS
C
      I=0
      ISEQ=0
      IEND=0
      ISYMM=0
      IHNGE=1000
      IF (ISURF .NE. 0) GOTO 230
      IF (NCAM .EQ. 1) GOTO 10
      IF (AFORG(1,2) .GT. 0.0001) GOTO 10
      IF (AFORG(NAF,2) .GT. 0.0001) GOTO 10
      IF (dcos(DBLE(AFORG(1,7))*PI/180.) .GT. 0.0001) GOTO 10
      IF (dcos(DBLE(AFORG(NAF,7))*PI/180.) .GT. 0.0001) GOTO 10
C
C ** SURFACE IS SYMMETRICAL ABOUT X-Z ORIGIN PLANE.
      ISYMM=-1
C ** CHECK IF PHI IS POSITIVE OR NEGATIVE.
      IF (AFORG(1,7) .LT. 0.0) GOTO 10
C
C ** POSITIVE VERTICAL, DO LOWER SURFACE FIRST.
      ISYMM=1
      I=NAF+1
      GOTO 200
C
C
   10 CONTINUE
      INEXT=1
      DZ=1.0
      DETA=1.0
C
   20 K=0
      STAT1=2
      STAT2=0
   30 I=I+INEXT
      JP=1
      IF (I .GT. NAF) GOTO 150
      IF (I .EQ. 0) GOTO 150
C
C *** CALCULATE CHORD LENGTH C AND AIRFOIL ORIENTATION,
C     SINE AND COSINE VALVES OF
C       YAW ANGLE   - SPSI,CPSI
C       PITCH ANGLE - STHETA,CTHETA
C       ROLL ANGLE  - SPHI,CPHI
C
      DXX=-(AFORG(I,4)-AFORG(I,1))*DX
      DYY=AFORG(I,2)-AFORG(I,5)
      DZZ=AFORG(I,6)-AFORG(I,3)
      DS1=DXX**2+DYY**2
      DS2=sqrt(DS1+DZZ**2)
      DS1=sqrt(DS1)
C
      SPSI=DYY/DS1
      CPSI=DXX/DS1
C
      STHETA=DZZ/DS2
      CTHETA=DS1/DS2
C
      SPHI=sin(AFORG(I,7)*PI/180.)
      CPHI=cos(AFORG(I,7)*PI/180.)
C
      C=0.01*DS2
C
C ** PRESET MEAN LINE SLOPES
      DO 40 J=1,NAFORD
      CDELTA(J)=1.0
   40 SDELTA(J)=0.0
C
C ** CHECK IF CAMBER DATA INPUT
      IF (NCAM .NE. 1) GOTO 70
C
      IF (NACA .NE. 2) GOTO 46
      IF (C .EQ. 0.0) GOTO 46
      CI=1.0/C
      DO 45 J=1,NAFORD
   45 AFCAM(I,J)=AFCAM(I,J)*CI
   46 CONTINUE
C
C ** CHECK AIRFOIL SECTION TYPE
      IF (NACA .NE. 1) GOTO 70
C
C *** NASA TYPE, THICKNESS NORMAL TO MEAN LINE.
C     MUST FIRST CALCULATE SLOPE ALONG MEAN LINE.
C     USE NEWTONIAN SINGLE QUADRATIC
C
      J1=0
      DO 60 IP=1,NAFORD
C
      IF (IP.EQ.2 .OR. IP.EQ.NAFORD) GOTO 50
C
      J1=J1+1
      J2=J1+1
      J3=J1+2
      X1=XOC(J1)
      X2=XOC(J2)
      X3=XOC(J3)
      Y1=AFCAM(I,J1)
      Y2=AFCAM(I,J2)
      Y3=AFCAM(I,J3)
C
   50 DYDX=(Y2-Y1)/(X2-X1)+(2.0*XOC(IP)-X2-X1)*
     1     ((Y3-Y2)/(X3-X2)-(Y2-Y1)/(X2-X1))/(X3-X1)
C
      CDELTA(IP)=1.0/sqrt(1.0+DYDX**2)
      SDELTA(IP)=DYDX*CDELTA(IP)
C
   60 CONTINUE
C
C
C ** BEGIN SURFACE CALCULATION
   70 J=0
      IF (K .EQ. 1) GOTO 90
   80 K=0
   90 J=J+1
      IF (J .LE. NAFORD) GOTO 100
C
C ** SET DUMMY POINT AND WRITE DATA.
      K=2
      X(K)=X(1)
      Y(K)=Y(1)
      Z(K)=Z(1)
      STAT2=STAT1
      GOTO (110,260), JP
C
C *** CALCULATE COORDINATES
  100 K=K+1
      XI=(XOC(J)-AFORD(I,J)*SDELTA(J)*DZ)*C
      ETA=(AFCAM(I,J)+DZ*AFORD(I,J)*CDELTA(J))*C
      X(K)=DX*AFORG(I,1)-XI*CTHETA*CPSI
     1     +DETA*ETA*(STHETA*CPSI*CPHI+SPSI*SPHI)
      Y(K)=AFORG(I,2)-XI*CTHETA*SPSI
     1     +DETA*ETA*(STHETA*SPSI*CPHI-CPSI*SPHI)
      Z(K)=AFORG(I,3)+XI*STHETA+DETA*ETA*CTHETA*CPHI
C
      IF (K .EQ. 1) GOTO 90
C
      GOTO (110,260), JP
C *** WRITE DATA
  110 ISEQ=ISEQ+1
      WRITE (ITAPE,120) X(1),Y(1),Z(1),STAT1,
     1   X(2),Y(2),Z(2),STAT2,CASE,SURFID,ITYPE,ISEQ
C
  120 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,1A4,1X,I2,4X,I4)
C
      IF (IPRINT .EQ. 1)
     1    WRITE (TAPEOT,130) X(1),Y(1),Z(1),STAT1,
     2                  X(2),Y(2),Z(2),STAT2,CASE,ITYPE,SURFID,ISEQ
C
  130 FORMAT (3F10.4,I1,3F10.4,I1,2X,I2,5X,I1,A4,I4)
C
C ** CHECK IF THIS IS TO HAVE A CONTROL SURFACE.
      IF (J .EQ.IHNGE) GOTO 250
C ** CHECK STATUS FLAG
      IF (STAT1 .GT. 0) STAT1=0
      IF (STAT2 .GT. 0) STAT2=0
C
C ** CHECK FOR PROPER CYCLING
      IF (J .LT. NAFORD) GOTO 80
C
C
C ** HAVE COMPLETED AIRFOIL SECTION, SET STATUS AND GO TO NEXT ONE.
  140 STAT1=1
      GOTO 30
C
C ** HAVE COMPLETED SURFACE, CHECK WHICH ONE.
  150 CONTINUE
      IF (NACA .EQ. 2) NACA=0
      IF (IFLAP .EQ. 1) GOTO 270
      IF (INEXT .LT. 0) GOTO 160
C
C ** JUST COMPLETED UPPER SURFACE.
      IF (IEND .EQ. 1) GOTO 190
      IF (ITIP .EQ. 1) GOTO 180
      IF (ISYMM .EQ. 0) GOTO 200
C
C ** JUST COMPLETED LOWER SURFACE.
  160 IF (IEND-1) 170,190,220
  170 IF (ITIP .EQ. 1) GOTO 180
      IF (IROOT .EQ. 1) GOTO 210
      RETURN
C
C
C
C ** TIP SURFACE
  180 STAT1=2
      STAT2=0
      IEND=1
      INEXT=+1
      I=NAF
      IF (ISYMM .NE. 1) GOTO 70
      DETA=0.0
      I=I-1
      GOTO 30
  190 DETA=1.0
      IF (ISYMM .EQ. -1) DETA=0.0
      IF (ISYMM .EQ. 0) DZ=-DZ
      ITIP=0
      IEND=0
      I=NAF
      J=0
      GOTO 80
C
C
C ** LOWER SURFACE.
  200 INEXT=-1
      DZ=-1.0
      DETA=1.0
      GOTO 20
C
C
C ** ROOT SURFACE.
  210 STAT1=2
      IEND=2
      INEXT=-1
      I=1
      DETA=1.0
      IF (ISYMM .EQ. 0) GOTO 70
      I=2
      IF (ISYMM .EQ. 1) GOTO 30
      DETA=0.0
      GOTO 30
  220 DETA=1.0
      IF (ISYMM .EQ. 1) DETA=0.0
      IF (ISYMM .EQ. 0) DZ=-DZ
      IROOT=0
      IEND=0
      I=1
      J=0
      GOTO 80
C
C
C
C
  230 ISYMM=-ISURF
C
C ** ONLY UPPER OR LOWER SURFACE, ZERO OUT TIP AND ROOT SECTIONS.
      ITIP=0
      IROOT=0
C
C ** CHECK IF THIS SURFACE TO HAVE A FLAP (OR CONTROL SURFACE).
      IF (ITIP .EQ. 0) GOTO 240
C
C ** CONTROL SURFACE. SET HINGE LINE LOCATION.
      IHNGE=NHNGE
      REWIND TAPEB
  240 IF (ISYMM .LT. 0) GOTO 10
      I=NAF+1
      GOTO 200
C
C
C
  250 J=J-1
      JP=2
      STAT1=1
      GOTO 80
C
C
  260 WRITE (TAPEB) X,Y,Z,STAT1,STAT2
      STAT1=0
      STAT2=0
      IF (J .LT. NAFORD) GOTO 80
C
C ** HAVE COMPLETED AIRFOIL SECTION
      STAT1=1
      GOTO 30
C
C ** HAVE COMPLETED AIRFOIL. TRANSFER FLAP ELEMENTS FROM
C    UNIT 3  TO UNIT ITAPE, GIVE FIRST POINT STATUS 2
C    AND LAST POINT STATUS 3.
C
  270 CONTINUE
      REWIND TAPEB
      ITOTAL=NAF*(NAFORD+1)/2
      READ (11) X,Y,Z,STAT1,STAT2
      STAT1=2
  280 ISEQ=ISEQ+1
      IF (ISEQ .EQ. ITOTAL) STAT2=3
      WRITE (ITAPE,120) X(1),Y(1),Z(1),STAT1,
     1   X(2),Y(2),Z(2),STAT2,CASE,SURFID,ITYPE,ISEQ
C
      IF (IPRINT .EQ. 1)
     1                  WRITE (TAPEOT,130) X(1),Y(1),Z(1),STAT1,
     2                  X(2),Y(2),Z(2),STAT2,CASE,ITYPE,SURFID,ISEQ
C
      IF (ISEQ .EQ. ITOTAL) RETURN
      READ (TAPEB) X,Y,Z,STAT1,STAT2
      GOTO 280
C
C
      END
      SUBROUTINE VALU2(N,X,Y,Z,XN,YN,ZN,IC,IT,INT,EMT,EMX,EMY,EMZ,
     1                 POP,TOT)
C
C  Array AA is removed from common /SURFN2/ and placed in new common
C  /SURFN/. To establish a correspondence with length of common /SURFN2/ 
C  in subroutine FLNTRP here added auxiliary array a(570). 
      COMMON /SURFN2/INORM,ISURF,IX,IY,IZ,U1,UL,V1,VL,CR,CT,CMX,N2,
     1   N3,XO,YO,ZO,AP11,AP12,AP13,AP21,AP22,AP23,AP31,AP32,AP33,
     2   flowc(7),xi(500),yi(500),b(503,7),xkf(503),
     3   XB(4),YB(4),ZB(4),
     4   NDSET,IABSET,IR,LORG(20),ISR(20),NS,ISFR,IVIS,IFTYP,IFLOW,
     5   BX(2,20),BY(2,20),NB, a(570)
*    2   FLOWC(7),XI(500),YI(500),B(503,7),XKF(503),AA(5999),

      REAL*8 aa(253009)
      common /surfn/ aa
C
      DIMENSION X(N),Y(N),Z(N),INT(N),EMT(N),EMX(N),EMY(N),EMZ(N),
     1          POP(N),TOT(N),VT(6),XT(6),FI(7),BP(2)
C
C
      DO 500 I=1,N
      IF (IC .EQ. 1) GOTO 70
C
C   TRANSFORM COORDS
      XX=X(I)-XO
      YY=Y(I)-YO
      ZZ=Z(I)-ZO
C
      XT(1)=XX*AP11+YY*AP12+ZZ*AP13
      XT(2)=XX*AP21+YY*AP22+ZZ*AP23
      XT(3)=XX*AP31+YY*AP32+ZZ*AP33
      XT(4)=XT(1)
      XT(5)=sqrt(XT(2)**2+XT(3)**2)
      IF (XT(2) .EQ. 0.0) GOTO 40
      XT(6)=atan2(XT(2),-XT(3))
      GOTO 50
   40 XT(6)=0.0
      IF (XT(3) .GT. 0.0) XT(6)=3.141592654
   50 CONTINUE
C
C   NORMALIZE COORDS
      YN=(XT(IY)-V1)/VL
      IF (ISURF .EQ. 1) GOTO 60
      XN=(XT(IX)-U1)/UL
      GOTO 70
   60 CHX=CR+(CT-CR)*YN
      XLE=U1+(UL-U1)*YN
      XN=(XT(IX)-XLE)/CHX
C
C   CHECK IF WITHIN SURFACE BOUNDARIES
   70 IF (XN .LT. 0.0) GOTO 80
      IF (XN .GT. 1.0) GOTO 80
      IF (YN .LT. 0.0) GOTO 80
      IF (YN .GT. 1.0) GOTO 80
C
C   CHECK IF WITHIN FLOW BOUNDARIES
      IB=0
  800 IB=IB+1
      DO 810 I1=1,NB
      J=I1
      IF (YN .LT. BY(IB,I1)) GOTO 820
  810 CONTINUE
C
  820 IF (J .EQ. 1) J=2
      DY=BY(IB,J)-BY(IB,J-1)
      IF (DY .EQ. 0.0) GOTO 80
      DX=BX(IB,J)-BX(IB,J-1)
      BP(IB)=BX(IB,J-1)+(YN-BY(IB,J-1))*DX/DY
      GOTO (830,840), IB
  830 IF (XN .LT. BP(IB)) GOTO 80
      GOTO 800
  840 IF (XN .GT. BP(IB)) GOTO 80
C
C   POINT WITHIN FLOW BOUNDARIES
      XN=XN-BP(1)
      IF (IVIS .EQ. 0) GOTO 850
      XN=XN/(BX(2,1)-BX(1,1))
      GOTO 860
  850 XN=XN/(BP(2)-BP(1))
  860 CONTINUE
C
C   POINT WITHIN BOUNDARIES. CALCULATE VALUES.
      XKF(1)=1.0
      XKF(2)=XN
      XKF(3)=YN
      J3=3
C
      DO 250 J=1,N2
      J3=J3+1
      UIJ=0.0
      TR1=0.0
      TR2=0.0
      IF (XN .EQ. XI(J)) GOTO 210
      TR1=(XN-XI(J))**2
  210 IF (YN .EQ. YI(J)) GOTO 220
      TR2=(YN-YI(J))**2
  220 RBIJ=TR1+TR2
      IF (RBIJ .EQ. 0.0) GOTO 230
      UIJ=RBIJ*log(RBIJ)
  230 XKF(J3)=UIJ
  250 CONTINUE
C
C
      DO 300 K=1,7
      FI(K)=FLOWC(K)
      DO 290 J=1,N3
      FI(K)=FI(K)+XKF(J)*B(J,K)
  290 CONTINUE
  300 CONTINUE
C
      INT(I)=1
      EMT(I)=FI(1)
      FT=sqrt(FI(2)**2+FI(3)**2+FI(4)**2)
      IF (FT .EQ. 0.0) FT=1.0
      FI(2)=FI(2)/FT
      FI(3)=FI(3)/FT
      FI(4)=FI(4)/FT
      EMX(I)=FI(2)/CR
      EMY(I)=FI(3)/VL
      POP(I)=FI(5)
      TOT(I)=FI(6)
      ZN=FI(7)
C
C   TRANSFORM XN,YN,ZN COORDS BACK TO (X,Y,Z)
      IF (IVIS .EQ. 0) GOTO 310
      XN=XN*(BX(2,1)-BX(1,1))
      GOTO 320
  310 XN=XN*(BP(2)-BP(1))
  320 XN=XN+BP(1)
      XT(IY)=YN*VL+V1
      XT(IZ)=ZN
      IF (ISURF .EQ. 1) GOTO 75
      XT(IX)=XN*UL+U1
      GOTO 76
   75 XT(IX)=XN*CHX+U1+(UL-U1)*YN
   76 CONTINUE
      IF (INORM .LE. 0) GOTO 79
      GOTO (81,82,83,84), INORM
C
C   INORM=0   IX=4,IY=5,IZ=6
   79 XX=XT(IX)
      SINPH=sin(XT(IZ))
      COSPH=cos(XT(IZ))
      YY=XT(IY)*SINPH
      ZZ=-XT(IY)*COSPH
      VT(1)=FI(2)
      VT(2)=FI(3)*SINPH+FI(4)*COSPH
      VT(3)=FI(4)*SINPH-FI(3)*COSPH
      GOTO 90
C
C   INORM=1   IX=1,IY=2,IZ=3
   81 XX=XT(IX)
      YY=XT(IY)
      ZZ=XT(IZ)
  110 VT(1)=FI(2)
      VT(2)=FI(3)
      VT(3)=FI(4)
      GOTO 90
C
C   INORM=2   IX=1,IY=3,IZ=2
   82 XX=XT(IX)
      YY=XT(IZ)
      ZZ=XT(IY)
  111 VT(1)=FI(2)
      VT(2)=FI(4)
      VT(3)=FI(3)
      GOTO 90
C
C   INORM=3    IX=2,IY=3,IZ=1
   83 XX=XT(IZ)
      YY=XT(IX)
      ZZ=XT(IY)
  112 VT(1)=FI(4)
      VT(2)=FI(2)
      VT(3)=FI(3)
      GOTO 90
C
C   INORM=4   IX=4,IY=6,IZ=5
   84 XX=XT(IX)
      SINPH=sin(XT(IY))
      COSPH=cos(XT(IY))
      YY=XT(IZ)*SINPH
      ZZ=-XT(IZ)*COSPH
      EMY(I)=EMY(I)/ZN
  113 VT(1)=FI(2)
      VT(2)=FI(4)*SINPH+FI(3)*COSPH
      VT(3)=FI(3)*SINPH-FI(4)*COSPH
C
   90 IF (IC .EQ. 0) GOTO 100
      X(I)=XO+XX*AP11+YY*AP21+ZZ*AP31
      Y(I)=YO+XX*AP12+YY*AP22+ZZ*AP32
      Z(I)=ZO+XX*AP13+YY*AP23+ZZ*AP33
C
C   CHECK COORDINATE SYSTEM FOR DIRECTION COSINES
  100 IF (IT .EQ. 1) GOTO 500
  120 EMX(I)=VT(1)*AP11+VT(2)*AP21+VT(3)*AP31
      EMY(I)=VT(1)*AP12+VT(2)*AP22+VT(3)*AP32
      EMZ(I)=VT(1)*AP13+VT(2)*AP23+VT(3)*AP33
      GOTO 500
C
C   POINT NOT WITHIN BOUNDARIES. SET FLAG AND GO TO NEXT POINT.
   80 INT(I)=0
C
C
  500 CONTINUE
C
C
      RETURN
      END
      SUBROUTINE SHIELD
C
C   THIS ROUTINE IS USED TO ACCOUNT FOR SHIELDING OF ONE ELEMENT BY
C   ANOTHER.
C
C
      COMMON /EXEC/CASE,TITLE,PAGE,ERROR
      COMMON /TAPE/TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1             TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      COMMON /TAGS/ITAG4,ITAG9,ITAG10
      COMMON /ABDATA/NAB,ALPHA(20),BETA(20),ROL(20),CDELTA(20),QI(20),
     1               RI(20),PI(20)
      COMMON /INTERF/INT,ISHE(20),NSHE(100),I9,ISHEF,INF(20,22),
     1               DINF(20,6),LTOTAB(20)
C Number of elements in a component was increased to 2000 in comparison 
C with 500 in original HABP.
      DIMENSION IN(2000),IM(2000),NX(2000),NY(2000),NZ(2000),
     1 AREA(2000),X1(2000),X2(2000),X3(2000),X4(2000),Y1(2000),Y2(2000),
     2 Y3(2000),Y4(2000),Z1(2000),Z2(2000),Z3(2000),Z4(2000),ELEM(25),
     3 XS(5),YS(5),ZS(5),X(5),Y(5),Z(5),S(4,2),LS(4,5),int11(8),
     4 int22(8),S2(2),LS2(2),XP(8),YP(8),ZP(8),IV2(4),IPF(9),XI(5),
     5 YI(5),ZI(5),YPIE(9),ZPIE(9),XSID(2),YSID(2),ZSID(2),YSIP(2),
     6 ZSIP(2),XO(4,3),YO(4,3),ZO(4,3),XPA(4),YPA(4),ZPA(4),XII(4),
     7 ETA(4),XCENT(2000),YCENT(2000),ZCENT(2000),XC(3),YC(3),ZC(3),
     8 AR(3),E(25),IV1(4)
*      DIMENSION IN(500),IM(500),NX(500),NY(500),NZ(500),
*     1 AREA(500),X1(500),X2(500),X3(500),X4(500),Y1(500),Y2(500),
*     2 Y3(500),Y4(500),Z1(500),Z2(500),Z3(500),Z4(500),ELEM(25),XS(5),
*     3 YS(5),ZS(5),X(5),Y(5),Z(5),S(4,2),LS(4,5),int11(8),int22(8),
*     4 S2(2),LS2(2),XP(8),YP(8),ZP(8),IV2(4),IPF(9),XI(5),YI(5),
*     5 ZI(5),YPIE(9),ZPIE(9),XSID(2),YSID(2),ZSID(2),YSIP(2),ZSIP(2),
*     6 XO(4,3),YO(4,3),ZO(4,3),XPA(4),YPA(4),ZPA(4),XII(4),ETA(4),
*     7 XCENT(500),YCENT(500),ZCENT(500),XC(3),YC(3),ZC(3),AR(3),E(25),
*     8 IV1(4)
      Integer EM(25), EP(25)
C
C
      Character *4 TITLE(15)
      INTEGER CASE,PAGE,ERROR,SYMFCT
      INTEGER TAPEIN,TAPEOT,TAPEA,TAPEB,TAPEC,TAPED,TAPEE,TAPEF,
     1        TAPEG,TAPEH,TAPEI,TAPEJ,TAPEK
      REAL NX,NY,NZ,NXO,NXO2,LS,LS2,NX2,NY2,NZ2,NDN2
      DATA ISIZE/2000/, eps/0.00001/
*      DATA ISIZE/500/, eps/0.00001/
C
      REWIND TAPEA
      REWIND TAPEB
      I9=0
      DO 10 I=1,100
   10 NSHE(I)=0
      READ (TAPEIN,20) NPANL,IPRINT,INAB,TITLE
   20 FORMAT( /// I7 // I7 // I7 // 15A4 )
*   20 FORMAT (I2,I1,I2,15A4)
      IG4=2
      READ( 4, REC=IG4 )  EM
*      CALL READMS(4,EM,25,IG4)
      NEXT=EM(1)
      NP=EM(2)
      NPMAX=EM(3)
      NREM=EM(4)
      NPAN=0
      READ( TAPEIN, '( / )' )
   30 NPAN=NPAN+1
   40 READ (TAPEIN,50) IPAN,ISHE
   50 FORMAT( / i7 // (10i7) )
*   50 FORMAT (I2,20I2)
C
C
C   READ PANEL TO BE ANALYZED FOR SHIELDING
      IG4=IPAN*5
      READ( 4, REC=IG4 )  EP
*      CALL READMS(4,EP,25,IG4)
      ISTAT3=EP(1)
      COM=EP(2)
      ISTART=EP(3)
      L=EP(4)
      IORN=EP(5)
      SYMFCT=EP(6)
      ISMY=SYMFCT
      ISTART=ISTART-NREM
      IF (L .GT. ISIZE) GOTO 1030
C
      DO 60 I=1,L
      IG4=ISTART+NREM*I
      READ( 4, REC=IG4 )  ELEM
*      CALL READMS(4,ELEM,25,IG4)
      IN(I)=ELEM(2)+0.0001
      IM(I)=ELEM(3)+0.0001
      NX(I)=ELEM(4)
      NY(I)=ELEM(5)
      NZ(I)=ELEM(6)
      XCENT(I)=ELEM(7)
      YCENT(I)=ELEM(8)
      ZCENT(I)=ELEM(9)
      AREA(I)=ELEM(10)
      X1(I)=ELEM(11)
      X2(I)=ELEM(12)
      X3(I)=ELEM(13)
      X4(I)=ELEM(14)
      Y1(I)=ELEM(15)
      Y2(I)=ELEM(16)
      Y3(I)=ELEM(17)
      Y4(I)=ELEM(18)
      Z1(I)=ELEM(19)
      Z2(I)=ELEM(20)
      Z3(I)=ELEM(21)
      Z4(I)=ELEM(22)
   60 CONTINUE
C
      LTOT=L
C
C
C   READ ALL SHIELDING ELEMENT COMPONENTS AND STORE ON TAPE
      K=0
      DO 80 I=1,20
      IF (ISHE(I) .EQ. 0) GOTO 90
      IG4=ISHE(I)*5
      READ( 4, REC=IG4 )  EP
*      CALL READMS(4,EP,25,IG4)
      ISTAT3=EP(1)
      COM=EP(2)
      ISTART=EP(3)
      L=EP(4)
      IORN=EP(5)
      SYMFCT=EP(6)
      ISTART=ISTART-NREM
C
      DO 70 II=1,L
      K=K+1
      IG4=ISTART+NREM*II
      READ( 4, REC=IG4 )  ELEM
*      CALL READMS(4,ELEM,25,IG4)
      WRITE (TAPEB) ELEM
   70 CONTINUE
   80 CONTINUE
C
   90 LTOTS=K
C
C
C   START ANGLE OF ATTACK - BETA CYCLE
      DO 1020 I=1,NAB
      IF (IPRINT .EQ. 0) GOTO 110
      CALL HEADER
      WRITE (TAPEOT,100) IPAN,ISHE,ALPHA(I),BETA(I)
  100 FORMAT (1H ,51H****SHIELDING PROGRAM OUTPUT NEGATIVE AREA ELEMENTS
     1 ,/1H ,5X,6HPANEL=,I2,3X,17HSHIELDING PANELS=,20I4,/1H ,
     2 5X,6HALPHA=,F6.2,7H  BETA=,F6.2,/1H ,8X,12H ICT  IN  IM,9X,2HNX,
     3 12X,2HNY,12X,2HNZ,11X,5HXCENT,9X,5HYCENT,9X,5HZCENT,10X,4HAREA,
     4 /1H ,29X,2HX1,12X,2HX2,12X,2HX3,12X,2HX4,/1H ,29X,2HY1,12X,2HY2,
     5 12X,2HY3,12X,2HY4,/1H ,29X,2HZ1,12X,2HZ2,12X,2HZ3,12X,2HZ4)
  110 CONTINUE
      PSI=BETA(I)/57.2958
      THETA=-ALPHA(I)/57.2958
      PHI=0.0
      ICT=0
C
C
C   SET UP CONSTANTS FOR ROTATION EQUATIONS
      SINTH=SIN(THETA)
      COSTH=COS(THETA)
      SINPSI=SIN(PSI)
      COSPSI=COS(PSI)
      SINPHI=SIN(PHI)
      COSPHI=COS(PHI)
      A1=COSTH*SINPSI
      A2=(COSPSI*COSPHI)+SINTH*(SINPSI*SINPHI)
      A3=-(COSPSI*SINPHI)+SINTH*(SINPSI*COSPHI)
      A4=-SINTH
      A5=COSTH*SINPHI
      A6=COSTH*COSPHI
      A7=COSTH*COSPSI
      A8=-(SINPSI*COSPHI)+SINTH*(COSPSI*SINPHI)
      A9=(SINPSI*SINPHI)+SINTH*(COSPSI*COSPHI)
C
C
C   SELF-SHIELDING WITHIN COMPONENT WILL BE CHECKED
      LMAX=LTOT+LTOTS
C
      DO 1010 J=1,LTOT
      CREF=1.0
      IREF1=1
      IF (AREA(J) .LT. 0.0001) GOTO 1010
      XI(1)=X1(J)
      XI(2)=X2(J)
      XI(3)=X3(J)
      XI(4)=X4(J)
      YI(1)=Y1(J)
      YI(2)=Y2(J)
      YI(3)=Y3(J)
      YI(4)=Y4(J)
      ZI(1)=Z1(J)
      ZI(2)=Z2(J)
      ZI(3)=Z3(J)
      ZI(4)=Z4(J)
      GOTO 130
  120 XI(2)=X4(J)
      XI(4)=X2(J)
      YI(1)=-Y1(J)
      YI(2)=-Y4(J)
      YI(3)=-Y3(J)
      YI(4)=-Y2(J)
      ZI(2)=Z4(J)
      ZI(4)=Z2(J)
  130 LSH=0
      REWIND TAPEB
C   APPLY ROTATION MATRIX TO OUTWARD NORMAL
      NXO=NX(J)*A7+NY(J)*A8*CREF+NZ(J)*A9
      IF (NXO .LE. 0.0001) GOTO 1000
C   APPLY ROTATION MATRIX TO ELEMENT
      X(1)=XI(1)*A7+YI(1)*A8+ZI(1)*A9
      X(2)=XI(2)*A7+YI(2)*A8+ZI(2)*A9
      X(3)=XI(3)*A7+YI(3)*A8+ZI(3)*A9
      X(4)=XI(4)*A7+YI(4)*A8+ZI(4)*A9
      Y(1)=XI(1)*A1+YI(1)*A2+ZI(1)*A3
      Y(2)=XI(2)*A1+YI(2)*A2+ZI(2)*A3
      Y(3)=XI(3)*A1+YI(3)*A2+ZI(3)*A3
      Y(4)=XI(4)*A1+YI(4)*A2+ZI(4)*A3
      Z(1)=XI(1)*A4+YI(1)*A5+ZI(1)*A6
      Z(2)=XI(2)*A4+YI(2)*A5+ZI(2)*A6
      Z(3)=XI(3)*A4+YI(3)*A5+ZI(3)*A6
      Z(4)=XI(4)*A4+YI(4)*A5+ZI(4)*A6
      YMIN=AMIN1(Y(1),Y(2),Y(3),Y(4))
      YMAX=AMAX1(Y(1),Y(2),Y(3),Y(4))
      ZMIN=AMIN1(Z(1),Z(2),Z(3),Z(4))
      ZMAX=AMAX1(Z(1),Z(2),Z(3),Z(4))
C
C
C   DO LOOP TO FIND SHIELDING ELEMENTS
      DO 990 K=1,LMAX
C   IS THIS THE COMPONENT OR IS IT THE SHIELDING ELEMENTS
      IREF2=1
      CREF2=1.0
C   AVOID ELEMENT SELF-SHIELDING
  140 IF (K.EQ.J .AND. IREF1.EQ.IREF2) GOTO 980
      IF (K .GT. LTOT) GOTO 160
      IF (AREA(K) .LT. 0.0001) GOTO 990
C   APPLY ROTATION MATRIX TO NORMAL
      NXO2=NX(K)*A7+NY(K)*A8*CREF2+NZ(K)*A9
C   CHECK IF REAR FACING
      IF (NXO2 .LE. 0.0001) GOTO 980
C
      ELEM(1)=K
      ELEM(2)=IN(K)
      ELEM(3)=IM(K)
      ELEM(4)=NX(K)
      ELEM(5)=NY(K)
      ELEM(6)=NZ(K)
      ELEM(7)=XCENT(K)
      ELEM(8)=YCENT(K)
      ELEM(9)=ZCENT(K)
      ELEM(10)=AREA(K)
      ELEM(11)=X1(K)
      ELEM(12)=X2(K)
      ELEM(13)=X3(K)
      ELEM(14)=X4(K)
      ELEM(15)=Y1(K)
      ELEM(16)=Y2(K)
      ELEM(17)=Y3(K)
      ELEM(18)=Y4(K)
      ELEM(19)=Z1(K)
      ELEM(20)=Z2(K)
      ELEM(21)=Z3(K)
      ELEM(22)=Z4(K)
      IF (IREF2 .EQ. 1) GOTO 180
  150 ELEM(5)=-NY(K)
      ELEM(8)=-YCENT(K)
      ELEM(12)=X4(K)
      ELEM(14)=X2(K)
      ELEM(15)=-Y1(K)
      ELEM(16)=-Y4(K)
      ELEM(17)=-Y3(K)
      ELEM(18)=-Y2(K)
      ELEM(20)=Z4(K)
      ELEM(22)=Z2(K)
      GOTO 180
C
C   SHIELDING COMPONENTS
  160 IF (IREF2 .EQ. 1) READ (TAPEB) ELEM
      IF (ELEM(10) .LT. 0.0001) GOTO 990
      IF (IREF2 .EQ. 1) GOTO 170
      ELEM(5)=-ELEM(5)
      ELEM(8)=-ELEM(8)
      ELEM(15)=-ELEM(15)
      ELEM(16)=-ELEM(16)
      ELEM(17)=-ELEM(17)
      ELEM(18)=-ELEM(18)
      ELT=ELEM(12)
      ELEM(12)=ELEM(14)
      ELEM(14)=ELT
      ELT=ELEM(16)
      ELEM(16)=ELEM(18)
      ELEM(18)=ELT
      ELT=ELEM(20)
      ELEM(20)=ELEM(22)
      ELEM(22)=ELT
C   APPLY ROTATION MATRIX TO NORMAL
  170 NXO2=ELEM(4)*A7+ELEM(5)*A8+ELEM(6)*A9
C   CHECK IF REAR FACING
      IF (NXO2 .LE. 0.0001) GOTO 980
C
  180 CONTINUE
      YS(1)=ELEM(11)*A1+ELEM(15)*A2+ELEM(19)*A3
      YS(2)=ELEM(12)*A1+ELEM(16)*A2+ELEM(20)*A3
      YS(3)=ELEM(13)*A1+ELEM(17)*A2+ELEM(21)*A3
      YS(4)=ELEM(14)*A1+ELEM(18)*A2+ELEM(22)*A3
      ZS(1)=ELEM(11)*A4+ELEM(15)*A5+ELEM(19)*A6
      ZS(2)=ELEM(12)*A4+ELEM(16)*A5+ELEM(20)*A6
      ZS(3)=ELEM(13)*A4+ELEM(17)*A5+ELEM(21)*A6
      ZS(4)=ELEM(14)*A4+ELEM(18)*A5+ELEM(22)*A6
      YMIN2=AMIN1(YS(1),YS(2),YS(3),YS(4))
      YMAX2=AMAX1(YS(1),YS(2),YS(3),YS(4))
      ZMIN2=AMIN1(ZS(1),ZS(2),ZS(3),ZS(4))
      ZMAX2=AMAX1(ZS(1),ZS(2),ZS(3),ZS(4))
C
C
C   CHECK FOR POSSIBLE SHIELDING
      IF( (YMIN2-YMAX) .GT. 0.0 .OR. abs(YMIN2-YMAX) .LT. eps ) GOTO 980
      IF( (YMIN-YMAX2) .GT. 0.0 .OR. abs(YMIN-YMAX2) .LT. eps ) GOTO 980
      IF( (ZMIN2-ZMAX) .GT. 0.0 .OR. abs(ZMIN2-ZMAX) .LT. eps ) GOTO 980
      IF( (ZMIN-ZMAX2) .GT. 0.0 .OR. abs(ZMIN-ZMAX2) .LT. eps ) GOTO 980
*      IF ((YMIN2-YMAX) .GE. 0.0) GOTO 980
*      IF ((YMIN-YMAX2) .GE. 0.0) GOTO 980
*      IF ((ZMIN2-ZMAX) .GE. 0.0) GOTO 980
*      IF ((ZMIN-ZMAX2) .GE. 0.0) GOTO 980
C   CHECK IF ELEMENT 2 IS REALLY IN FRONT OF ELEMENT 1
      XMIN=AMIN1(X(1),X(2),X(3),X(4))
      XS(1)=ELEM(11)*A7+ELEM(15)*A8+ELEM(19)*A9
      XS(2)=ELEM(12)*A7+ELEM(16)*A8+ELEM(20)*A9
      XS(3)=ELEM(13)*A7+ELEM(17)*A8+ELEM(21)*A9
      XS(4)=ELEM(14)*A7+ELEM(18)*A8+ELEM(22)*A9
      XMAX2=AMAX1(XS(1),XS(2),XS(3),XS(4))
      IF (XMIN .GE. XMAX2) GOTO 980
C
C   POSSIBLE OVERLAP. CALCULATE SIDE VECTORS OF SHIELDED ELEMENT
      S(1,1)=Y(2)-Y(1)
      S(1,2)=Z(2)-Z(1)
      S(2,1)=Y(3)-Y(2)
      S(2,2)=Z(3)-Z(2)
      S(3,1)=Y(4)-Y(3)
      S(3,2)=Z(4)-Z(3)
      S(4,1)=Y(1)-Y(4)
      S(4,2)=Z(1)-Z(4)
C
C   CALCULATE L'S
      IC=0
      DO 200 I1=1,4
C   CHECK FOR ZERO LENGTH SIDE OF ELEMENT 1
      IF (S(I1,1).EQ.0.0 .AND. S(I1,2).EQ.0.0) IC=I1
      DO 190 I2=1,4
      LS(I1,I2)=(ZS(I2)-Z(I1))*S(I1,1)-(YS(I2)-Y(I1))*S(I1,2)
      if( abs(LS(I1,I2)) .LT. eps ) LS(I1,I2) = 0.0
  190 CONTINUE
      LS(I1,5)=LS(I1,1)
  200 CONTINUE
C
      DO 210 IE=1,8
      int11(IE)=0
  210 int22(IE)=0
C
      JPOS=0
      IE=0
      DO 230 I1=1,4
      IF (I1 .EQ. IC) GOTO 230
      DO 220 I2=1,4
*      IF( abs(LS(I1,I2)) .EQ. 0.0 .AND. abs(LS(I1,I2+1)) .EQ. 0.0 )
*     +                                                    GOTO 220
*      IF( LS(I1,I2) .GT. 0.0 .AND. LS(I1,I2+1) .GT. 0.0 ) GOTO 220
*      IF( LS(I1,I2) .LT. 0.0 .AND. LS(I1,I2+1) .LT. 0.0 ) GOTO 220
      IF( LS(I1,I2) .GE. 0.0 .AND. LS(I1,I2+1) .GE. 0.0 ) GOTO 220
      IF( LS(I1,I2) .LE. 0.0 .AND. LS(I1,I2+1) .LE. 0.0 ) GOTO 220
      X(5)=X(1)
      Y(5)=Y(1)
      Z(5)=Z(1)
      YS(5)=YS(1)
      ZS(5)=ZS(1)
      XI(5)=XI(1)
      YI(5)=YI(1)
      ZI(5)=ZI(1)
C
C   INTERSECTION IS POSSIBLE. DO REVERSE-L CHECK TO VERIFY INTERSECTION.
C    (JPOS IS THE 'POSSIBLE INTERSECTION' COUNTER)
      JPOS=JPOS+1
      S2(1)=YS(I2+1)-YS(I2)
      S2(2)=ZS(I2+1)-ZS(I2)
      IF ( abs(S2(1)) .LT. eps .AND. abs(S2(2)) .LT. eps ) GOTO 220
      LS2(1)=(Z(I1)-ZS(I2))*S2(1)-(Y(I1)-YS(I2))*S2(2)
      LS2(2)=(Z(I1+1)-ZS(I2))*S2(1)-(Y(I1+1)-YS(I2))*S2(2)
      if( abs(LS2(1)) .LT. eps ) LS2(1) = 0.0
      if( abs(LS2(2)) .LT. eps ) LS2(2) = 0.0
*      IF( LS2(1) .GT. 0.0 .AND. LS2(2) .GT. 0.0 ) GOTO 220
*      IF( LS2(1) .LT. 0.0 .AND. LS2(2) .LT. 0.0 ) GOTO 220
      IF( LS2(1) .GE. 0.0 .AND. LS2(2) .GE. 0.0 ) GOTO 220
      IF( LS2(1) .LE. 0.0 .AND. LS2(2) .LE. 0.0 ) GOTO 220
C
C   A DEFINITE INTERSECTION HAS BEEN CONFIRMED. SET INTERSECTION ID
      IE=IE+1
      int11(IE)=I1
      int22(IE)=I2
      IF (IE .NE. 2) GOTO 220
      IF (int11(1) .NE. int11(2)) GOTO 220
      IF (int22(2) .GT. int22(1)) GOTO 220
      INT2S=int22(1)
      int22(1)=int22(2)
      int22(2)=INT2S
C
  220 CONTINUE
  230 CONTINUE
C
C
C   CHECK IF FIRST ELEMENT COMPLETELY CONTAINS THE SECOND
      DO 290 I1=1,4
      IF (I1 .EQ. IC) GOTO 290
      DO 289 I2=1,4
      IF (LS(I1,I2) .GT. 0.0) GOTO 311
*      IF (LS(I1,I2) .GT. 0.0) GOTO 310
  289 CONTINUE
  290 CONTINUE
C
C
C   THE FIRST ELEMENT COMPLETELY CONTAINS THE SECOND SINCE ALL L'S
C   WERE FOUND TO BE .LE. 0.0
C
C   SET UP AND SAVE THE NEW SHIELDED ELEMENT (IT IS THE SAME AS THE 2ND)
C
      DO 300 I1=1,4
      XP(I1)=ELEM(I1+10)
      YP(I1)=ELEM(I1+14)
      ZP(I1)=ELEM(I1+18)
      YPIE(I1)=YS(I1)
  300 ZPIE(I1)=ZS(I1)
      XP(5)=XP(1)
      YP(5)=YP(1)
      ZP(5)=ZP(1)
      YPIE(5)=YPIE(1)
      ZPIE(5)=ZPIE(1)
      IPF(1)=10
      IPF(2)=20
      IPF(3)=30
      IPF(4)=40
      IP=4
      Y(5)=Y(1)
      Z(5)=Z(1)
      XI(5)=XI(1)
      YI(5)=YI(1)
      ZI(5)=ZI(1)
      YS(5)=YS(1)
      ZS(5)=ZS(1)
      LSH=LSH+1
      NE=1
      GOTO 630
C
C
C   CHECK IF THE FIRST ELEMENT IS COMPLETELY CONTAINED BY THE SECOND
C    (JPOS = 8 BUT INT'S = 0)
  311 IBP=0
*      IF (JPOS .NE. 8) GOTO 280
      IF (int11(1) .NE. 0) GOTO 280
C   CHECK THAT ALL ELEMENT 1 CORNERS ARE REALLY INSIDE OF ELEMENT 2
      I4=0
      DO 260 I1=1,4
      IF (I1 .EQ. IC) GOTO 260
      DO 250 I2=1,4
      S2(1)=YS(I2+1)-YS(I2)
      S2(2)=ZS(I2+1)-ZS(I2)
      if( abs(S2(1)) .lt. eps )  S2(1) = 0.0
      if( abs(S2(2)) .lt. eps )  S2(2) = 0.0
      IF (S2(1).NE.0.0 .or. S2(2).NE.0.0) GOTO 240
*      IF (S2(1).NE.0.0 .AND. S2(2).NE.0.0) GOTO 240
      GOTO 250
  240 LS2(1)=(Z(I1)-ZS(I2))*S2(1)-(Y(I1)-YS(I2))*S2(2)
      if( abs(LS2(1)) .LT. eps )  LS2(1) = 0.0
      IF (LS2(1) .GT. 0.0) GOTO 260
  250 CONTINUE
      I4=I4+1
  260 CONTINUE
      IF (IC.EQ.0 .AND. I4.NE.4) GOTO 980
      IF (IC.NE.0 .AND. I4.NE.3) GOTO 980
C
C   THE FIRST ELEMENT IS CONTAINED BY THE SECOND. SET UP AND SAVE
C   SHIELDED ELEMENT CHARACTERISTICS (THEY ARE THE SAME AS THE 1ST)
      NE=1
      DO 270 I1=1,4
      IPF(I1)=I1*100
      XO(I1,1)=XI(I1)
      XP(I1)=XI(I1)
      YO(I1,1)=YI(I1)
      YP(I1)=YI(I1)
      ZO(I1,1)=ZI(I1)
  270 ZP(I1)=ZI(I1)
      XC(1)=XCENT(J)
      YC(1)=YCENT(J)*CREF
      ZC(1)=ZCENT(J)
      AR(1)=AREA(J)
      IP=4
      IBP=1
      GOTO 750
C
  280 CONTINUE
C
C
C   CHECK IF ELEMENTS 1 AND 2 WERE FOUND TO OVERLAP
  310 IF (int11(1) .EQ. 0) GOTO 980
C
C   ELEMENTS OVERLAP. FROM NEW NEGATIVE ELEMENTS FOR SHIELDED AREA
C
C **DETERMINE CORNERS OF POLYGON
C
C   CHECK ALL L'S FOR POINTS INSIDE OF ELEMENT 1 AND SAVE ID NUMBERS
      I3=0
      DO 330 I2=1,4
      DO 320 I1=1,4
      IF (I1 .EQ. IC) GOTO 320
*      IF (LS(I1,I2) .GE. 0.0) GOTO 330
      IF (LS(I1,I2) .GT. 0.0001) GOTO 330
  320 CONTINUE
      I3=I3+1
      IV2(I3)=I2
  330 CONTINUE
C
C   CHECK FOR ANY ELEMENT 1 CORNERS THAT ARE INSIDE OF ELEMENT 2
      I4=0
      DO 360 I1=1,4
      IF (I1 .EQ. IC) GOTO 360
      DO 350 I2=1,4
      S2(1)=YS(I2+1)-YS(I2)
      S2(2)=ZS(I2+1)-ZS(I2)
      IF ( abs(S2(1)) .LT. eps .AND. abs(S2(2)) .LT. eps ) GOTO 350
  340 LS2(1)=(Z(I1)-ZS(I2))*S2(1)-(Y(I1)-YS(I2))*S2(2)
      if( abs(LS2(1)) .LT. eps ) LS2(1) = 0.0
*      IF (LS2(1) .GE. 0.0) GOTO 360
      IF (LS2(1) .GT. 0.0001) GOTO 360
  350 CONTINUE
C
      I4=I4+1
      IV1(I4)=I1
  360 CONTINUE
C
      IP=0
      ICHK=0
      IVT=IE+I3+I4
      IF (IE.LE.2 .AND. IE.EQ.IVT) GOTO 980
C   CHECK IF ALL ELEMENT 2 CORNERS ARE OUTSIDE OF ELEMENT 1
      IF (I3 .EQ. 0) GOTO 430
C   SET ELEMENT 2 CORNER POINT AS POLYGON CORNER POINT
      I42=IV2(1)
      I11=0
  370 IP=IP+1
      IPF(IP)=I42*10
      IF (IP .EQ. IVT) GOTO 540
C
C   CHECK IF THERE IS AN INTERSECTION ON THIS SIDE OF ELEMENT 2
  380 DO 390 I1=1,IE
      IF (I1 .EQ. I11) GOTO 390
      IF (int22(I1) .EQ. I42) GOTO 420
  390 CONTINUE
      I42=I42+1
      IF (I42 .GT. 4) I42=1
      IF (I3 .EQ. 0) GOTO 410
      DO 400 I1=1,I3
      IF (IV2(I1) .EQ. I42) GOTO 370
  400 CONTINUE
  410 IF (ICHK .EQ. 1) GOTO 980
      IP=0
      ICHK=1
      GOTO 430
C
C   SAVE INTERSECTION ON ELEMENT 2 SIDE AS NEXT POLYGON CORNER POINT
  420 IP=IP+1
      IPF(IP)=I1
      IF (IP .EQ. IVT) GOTO 540
      I41=I1
      GOTO 450
C
C   CHECK IF ANY ELEMENT 1 CORNERS ARE INSIDE OF ELEMENT 2
  430 IF (I4 .EQ. 0) GOTO 440
      I2=1
      I1=0
      GOTO 500
C   SET THE LOWEST ORDER INTERSECTION ON ELEMENT 1 AND SAVE AS CORNER
  440 IP=1
      IPF(IP)=1
      I41=1
      I1=1
C
C   CHECK IF THERE IS AN INTERSECTION ON THIS SIDE OF ELEMENT 1
  450 DO 460 I11=1,IE
      IF (I11 .EQ. I41) GOTO 460
      IF (int11(I11) .EQ. int11(I1)) GOTO 530
  460 CONTINUE
C
C   CHECK IF NEXT CORNER POINT OF ELEMENT 1 IS INSIDE OF ELEMENT 2
  470 IF (I4 .EQ. 0) GOTO 490
      IF (I1 .GT. IE) GOTO 490
      IF (I1 .EQ. 0) GOTO 980
      I41=int11(I1)+1
      IF (I41 .GT. 4) I41=1
      IF (I41 .EQ. IC) I41=I41+1
      IF (I41 .GT. 4) I41=1
      DO 480 I2=1,I4
      IF (IV1(I2) .EQ. I41) GOTO 500
  480 CONTINUE
  490 I43=I41
      GOTO 510
C
C   SAVE ELEMENT 1 CORNER AS NEXT POLYGON CORNER
  500 IP=IP+1
      I43=IV1(I2)
      IPF(IP)=I43*100
      IF (IP .EQ. IVT) GOTO 540
C
C   CHECK IF THE NEXT CORNER OF ELEMENT 1 IS ALSO INSIDE OF ELEMENT 2
      I2=I2+1
      IF (I2 .GT. I4) GOTO 510
      I44=I43+1
      IF (IV1(I2) .EQ. I44) GOTO 500
C
C   CHECK IF THERE IS AN INTERSECTION ON THIS SIDE OF ELEMENT 1
  510 DO 520 I11=1,IE
      IF (int11(I11) .EQ. I43) GOTO 530
  520 CONTINUE
C
      I41=I41+1
      GOTO 470
C
C   SAVE INTERSECTION ON SIDE OF ELEMENT 1 AS NEXT POLYGON CORNER
  530 IP=IP+1
      IPF(IP)=I11
      IF (IP .EQ. IVT) GOTO 540
      I42=int22(I11)
      GOTO 380
C
C   POLYGON HAS BEEN COMPLETED. IT HAS IP CORNER POINTS.
C
  540 IF (IP .GE. 3) GOTO 550
      WRITE (6,522) J,K,X,Y,Z,YS,ZS,LS
  522 FORMAT (1H ,48H***THERE ARE NOT ENOUGH INTERSECTIONS AND INSIDE,
     1 36H CORNER POINTS TO FORM A NEW ELEMENT,/1H ,2X,2HJ=,I3,
     2  4H  K=,I3,/,(3X,5F10.4))
      GOTO 980
C
C *  SET UP POLYGON CORNER POINTS
  550 DO 620 IE=1,IP
C   CHECK IF INTERSECTION OF SIDES, CORNER OF ELEMENT 2 OR ELEMENT 1
      IF (IPF(IE) .LT. 10) GOTO 560
      IF (IPF(IE) .LT. 100) GOTO 600
      GOTO 610
C
C   SIDE INTERSECTION
  560 I7=IPF(IE)
      I1=int11(I7)
      I2=int22(I7)
      SAS=1.0/(1.0+ABS(LS(I1,I2+1)/LS(I1,I2)))
      YPIE(IE)=SAS*(YS(I2+1)-YS(I2))+YS(I2)
      ZPIE(IE)=SAS*(ZS(I2+1)-ZS(I2))+ZS(I2)
      DY=ABS(Y(I1+1)-Y(I1))
      DZ=ABS(Z(I1+1)-Z(I1))
      IF (DZ .GT. DY) GOTO 580
      IF (DY .GT. 0.00001) GOTO 570
      DAD=0.0
      GOTO 590
  570 DAD=ABS((YPIE(IE)-Y(I1))/DY)
      GOTO 590
  580 DAD=ABS((ZPIE(IE)-Z(I1))/DZ)
  590 XP(IE)=XI(I1)+(XI(I1+1)-XI(I1))*DAD
      YP(IE)=YI(I1)+(YI(I1+1)-YI(I1))*DAD
      ZP(IE)=ZI(I1)+(ZI(I1+1)-ZI(I1))*DAD
      GOTO 620
C
C   CORNER POINT OF ELEMENT 2
  600 I7=IPF(IE)/10
      XP(IE)=ELEM(I7+10)
      YP(IE)=ELEM(I7+14)
      ZP(IE)=ELEM(I7+18)
      GOTO 620
C
C   CORNER POINT OF ELEMENT 1
  610 I7=IPF(IE)/100
      XP(IE)=XI(I7)
      YP(IE)=YI(I7)
      ZP(IE)=ZI(I7)
C
  620 CONTINUE
  630 CONTINUE
C ** PROJECTION OF ELEMENT 2 CORNER POINTS INTO PLANE OF INPUT ELEMENT.
C
      IPF(IP+1)=IPF(1)
      DO 740 IE=1,IP
C   CHECK IF THIS POLYGON CORNER PT. WAS AN ELEMENT 2 CORNER
      IF (IPF(IE).LT.10 .OR. IPF(IE).GT.40) GOTO 740
      IEE=IE+1
      I7=0
      I2=IPF(IE)/10
C   CALCULATE SIDE VECTORS
  640 S2(1)=YS(I2+1)-YS(I2)
      S2(2)=ZS(I2+1)-ZS(I2)
C   CHECK IF ZERO LENGTH SIDE
      IF ( abs(S2(1)) .LT. eps .AND. abs(S2(2)) .LT. eps ) GOTO 650
      GOTO 660
  650 I2=I2+1
      IF (I2 .EQ. 5) I2=1
      GOTO 640
C   SEARCH FOR SIDE PROJECTION INTERSECTIONS AND CALCULATE COORDINATES
  660 DO 690 I1=1,4
      LS2(1)=(Z(I1)-ZS(I2))*S2(1)-(Y(I1)-YS(I2))*S2(2)
      LS2(2)=(Z(I1+1)-ZS(I2))*S2(1)-(Y(I1+1)-YS(I2))*S2(2)
      if( abs(LS2(1)) .lt. eps )  LS2(1) = 0.0
      if( abs(LS2(2)) .lt. eps )  LS2(2) = 0.0
      IF( LS2(1) .eq. 0.0 .AND. LS2(2) .eq. 0.0 ) GOTO 690
      IF( LS2(1) .GT. 0.0 .AND. LS2(2) .GT. 0.0 ) GOTO 690
      IF( LS2(1) .LT. 0.0 .AND. LS2(2) .LT. 0.0 ) GOTO 690
      I7=I7+1
      IF (ABS(LS2(1)) .GT. 0.00001) GOTO 670
      XSID(I7)=XI(I1)
      YSID(I7)=YI(I1)
      ZSID(I7)=ZI(I1)
      YSIP(I7)=Y(I1)
      ZSIP(I7)=Z(I1)
      GOTO 680
  670 SAS=1.0/(1.0+ABS(LS2(2)/LS2(1)))
C   CALCULATE SIDE INTERSECTION IN INPUT COORDINATE SYSTEM
      XSID(I7)=XI(I1)+SAS*(XI(I1+1)-XI(I1))
      YSID(I7)=YI(I1)+SAS*(YI(I1+1)-YI(I1))
      ZSID(I7)=ZI(I1)+SAS*(ZI(I1+1)-ZI(I1))
C   CALCULATE SIDE INTERSECTION COORDINATES IN VIEWING REFERENCE COORD.
      YSIP(I7)=Y(I1)+SAS*(Y(I1+1)-Y(I1))
      ZSIP(I7)=Z(I1)+SAS*(Z(I1+1)-Z(I1))
  680 CONTINUE
      IF (I7 .EQ. 2) GOTO 700
  690 CONTINUE
C   CALCULATE  COORDINATES OF CORNER PT. IN ELEMENT PLANE
  700 DY=ABS(YSIP(2)-YSIP(1))
      DZ=ABS(ZSIP(2)-ZSIP(1))
      IF (DZ .GT. DY) GOTO 720
      IF (DY .GT. 0.00001) GOTO 710
      DAD=0.0
      GOTO 730
  710 DAD=ABS((YS(I2)-YSIP(1))/DY)
      GOTO 730
  720 DAD=ABS((ZS(I2)-ZSIP(1))/DZ)
  730 XP(IE)=XSID(1)+(XSID(2)-XSID(1))*DAD
      YP(IE)=YSID(1)+(YSID(2)-YSID(1))*DAD
      ZP(IE)=ZSID(1)+(ZSID(2)-ZSID(1))*DAD
  740 CONTINUE
  750 CONTINUE
C   POLYGON CORNER POINTS ARE NOW COMPLETE AND STORED IN XP, YP, ZP
C   MAKE CHECK FOR DEFINITE SHIELDING
      XMAX=AMAX1(X(1),X(2),X(3),X(4))
      IF (IP .EQ. 8) GOTO 770
      DO 760 IE=IP,7
  760 XP(IE+1)=99999.9
  770 XMIN2=AMIN1(XP(1),XP(2),XP(3),XP(4),XP(5),XP(6),XP(7),XP(8))
      IF (XMIN2 .GE. XMAX) GOTO 790
C   SHIELDING NOT DEFINITE, SO CHECK FURTHER
      DO 780 IE=1,IP
      IF (IPF(IE).GT.9 .AND. IPF(IE).LT.50) GOTO 780
      NX2=XP(IE)-ELEM(7)
      NY2=YP(IE)-ELEM(8)
      NZ2=ZP(IE)-ELEM(9)
      VN=SQRT(NX2*NX2+NY2*NY2+NZ2*NZ2)
      IF (VN .EQ. 0.0) GOTO 780
      NX2=NX2/VN
      NY2=NY2/VN
      NZ2=NZ2/VN
      NDN2=ELEM(4)*NX2+ELEM(5)*NY2+ELEM(6)*NZ2
      IF (NDN2 .GT. 0.0001) GOTO 980
  780 CONTINUE
      IF (IBP .EQ. 1) GOTO 950
  790 CONTINUE
C
C   SET UP PROJECTION TRANSFORMATION DATA FOR SHIELDED ELEMENT
      T1X=XI(3)-XI(1)
      T2X=XI(4)-XI(2)
      T1Y=YI(3)-YI(1)
      T2Y=YI(4)-YI(2)
      T1Z=ZI(3)-ZI(1)
      T2Z=ZI(4)-ZI(2)
      AVX=0.25*(XI(1)+XI(2)+XI(3)+XI(4))
      AVY=0.25*(YI(1)+YI(2)+YI(3)+YI(4))
      AVZ=0.25*(ZI(1)+ZI(2)+ZI(3)+ZI(4))
      T=SQRT(T1X*T1X+T1Y*T1Y+T1Z*T1Z)
      IF ( abs(T) .LT. eps ) GOTO 800
      T1X=T1X/T
      T1Y=T1Y/T
      T1Z=T1Z/T
  800 T2X=NY(J)*T1Z*CREF-NZ(J)*T1Y
      T2Y=NZ(J)*T1X-NX(J)*T1Z
      T2Z=NX(J)*T1Y-NY(J)*T1X*CREF
C   PROJECT POLYGON POINTS INTO QUADRILATERAL PLANE
      DO 810 IE=1,IP
      IF (IPF(IE) .GT. 40) GOTO 810
      XN=T1X*(XP(IE)-AVX)+T1Y*(YP(IE)-AVY)+T1Z*(ZP(IE)-AVZ)
      YN=T2X*(XP(IE)-AVX)+T2Y*(YP(IE)-AVY)+T2Z*(ZP(IE)-AVZ)
      XP(IE)=AVX+T1X*XN+T2X*YN
      YP(IE)=AVY+T1Y*XN+T2Y*YN
      ZP(IE)=AVZ+T1Z*XN+T2Z*YN
  810 CONTINUE
C
C   CONVERT POLYGON POINTS TO REQUIRED NUMBER OF ELEMENTS
      DO 820 I1=1,4
      XO(I1,1)=XP(I1)
      YO(I1,1)=YP(I1)
  820 ZO(I1,1)=ZP(I1)
      NE=1
      IF (IP .NE. 3) GOTO 830
      XO(4,1)=XP(3)
      YO(4,1)=YP(3)
      ZO(4,1)=ZP(3)
      GOTO 880
C
  830 IF (IP .EQ. 4) GOTO 880
      DO 840 I1=1,4
      XO(I1,2)=XP(I1+3)
      YO(I1,2)=YP(I1+3)
  840 ZO(I1,2)=ZP(I1+3)
      NE=2
      IF (IP .NE. 5) GOTO 850
      XO(3,2)=XP(1)
      YO(3,2)=YP(1)
      ZO(3,2)=ZP(1)
      XO(4,2)=XP(1)
      YO(4,2)=YP(1)
      ZO(4,2)=ZP(1)
      GOTO 880
  850 IF (IP .NE. 6) GOTO 860
      XO(4,2)=XP(1)
      YO(4,2)=YP(1)
      ZO(4,2)=ZP(1)
      GOTO 880
C
  860 XO(1,3)=XP(4)
      YO(1,3)=YP(4)
      ZO(1,3)=ZP(4)
      XO(2,3)=XP(7)
      YO(2,3)=YP(7)
      ZO(2,3)=ZP(7)
      NE=3
      IF (IP .NE. 7) GOTO 870
      XO(3,3)=XP(1)
      YO(3,3)=YP(1)
      ZO(3,3)=ZP(1)
      XO(4,3)=XP(1)
      YO(4,3)=YP(1)
      ZO(4,3)=ZP(1)
      GOTO 880
  870 XO(3,3)=XP(8)
      YO(3,3)=YP(8)
      ZO(3,3)=ZP(8)
      XO(4,3)=XP(1)
      YO(4,3)=YP(1)
      ZO(4,3)=ZP(1)
      GOTO 880
C
  880 CONTINUE
C   CALCULATE AREA AND CENTROID FOR NEW NEGATIVE ELEMENTS
      DO 940 I1=1,NE
      T1X=XO(3,I1)-XO(1,I1)
      T2X=XO(4,I1)-XO(2,I1)
      T1Y=YO(3,I1)-YO(1,I1)
      T2Y=YO(4,I1)-YO(2,I1)
      T1Z=ZO(3,I1)-ZO(1,I1)
      T2Z=ZO(4,I1)-ZO(2,I1)
      AVX=0.25*(XO(1,I1)+XO(2,I1)+XO(3,I1)+XO(4,I1))
      AVY=0.25*(YO(1,I1)+YO(2,I1)+YO(3,I1)+YO(4,I1))
      AVZ=0.25*(ZO(1,I1)+ZO(2,I1)+ZO(3,I1)+ZO(4,I1))
      D=NX(J)*(AVX-XO(1,I1))+NY(J)*(AVY-YO(1,I1))*CREF+
     1  NZ(J)*(AVZ-ZO(1,I1))
      PD=ABS(D)
      T=SQRT(T1X*T1X+T1Y*T1Y+T1Z*T1Z)
      IF (T .LT. 0.0001) GOTO 890
      T1X=T1X/T
      T1Y=T1Y/T
      T1Z=T1Z/T
  890 T2X=NY(J)*T1Z*CREF-NZ(J)*T1Y
      T2Y=NZ(J)*T1X-NX(J)*T1Z
      T2Z=NX(J)*T1Y-NY(J)*T1X*CREF
      DO 900 I2=1,4
      XPA(I2)=XO(I2,I1)+NX(J)*D
      YPA(I2)=YO(I2,I1)+NY(J)*D*CREF
      ZPA(I2)=ZO(I2,I1)+NZ(J)*D
      D=-D
      XDIF=XPA(I2)-AVX
      YDIF=YPA(I2)-AVY
      ZDIF=ZPA(I2)-AVZ
      XII(I2)=T1X*XDIF+T1Y*YDIF+T1Z*ZDIF
  900 ETA(I2)=T2X*XDIF+T2Y*YDIF+T2Z*ZDIF
      ETACK=ETA(2)-ETA(4)
      IF (ABS(ETACK) .GT. 0.0001) GOTO 910
      XI0=0.0
      GOTO 920
  910 XI0=0.333333*(XII(4)*(ETA(1)-ETA(2))+XII(2)*
     1    (ETA(4)-ETA(1)))/(ETA(2)-ETA(4))
  920 ETA0=-0.333333*ETA(1)
      DO 930 I2=1,4
      XII(I2)=XII(I2)-XI0
  930 ETA(I2)=ETA(I2)-ETA0
      XC(I1)=AVX+T1X*XI0+T2X*ETA0
      YC(I1)=AVY+T1Y*XI0+T2Y*ETA0
      ZC(I1)=AVZ+T1Z*XI0+T2Z*ETA0
      XI3M1=XII(3)-XII(1)
      ETA2M4=ETA(2)-ETA(4)
      AR(I1)=0.5*XI3M1*ETA2M4
  940 CONTINUE
  950 CONTINUE
C
      DO 970 I8=1,NE
      IF (AR(I8) .LE. 0.0001) GOTO 970
      ICT=ICT+1
      E(1)=ICT
      E(2)=IN(J)
      E(3)=IM(J)
      E(4)=NX(J)
      E(5)=NY(J)*CREF
      E(6)=NZ(J)
      E(7)=XC(I8)
      E(8)=YC(I8)
      E(9)=ZC(I8)
      E(10)=-AR(I8)
      E(11)=XO(1,I8)
      E(12)=XO(2,I8)
      E(13)=XO(3,I8)
      E(14)=XO(4,I8)
      E(15)=YO(1,I8)
      E(16)=YO(2,I8)
      E(17)=YO(3,I8)
      E(18)=YO(4,I8)
      E(19)=ZO(1,I8)
      E(20)=ZO(2,I8)
      E(21)=ZO(3,I8)
      E(22)=ZO(4,I8)
      E(23)=4.0
      E(24)=0.0
      E(25)=0.0
      WRITE (TAPEA) E
      IF (IPRINT .NE. 0) WRITE (TAPEOT,960) E
  960 FORMAT (1H ,8X,3F4.0,2X,7E14.5,/1H ,22X,4E14.5,/1H ,22X,4E14.5,/
     1  1H ,22X,4E14.5,/1H ,22X,3E14.5)
  970 CONTINUE
  980 IF (IREF2.EQ.2 .OR. ISMY.EQ.1 .OR. BETA(I).EQ.0.0) GOTO 990
      IREF2=2
      CREF2=-1.0
      GOTO 140
C
  990 CONTINUE
 1000 IF (IREF1.EQ.2 .OR. ISMY.EQ.1 .OR. BETA(I).EQ.0.0) GOTO 1010
      IREF1=2
      CREF=-1.0
      GOTO 120
 1010 CONTINUE
C
C
      I9=I9+1
      NSHE(I9)=ICT
 1020 CONTINUE
C   END OF ALPHA-BETA LOOP
C
C   CHECK FOR END OF COMPONENT ANALYSIS LOOP
      IF (NPAN .LT. NPANL) GOTO 30
      REWIND TAPEA
      GOTO 1050
C
 1030 WRITE (6,1040) ISIZE
 1040 FORMAT (1H ,43H**ERROR** NUMBER OF ELEMENTS IN A COMPONENT,
     1 14HCANNOT EXCEED  ,I4,34H  A STOP WILL BE CALLED IN ROUTINE  ,
     2  8H SHIELD.  )
      STOP
 1050 RETURN
      END
